 /*+----------------------------------------------------------------- */
 /*  Copyright (C) 1996-1999, Microsoft Corporation.                  */
 /*                                                                   */
 /*  File:       adssts.h                                             */
 /*                                                                   */
 /*  Contents:   Status Codes for ADS objects                         */
 /*                                                                   */
 /*------------------------------------------------------------------ */

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;

 /*                       */
 /* printer status values */
 /*                       */

 dcl ADS_PRINTER_PAUSED               fixed bin(31) value('00000001'xn);
 dcl ADS_PRINTER_PENDING_DELETION     fixed bin(31) value('00000002'xn);
 dcl ADS_PRINTER_ERROR                fixed bin(31) value('00000003'xn);
 dcl ADS_PRINTER_PAPER_JAM            fixed bin(31) value('00000004'xn);
 dcl ADS_PRINTER_PAPER_OUT            fixed bin(31) value('00000005'xn);
 dcl ADS_PRINTER_MANUAL_FEED          fixed bin(31) value('00000006'xn);
 dcl ADS_PRINTER_PAPER_PROBLEM        fixed bin(31) value('00000007'xn);
 dcl ADS_PRINTER_OFFLINE              fixed bin(31) value('00000008'xn);
 dcl ADS_PRINTER_IO_ACTIVE            fixed bin(31) value('00000100'xn);
 dcl ADS_PRINTER_BUSY                 fixed bin(31) value('00000200'xn);
 dcl ADS_PRINTER_PRINTING             fixed bin(31) value('00000400'xn);
 dcl ADS_PRINTER_OUTPUT_BIN_FULL      fixed bin(31) value('00000800'xn);
 dcl ADS_PRINTER_NOT_AVAILABLE        fixed bin(31) value('00001000'xn);
 dcl ADS_PRINTER_WAITING              fixed bin(31) value('00002000'xn);
 dcl ADS_PRINTER_PROCESSING           fixed bin(31) value('00004000'xn);
 dcl ADS_PRINTER_INITIALIZING         fixed bin(31) value('00008000'xn);
 dcl ADS_PRINTER_WARMING_UP           fixed bin(31) value('00010000'xn);
 dcl ADS_PRINTER_TONER_LOW            fixed bin(31) value('00020000'xn);
 dcl ADS_PRINTER_NO_TONER             fixed bin(31) value('00040000'xn);
 dcl ADS_PRINTER_PAGE_PUNT            fixed bin(31) value('00080000'xn);
 dcl ADS_PRINTER_USER_INTERVENTION    fixed bin(31) value('00100000'xn);
 dcl ADS_PRINTER_OUT_OF_MEMORY        fixed bin(31) value('00200000'xn);
 dcl ADS_PRINTER_DOOR_OPEN            fixed bin(31) value('00400000'xn);
 dcl ADS_PRINTER_SERVER_UNKNOWN       fixed bin(31) value('00800000'xn);
 dcl ADS_PRINTER_POWER_SAVE           fixed bin(31) value('01000000'xn);

 /*                   */
 /* job status values */
 /*                   */

 dcl ADS_JOB_PAUSED                   fixed bin(31) value('00000001'xn);
 dcl ADS_JOB_ERROR                    fixed bin(31) value('00000002'xn);
 dcl ADS_JOB_DELETING                 fixed bin(31) value('00000004'xn);
 dcl ADS_JOB_SPOOLING                 fixed bin(31) value('00000008'xn);
 dcl ADS_JOB_PRINTING                 fixed bin(31) value('00000010'xn);
 dcl ADS_JOB_OFFLINE                  fixed bin(31) value('00000020'xn);
 dcl ADS_JOB_PAPEROUT                 fixed bin(31) value('00000040'xn);
 dcl ADS_JOB_PRINTED                  fixed bin(31) value('00000080'xn);
 dcl ADS_JOB_DELETED                  fixed bin(31) value('00000100'xn);

 /*                       */
 /* service status values */
 /*                       */

 dcl ADS_SERVICE_STOPPED              fixed bin(31) value('00000001'xn);
 dcl ADS_SERVICE_START_PENDING	       fixed bin(31) value('00000002'xn);
 dcl ADS_SERVICE_STOP_PENDING         fixed bin(31) value('00000003'xn);
 dcl ADS_SERVICE_RUNNING	             fixed bin(31) value('00000004'xn);
 dcl ADS_SERVICE_CONTINUE_PENDING     fixed bin(31) value('00000005'xn);
 dcl ADS_SERVICE_PAUSE_PENDING	       fixed bin(31) value('00000006'xn);
 dcl ADS_SERVICE_PAUSED               fixed bin(31) value('00000007'xn);
 dcl ADS_SERVICE_ERROR                fixed bin(31) value('00000008'xn);

 /*-----------------------------------------------------------------  */

 /*                           */
 /* Service Type Valid Values */
 /*                           */

 dcl ADS_SERVICE_OWN_PROCESS          fixed bin(31) value('00000010'xn);
 dcl ADS_SERVICE_SHARE_PROCESS        fixed bin(31) value('00000020'xn);
 dcl ADS_SERVICE_KERNEL_DRIVER        fixed bin(31) value('00000001'xn);
 dcl ADS_SERVICE_FILE_SYSTEM_DRIVER   fixed bin(31) value('00000002'xn);

 /*                         */
 /* Start Type Valid Values */
 /*                         */

 dcl ADS_SERVICE_BOOT_START   fixed bin(31) value(SERVICE_BOOT_START);
 dcl ADS_SERVICE_SYSTEM_START fixed bin(31) value(SERVICE_SYSTEM_START);
 dcl ADS_SERVICE_AUTO_START   fixed bin(31) value(SERVICE_AUTO_START);
 dcl ADS_SERVICE_DEMAND_START fixed bin(31) value(SERVICE_DEMAND_START);
 dcl ADS_SERVICE_DISABLED     fixed bin(31) value(SERVICE_DISABLED);

 /*                      */
 /* Error Control Values */
 /*                      */

 dcl ADS_SERVICE_ERROR_IGNORE         fixed bin(31) value(0);
 dcl ADS_SERVICE_ERROR_NORMAL         fixed bin(31) value(1);
 dcl ADS_SERVICE_ERROR_SEVERE         fixed bin(31) value(2);
 dcl ADS_SERVICE_ERROR_CRITICAL       fixed bin(31) value(3);

