 /*********************************************************************/
 /* Copyright (c) Wonderware Software Development Corp. 1991-1993.    */
 /*               All Rights Reserved.                                */
 /* Copyright (c) Microsoft Inc. 1995-1997                            */
 /*               All Rights Reserved.                                */
 /*********************************************************************/

 %dcl #INC_NDDEAPI char ext;
 %if #INC_NDDEAPI = '' %then %do;
 %dcl #INC_NDDEAPI char ext;
 %#INC_NDDEAPI = 'Y';

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;

 %dcl UNICODE char ext;


 %dcl #CNLEN char ext;
 %if #CNLEN = '' %then %do;
 %#CNLEN = 'Y';
 dcl CNLEN  fixed bin(31) value(15);      /* Computer name length     */
 dcl UNCLEN fixed bin(31) value(CNLEN+2); /* UNC computer name length */
 %end; /* #CNLEN */

 /* the choice of this char affects legal share,topic, etc. names */
 dcl SEP_CHAR  char  value(',');
 dcl BAR_CHAR  char  value('|');

 dcl SEP_WCHAR WCHAR value(',');
 dcl BAR_WCHAR WCHAR value('|');


 /* API error codes  */
 dcl NDDE_NO_ERROR                fixed bin(31) value(0);
 dcl NDDE_ACCESS_DENIED           fixed bin(31) value(1);
 dcl NDDE_BUF_TOO_SMALL           fixed bin(31) value(2);
 dcl NDDE_ERROR_MORE_DATA         fixed bin(31) value(3);
 dcl NDDE_INVALID_SERVER          fixed bin(31) value(4);
 dcl NDDE_INVALID_SHARE           fixed bin(31) value(5);
 dcl NDDE_INVALID_PARAMETER       fixed bin(31) value(6);
 dcl NDDE_INVALID_LEVEL           fixed bin(31) value(7);
 dcl NDDE_INVALID_PASSWORD        fixed bin(31) value(8);
 dcl NDDE_INVALID_ITEMNAME        fixed bin(31) value(9);
 dcl NDDE_INVALID_TOPIC           fixed bin(31) value(10);
 dcl NDDE_INTERNAL_ERROR          fixed bin(31) value(11);
 dcl NDDE_OUT_OF_MEMORY           fixed bin(31) value(12);
 dcl NDDE_INVALID_APPNAME         fixed bin(31) value(13);
 dcl NDDE_NOT_IMPLEMENTED         fixed bin(31) value(14);
 dcl NDDE_SHARE_ALREADY_EXIST     fixed bin(31) value(15);
 dcl NDDE_SHARE_NOT_EXIST         fixed bin(31) value(16);
 dcl NDDE_INVALID_FILENAME        fixed bin(31) value(17);
 dcl NDDE_NOT_RUNNING             fixed bin(31) value(18);
 dcl NDDE_INVALID_WINDOW          fixed bin(31) value(19);
 dcl NDDE_INVALID_SESSION         fixed bin(31) value(20);
 dcl NDDE_INVALID_ITEM_LIST       fixed bin(31) value(21);
 dcl NDDE_SHARE_DATA_CORRUPTED    fixed bin(31) value(22);
 dcl NDDE_REGISTRY_ERROR          fixed bin(31) value(23);
 dcl NDDE_CANT_ACCESS_SERVER      fixed bin(31) value(24);
 dcl NDDE_INVALID_SPECIAL_COMMAND fixed bin(31) value(25);
 dcl NDDE_INVALID_SECURITY_DESC   fixed bin(31) value(26);
 dcl NDDE_TRUST_SHARE_FAIL        fixed bin(31) value(27);

 /* string size constants */
 dcl MAX_NDDESHARENAME            fixed bin(31) value(256);
 dcl MAX_DOMAINNAME               fixed bin(31) value(15);
 dcl MAX_USERNAME                 fixed bin(31) value(15);
 dcl MAX_APPNAME                  fixed bin(31) value(255);
 dcl MAX_TOPICNAME                fixed bin(31) value(255);
 dcl MAX_ITEMNAME                 fixed bin(31) value(255);

 /* connectFlags bits for ndde service affix */
 dcl NDDEF_NOPASSWORDPROMPT       fixed bin(15) value('0001'xn);
 dcl NDDEF_NOCACHELOOKUP          fixed bin(15) value('0002'xn);
 dcl NDDEF_STRIP_NDDE             fixed bin(15) value('0004'xn);


 /* NDDESHAREINFO - contains information about a NDDE share */

 define structure
   1 NDDESHAREINFO,
     2 lRevision        type LONG,
     2 lpszShareName    type LPTSTR,
     2 lShareType       type LONG,
     2 lpszAppTopicList type LPTSTR,
     2 fSharedFlag      type LONG,
     2 fService         type LONG,
     2 fStartAppFlag    type LONG,
     2 nCmdShow         type LONG,
     2 qModifyId (2)    type LONG,
     2 cNumItems        type LONG,
     2 lpszItemList     type LPTSTR;
 define alias PNDDESHAREINFO handle NDDESHAREINFO;

 /*  Share Types */
 dcl SHARE_TYPE_OLD    fixed bin(15) value('01'xn);
     /* Excel|sheet1.xls */
 dcl SHARE_TYPE_NEW    fixed bin(15) value('02'xn);
     /* ExcelWorksheet|sheet1.xls */
 dcl SHARE_TYPE_STATIC fixed bin(15) value('04'xn);
     /* ClipSrv|SalesData */

 /* Add new share */
 dcl NDdeShareAddA
     entry (char (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            type UINT,   /* info level must be 2 */
            type PSECURITY_DESCRIPTOR,
                         /* initial security descriptor (optional) */
            type LPBYTE, /* contains (NDDESHAREINFO) + data */
            type DWORD)  /* size of supplied buffer */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeShareAddA');

 dcl NDdeShareAddW
     entry (WCHAR (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            type UINT,   /* info level must be 2 */
            type PSECURITY_DESCRIPTOR,
                         /* initial security descriptor (optional) */
            type LPBYTE, /* contains (NDDESHAREINFO) + data */
            type DWORD)  /* sizeof supplied buffer */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeShareAddW');

 /* Delete a share */
 dcl NDdeShareDelA
     entry (char (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            char (*) varz byaddr, /* name of share to delete */
            type UINT)   /* reserved for force level (?) 0 for now */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeShareDelA');

 dcl NDdeShareDelW
     entry (WCHAR (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            WCHAR (*) varz byaddr, /* name of share to delete */
            type UINT)   /* reserved for force level (?) 0 for now */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeShareDelW');

 /* Get Share Security Descriptor */

 dcl NDdeGetShareSecurityA
     entry (char (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            char (*) varz byaddr, /* name of share */
            type SECURITY_INFORMATION, /* requested information */
            type PSECURITY_DESCRIPTOR,
                         /* address of security descriptor */
            type DWORD,  /* size of buffer for security descriptor */
            type DWORD byaddr)/* address of required size of buffer */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeGetShareSecurityA');

 dcl NDdeGetShareSecurityW
     entry (WCHAR (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            WCHAR (*) varz byaddr, /* name of share */
            type SECURITY_INFORMATION, /* requested information */
            type PSECURITY_DESCRIPTOR,
                         /* address of security descriptor */
            type DWORD,  /* size of buffer for security descriptor */
            type DWORD byaddr)/* address of required size of buffer */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeGetShareSecurityW');

 /* Set Share Security Descriptor */

 dcl NDdeSetShareSecurityA
     entry (char (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            char (*) varz byaddr, /* name of share */
            type SECURITY_INFORMATION, /* type of information to set */
            type PSECURITY_DESCRIPTOR)
                         /* address of security descriptor */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeSetShareSecurityA');

 dcl NDdeSetShareSecurityW
     entry (WCHAR (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            WCHAR (*) varz byaddr, /* name of share */
            type SECURITY_INFORMATION, /* type of information to set */
            type PSECURITY_DESCRIPTOR)
                         /* address of security descriptor */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeSetShareSecurityW');

 /* Enumerate shares */
 dcl NDdeShareEnumA
     entry (char (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            type UINT,   /* 0 for null separated 00 terminated list */
            type LPBYTE, /* pointer to buffer */
            type DWORD,  /* size of buffer */
            type DWORD byaddr, /* number of names returned */
            type DWORD byaddr) /* number of bytes available */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeShareEnumA');

 dcl NDdeShareEnumW
     entry (WCHAR (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            type UINT,   /* 0 for null separated 00 terminated list */
            type LPBYTE, /* pointer to buffer */
            type DWORD,  /* size of buffer */
            type DWORD byaddr, /* number of names returned */
            type DWORD byaddr) /* number of bytes available */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeShareEnumW');

 /* Get information on a share */
 dcl NDdeShareGetInfoA
     entry (char (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            char (*) varz byaddr, /* name of share */
            type UINT,   /* info level must be 2 */
            type LPBYTE, /* gets struc containing NDDESHAREINFO + data*/
            type DWORD,  /* sizeof buffer */
            type DWORD byaddr,/* number of bytes available */
            type WORD  byaddr)
                         /* item mask for partial getinfo (must be 0) */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeShareGetInfoA');

 dcl NDdeShareGetInfoW
     entry (WCHAR (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            WCHAR (*) varz byaddr, /* name of share */
            type UINT,   /* info level must be 2 */
            type LPBYTE, /* gets struc containing NDDESHAREINFO + data*/
            type DWORD,  /* sizeof buffer */
            type DWORD byaddr,/* number of bytes available */
            type WORD  byaddr)
                         /* item mask for partial getinfo (must be 0) */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeShareGetInfoW');

 /* Modify DDE share data */
 dcl NDdeShareSetInfoA
     entry (char (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            char (*) varz byaddr, /* name of share */
            type UINT,   /* info level must be 2 */
            type LPBYTE, /* points to struct with NDDESHAREINFO + data*/
            type DWORD,  /* size of buffer */
            type WORD)   /* Parameter index ( must be 0 - entire ) */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeShareSetInfoA');

 dcl NDdeShareSetInfoW
     entry (WCHAR (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            WCHAR (*) varz byaddr, /* name of share */
            type UINT,   /* info level must be 2 */
            type LPBYTE, /* points to struct with NDDESHAREINFO + data*/
            type DWORD,  /* sizeof buffer */
            type WORD)   /* Parameter index ( must be 0 - entire ) */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeShareSetInfoW');

 /* Set/Create a trusted share */

 dcl NDdeSetTrustedShareA
     entry (char (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            char (*) varz byaddr, /* name of share */
            type DWORD)  /* trust options to apply */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeSetTrustedShareA');

 dcl NDdeSetTrustedShareW
     entry (WCHAR (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            WCHAR (*) varz byaddr, /* name of share */
            type DWORD)  /* trust options to apply */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeSetTrustedShareW');

 /*  Trusted share options       */
 dcl NDDE_TRUST_SHARE_START fixed bin(31) value('80000000'xn);
     /* Start App Allowed */
 dcl NDDE_TRUST_SHARE_INIT  fixed bin(31) value('40000000'xn);
     /* Init Conv Allowed */
 dcl NDDE_TRUST_SHARE_DEL   fixed bin(31) value('20000000'xn);
     /* Delete Trusted Share (on set) */
 dcl NDDE_TRUST_CMD_SHOW    fixed bin(31) value('10000000'xn);
     /* Use supplied cmd show */
 dcl NDDE_CMD_SHOW_MASK     fixed bin(31) value('0000FFFF'xn);
     /* Command Show mask */

 /* Get a trusted share options */

 dcl NDdeGetTrustedShareA
     entry (char (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            char (*) varz byaddr,  /* name of share to query */
            type DWORD byaddr, /* trust options in effect */
            type DWORD byaddr, /* first word of share mod id */
            type DWORD byaddr) /* second word of share mod id */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeGetTrustedShareA');

 dcl NDdeGetTrustedShareW
     entry (WCHAR (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            WCHAR (*) varz byaddr, /* name of share to query */
            type DWORD byaddr, /* trust options in effect */
            type DWORD byaddr, /* first word of share mod id */
            type DWORD byaddr) /* second word of share mod id */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeGetTrustedShareW');


 /*  Enumerate trusted shares */
 dcl NDdeTrustedShareEnumA
     entry (char (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            type UINT,   /*  0 for null separated 00 terminated list */
            type LPBYTE, /* pointer to buffer */
            type DWORD,  /* size of buffer */
            type DWORD byaddr, /* number of names returned */
            type DWORD byaddr) /* number of bytes available */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeTrustedShareEnumA');

 dcl NDdeTrustedShareEnumW
     entry (WCHAR (*) varz byaddr optional,
                         /* server to execute on ( must be * ) */
            type UINT,   /*  0 for null separated 00 terminated list */
            type LPBYTE, /* pointer to buffer */
            type DWORD,  /* size of buffer */
            type DWORD byaddr, /* number of names returned */
            type DWORD byaddr) /* number of bytes available */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeTrustedShareEnumW');

 /* Convert error code to string value */
 dcl NDdeGetErrorStringA
     entry (type UINT,  /* Error code to get string for */
            char (*) varz byaddr, /* buffer to hold error string */
            type DWORD) /* sizeof buffer */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeGetErrorStringA');

 dcl NDdeGetErrorStringW  entry (
            type UINT,  /* Error code to get string for */
            WCHAR (*) varz byaddr,/* buffer to hold error string */
            type DWORD) /* sizeof buffer */
     returns (type UINT byvalue optional)
     WINAPI external('NDdeGetErrorStringW');

 /* Validate share name format */
 dcl NDdeIsValidShareNameA
     entry (char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('NDdeIsValidShareNameA');

 dcl NDdeIsValidShareNameW
     entry (WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('NDdeIsValidShareNameW');

 /* Validate application/topic list format */
 dcl NDdeIsValidAppTopicListA
     entry (char (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('NDdeIsValidAppTopicListA');

 dcl NDdeIsValidAppTopicListW
     entry (WCHAR (*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('NDdeIsValidAppTopicListW');

 %dcl NDdeShareAdd            char ext;
 %dcl NDdeShareDel            char ext;
 %dcl NDdeSetShareSecurity    char ext;
 %dcl NDdeGetShareSecurity    char ext;
 %dcl NDdeShareEnum           char ext;
 %dcl NDdeShareGetInfo        char ext;
 %dcl NDdeShareSetInfo        char ext;
 %dcl NDdeGetErrorString      char ext;
 %dcl NDdeIsValidShareName    char ext;
 %dcl NDdeIsValidAppTopicList char ext;
 %dcl NDdeSetTrustedShare     char ext;
 %dcl NDdeGetTrustedShare     char ext;
 %dcl NDdeTrustedShareEnum    char ext;
 %if UNICODE ^= '' %then %do;
 %NDdeShareAdd            = 'NDdeShareAddW';
 %NDdeShareDel            = 'NDdeShareDelW';
 %NDdeSetShareSecurity    = 'NDdeSetShareSecurityW';
 %NDdeGetShareSecurity    = 'NDdeGetShareSecurityW';
 %NDdeShareEnum           = 'NDdeShareEnumW';
 %NDdeShareGetInfo        = 'NDdeShareGetInfoW';
 %NDdeShareSetInfo        = 'NDdeShareSetInfoW';
 %NDdeGetErrorString      = 'NDdeGetErrorStringW';
 %NDdeIsValidShareName    = 'NDdeIsValidShareNameW';
 %NDdeIsValidAppTopicList = 'NDdeIsValidAppTopicListW';
 %NDdeSetTrustedShare     = 'NDdeSetTrustedShareW';
 %NDdeGetTrustedShare     = 'NDdeGetTrustedShareW';
 %NDdeTrustedShareEnum    = 'NDdeTrustedShareEnumW';
 %end; %else %do;
 %NDdeShareAdd            = 'NDdeShareAddA';
 %NDdeShareDel            = 'NDdeShareDelA';
 %NDdeSetShareSecurity    = 'NDdeSetShareSecurityA';
 %NDdeGetShareSecurity    = 'NDdeGetShareSecurityA';
 %NDdeShareEnum           = 'NDdeShareEnumA';
 %NDdeShareGetInfo        = 'NDdeShareGetInfoA';
 %NDdeShareSetInfo        = 'NDdeShareSetInfoA';
 %NDdeGetErrorString      = 'NDdeGetErrorStringA';
 %NDdeIsValidShareName    = 'NDdeIsValidShareNameA';
 %NDdeIsValidAppTopicList = 'NDdeIsValidAppTopicListA';
 %NDdeSetTrustedShare     = 'NDdeSetTrustedShareA';
 %NDdeGetTrustedShare     = 'NDdeGetTrustedShareA';
 %NDdeTrustedShareEnum    = 'NDdeTrustedShareEnumA';
 %end;

 %end; /* _INC_NDDEAPI */

