 /*-------------------------------------------------------------------*/
 /*   ODBCInst.cpy -- Prototypes for ODBCCP32.DLL                     */
 /*                                                                   */
 /*   (c) Microsoft Corp., 1990-1996                                  */
 /*-------------------------------------------------------------------*/

 %dcl #_ODBCINST_H char ext;
 %if #_ODBCINST_H = '' %then %do;
 %#_ODBCINST_H = 'Y';

 /* in contrast to the ODBC Usage include files, */
 /* this include file requires the basic windows type definitions */
 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;

 %dcl #_SQL char ext;
 %if #_SQL = '' %then %do;
 %include odbcsql;
 %end;

 %dcl SQL_NOUNICODEMAP char ext; /* set to 'Y' to disable the mapping */
 %dcl UNICODE char ext;


 /* Constants --------------------------------------------------------*/

 /* SQLConfigDataSource request flags */
 dcl ODBC_ADD_DSN            fixed bin(31) value(1);
     /* Add data source */
 dcl ODBC_CONFIG_DSN         fixed bin(31) value(2);
     /* Configure (edit) data source */
 dcl ODBC_REMOVE_DSN         fixed bin(31) value(3);
     /* Remove data source */

 %if (ODBCVER >= '0250'x) %then %do;
 dcl ODBC_ADD_SYS_DSN        fixed bin(31) value(4);
     /* add a system DSN */
 dcl ODBC_CONFIG_SYS_DSN     fixed bin(31) value(5);
     /* Configure a system DSN */
 dcl ODBC_REMOVE_SYS_DSN     fixed bin(31) value(6);
     /* remove a system DSN */

 %if (ODBCVER >= '0300'x) %then %do;
 dcl ODBC_REMOVE_DEFAULT_DSN fixed bin(31) value(7);
     /* remove the default DSN */
 %end; /* ODBCVER >= 0x0300 */

 /* install request flags */
 dcl ODBC_INSTALL_INQUIRY    fixed bin(31) value(1);
 dcl ODBC_INSTALL_COMPLETE   fixed bin(31) value(2);

 /* config driver flags */
 dcl ODBC_INSTALL_DRIVER     fixed bin(31) value(1);
 dcl ODBC_REMOVE_DRIVER      fixed bin(31) value(2);
 dcl ODBC_CONFIG_DRIVER      fixed bin(31) value(3);
 dcl ODBC_CONFIG_DRIVER_MAX  fixed bin(31) value(100);
 %end;

 /* SQLGetConfigMode and SQLSetConfigMode flags */

 %if (ODBCVER >= '0300'x) %then %do;
 dcl ODBC_BOTH_DSN           fixed bin(31) value(0);
 dcl ODBC_USER_DSN           fixed bin(31) value(1);
 dcl ODBC_SYSTEM_DSN         fixed bin(31) value(2);
 %end;  /* ODBCVER >= 0x0300 */

 /* SQLInstallerError code */

 %if (ODBCVER >= '0300'x) %then %do;
 dcl ODBC_ERROR_GENERAL_ERR             fixed bin(31) value(1);
 dcl ODBC_ERROR_INVALID_BUFF_LEN        fixed bin(31) value(2);
 dcl ODBC_ERROR_INVALID_HWND            fixed bin(31) value(3);
 dcl ODBC_ERROR_INVALID_STR             fixed bin(31) value(4);
 dcl ODBC_ERROR_INVALID_REQUEST_TYPE    fixed bin(31) value(5);
 dcl ODBC_ERROR_COMPONENT_NOT_FOUND     fixed bin(31) value(6);
 dcl ODBC_ERROR_INVALID_NAME            fixed bin(31) value(7);
 dcl ODBC_ERROR_INVALID_KEYWORD_VALUE   fixed bin(31) value(8);
 dcl ODBC_ERROR_INVALID_DSN             fixed bin(31) value(9);
 dcl ODBC_ERROR_INVALID_INF             fixed bin(31) value(10);
 dcl ODBC_ERROR_REQUEST_FAILED          fixed bin(31) value(11);
 dcl ODBC_ERROR_INVALID_PATH            fixed bin(31) value(12);
 dcl ODBC_ERROR_LOAD_LIB_FAILED         fixed bin(31) value(13);
 dcl ODBC_ERROR_INVALID_PARAM_SEQUENCE  fixed bin(31) value(14);
 dcl ODBC_ERROR_INVALID_LOG_FILE        fixed bin(31) value(15);
 dcl ODBC_ERROR_USER_CANCELED           fixed bin(31) value(16);
 dcl ODBC_ERROR_USAGE_UPDATE_FAILED     fixed bin(31) value(17);
 dcl ODBC_ERROR_CREATE_DSN_FAILED       fixed bin(31) value(18);
 dcl ODBC_ERROR_WRITING_SYSINFO_FAILED  fixed bin(31) value(19);
 dcl ODBC_ERROR_REMOVE_DSN_FAILED       fixed bin(31) value(20);
 dcl ODBC_ERROR_OUT_OF_MEM              fixed bin(31) value(21);
 dcl ODBC_ERROR_OUTPUT_STRING_TRUNCATED fixed bin(31) value(22);
 %end; /* ODBCVER >= 0x0300 */

 /* Prototypes -------------------------------------------------------*/

 %dcl INSTAPI char ext;
 %INSTAPI='options(linkage(stdcall) byvalue nodescriptor)';


 /* High level APIs */

 dcl SQLInstallODBC
     entry (type HWND,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallODBC');

 dcl SQLManageDataSources
     entry (type HWND)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLManageDataSources');

 dcl SQLCreateDataSource
     entry (type HWND,
            char (*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLCreateDataSource');

 dcl SQLGetTranslator
     entry (type HWND,
            char (*) varz byaddr,
            type WORD,
            type WORD byaddr optional,
            char(*) varz byaddr,
            type WORD,
            type WORD byaddr optional,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLGetTranslator');

 /* Low level APIs                                              */
 /* NOTE: The high-level APIs should always be used. These APIs */
 /*       have been left for compatibility.                     */

 dcl SQLInstallDriver
     entry (type LPCSTR, /* nul-terminated concat of char(*) varz */
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr,
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallDriver');

 dcl SQLInstallDriverManager
     entry (char (*) varz byaddr,
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallDriverManager');

 dcl SQLGetInstalledDrivers
     entry (type LPSTR, /* nul-terminated concat of char(*) varz */
            type WORD,
            type WORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLGetInstalledDrivers');

 dcl SQLGetAvailableDrivers
     entry (char (*) varz byaddr nonasgn,
            type LPSTR, /* nul-terminated concat of char(*) varz */
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLGetAvailableDrivers');

 dcl SQLConfigDataSource
     entry (type HWND,
            type WORD,
            char (*) varz byaddr nonasgn,
            type LPCSTR) /* nul-terminated concat of char(*) varz */
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLConfigDataSource');

 dcl SQLRemoveDefaultDataSource
     entry ()
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLRemoveDefaultDataSource');

 dcl SQLWriteDSNToIni
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLWriteDSNToIni');

 dcl SQLRemoveDSNFromIni
     entry (char (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLRemoveDSNFromIni');

 dcl SQLValidDSN
     entry (char (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLValidDSN');

 dcl SQLWritePrivateProfileString
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLWritePrivateProfileString');

 dcl SQLGetPrivateProfileString
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            fixed bin(31),
            char (*) varz byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     INSTAPI external('SQLGetPrivateProfileString');

 %if (ODBCVER >= '0250'x) %then %do;
 dcl SQLRemoveDriverManager
     entry (type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLRemoveDriverManager');

  dcl SQLInstallTranslator
     entry (char (*) varz byaddr nonasgn,
            type LPCSTR,  /* nul-terminated concat of char(*) varz */
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr,
            type WORD,
            type WORD byaddr optional,
            type WORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallTranslator');

 dcl SQLRemoveTranslator
     entry (char (*) varz byaddr nonasgn,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLRemoveTranslator');

 dcl SQLRemoveDriver
     entry (char (*) varz byaddr nonasgn,
            type BOOL,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLRemoveDriver');

 dcl SQLConfigDriver
     entry (type HWND,
            type WORD,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLConfigDriver');
 %end;

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLInstallerError
     entry (type WORD,
            type DWORD byaddr,
            char (*) varz byaddr,
            type WORD,
            type WORD byaddr optional)
     returns (type SQLRETURN byvalue optional)
     INSTAPI external('SQLInstallerError');

 dcl SQLPostInstallerError
     entry (type DWORD,
            char (*) varz byaddr nonasgn)
     returns (type SQLRETURN byvalue optional)
     INSTAPI external('SQLPostInstallerError');

 dcl SQLWriteFileDSN
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLWriteFileDSN');

 dcl SQLReadFileDSN
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            type LPSTR, /* may be nul-term'ed concat of char(*) varz */
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLReadFileDSN');

 dcl SQLInstallDriverEx
     entry (type LPCSTR, /* nul-terminated concat of char(*) varz */
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type WORD,
            type WORD byaddr optional,
            type WORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallDriverEx');

 dcl SQLInstallTranslatorEx
     entry (type LPCSTR, /* nul-terminated concat of char(*) varz */
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr optional,
            type WORD,
            type WORD byaddr optional,
            type WORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallTranslatorEx');

 dcl SQLGetConfigMode
     entry (type UWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLGetConfigMode');

 dcl SQLSetConfigMode
     entry (type UWORD)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLSetConfigMode');
 %end; /* ODBCVER >= 0x0300 */

 /* Driver specific Setup APIs called by installer */

 dcl ConfigDSN
     entry (type HWND,
            type WORD,
            char (*) varz byaddr nonasgn,
            type LPCSTR) /* nul-terminated concat of char(*) varz */
     returns (type BOOL byvalue optional)
     INSTAPI external('ConfigDSN');

 dcl ConfigTranslator
     entry (type HWND,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('ConfigTranslator');

 %if (ODBCVER >= '0250'x) %then %do;
 dcl ConfigDriver
     entry (type HWND,
            type WORD,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('ConfigDriver');
 %end;


 /* UNICODE APIs */

 /* High level APIs */
 dcl SQLInstallODBCW
     entry (type HWND,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallODBCW');

 dcl SQLCreateDataSourceW
     entry (type HWND,
            WCHAR (*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLCreateDataSourceW');

 dcl SQLGetTranslatorW
     entry (type HWND,
            WCHAR (*) varz byaddr,
            type WORD,
            type WORD byaddr optional,
            WCHAR(*) varz byaddr,
            type WORD,
            type WORD byaddr optional,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLGetTranslatorW');

 /* Low level APIs */
 /* NOTE: The high-level APIs should always be used. These APIs */
 /*       have been left for compatibility. */

 dcl SQLInstallDriverW
     entry (type LPCWSTR, /* nul-terminated concat of wchar(*) varz */
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr,
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallDriverW');

 dcl SQLInstallDriverManagerW
     entry (WCHAR (*) varz byaddr,
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallDriverManagerW');

 dcl SQLGetInstalledDriversW
     entry (type LPWSTR, /* nul-terminated concat of wchar(*) varz */
            type WORD,
            type WORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLGetInstalledDriversW');

 dcl SQLGetAvailableDriversW
     entry (WCHAR (*) varz byaddr nonasgn,
            type LPWSTR, /* nul-terminated concat of wchar(*) varz */
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLGetAvailableDriversW');

 dcl SQLConfigDataSourceW
     entry (type HWND,
            type WORD,
            WCHAR (*) varz byaddr nonasgn,
            type LPCWSTR) /* nul-terminated concat of wchar(*) varz */
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLConfigDataSourceW');

 dcl SQLWriteDSNToIniW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLWriteDSNToIniW');

 dcl SQLRemoveDSNFromIniW
     entry (WCHAR (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLRemoveDSNFromIniW');

 dcl SQLValidDSNW
     entry (WCHAR (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLValidDSNW');

 dcl SQLWritePrivateProfileStringW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLWritePrivateProfileStringW');

 dcl SQLGetPrivateProfileStringW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            fixed bin(31),
            WCHAR (*) varz byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     INSTAPI external('SQLGetPrivateProfileStringW');


 %if (ODBCVER >= '0250'x) %then %do;
 dcl SQLInstallTranslatorW
     entry (WCHAR (*) varz byaddr nonasgn,
            type LPCWSTR,  /* nul-terminated concat of wchar(*) varz */
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr,
            type WORD,
            type WORD byaddr optional,
            type WORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallTranslatorW');

 dcl SQLRemoveTranslatorW
     entry (WCHAR (*) varz byaddr nonasgn,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLRemoveTranslatorW');

 dcl SQLRemoveDriverW
     entry (WCHAR (*) varz byaddr nonasgn,
            type BOOL,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLRemoveDriverW');

 dcl SQLConfigDriverW
     entry (type HWND,
            type WORD,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLConfigDriverW');
 %end;


 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLInstallerErrorW
     entry (type WORD,
            type DWORD byaddr,
            WCHAR (*) varz byaddr,
            type WORD,
            type WORD byaddr optional)
     returns (type SQLRETURN byvalue optional)
     INSTAPI external('SQLInstallerErrorW');

 dcl SQLPostInstallerErrorW
     entry (type DWORD,
            WCHAR (*) varz byaddr nonasgn)
     returns (type SQLRETURN byvalue optional)
     INSTAPI external('SQLPostInstallerErrorW');

 dcl SQLWriteFileDSNW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLWriteFileDSNW');

 dcl SQLReadFileDSNW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type LPWSTR, /* may be nul-term'ed concat of wchar(*) varz*/
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLReadFileDSNW');

 dcl SQLInstallDriverExW
     entry (type LPCWSTR, /* nul-terminated concat of wchar(*) varz */
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type WORD,
            type WORD byaddr optional,
            type WORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallDriverExW');

 dcl SQLInstallTranslatorExW
     entry (type LPCWSTR, /* nul-terminated concat of wchar(*) varz */
            wCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr optional,
            type WORD,
            type WORD byaddr optional,
            type WORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     INSTAPI external('SQLInstallTranslatorExW');
 %end; /* ODBCVER >= 0x0300 */

 /* Driver specific Setup APIs called by installer */

 dcl ConfigDSNW
     entry (type HWND,
            type WORD,
            WCHAR (*) varz byaddr nonasgn,
            type LPCWSTR) /* nul-terminated concat of wchar(*) varz */
     returns (type BOOL byvalue optional)
     INSTAPI external('ConfigDSNW');

 %if (ODBCVER >= '0250'x) %then %do;
 dcl ConfigDriverW
     entry (type HWND,
            type WORD,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type WORD,
            type WORD byaddr optional)
     returns (type BOOL byvalue optional)
     INSTAPI external('ConfigDriverW');
 %end;

 %if SQL_NOUNICODEMAP = '' %then %do;
 %if UNICODE ^= '' %then %do;

 %dcl SQLInstallODBC               char ext;
 %SQLInstallODBC                 = 'SQLInstallODBCW';
 %dcl SQLCreateDataSource          char ext;
 %SQLCreateDataSource            = 'SQLCreateDataSourceW';
 %dcl SQLGetTranslator             char ext;
 %SQLGetTranslator               = 'SQLGetTranslatorW';
 %dcl SQLInstallDriver             char ext;
 %SQLInstallDriver               = 'SQLInstallDriverW';
 %dcl SQLInstallDriverManager      char ext;
 %SQLInstallDriverManager        = 'SQLInstallDriverManagerW';
 %dcl SQLGetInstalledDrivers       char ext;
 %SQLGetInstalledDrivers         = 'SQLGetInstalledDriversW';
 %dcl SQLGetAvailableDrivers       char ext;
 %SQLGetAvailableDrivers         = 'SQLGetAvailableDriversW';
 %dcl SQLConfigDataSource          char ext;
 %SQLConfigDataSource            = 'SQLConfigDataSourceW';
 %dcl SQLWriteDSNToIni             char ext;
 %SQLWriteDSNToIni               = 'SQLWriteDSNToIniW';
 %dcl SQLRemoveDSNFromIni          char ext;
 %SQLRemoveDSNFromIni            = 'SQLRemoveDSNFromIniW';
 %dcl SQLValidDSN                  char ext;
 %SQLValidDSN                    = 'SQLValidDSNW';
 %dcl SQLWritePrivateProfileString char ext;
 %SQLWritePrivateProfileString   = 'SQLWritePrivateProfileStringW';
 %dcl SQLGetPrivateProfileString   char ext;
 %SQLGetPrivateProfileString     = 'SQLGetPrivateProfileStringW';
 %dcl SQLInstallTranslator         char ext;
 %SQLInstallTranslator           = 'SQLInstallTranslatorW';
 %dcl SQLRemoveTranslator          char ext;
 %SQLRemoveTranslator            = 'SQLRemoveTranslatorW';
 %dcl SQLRemoveDriver              char ext;
 %SQLRemoveDriver                = 'SQLRemoveDriverW';
 %dcl SQLConfigDriver              char ext;
 %SQLConfigDriver                = 'SQLConfigDriverW';
 %dcl SQLInstallerError            char ext;
 %SQLInstallerError              = 'SQLInstallerErrorW';
 %dcl SQLPostInstallerError        char ext;
 %SQLPostInstallerError          = 'SQLPostInstallerErrorW';
 %dcl SQLReadFileDSN               char ext;
 %SQLReadFileDSN                 = 'SQLReadFileDSNW';
 %dcl SQLWriteFileDSN              char ext;
 %SQLWriteFileDSN                = 'SQLWriteFileDSNW';
 %dcl SQLInstallDriverEx           char ext;
 %SQLInstallDriverEx             = 'SQLInstallDriverExW';
 %dcl SQLInstallTranslatorEx       char ext;
 %SQLInstallTranslatorEx         = 'SQLInstallTranslatorExW';

 /* WARNING. There are no Unicode mappings for                    */
 /*   ConfigDSN                                                   */
 /*   ConfigTranslator                                            */
 /*   ConfigDriver                                                */
 /* in the original Microsoft header, and so there are none here. */
 /* This may be because they are really only "templates", telling */
 /* the installer developer how to code his DLL entry points.     */

 %end; /* UNICODE */
 %end; /* SQL_NOUNICODEMAP */

 %end; /* __ODBCINST_H */
