 /*****************************************************************/
 /** ODBCUCOD.CPY- This is the unicode include for ODBC functions.*/
 /**             - ODBC V 3.0 Level                               */
 /**                                                              */
 /*****************************************************************/
 /*                                                               */
 /*  Licensed Materials - Property of IBM                         */
 /*  5639-A83, 5639-A24 (C) Copyright IBM Corp. 1998.             */
 /*  All Rights Reserved.                                         */
 /*   (C) Copyright IBM Corp. 1998. All Rights Reserved.          */
 /*   US Government Users Restricted Rights-- Use, duplication or */
 /*   disclosure restricted by GSA ADP Schedule Contract with     */
 /*   IBM Corp.                                                   */
 /*                                                               */
 /* DISCLAIMER OF WARRANTIES                                      */
 /*   The following enclosed code is sample code created by IBM */
 /*   Corporation. This sample code is not part of any standard   */
 /*   IBM product and is provided to you solely for the purpose of*/
 /*   assisting you in the development of your applications.  The */
 /*   code is provided "AS IS", without warranty of any kind.     */
 /*   IBM shall not be liable for any damages arising out of your */
 /*   use of the sample code, even if IBM has been advised of the */
 /*   possibility of such damages.                                */
 /*                                                               */
 /*****************************************************************/

 %dcl #_SQLUCODE char ext;
 %if #_SQLUCODE = '' %then %do;
   %#_SQLUCODE = 'Y';

 %dcl UNICODE char ext;

 %include odbcext;

 dcl SQL_WCHAR          fixed bin(31) value(-8);
 dcl SQL_WVARCHAR       fixed bin(31) value(-9);
 dcl SQL_WLONGVARCHAR   fixed bin(31) value(-10);
 dcl SQL_C_WCHAR        fixed bin(31) value(SQL_WCHAR);

 %if UNICODE ^= '' %then %do;
 dcl SQL_C_TCHAR        fixed bin(31) value(SQL_C_WCHAR);
 %end; %else %do;
 dcl SQL_C_TCHAR        fixed bin(31) value(SQL_C_CHAR);
 %end;

 /* size of SQLSTATE for unicode */
 dcl SQL_SQLSTATE_SIZEW fixed bin(31) value(10);

 /* UNICODE versions */

 dcl SQLColAttributeW entry (
        type SQLHSTMT,
        type SQLSMALLINT,
        type SQLSMALLINT,
        type SQLPOINTER,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        type SQLPOINTER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLColAttributeW');

 dcl SQLColAttributesW entry (
        type SQLHSTMT,
        type SQLUSMALLINT,
        type SQLUSMALLINT,
        type SQLPOINTER,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLColAttributesW');

 dcl SQLConnectW entry (
        type SQLHDBC,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLConnectW');

 dcl SQLDescribeColW entry (
        type SQLHSTMT,
        type SQLUSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr,
        type SQLUINTEGER byaddr,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDescribeColW');

 dcl SQLErrorW entry (
        type SQLHENV,
        type SQLHDBC,
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr,
        type SQLINTEGER byaddr,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLErrorW');

 dcl SQLExecDirectW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr,
        type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLExecDirectW');

 dcl SQLGetConnectAttrW entry (
        type SQLHDBC,
        type SQLINTEGER,
        type SQLPOINTER,
        type SQLINTEGER,
        type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetConnectAttrW');

 dcl SQLGetCursorNameW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetCursorNameW');

 %if (ODBCVER >= '0300'x)  %then %do;
 dcl SQLSetDescFieldW entry (
        type SQLHDESC,
        type SQLSMALLINT,
        type SQLSMALLINT,
        type SQLPOINTER,
        type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetDescFieldW');

 dcl SQLGetDescFieldW entry (
        type SQLHDESC,
        type SQLSMALLINT,
        type SQLSMALLINT,
        type SQLPOINTER,
        type SQLINTEGER,
        type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDescFieldW');

 dcl SQLGetDescRecW entry (
        type SQLHDESC,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr,
        type SQLINTEGER byaddr,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDescRecW');

 dcl SQLGetDiagFieldW entry (
        type SQLSMALLINT,
        type SQLHANDLE,
        type SQLSMALLINT,
        type SQLSMALLINT,
        type SQLPOINTER,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDiagFieldW');

 dcl SQLGetDiagRecW entry (
        type SQLSMALLINT,
        type SQLHANDLE,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLINTEGER byaddr,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDiagRecW');

 %end;

 dcl SQLPrepareW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr,
        type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLPrepareW');

 dcl SQLSetConnectAttrW entry (
        type SQLHDBC,
        type SQLINTEGER,
        type SQLPOINTER,
        type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetConnectAttrW');

 dcl SQLSetCursorNameW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetCursorNameW');

 dcl SQLColumnsW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLColumnsW');

 dcl SQLGetConnectOptionW entry (
        type SQLHDBC,
        type SQLUSMALLINT,
        type SQLPOINTER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetConnectOptionW');

 dcl SQLGetInfoW entry (
        type SQLHDBC,
        type SQLUSMALLINT,
        type SQLPOINTER,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetInfoW');

 dcl SQLGetTypeInfoW entry (
        type SQLHSTMT,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetTypeInfoW');

 dcl SQLSetConnectOptionW entry (
        type SQLHDBC,
        type SQLUSMALLINT,
        type SQLUINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetConnectOptionW');

 dcl SQLSpecialColumnsW entry (
        type SQLHSTMT,
        type SQLUSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLUSMALLINT,
        type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSpecialColumnsW');

 dcl SQLStatisticsW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLUSMALLINT,
        type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLStatisticsW');

 dcl SQLTablesW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLTablesW');

 dcl SQLDataSourcesW entry (
        type SQLHENV,
        type SQLUSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDataSourcesW');

 dcl SQLDriverConnectW entry (
        type SQLHDBC,
        type SQLHWND,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDriverConnectW');

 dcl SQLBrowseConnectW entry (
        type SQLHDBC,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLBrowseConnectW');

 dcl SQLColumnPrivilegesW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLColumnPrivilegesW');

 dcl SQLGetStmtAttrW entry (
        type SQLHSTMT,
        type SQLINTEGER,
        type SQLPOINTER,
        type SQLINTEGER,
        type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetStmtAttrW');

 dcl SQLSetStmtAttrW entry (
        type SQLHSTMT,
        type SQLINTEGER,
        type SQLPOINTER,
        type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetStmtAttrW');

 dcl SQLForeignKeysW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLForeignKeysW');

 dcl SQLNativeSqlW entry (
        type SQLHDBC,
        SQLWCHAR(*) varz byaddr,
        type SQLINTEGER,
        SQLWCHAR(*) varz byaddr,
        type SQLINTEGER,
        type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLNativeSqlW');

 dcl SQLPrimaryKeysW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLPrimaryKeysW');

 dcl SQLProcedureColumnsW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLProcedureColumnsW');

 dcl SQLProceduresW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLProceduresW');

 dcl SQLTablePrivilegesW entry (
        type SQLHSTMT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT,
        SQLWCHAR(*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLTablePrivilegesW');

 dcl SQLDriversW entry (
        type SQLHENV,
        type SQLUSMALLINT,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        SQLWCHAR(*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDriversW');


 /* ANSI versions */

 dcl SQLColAttributeA entry (
        type SQLHSTMT,
        type SQLSMALLINT,
        type SQLSMALLINT,
        type SQLPOINTER,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        type SQLPOINTER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLColAttributeA');

 dcl SQLColAttributesA entry (
        type SQLHSTMT,
        type SQLUSMALLINT,
        type SQLUSMALLINT,
        type SQLPOINTER,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLColAttributesA');

 dcl SQLConnectA entry (
        type SQLHDBC,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLConnectA');

 dcl SQLDescribeColA entry (
        type SQLHSTMT,
        type SQLUSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr,
        type SQLUINTEGER byaddr,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDescribeColA');

 dcl SQLErrorA entry (
        type SQLHENV,
        type SQLHDBC,
        type SQLHSTMT,
        char (*) varz byaddr,
        type SQLINTEGER byaddr,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLErrorA');

 dcl SQLExecDirectA entry (
        type SQLHSTMT,
        char (*) varz byaddr,
        type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLExecDirectA');

 dcl SQLGetConnectAttrA entry (
        type SQLHDBC,
        type SQLINTEGER,
        type SQLPOINTER,
        type SQLINTEGER,
        type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetConnectAttrA');

 dcl SQLGetCursorNameA entry (
        type SQLHSTMT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetCursorNameA');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLGetDescFieldA entry (
        type SQLHDESC,
        type SQLSMALLINT,
        type SQLSMALLINT,
        type SQLPOINTER,
        type SQLINTEGER,
        type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDescFieldA');

 dcl SQLGetDescRecA entry (
        type SQLHDESC,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr,
        type SQLINTEGER byaddr,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDescRecA');

 dcl SQLGetDiagFieldA entry (
        type SQLSMALLINT,
        type SQLHANDLE,
        type SQLSMALLINT,
        type SQLSMALLINT,
        type SQLPOINTER,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDiagFieldA');

 dcl SQLGetDiagRecA entry (
        type SQLSMALLINT,
        type SQLHANDLE,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLINTEGER byaddr,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDiagRecA');

 dcl SQLGetStmtAttrA entry (
        type SQLHSTMT,
        type SQLINTEGER,
        type SQLPOINTER,
        type SQLINTEGER,
        type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetStmtAttrA');

 %end;

 dcl SQLGetTypeInfoA entry (
        type SQLHSTMT,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetTypeInfoA');

 dcl SQLPrepareA entry (
        type SQLHSTMT,
        char (*) varz byaddr,
        type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLPrepareA');

 dcl SQLSetConnectAttrA entry (
        type SQLHDBC,
        type SQLINTEGER,
        type SQLPOINTER,
        type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetConnectAttrA');

 dcl SQLSetCursorNameA entry (
        type SQLHSTMT,
        char (*) varz byaddr,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetCursorNameA');

 dcl SQLColumnsA entry (
        type SQLHSTMT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLColumnsA');

 dcl SQLGetConnectOptionA entry (
        type SQLHDBC,
        type SQLUSMALLINT,
        type SQLPOINTER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetConnectOptionA');

 dcl SQLGetInfoA entry (
        type SQLHDBC,
        type SQLUSMALLINT,
        type SQLPOINTER,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetInfoA');

 dcl SQLGetStmtOptionA entry (
        type SQLHSTMT,
        type SQLUSMALLINT,
        type SQLPOINTER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetStmtOptionA');

 dcl SQLSetConnectOptionA entry (
        type SQLHDBC,
        type SQLUSMALLINT,
        type SQLUINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetConnectOptionA');

 dcl SQLSetStmtOptionA entry (
        type SQLHSTMT,
        type SQLUSMALLINT,
        type SQLUINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetStmtOptionA');

 dcl SQLSpecialColumnsA entry (
        type SQLHSTMT,
        type SQLUSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLUSMALLINT,
        type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSpecialColumnsA');

 dcl SQLStatisticsA entry (
        type SQLHSTMT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLUSMALLINT,
        type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLStatisticsA');

 dcl SQLTablesA entry (
        type SQLHSTMT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLTablesA');

 dcl SQLDataSourcesA entry (
        type SQLHENV,
        type SQLUSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDataSourcesA');

 dcl SQLDriverConnectA entry (
        type SQLHDBC,
        type SQLHWND,
        char (*) varz byaddr,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDriverConnectA');

 dcl SQLBrowseConnectA entry (
        type SQLHDBC,
        char (*) varz byaddr,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLBrowseConnectA');

 dcl SQLColumnPrivilegesA entry (
        type SQLHSTMT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLColumnPrivilegesA');

 dcl SQLDescribeParamA entry (
        type SQLHSTMT,
        type SQLUSMALLINT,
        type SQLSMALLINT byaddr,
        type SQLUINTEGER byaddr,
        type SQLSMALLINT byaddr,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDescribeParamA');

 dcl SQLForeignKeysA entry (
        type SQLHSTMT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLForeignKeysA');

 dcl SQLNativeSqlA entry (
        type SQLHDBC,
        char (*) varz byaddr,
        type SQLINTEGER,
        char (*) varz byaddr,
        type SQLINTEGER,
        type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLNativeSqlA');

 dcl SQLPrimaryKeysA entry (
        type SQLHSTMT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLPrimaryKeysA');

 dcl SQLProcedureColumnsA entry (
        type SQLHSTMT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLProcedureColumnsA');

 dcl SQLProceduresA entry (
        type SQLHSTMT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLProceduresA');

 dcl SQLTablePrivilegesA entry (
        type SQLHSTMT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT,
        char (*) varz byaddr optional,
        type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLTablePrivilegesA');

 dcl SQLDriversA entry (
        type SQLHENV,
        type SQLUSMALLINT,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr,
        char (*) varz byaddr,
        type SQLSMALLINT,
        type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDriversA');


 /*--------------------------------------------- */
 /* Mapping macros for Unicode */
 /*--------------------------------------------- */

 %dcl SQL_NOUNICODEMAP char ext;
 %if SQL_NOUNICODEMAP = '' %then %do;
 %if UNICODE ^= '' %then %do;

 %dcl SQLColAttribute     char ext;
 %SQLColAttribute       = 'SQLColAttributeW';
 %dcl SQLColAttributes    char ext;
 %SQLColAttributes      = 'SQLColAttributesW';
 %dcl SQLConnect          char ext;
 %SQLConnect            = 'SQLConnectW';
 %dcl SQLDescribeCol      char ext;
 %SQLDescribeCol        = 'SQLDescribeColW';
 %dcl SQLError            char ext;
 %SQLError              = 'SQLErrorW';
 %dcl SQLExecDirect       char ext;
 %SQLExecDirect         = 'SQLExecDirectW';
 %dcl SQLGetConnectAttr   char ext;
 %SQLGetConnectAttr     = 'SQLGetConnectAttrW';
 %dcl SQLGetCursorName    char ext;
 %SQLGetCursorName      = 'SQLGetCursorNameW';
 %dcl SQLGetDescField     char ext;
 %SQLGetDescField       = 'SQLGetDescFieldW';
 %dcl SQLGetDescRec       char ext;
 %SQLGetDescRec         = 'SQLGetDescRecW';
 %dcl SQLGetDiagField     char ext;
 %SQLGetDiagField       = 'SQLGetDiagFieldW';
 %dcl SQLGetDiagRec       char ext;
 %SQLGetDiagRec         = 'SQLGetDiagRecW';
 %dcl SQLPrepare          char ext;
 %SQLPrepare            = 'SQLPrepareW';
 %dcl SQLSetConnectAttr   char ext;
 %SQLSetConnectAttr     = 'SQLSetConnectAttrW';
 %dcl SQLSetCursorName    char ext;
 %SQLSetCursorName      = 'SQLSetCursorNameW';
 %dcl SQLSetDescField     char ext;
 %SQLSetDescField       = 'SQLSetDescFieldW';
 %dcl SQLSetStmtAttr      char ext;
 %SQLSetStmtAttr        = 'SQLSetStmtAttrW';
 %dcl SQLGetStmtAttr      char ext;
 %SQLGetStmtAttr        = 'SQLGetStmtAttrW';
 %dcl SQLColumns          char ext;
 %SQLColumns            = 'SQLColumnsW';
 %dcl SQLGetConnectOption char ext;
 %SQLGetConnectOption   = 'SQLGetConnectOptionW';
 %dcl SQLGetInfo          char ext;
 %SQLGetInfo            = 'SQLGetInfoW';
 %dcl SQLGetTypeInfo      char ext;
 %SQLGetTypeInfo        = 'SQLGetTypeInfoW';
 %dcl SQLSetConnectOption char ext;
 %SQLSetConnectOption   = 'SQLSetConnectOptionW';
 %dcl SQLSpecialColumns   char ext;
 %SQLSpecialColumns     = 'SQLSpecialColumnsW';
 %dcl SQLStatistics       char ext;
 %SQLStatistics         = 'SQLStatisticsW';
 %dcl SQLTables           char ext;
 %SQLTables             = 'SQLTablesW';
 %dcl SQLDataSources      char ext;
 %SQLDataSources        = 'SQLDataSourcesW';
 %dcl SQLDriverConnect    char ext;
 %SQLDriverConnect      = 'SQLDriverConnectW';
 %dcl SQLBrowseConnect    char ext;
 %SQLBrowseConnect      = 'SQLBrowseConnectW';
 %dcl SQLColumnPrivileges char ext;
 %SQLColumnPrivileges   = 'SQLColumnPrivilegesW';
 %dcl SQLForeignKeys      char ext;
 %SQLForeignKeys        = 'SQLForeignKeysW';
 %dcl SQLNativeSql        char ext;
 %SQLNativeSql          = 'SQLNativeSqlW';
 %dcl SQLPrimaryKeys      char ext;
 %SQLPrimaryKeys        = 'SQLPrimaryKeysW';
 %dcl SQLProcedureColumns char ext;
 %SQLProcedureColumns   = 'SQLProcedureColumnsW';
 %dcl SQLProcedures       char ext;
 %SQLProcedures         = 'SQLProceduresW';
 %dcl SQLTablePrivileges  char ext;
 %SQLTablePrivileges    = 'SQLTablePrivilegesW';
 %dcl SQLDrivers          char ext;
 %SQLDrivers            = 'SQLDriversW';

 %end; /* UNICODE */
 %end; /* SQL_NOUNICODEMAP */

 %end; /* #ifndef __ SQLUCODE */
