 /*  regstr.h - Registry string definitions                           */
 /*                                                                   */
 /*  This module contains public registry string definitions.         */
 /*                                                                   */
 /*  Copyright (c) 1992-1997 Microsoft Corporation                    */
 /*  Created     12/10/92                                             */
 /*                                                                   */


 %dcl #INC_REGSTR char ext;
 %if #INC_REGSTR = '' %then %do;
 %#INC_REGSTR = 'Y';

 %dcl NEC_98 char ext;


 /* Public registry key names */

 dcl REGSTR_KEY_CLASS       TCHAR value('Class');
     /* child of LOCAL_MACHINE */
 dcl REGSTR_KEY_CONFIG      TCHAR value('Config');
     /* child of LOCAL_MACHINE */
 dcl REGSTR_KEY_ENUM        TCHAR value('Enum');
     /* child of LOCAL_MACHINE */
 dcl REGSTR_KEY_ROOTENUM    TCHAR value('Root');    /* child of ENUM */
 dcl REGSTR_KEY_BIOSENUM    TCHAR value('BIOS');    /* child of ENUM */
 dcl REGSTR_KEY_ACPIENUM    TCHAR value('ACPI');    /* child of ENUM */
 dcl REGSTR_KEY_PCMCIAENUM  TCHAR value('PCMCIA');  /* child of ENUM */
 dcl REGSTR_KEY_PCIENUM     TCHAR value('PCI');     /* child of ENUM */
 dcl REGSTR_KEY_VPOWERDENUM TCHAR value("VPOWERD"); /* child of ENUM */

 %if NEC_98 = '' %then %do;
 dcl REGSTR_KEY_ISAENUM     TCHAR value('ISAPnP');/* child of ENUM */
 dcl REGSTR_KEY_EISAENUM    TCHAR value('EISA');  /* child of ENUM */
 %end; %else %do;
 dcl REGSTR_KEY_ISAENUM     TCHAR value('C98PnP');/* child of ENUM */
 dcl REGSTR_KEY_EISAENUM    TCHAR value('NESA');  /* child of ENUM */
 %end; /* NEC_98 */

 dcl REGSTR_KEY_LOGCONFIG   TCHAR value('LogConfig');
     /* child of enum\root\dev\inst */
 dcl REGSTR_KEY_SYSTEMBOARD TCHAR value('*PNP0C01');
     /* child of enum\root */
 dcl REGSTR_KEY_APM         TCHAR value('*PNP0C05');
     /* child of enum\root */

 dcl REGSTR_KEY_INIUPDATE   TCHAR value('IniUpdate');
 dcl REG_KEY_INSTDEV        TCHAR value('Installed');
     /*Child of hklm\class\classname */

 dcl REGSTR_KEY_DOSOPTCDROM TCHAR value('CD-ROM');
 dcl REGSTR_KEY_DOSOPTMOUSE TCHAR value('MOUSE');

 dcl REGSTR_KEY_KNOWNDOCKINGSTATES TCHAR value('Hardware Profiles');
 dcl REGSTR_KEY_DEVICEPARAMETERS   TCHAR value('Device Parameters');

 /* Public registry paths */

 dcl REGSTR_DEFAULT_INSTANCE TCHAR value('0000');
 dcl REGSTR_PATH_MOTHERBOARD TCHAR
     value(REGSTR_KEY_SYSTEMBOARD || '\' || REGSTR_DEFAULT_INSTANCE);
 dcl REGSTR_PATH_SETUP       TCHAR
     value('Software\Microsoft\Windows\CurrentVersion');
 dcl REGSTR_PATH_DRIVERSIGN  TCHAR
     value('Software\Microsoft\Driver Signing');
 dcl REGSTR_PATH_DRIVERSIGN_DS TCHAR
     value('Software\Policies\Microsoft\Windows NT\Driver Signing');
 dcl REGSTR_PATH_PIFCONVERT  TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\PIFConvert');
 dcl REGSTR_PATH_MSDOSOPTS   TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'MS-DOSOptions');
 dcl REGSTR_PATH_NOSUGGMSDOS TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\NoMSDOSWarn');
 dcl REGSTR_PATH_NEWDOSBOX   TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'MS-DOSSpecialConfig');
 dcl REGSTR_PATH_MSDOSEMU    TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'MS-DOS Emulation');
 dcl REGSTR_PATH_RUNONCE     TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'RunOnce');
 dcl REGSTR_PATH_RUNONCEEX   TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'RunOnceEx');
 dcl REGSTR_PATH_RUN         TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'Run');
 dcl REGSTR_PATH_RUNSERVICESONCE TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'RunServicesOnce');
 dcl REGSTR_PATH_RUNSERVICES TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'RunServices');
 dcl REGSTR_PATH_EXPLORER    TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'Explorer');
 dcl REGSTR_PATH_DETECT      TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'Detect');
 dcl REGSTR_PATH_APPPATHS    TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'App Paths');
 dcl REGSTR_PATH_UNINSTALL   TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'Uninstall');
 dcl REGSTR_PATH_REALMODENET TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'Network\Real Mode Net');
 dcl REGSTR_PATH_NETEQUIV    TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'Network\Equivalent');
 dcl REGSTR_PATH_CVNETWORK   TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'Network');

 /* Disk Cleanup applet and Cleanup COM objects */

 dcl REGSTR_PATH_VOLUMECACHE TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'Explorer\VolumeCaches');
 dcl REGSTR_VAL_DISPLAY      TCHAR value('display');

 dcl REGSTR_PATH_IDCONFIGDB      TCHAR
     value('System\CurrentControlSet\Control\IDConfigDB');
 dcl REGSTR_PATH_CRITICALDEVICEDATABASE TCHAR
     value('System\CurrentControlSet\Control\CriticalDeviceDatabase');
 dcl REGSTR_PATH_CLASS           TCHAR
     value('System\CurrentControlSet\Services\ Class');
 dcl REGSTR_PATH_DISPLAYSETTINGS TCHAR
     value('Display\Settings');
 dcl REGSTR_PATH_FONTS TCHAR
     value('Display\Fonts');
 dcl REGSTR_PATH_ENUM  TCHAR
     value('Enum');
 dcl REGSTR_PATH_ROOT  TCHAR
     value('Enum\Root');

 dcl REGSTR_PATH_CURRENTCONTROLSET TCHAR
     value('System\CurrentControlSet');
 dcl REGSTR_PATH_SYSTEMENUM        TCHAR
     value('System\CurrentControlSet\Enum');
 dcl REGSTR_PATH_HWPROFILES        TCHAR
     value('System\CurrentControlSet\Hardware Profiles');
 dcl REGSTR_PATH_HWPROFILESCURRENT TCHAR
     value('System\CurrentControlSet\Hardware Profiles\Current');
 dcl REGSTR_PATH_CLASS_NT          TCHAR
     value('System\CurrentControlSet\Control\Class');

 dcl REGSTR_PATH_DEVICE_CLASSES    TCHAR
     value('System\CurrentControlSet\Control\DeviceClasses');

 dcl REGSTR_PATH_SERVICES          TCHAR
     value('System\CurrentControlSet\Services');
 dcl REGSTR_PATH_VXD               TCHAR
     value('System\CurrentControlSet\Services\VxD');
 dcl REGSTR_PATH_IOS               TCHAR
     value('System\CurrentControlSet\Services\VxD\IOS');
 dcl REGSTR_PATH_VMM               TCHAR
     value('System\CurrentControlSet\Services\VxD\VMM');
 dcl REGSTR_PATH_VPOWERD           TCHAR
     value('System\CurrentControlSet\Services\VxD\VPOWERD');
 dcl REGSTR_PATH_VNETSUP           TCHAR
     value('System\CurrentControlSet\Services\VxD\VNETSUP');
 dcl REGSTR_PATH_NWREDIR           TCHAR
     value('System\CurrentControlSet\Services\VxD\NWREDIR');
 dcl REGSTR_PATH_NCPSERVER         TCHAR
     value('System\CurrentControlSet\Services\NcpServer\Parameters');
 dcl REGSTR_PATH_VCOMM             TCHAR
     value('System\CurrentControlSet\Services\VxD\VCOMM');

 dcl REGSTR_PATH_IOARB             TCHAR
     value('System\CurrentControlSet\Services\Arbitrators\IOArb');
 dcl REGSTR_PATH_ADDRARB           TCHAR
     value('System\CurrentControlSet\Services\Arbitrators\AddrArb');
 dcl REGSTR_PATH_DMAARB            TCHAR
     value('System\CurrentControlSet\Services\Arbitrators\DMAArb');
 dcl REGSTR_PATH_IRQARB            TCHAR
     value('System\CurrentControlSet\Services\Arbitrators\IRQArb');

 dcl REGSTR_PATH_CODEPAGE          TCHAR
     value('System\CurrentControlSet\Control\Nls\Codepage');
 dcl REGSTR_PATH_FILESYSTEM        TCHAR
     value('System\CurrentControlSet\Control\FileSystem');
 dcl REGSTR_PATH_FILESYSTEM_NOVOLTRACK TCHAR
     value('System\CurrentControlSet\Control\FileSystem\NoVolTrack');
 dcl REGSTR_PATH_CDFS              TCHAR
     value('System\CurrentControlSet\Control\FileSystem\CDFS');
 dcl REGSTR_PATH_WINBOOT           TCHAR
     value('System\CurrentControlSet\Control\WinBoot');
 dcl REGSTR_PATH_INSTALLEDFILES    TCHAR
     value('System\CurrentControlSet\Control\InstalledFiles');
 dcl REGSTR_PATH_VMM32FILES        TCHAR
     value('System\CurrentControlSet\Control\VMM32Files');

 /* Reasonable Limit for Values Names */
 dcl REGSTR_MAX_VALUE_LENGTH fixed bin(31) value(256);


 /* Values used by user mode Pnp Manager */

 dcl REGSTR_VAL_SLOTNUMBER           TCHAR value('SlotNumber');
 dcl REGSTR_VAL_ATTACHEDCOMPONENTS   TCHAR value('AttachedComponents');
 dcl REGSTR_VAL_BASEDEVICEPATH       TCHAR value('BaseDevicePath');
 dcl REGSTR_VAL_SYSTEMBUSNUMBER      TCHAR value('SystemBusNumber');
 dcl REGSTR_VAL_BUSDATATYPE          TCHAR value('BusDataType');
 dcl REGSTR_VAL_INTERFACETYPE        TCHAR value('InterfaceType');
 dcl REGSTR_VAL_NTDEVICEPATHS        TCHAR value('NtDevicePaths');
 dcl REGSTR_VAL_SERVICE              TCHAR value('Service');
 dcl REGSTR_VAL_CONFIGURATION        TCHAR value('Configuration');
 dcl REGSTR_VAL_CONFIGURATIONVECTOR  TCHAR value('ConfigurationVector');
 dcl REGSTR_VAL_DETECTSIGNATURE      TCHAR value('DetectSignature');
 dcl REGSTR_VAL_CLASSGUID            TCHAR value('ClassGUID');
 dcl REGSTR_VAL_INSTANCEIDENTIFIER   TCHAR value('InstanceIdentifier');
 dcl REGSTR_VAL_DUPLICATEOF          TCHAR value('DuplicateOf');
 dcl REGSTR_VAL_STATUSFLAGS          TCHAR value('StatusFlags');
 dcl REGSTR_VAL_DISABLECOUNT         TCHAR value('DisableCount');
 dcl REGSTR_VAL_UNKNOWNPROBLEMS      TCHAR value('UnknownProblem');
 dcl REGSTR_VAL_FOUNDATENUM          TCHAR value('FoundAtEnum');
 dcl REGSTR_VAL_DOCKSTATE            TCHAR value('DockState');
 dcl REGSTR_VAL_PREFERENCEORDER      TCHAR value('PreferenceOrder');
 dcl REGSTR_VAL_USERWAITINTERVAL     TCHAR value('UserWaitInterval');
 dcl REGSTR_VAL_PHANTOM              TCHAR value('Phantom');
 dcl REGSTR_VAL_DEVICE_INSTANCE      TCHAR value('DeviceInstance');
 dcl REGSTR_VAL_SYMBOLIC_LINK        TCHAR value('SymbolicLink');
 dcl REGSTR_VAL_DEFAULT              TCHAR value('Default');
 dcl REGSTR_VAL_LOWERFILTERS         TCHAR value('LowerFilters');
 dcl REGSTR_VAL_UPPERFILTERS         TCHAR value('UpperFilters');
 dcl REGSTR_VAL_LOCATION_INFORMATION TCHAR value('LocationInformation');
 dcl REGSTR_VAL_UI_NUMBER            TCHAR value('UINumber');
 dcl REGSTR_VAL_CAPABILITIES         TCHAR value('Capabilities');
 dcl REGSTR_VAL_DEVICE_TYPE          TCHAR value('DeviceType');
 dcl REGSTR_VAL_DEVICE_CHARACTERISTICS TCHAR
     value('DeviceCharacteristics');
 dcl REGSTR_VAL_DEVICE_SECURITY_DESCRIPTOR TCHAR value('Security');
 dcl REGSTR_VAL_POWERENABLE          TCHAR value('PowerEnable');

 /* Values used by kernel mode Pnp Manager */

 dcl REGSTR_VALUE_DEVICE_OBJECT_NAME TCHAR value('DeviceObjectName');
 dcl REGSTR_VALUE_DEVICE_SYMBOLIC_NAME TCHAR
     value('DeviceSymbolicName');


 /* Values used by both kernel-mode and user-mode PnP Managers */

 dcl REGSTR_KEY_CONTROL              TCHAR value('Control');
 dcl REGSTR_VAL_ACTIVESERVICE        TCHAR value('ActiveService');
 dcl REGSTR_VAL_LINKED               TCHAR value('Linked');
 dcl REGSTR_VAL_PHYSICALDEVICEOBJECT TCHAR
     value('PhysicalDeviceObject');


 /* Values under REGSTR_PATH_DISPLAYSETTINGS */

 dcl REGSTR_VAL_BITSPERPIXEL         TCHAR value('BitsPerPixel');
 dcl REGSTR_VAL_RESOLUTION           TCHAR value('Resolution');
 dcl REGSTR_VAL_DPILOGICALX          TCHAR value('DPILogicalX');
 dcl REGSTR_VAL_DPILOGICALY          TCHAR value('DPILogicalY');
 dcl REGSTR_VAL_DPIPHYSICALX         TCHAR value('DPIPhysicalX');
 dcl REGSTR_VAL_DPIPHYSICALY         TCHAR value('DPIPhysicalY');
 dcl REGSTR_VAL_REFRESHRATE          TCHAR value('RefreshRate');
 dcl REGSTR_VAL_DISPLAYFLAGS         TCHAR value('DisplayFlags');


 /* under HKEY_CURRENT_USER */
 dcl REGSTR_PATH_CONTROLPANEL TCHAR value('Control Panel');

 /* under HKEY_LOCAL_MACHINE */
 dcl REGSTR_PATH_CONTROLSFOLDER TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Controls Folder');

 /* Entries under REGSTR_PATH_CODEPAGE */

 dcl REGSTR_VAL_DOSCP        TCHAR value('OEMCP');
 dcl REGSTR_VAL_WINCP        TCHAR value('ACP');

 dcl REGSTR_PATH_DYNA_ENUM   TCHAR value('Config Manager\Enum');

 /* Entries under REGSTR_PATH_DYNA_ENUM */
 dcl REGSTR_VAL_HARDWARE_KEY TCHAR value('HardWareKey');
 dcl REGSTR_VAL_ALLOCATION   TCHAR value('Allocation');
 dcl REGSTR_VAL_PROBLEM      TCHAR value('Problem');
 dcl REGSTR_VAL_STATUS       TCHAR value('Status');

 /* Used by address arbitrator */
 dcl REGSTR_VAL_DONTUSEMEM   TCHAR value('DontAllocLastMem');

 /* Entries under REGSTR_PATH_SETUP */

 dcl REGSTR_VAL_SYSTEMROOT      TCHAR value('SystemRoot');
 dcl REGSTR_VAL_BOOTCOUNT       TCHAR value('BootCount');
 dcl REGSTR_VAL_REALNETSTART    TCHAR value('RealNetStart');
 dcl REGSTR_VAL_MEDIA           TCHAR value('MediaPath');
 dcl REGSTR_VAL_CONFIG          TCHAR value('ConfigPath');
 dcl REGSTR_VAL_DEVICEPATH      TCHAR value('DevicePath');
 dcl REGSTR_VAL_SRCPATH         TCHAR value('SourcePath');
     /*last source files path during setup. */
 dcl REGSTR_VAL_OLDWINDIR       TCHAR value('OldWinDir');
     /*old windows location */
 dcl REGSTR_VAL_SETUPFLAGS      TCHAR value('SetupFlags');
     /*flags that setup passes on after install. */
 dcl REGSTR_VAL_REGOWNER        TCHAR value('RegisteredOwner');
 dcl REGSTR_VAL_REGORGANIZATION TCHAR value('RegisteredOrganization');
 dcl REGSTR_VAL_LICENSINGINFO   TCHAR value('LicensingInfo');
 dcl REGSTR_VAL_OLDMSDOSVER     TCHAR value('OldMSDOSVer');
     /* will be DOS ver < 7 (when Setup run) */
 dcl REGSTR_VAL_FIRSTINSTALLDATETIME TCHAR
     value('FirstInstallDateTime');
     /* will Win 95 install date-time */

 dcl REGSTR_VAL_INSTALLTYPE     TCHAR value('InstallType');

 dcl REGSTR_VAL_WRAPPER         TCHAR value('Wrapper');

 /*  Values for InstallType */
 dcl IT_COMPACT  fixed bin(15) value('0000'xn);
 dcl IT_TYPICAL  fixed bin(15) value('0001'xn);
 dcl IT_PORTABLE fixed bin(15) value('0002'xn);
 dcl IT_CUSTOM   fixed bin(15) value('0003'xn);

 dcl REGSTR_KEY_SETUP       TCHAR value('\Setup');
 dcl REGSTR_VAL_BOOTDIR     TCHAR value('BootDir');
 dcl REGSTR_VAL_WINBOOTDIR  TCHAR value('WinbootDir');
 dcl REGSTR_VAL_WINDIR      TCHAR value('WinDir');

 dcl REGSTR_VAL_APPINSTPATH TCHAR value('AppInstallPath');
     /* Used by install wizard */

 /* Values for international startup disk */
 dcl REGSTR_PATH_EBD        TCHAR
     value(REGSTR_PATH_SETUP || REGSTR_KEY_SETUP || '\EBD');
 /* Keys under REGSTR_KEY_EBD */
 dcl REGSTR_KEY_EBDFILESLOCAL       TCHAR value('EBDFilesLocale');
 dcl REGSTR_KEY_EBDFILESKEYBOARD    TCHAR value('EBDFilesKeyboard');
 dcl REGSTR_KEY_EBDAUTOEXECBATLOCAL TCHAR value('EBDAutoexecBatLocale');
 dcl REGSTR_KEY_EBDAUTOEXECBATKEYBOARD TCHAR
     value('EBDAutoexecBatKeyboard');
 dcl REGSTR_KEY_EBDCONFIGSYSLOCAL   TCHAR value('EBDConfigSysLocale');
 dcl REGSTR_KEY_EBDCONFIGSYSKEYBOARD TCHAR
     value('EBDConfigSysKeyboard');

 /* Values under REGSTR_PATH_DRIVERSIGN */
 dcl REGSTR_VAL_POLICY              TCHAR value ('Policy');

 /* Values under REGSTR_PATH_DRIVERSIGN_DS */
 dcl REGSTR_VAL_BEHAVIOR_ON_FAILED_VERIFY  TCHAR
     value('BehaviorOnFailedVerify');

 /* Types of driver signing policies                          */
 /* (apply to both DS and non-DS policy values defined above) */
 dcl DRIVERSIGN_NONE             fixed bin(31) value('00000000'xn);
 dcl DRIVERSIGN_WARNING          fixed bin(31) value('00000001'xn);
 dcl DRIVERSIGN_BLOCKING         fixed bin(31) value('00000002'xn);

 /*  Entries under REGSTR_PATH_PIFCONVERT */

 dcl REGSTR_VAL_MSDOSMODE        TCHAR value('MSDOSMode');
 dcl REGSTR_VAL_MSDOSMODEDISCARD TCHAR value('Discard');

 /*  Entries under REGSTR_PATH_MSDOSOPTS (global settings) */

 dcl REGSTR_VAL_DOSOPTGLOBALFLAGS TCHAR value('GlobalFlags');
     /*  Flags for GlobalFlags */
 dcl DOSOPTGF_DEFCLEAN fixed bin(31) value('00000001'xn);
     /* Default action is clean config */

 /*  Entries under REGSTR_PATH_MSDOSOPTS \ OptionSubkey */

 dcl REGSTR_VAL_DOSOPTFLAGS  TCHAR value('Flags');
 dcl REGSTR_VAL_OPTORDER     TCHAR value('Order');
 dcl REGSTR_VAL_CONFIGSYS    TCHAR value('Config.Sys');
 dcl REGSTR_VAL_AUTOEXEC     TCHAR value('Autoexec.Bat');
 dcl REGSTR_VAL_STDDOSOPTION TCHAR value('StdOption');
 dcl REGSTR_VAL_DOSOPTTIP    TCHAR value('TipText');

 /*  Flags for DOSOPTFLAGS */
 dcl DOSOPTF_DEFAULT     fixed bin(31) value('00000001'xn);
     /* Default enabled for clean config */
 dcl DOSOPTF_SUPPORTED   fixed bin(31) value('00000002'xn);
     /* Option actually supported */
 dcl DOSOPTF_ALWAYSUSE   fixed bin(31) value('00000004'xn);
     /* Always use this option */
 dcl DOSOPTF_USESPMODE   fixed bin(31) value('00000008'xn);
     /* Option puts machine in Prot Mode */
 dcl DOSOPTF_PROVIDESUMB fixed bin(31) value('00000010'xn);
     /* Can load drivers high */
 dcl DOSOPTF_NEEDSETUP   fixed bin(31) value('00000020'xn);
     /* Need to configure option */
 dcl DOSOPTF_INDOSSTART  fixed bin(31) value('00000040'xn);
     /* Suppored by DOSSTART.BAT */
 dcl DOSOPTF_MULTIPLE    fixed bin(31) value('00000080'xn);
     /* Load multiple configuration lines */

 /*  Flags returned by SUGetSetSetupFlags and in the registry */

 dcl SUF_FIRSTTIME  fixed bin(31) value('00000001'xn);
     /* First boot into Win95. */
 dcl SUF_EXPRESS    fixed bin(31) value('00000002'xn);
     /* User Setup via express mode (vs customize). */
 dcl SUF_BATCHINF   fixed bin(31) value('00000004'xn);
     /* Setup using batch file (MSBATCH.INF). */
 dcl SUF_CLEAN      fixed bin(31) value('00000008'xn);
     /* Setup was done to a clean directory. */
 dcl SUF_INSETUP    fixed bin(31) value('00000010'xn);
     /* You're in Setup. */
 dcl SUF_NETSETUP   fixed bin(31) value('00000020'xn);
     /* Doing a net (workstation) setup. */
 dcl SUF_NETHDBOOT  fixed bin(31) value('00000040'xn);
     /* Workstation boots from local harddrive */
 dcl SUF_NETRPLBOOT fixed bin(31) value('00000080'xn);
     /* Workstation boots via RPL (vs floppy) */
 dcl SUF_SBSCOPYOK  fixed bin(31) value('00000100'xn);
     /* Can copy to LDID_SHARED (SBS) */

 /*  Entries under REGSTR_PATH_VMM */

 dcl REGSTR_VAL_DOSPAGER  TCHAR value('DOSPager');
 dcl REGSTR_VAL_VXDGROUPS TCHAR value('VXDGroups');

 /*  Entries under REGSTR_PATH_VPOWERD */

 dcl REGSTR_VAL_VPOWERDFLAGS   TCHAR value('Flags');
     /* Stupid machine workarounds */
 dcl VPDF_DISABLEPWRMGMT       fixed bin(31) value('00000001'xn);
     /* Don't load device */
 dcl VPDF_FORCEAPM10MODE       fixed bin(31) value('00000002'xn);
     /* Always go into 1.0 mode */
 dcl VPDF_SKIPINTELSLCHECK     fixed bin(31) value('00000004'xn);
     /* Don't detect Intel SL chipset */
 dcl VPDF_DISABLEPWRSTATUSPOLL fixed bin(31) value('00000008'xn);
     /* Don't poll power status */
 dcl VPDF_DISABLERINGRESUME    fixed bin(31) value('00000010'xn);
     /* Don't let the modem wake the machine (APM 1.2 only) */
 dcl VPDF_SHOWMULTIBATT        fixed bin(31) value('00000020'xn);
     /* Show all batteries checkbox in power control panel */

 /*  Entries under REGSTR_PATH_VNETSUP */

 dcl REGSTR_VAL_WORKGROUP         TCHAR value('Workgroup');
 dcl REGSTR_VAL_DIRECTHOST        TCHAR value('DirectHost');
 dcl REGSTR_VAL_FILESHARING       TCHAR value('FileSharing');
 dcl REGSTR_VAL_PRINTSHARING      TCHAR value('PrintSharing');

 /*  Entries under REGSTR_PATH_NWREDIR */

 dcl REGSTR_VAL_FIRSTNETDRIVE     TCHAR value('FirstNetworkDrive');
 dcl REGSTR_VAL_MAXCONNECTIONS    TCHAR value('MaxConnections');
 dcl REGSTR_VAL_APISUPPORT        TCHAR value('APISupport');
 dcl REGSTR_VAL_MAXRETRY          TCHAR value('MaxRetry');
 dcl REGSTR_VAL_MINRETRY          TCHAR value('MinRetry');
 dcl REGSTR_VAL_SUPPORTLFN        TCHAR value('SupportLFN');
 dcl REGSTR_VAL_SUPPORTBURST      TCHAR value('SupportBurst');
 dcl REGSTR_VAL_SUPPORTTUNNELLING TCHAR value('SupportTunnelling');
 dcl REGSTR_VAL_FULLTRACE         TCHAR value('FullTrace');
 dcl REGSTR_VAL_READCACHING       TCHAR value('ReadCaching');
 dcl REGSTR_VAL_SHOWDOTS          TCHAR value('ShowDots');
 dcl REGSTR_VAL_GAPTIME           TCHAR value('GapTime');
 dcl REGSTR_VAL_SEARCHMODE        TCHAR value('SearchMode');
 dcl REGSTR_VAL_SHELLVERSION      TCHAR value('ShellVersion');
 dcl REGSTR_VAL_MAXLIP            TCHAR value('MaxLIP');
 dcl REGSTR_VAL_PRESERVECASE      TCHAR value('PreserveCase');
 dcl REGSTR_VAL_OPTIMIZESFN       TCHAR value('OptimizeSFN');


 /*  Entries under REGSTR_PATH_NCPSERVER */

 dcl REGSTR_VAL_NCP_BROWSEMASTER    TCHAR value('BrowseMaster');
 dcl REGSTR_VAL_NCP_USEPEERBROWSING TCHAR value('Use_PeerBrowsing');
 dcl REGSTR_VAL_NCP_USESAP          TCHAR value('Use_Sap');

 /* Entries under REGSTR_PATH_VCOMM */

 dcl REGSTR_VAL_PCCARD_POWER        TCHAR
     value('EnablePowerManagement');

 /*  Entries under REGSTR_PATH_FILESYSTEM */
 dcl REGSTR_VAL_WIN31FILESYSTEM     TCHAR value('Win31FileSystem');
 dcl REGSTR_VAL_PRESERVELONGNAMES   TCHAR value('PreserveLongNames');
 dcl REGSTR_VAL_DRIVEWRITEBEHIND    TCHAR value('DriveWriteBehind');
 dcl REGSTR_VAL_ASYNCFILECOMMIT     TCHAR value('AsyncFileCommit');
 dcl REGSTR_VAL_PATHCACHECOUNT      TCHAR value('PathCache');
 dcl REGSTR_VAL_NAMECACHECOUNT      TCHAR value('NameCache');
 dcl REGSTR_VAL_CONTIGFILEALLOC     TCHAR value('ContigFileAllocSize');
 dcl REGSTR_VAL_FREESPACERATIO      TCHAR value('FreeSpaceRatio');
 dcl REGSTR_VAL_VOLIDLETIMEOUT      TCHAR value('VolumeIdleTimeout');
 dcl REGSTR_VAL_BUFFIDLETIMEOUT     TCHAR value('BufferIdleTimeout');
 dcl REGSTR_VAL_BUFFAGETIMEOUT      TCHAR value('BufferAgeTimeout');
 dcl REGSTR_VAL_NAMENUMERICTAIL     TCHAR value('NameNumericTail');
 dcl REGSTR_VAL_READAHEADTHRESHOLD  TCHAR value('ReadAheadThreshold');
 dcl REGSTR_VAL_DOUBLEBUFFER        TCHAR value('DoubleBuffer');
 dcl REGSTR_VAL_SOFTCOMPATMODE      TCHAR value('SoftCompatMode');
 dcl REGSTR_VAL_DRIVESPINDOWN       TCHAR value('DriveSpinDown');
 dcl REGSTR_VAL_FORCEPMIO           TCHAR value('ForcePMIO');
 dcl REGSTR_VAL_FORCERMIO           TCHAR value('ForceRMIO');
 dcl REGSTR_VAL_LASTBOOTPMDRVS      TCHAR value('LastBootPMDrvs');
 dcl REGSTR_VAL_ACSPINDOWNPREVIOUS  TCHAR value('ACSpinDownPrevious');
 dcl REGSTR_VAL_BATSPINDOWNPREVIOUS TCHAR value('BatSpinDownPrevious');
 dcl REGSTR_VAL_VIRTUALHDIRQ        TCHAR value('VirtualHDIRQ');
 dcl REGSTR_VAL_SRVNAMECACHECOUNT   TCHAR value('ServerNameCacheMax');
 dcl REGSTR_VAL_SRVNAMECACHE        TCHAR value('ServerNameCache');
 dcl REGSTR_VAL_SRVNAMECACHENETPROV TCHAR
     value('ServerNameCacheNumNets');
 dcl REGSTR_VAL_AUTOMOUNT           TCHAR value('AutoMountDrives');
 dcl REGSTR_VAL_COMPRESSIONMETHOD   TCHAR
     value('CompressionAlgorithm');
 dcl REGSTR_VAL_COMPRESSIONTHRESHOLD TCHAR
     value('CompressionThreshold');
 dcl REGSTR_VAL_ACDRIVESPINDOWN     TCHAR value('ACDriveSpinDown');
 dcl REGSTR_VAL_BATDRIVESPINDOWN    TCHAR value('BatDriveSpinDown');


 /* Entries under REGSTR_PATH_FILESYSTEM_NOVOLTRACK */

 /* A sub-key under which a variable number of variable length        */
 /* structures are stored. Each structure contains an offset followed */
 /* by a number of pattern bytes. The pattern in each structure is    */
 /* compared at the specified offset within the boot record at the    */
 /* time a volume is mounted. If any pattern in this set of patterns  */
 /* matches a pattern already in the boot record, VFAT will not write */
 /* a volume tracking serial number in the OEM_SerialNum field of the */
 /* boot record on the volume being mounted.                          */

 /*  Entries under REGSTR_PATH_CDFS */

 dcl REGSTR_VAL_CDCACHESIZE    TCHAR value('CacheSize');
     /* Number of 2K cache sectors */
 dcl REGSTR_VAL_CDPREFETCH     TCHAR value('Prefetch');
     /* Number of 2K cache sectors for prefetching */
 dcl REGSTR_VAL_CDPREFETCHTAIL TCHAR value('PrefetchTail');
     /* Number of LRU1 prefetch sectors */
 dcl REGSTR_VAL_CDRAWCACHE     TCHAR value('RawCache');
     /* Number of 2352-byte cache sectors */
 dcl REGSTR_VAL_CDEXTERRORS    TCHAR value('ExtendedErrors');
     /* Return extended error codes */
 dcl REGSTR_VAL_CDSVDSENSE     TCHAR value('SVDSense');
     /* 0=PVD, 1=Kanji, 2=Unicode */
 dcl REGSTR_VAL_CDSHOWVERSIONS TCHAR value('ShowVersions');
     /* Show file version numbers */
 dcl REGSTR_VAL_CDCOMPATNAMES  TCHAR value('MSCDEXCompatNames');
     /* Disable Numeric Tails on long file names */
 dcl REGSTR_VAL_CDNOREADAHEAD  TCHAR value('NoReadAhead');
     /* Disable Read Ahead if set to 1 */

 /* define values for IOS devices */

 dcl REGSTR_VAL_SCSI TCHAR value('SCSI\');
 dcl REGSTR_VAL_ESDI TCHAR value('ESDI\');
 dcl REGSTR_VAL_FLOP TCHAR value('FLOP\');

 /* define defs for IOS device types and values for IOS devices */

 dcl REGSTR_VAL_DISK        TCHAR value('GenDisk');
 dcl REGSTR_VAL_CDROM       TCHAR value('GenCD');
 dcl REGSTR_VAL_TAPE        TCHAR value('TAPE');
 dcl REGSTR_VAL_SCANNER     TCHAR value('SCANNER');
 dcl REGSTR_VAL_FLOPPY      TCHAR value('FLOPPY');

 dcl REGSTR_VAL_SCSITID     TCHAR value('SCSITargetID');
 dcl REGSTR_VAL_SCSILUN     TCHAR value('SCSILUN');
 dcl REGSTR_VAL_REVLEVEL    TCHAR value('RevisionLevel');
 dcl REGSTR_VAL_PRODUCTID   TCHAR value('ProductId');
 dcl REGSTR_VAL_PRODUCTTYPE TCHAR value('ProductType');
 dcl REGSTR_VAL_DEVTYPE     TCHAR value('DeviceType');
 dcl REGSTR_VAL_REMOVABLE   TCHAR value('Removable');
 dcl REGSTR_VAL_CURDRVLET   TCHAR value('CurrentDriveLetterAssignment');
 dcl REGSTR_VAL_USRDRVLET   TCHAR value('UserDriveLetterAssignment');
 dcl REGSTR_VAL_SYNCDATAXFER TCHAR value('SyncDataXfer');
 dcl REGSTR_VAL_AUTOINSNOTE  TCHAR value('AutoInsertNotification');
 dcl REGSTR_VAL_DISCONNECT   TCHAR value('Disconnect');
 dcl REGSTR_VAL_INT13        TCHAR value('Int13');
 dcl REGSTR_VAL_PMODE_INT13  TCHAR value('PModeInt13');
 dcl REGSTR_VAL_USERSETTINGS TCHAR value('AdapterSettings');
 dcl REGSTR_VAL_NOIDE        TCHAR value('NoIDE');

 /* The foll. clase name definitions should be the same as in         */
 /* dirkdrv.inx and cdrom.inx                                         */
 dcl REGSTR_VAL_DISKCLASSNAME  TCHAR value('DiskDrive');
 dcl REGSTR_VAL_CDROMCLASSNAME TCHAR value('CDROM');

 /* The foll. value determines whether a port driver should be force  */
 /* loaded or not.                                                    */

 dcl REGSTR_VAL_FORCELOAD      TCHAR value('ForceLoadPD');

 /* The foll. value determines whether or not the FIFO is used on the */
 /* Floppy controller.                                                */

 dcl REGSTR_VAL_FORCEFIFO      TCHAR value('ForceFIFO');
 dcl REGSTR_VAL_FORCECL        TCHAR value('ForceChangeLine');


 /* Generic CLASS Entries */

 dcl REGSTR_VAL_NOUSECLASS     TCHAR value('NoUseClass');
     /* Don't include this class in PnP functions */
 dcl REGSTR_VAL_NOINSTALLCLASS TCHAR value('NoInstallClass');
     /* Don't include this class in New Device Wizard */
 dcl REGSTR_VAL_NODISPLAYCLASS TCHAR value('NoDisplayClass');
     /* Don't include this class in Device Manager */
 dcl REGSTR_VAL_SILENTINSTALL  TCHAR value('SilentInstall');
     /* Always Silent Install devices of this class. */


 /*  Class Names */
 dcl REGSTR_KEY_PCMCIA_CLASS   TCHAR value('PCMCIA');
     /*child of PATH_CLASS */
 dcl REGSTR_KEY_SCSI_CLASS     TCHAR value('SCSIAdapter');
 dcl REGSTR_KEY_PORTS_CLASS    TCHAR value('ports');
 dcl REGSTR_KEY_MEDIA_CLASS    TCHAR value('MEDIA');
 dcl REGSTR_KEY_DISPLAY_CLASS  TCHAR value('Display');
 dcl REGSTR_KEY_KEYBOARD_CLASS TCHAR value('Keyboard');
 dcl REGSTR_KEY_MOUSE_CLASS    TCHAR value('Mouse');
 dcl REGSTR_KEY_MONITOR_CLASS  TCHAR value('Monitor');
 dcl REGSTR_KEY_MODEM_CLASS    TCHAR value('Modem');

 /*  Values under PATH_CLASS\PCMCIA */

 dcl REGSTR_VAL_PCMCIA_OPT   TCHAR value('Options');
 dcl PCMCIA_OPT_HAVE_SOCKET  fixed bin(31) value('00000001'xn);
 /*dcl PCMCIA_OPT_ENABLED      fixed bin(31) value('00000002'xn) */
 dcl PCMCIA_OPT_AUTOMEM      fixed bin(31) value('00000004'xn);
 dcl PCMCIA_OPT_NO_SOUND     fixed bin(31) value('00000008'xn);
 dcl PCMCIA_OPT_NO_AUDIO     fixed bin(31) value('00000010'xn);
 dcl PCMCIA_OPT_NO_APMREMOVE fixed bin(31) value('00000020'xn);

 dcl REGSTR_VAL_PCMCIA_MEM   TCHAR value('Memory');
     /* Card services shared mem range */
 dcl PCMCIA_DEF_MEMBEGIN     fixed bin(31) value('000C0000'xn);
     /* default 0xC0000 - 0x00FFFFFF */
 dcl PCMCIA_DEF_MEMEND       fixed bin(31) value('00FFFFFF'xn);
     /* (0 - 16meg) */
 dcl PCMCIA_DEF_MEMLEN       fixed bin(31) value('00001000'xn);
     /* default 4k window */

 dcl REGSTR_VAL_PCMCIA_ALLOC TCHAR value('AllocMemWin');
     /* PCCard alloced memory Window */
 dcl REGSTR_VAL_PCMCIA_ATAD  TCHAR value('ATADelay');
     /* ATA device config start delay */

 dcl REGSTR_VAL_PCMCIA_SIZ   TCHAR value('MinRegionSize');
     /* Minimum region size */
 dcl PCMCIA_DEF_MIN_REGION   fixed bin(31) value('00010000'xn);
     /* 64K minimum region size */

 /* Values in LPTENUM keys */
 dcl REGSTR_VAL_P1284MDL     TCHAR value('Model');
 dcl REGSTR_VAL_P1284MFG     TCHAR value('Manufacturer');

 /*  Values under PATH_CLASS\ISAPNP */

 dcl REGSTR_VAL_ISAPNP              TCHAR value('ISAPNP');
     /* ISAPNP VxD name */
 dcl REGSTR_VAL_ISAPNP_RDP_OVERRIDE TCHAR value('RDPOverRide');
     /* ReadDataPort OverRide */

 /*  Values under PATH_CLASS\PCI */

 dcl REGSTR_VAL_PCI      TCHAR value('PCI'); /* PCI VxD name */
 dcl REGSTR_PCI_OPTIONS  TCHAR value('Options');
     /* Possible PCI options */
 dcl REGSTR_PCI_DUAL_IDE TCHAR value('PCIDualIDE');
     /* Dual IDE flag */
 dcl PCI_OPTIONS_USE_BIOS          fixed bin(31) value('00000001'xn);
 dcl PCI_OPTIONS_USE_IRQ_STEERING  fixed bin(31) value('00000002'xn);
 dcl PCI_FLAG_NO_VIDEO_IRQ         fixed bin(31) value('00000001'xn);
 dcl PCI_FLAG_PCMCIA_WANT_IRQ      fixed bin(31) value('00000002'xn);
 dcl PCI_FLAG_DUAL_IDE             fixed bin(31) value('00000004'xn);
 dcl PCI_FLAG_NO_ENUM_AT_ALL       fixed bin(31) value('00000008'xn);
 dcl PCI_FLAG_ENUM_NO_RESOURCE     fixed bin(31) value('00000010'xn);
 dcl PCI_FLAG_NEED_DWORD_ACCESS    fixed bin(31) value('00000020'xn);
 dcl PCI_FLAG_SINGLE_FUNCTION      fixed bin(31) value('00000040'xn);
 dcl PCI_FLAG_ALWAYS_ENABLED       fixed bin(31) value('00000080'xn);
 dcl PCI_FLAG_IS_IDE               fixed bin(31) value('00000100'xn);
 dcl PCI_FLAG_IS_VIDEO             fixed bin(31) value('00000200'xn);
 dcl PCI_FLAG_FAIL_START           fixed bin(31) value('00000400'xn);
 dcl PCI_FLAG_GHOST                fixed bin(31) value('00000800'xn);
 dcl PCI_FLAG_DOUBLE_DECKER        fixed bin(31) value('00001000'xn);
 dcl PCI_FLAG_ONE_CHILD            fixed bin(31) value('00002000'xn);
 dcl PCI_FLAG_PRESERVE_COMMAND     fixed bin(31) value('00004000'xn);
 dcl PCI_FLAG_IS_VGA               fixed bin(31) value('00008000'xn);
 dcl PCI_FLAG_CB_SHARE_CMD_BITS    fixed bin(31) value('00010000'xn);
 dcl PCI_FLAG_STRAIGHT_IRQ_ROUTING fixed bin(31) value('00020000'xn);
 dcl PCI_FLAG_SUBTRACTIVE_DECODE   fixed bin(31) value('00040000'xn);
 dcl PCI_FLAG_FDMA_ISA             fixed bin(31) value('00080000'xn);
 dcl PCI_FLAG_EXCLUSIVE            fixed bin(31) value('00100000'xn);
 dcl PCI_FLAG_EDGE                 fixed bin(31) value('00200000'xn);
 dcl PCI_FLAG_NO_SUBSYSTEM         fixed bin(31) value('00400000'xn);
 dcl PCI_FLAG_NO_WPE               fixed bin(31) value('00800000'xn);
 dcl PCI_FLAG_OLD_ID               fixed bin(31) value('01000000'xn);
 dcl PCI_FLAG_DONT_SHRINK_BRIDGE   fixed bin(31) value('02000000'xn);
 dcl PCI_FLAG_TURN_OFF_PARITY      fixed bin(31) value('04000000'xn);
 dcl PCI_FLAG_NO_NON_PCI_CHILD_BAR fixed bin(31) value('08000000'xn);
 dcl PCI_FLAG_NO_ENUM_WITH_DISABLE fixed bin(31) value('10000000'xn);
 dcl PCI_FLAG_NO_PM_CAPS           fixed bin(31) value('20000000'xn);

 /* Detection related values */

 dcl REGSTR_KEY_CRASHES             TCHAR value('Crashes');
     /* key of REGSTR_PATH_DETECT */
 dcl REGSTR_KEY_DANGERS             TCHAR value('Dangers');
     /* key of REGSTR_PATH_DETECT */
 dcl REGSTR_KEY_DETMODVARS          TCHAR value('DetModVars');
     /* key of REGSTR_PATH_DETECT */
 dcl REGSTR_KEY_NDISINFO            TCHAR value('NDISInfo');
     /* key of netcard hw entry */
 dcl REGSTR_VAL_PROTINIPATH         TCHAR value('ProtIniPath');
     /* protocol.ini path */
 dcl REGSTR_VAL_RESOURCES           TCHAR value('Resources');
     /* resources of crash func. */
 dcl REGSTR_VAL_CRASHFUNCS          TCHAR value('CrashFuncs');
     /* detfunc caused the crash */
 dcl REGSTR_VAL_CLASS               TCHAR value('Class');
     /* device class */
 dcl REGSTR_VAL_DEVDESC             TCHAR value('DeviceDesc');
     /* device description */
 dcl REGSTR_VAL_BOOTCONFIG          TCHAR value('BootConfig');
     /* detected configuration */
 dcl REGSTR_VAL_DETFUNC             TCHAR value('DetFunc');
     /* specifies detect mod/func. */
 dcl REGSTR_VAL_DETFLAGS            TCHAR value('DetFlags');
     /* detection flags */
 dcl REGSTR_VAL_COMPATIBLEIDS       TCHAR value('CompatibleIDs');
     /*value of enum\dev\inst */
 dcl REGSTR_VAL_DETCONFIG           TCHAR value('DetConfig');
     /* detected configuration */
 dcl REGSTR_VAL_VERIFYKEY           TCHAR value('VerifyKey');
     /* key used in verify mode */
 dcl REGSTR_VAL_COMINFO             TCHAR value('ComInfo');
     /* com info. for serial mouse */
 dcl REGSTR_VAL_INFNAME             TCHAR value('InfName');
     /* INF filename */
 dcl REGSTR_VAL_CARDSPECIFIC        TCHAR value('CardSpecific');
     /* Netcard specific info (WORD) */
 dcl REGSTR_VAL_NETOSTYPE           TCHAR value('NetOSType');
     /* NetOS type associate w/ card */
 dcl REGSTR_DATA_NETOS_NDIS         TCHAR value('NDIS');
     /* Data of REGSTR_VAL_NETOSTYPE */
 dcl REGSTR_DATA_NETOS_ODI          TCHAR value('ODI');
     /* Data of REGSTR_VAL_NETOSTYPE */
 dcl REGSTR_DATA_NETOS_IPX          TCHAR value('IPX');
     /* Data of REGSTR_VAL_NETOSTYPE */
 dcl REGSTR_VAL_MFG                 TCHAR value('Mfg');
 dcl REGSTR_VAL_SCAN_ONLY_FIRST     TCHAR value('ScanOnlyFirstDrive');
     /* used with IDE driver */
 dcl REGSTR_VAL_SHARE_IRQ           TCHAR value('ForceIRQSharing');
     /* used with IDE driver */
 dcl REGSTR_VAL_NONSTANDARD_ATAPI   TCHAR value('NonStandardATAPI');
     /* used with IDE driver */
 dcl REGSTR_VAL_IDE_FORCE_SERIALIZE TCHAR value('ForceSerialization');
     /* used with IDE driver */
 dcl REGSTR_VAL_MAX_HCID_LEN        fixed bin(31) value(1024);
     /* Maximum hardware/compat ID len */
 dcl REGSTR_VAL_HWREV               TCHAR value('HWRevision');
 dcl REGSTR_VAL_ENABLEINTS          TCHAR value('EnableInts');

 /* Bit values of REGSTR_VAL_DETFLAGS */

 dcl REGDF_NOTDETIO  fixed bin(31) value('00000001'xn);
     /*cannot detect I/O resource */
 dcl REGDF_NOTDETMEM fixed bin(31) value('00000002'xn);
     /*cannot detect mem resource */
 dcl REGDF_NOTDETIRQ fixed bin(31) value('00000004'xn);
     /*cannot detect IRQ resource */
 dcl REGDF_NOTDETDMA fixed bin(31) value('00000008'xn);
     /*cannot detect DMA resource */
 dcl REGDF_NOTDETALL fixed bin(31) value (ior (REGDF_NOTDETIO,
                                               REGDF_NOTDETMEM,
                                               REGDF_NOTDETIRQ,
                                               REGDF_NOTDETDMA));
 dcl REGDF_NEEDFULLCONFIG  fixed bin(31) value('00000010'xn);
     /*stop devnode if lack resource */
 dcl REGDF_GENFORCEDCONFIG fixed bin(31) value('00000020'xn);
     /*also generate forceconfig */
 dcl REGDF_NODETCONFIG     fixed bin(31) value('00008000'xn);
     /*don't write detconfig to reg. */
 dcl REGDF_CONFLICTIO      fixed bin(31) value('00010000'xn);
     /*I/O res. in conflict */
 dcl REGDF_CONFLICTMEM     fixed bin(31) value('00020000'xn);
     /*mem res. in conflict */
 dcl REGDF_CONFLICTIRQ     fixed bin(31) value('00040000'xn);
     /*IRQ res. in conflict */
 dcl REGDF_CONFLICTDMA     fixed bin(31) value('00080000'xn);
    /*DMA res. in conflict */
 dcl REGDF_CONFLICTALL     fixed bin(31)
     value( ior (REGDF_CONFLICTIO,
                 REGDF_CONFLICTMEM,
                 REGDF_CONFLICTIRQ,
                 REGDF_CONFLICTDMA));
 dcl REGDF_MAPIRQ2TO9      fixed bin(31) value('00100000'xn);
     /*IRQ2 has been mapped to 9 */
 dcl REGDF_NOTVERIFIED     fixed bin(31) value('80000000'xn);
     /*previous device unverified */


 /*  Values in REGSTR_KEY_SYSTEMBOARD */

 dcl REGSTR_VAL_APMBIOSVER         TCHAR value('APMBiosVer');
 dcl REGSTR_VAL_APMFLAGS           TCHAR value('APMFlags');
 dcl REGSTR_VAL_SLSUPPORT          TCHAR value('SLSupport');
 dcl REGSTR_VAL_MACHINETYPE        TCHAR value('MachineType');
 dcl REGSTR_VAL_SETUPMACHINETYPE   TCHAR value('SetupMachineType');
 dcl REGSTR_MACHTYPE_UNKNOWN       TCHAR value('Unknown');
 dcl REGSTR_MACHTYPE_IBMPC         TCHAR value('IBM PC');
 dcl REGSTR_MACHTYPE_IBMPCJR       TCHAR value('IBM PCjr');
 dcl REGSTR_MACHTYPE_IBMPCCONV     TCHAR value('IBM PC Convertible');
 dcl REGSTR_MACHTYPE_IBMPCXT       TCHAR value('IBM PC/XT');
 dcl REGSTR_MACHTYPE_IBMPCXT_286   TCHAR value('IBM PC/XT 286');
 dcl REGSTR_MACHTYPE_IBMPCAT       TCHAR value('IBM PC/AT');
 dcl REGSTR_MACHTYPE_IBMPS2_25     TCHAR value('IBM PS/2-25');
 dcl REGSTR_MACHTYPE_IBMPS2_30_286 TCHAR value('IBM PS/2-30 286');
 dcl REGSTR_MACHTYPE_IBMPS2_30     TCHAR value('IBM PS/2-30');
 dcl REGSTR_MACHTYPE_IBMPS2_50     TCHAR value('IBM PS/2-50');
 dcl REGSTR_MACHTYPE_IBMPS2_50Z    TCHAR value('IBM PS/2-50Z');
 dcl REGSTR_MACHTYPE_IBMPS2_55SX   TCHAR value('IBM PS/2-55SX');
 dcl REGSTR_MACHTYPE_IBMPS2_60     TCHAR value('IBM PS/2-60');
 dcl REGSTR_MACHTYPE_IBMPS2_65SX   TCHAR value('IBM PS/2-65SX');
 dcl REGSTR_MACHTYPE_IBMPS2_70     TCHAR value('IBM PS/2-70');
 dcl REGSTR_MACHTYPE_IBMPS2_P70    TCHAR value('IBM PS/2-P70');
 dcl REGSTR_MACHTYPE_IBMPS2_70_80  TCHAR value('IBM PS/2-70/80');
 dcl REGSTR_MACHTYPE_IBMPS2_80     TCHAR value('IBM PS/2-80');
 dcl REGSTR_MACHTYPE_IBMPS2_90     TCHAR value('IBM PS/2-90');
 dcl REGSTR_MACHTYPE_IBMPS1        TCHAR value('IBM PS/1');
 dcl REGSTR_MACHTYPE_PHOENIX_PCAT  TCHAR
     value('Phoenix PC/AT Compatible');
 dcl REGSTR_MACHTYPE_HP_VECTRA     TCHAR value('HP Vectra');
 dcl REGSTR_MACHTYPE_ATT_PC        TCHAR value('AT&T PC');
 dcl REGSTR_MACHTYPE_ZENITH_PC     TCHAR value('Zenith PC');

 dcl REGSTR_VAL_APMMENUSUSPEND     TCHAR value('APMMenuSuspend');
 dcl APMMENUSUSPEND_DISABLED       fixed bin(31) value(0);
     /* always disabled */
 dcl APMMENUSUSPEND_ENABLED        fixed bin(31) value(1);
     /* always enabled */
 dcl APMMENUSUSPEND_UNDOCKED       fixed bin(31) value(2);
     /* enabled undocked */
 dcl APMMENUSUSPEND_NOCHANGE       fixed bin(31) value('80'xn);
     /* bitflag - cannot change setting via UI */

 dcl REGSTR_VAL_APMACTIMEOUT       TCHAR value('APMACTimeout');
 dcl REGSTR_VAL_APMBATTIMEOUT      TCHAR value('APMBatTimeout');
 dcl APMTIMEOUT_DISABLED           fixed bin(31) value(0);

 dcl REGSTR_VAL_APMSHUTDOWNPOWER   TCHAR value('APMShutDownPower');

 dcl REGSTR_VAL_BUSTYPE        TCHAR value('BusType');
 dcl REGSTR_VAL_CPU            TCHAR value('CPU');
 dcl REGSTR_VAL_NDP            TCHAR value('NDP');
 dcl REGSTR_VAL_PNPBIOSVER     TCHAR value('PnPBIOSVer');
 dcl REGSTR_VAL_PNPSTRUCOFFSET TCHAR value('PnPStrucOffset');
 dcl REGSTR_VAL_PCIBIOSVER     TCHAR value('PCIBIOSVer');
 dcl REGSTR_VAL_HWMECHANISM    TCHAR value('HWMechanism');
 dcl REGSTR_VAL_LASTPCIBUSNUM  TCHAR value('LastPCIBusNum');
 dcl REGSTR_VAL_CONVMEM        TCHAR value('ConvMem');
 dcl REGSTR_VAL_EXTMEM         TCHAR value('ExtMem');
 dcl REGSTR_VAL_COMPUTERNAME   TCHAR value('ComputerName');
 dcl REGSTR_VAL_BIOSNAME       TCHAR value('BIOSName');
 dcl REGSTR_VAL_BIOSVERSION    TCHAR value('BIOSVersion');
 dcl REGSTR_VAL_BIOSDATE       TCHAR value('BIOSDate');
 dcl REGSTR_VAL_MODEL          TCHAR value('Model');
 dcl REGSTR_VAL_SUBMODEL       TCHAR value('Submodel');
 dcl REGSTR_VAL_REVISION       TCHAR value('Revision');

 /*  Values used in the LPT(ECP) device entry */

 dcl REGSTR_VAL_FIFODEPTH       TCHAR value('FIFODepth');
 dcl REGSTR_VAL_RDINTTHRESHOLD  TCHAR value('RDIntThreshold');
 dcl REGSTR_VAL_WRINTTHRESHOLD  TCHAR value('WRIntThreshold');

 /* used in enum\xxx\<devname>\<instname> */
 dcl REGSTR_VAL_PRIORITY        TCHAR value('Priority');
     /* WHAT IS THIS FOR?? */
 dcl REGSTR_VAL_DRIVER          TCHAR value('Driver');

 dcl REGSTR_VAL_FUNCDESC        TCHAR value('FunctionDesc');

 dcl REGSTR_VAL_FORCEDCONFIG    TCHAR value('ForcedConfig');

 dcl REGSTR_VAL_CONFIGFLAGS     TCHAR value('ConfigFlags');
     /* (binary ULONG) */
 dcl REGSTR_VAL_CSCONFIGFLAGS   TCHAR value('CSConfigFlags');
     /* (binary ULONG) */

 dcl CONFIGFLAG_DISABLED        fixed bin(31) value('00000001'xn);
     /* Set if disabled */
 dcl CONFIGFLAG_REMOVED         fixed bin(31) value('00000002'xn);
     /* Set if a present hardware enum device deleted */
 dcl CONFIGFLAG_MANUAL_INSTALL  fixed bin(31) value('00000004'xn);
     /* Set if the devnode was manually installed */
 dcl CONFIGFLAG_IGNORE_BOOT_LC  fixed bin(31) value('00000008'xn);
     /* Set if skip the boot config */
 dcl CONFIGFLAG_NET_BOOT        fixed bin(31) value('00000010'xn);
     /* Load this devnode when in net boot */
 dcl CONFIGFLAG_REINSTALL       fixed bin(31) value('00000020'xn);
     /* Redo install */
 dcl CONFIGFLAG_FAILEDINSTALL   fixed bin(31) value('00000040'xn);
     /* Failed the install */
 dcl CONFIGFLAG_CANTSTOPACHILD  fixed bin(31) value('00000080'xn);
     /* Can't stop/remove a single child */
 dcl CONFIGFLAG_OKREMOVEROM     fixed bin(31) value('00000100'xn);
     /* Can remove even if rom. */
 dcl CONFIGFLAG_NOREMOVEEXIT    fixed bin(31) value('00000200'xn);
     /* Don't remove at exit. */

 dcl CSCONFIGFLAG_BITS          fixed bin(31) value('00000007'xn);
     /* OR of below bits */
 dcl CSCONFIGFLAG_DISABLED      fixed bin(31) value('00000001'xn);
     /* Set if */
 dcl CSCONFIGFLAG_DO_NOT_CREATE fixed bin(31) value('00000002'xn);
     /* Set if */
 dcl CSCONFIGFLAG_DO_NOT_START  fixed bin(31) value('00000004'xn);
     /* Set if */

 dcl DMSTATEFLAG_APPLYTOALL     fixed bin(31) value('00000001'xn);
     /* Set if Apply To All check box is checked */

 /* Special devnodes name */

 dcl REGSTR_VAL_ROOT_DEVNODE     TCHAR value('HTREE\ROOT\0');
 dcl REGSTR_VAL_RESERVED_DEVNODE TCHAR value('HTREE\RESERVED\0');
 dcl REGSTR_PATH_READDATAPORT    TCHAR
     value(REGSTR_KEY_ISAENUM || '\ReadDataPort\0');

 /* Multifunction definitions */

 dcl REGSTR_PATH_MULTI_FUNCTION   TCHAR value('MF');
 dcl REGSTR_VAL_RESOURCE_MAP      TCHAR value('ResourceMap');
 dcl REGSTR_PATH_CHILD_PREFIX     TCHAR value('Child');
 dcl NUM_RESOURCE_MAP             fixed bin(31) value(256);
 dcl REGSTR_VAL_MF_FLAGS          TCHAR value('MFFlags');
 dcl MF_FLAGS_EVEN_IF_NO_RESOURCE fixed bin(31) value('00000001'xn);
 dcl MF_FLAGS_NO_CREATE_IF_NO_RESOURCE    fixed bin(31)
     value('00000002'xn);
 dcl MF_FLAGS_FILL_IN_UNKNOWN_RESOURCE    fixed bin(31)
     value('00000004'xn);
 dcl MF_FLAGS_CREATE_BUT_NO_SHOW_DISABLED fixed bin(31)
     value('00000008'xn);

 /* EISA multi functions add-on */
 %if NEC_98 = '' %then %do;
 dcl REGSTR_VAL_EISA_RANGES         TCHAR value('EISARanges');
 dcl REGSTR_VAL_EISA_FUNCTIONS      TCHAR value('EISAFunctions');
 dcl REGSTR_VAL_EISA_FUNCTIONS_MASK TCHAR value('EISAFunctionsMask');
 dcl REGSTR_VAL_EISA_FLAGS          TCHAR value('EISAFlags');
 dcl REGSTR_VAL_EISA_SIMULATE_INT15 TCHAR value('EISASimulateInt15');
 %end; %else %do;
 dcl REGSTR_VAL_EISA_RANGES         TCHAR value('NESARanges');
 dcl REGSTR_VAL_EISA_FUNCTIONS      TCHAR value('NESAFunctions');
 dcl REGSTR_VAL_EISA_FUNCTIONS_MASK TCHAR value('NESAFunctionsMask');
 dcl REGSTR_VAL_EISA_FLAGS          TCHAR value('NESAFlags');
 dcl REGSTR_VAL_EISA_SIMULATE_INT15 TCHAR value('NESASimulateInt15');
 %end; /* NEC_98 */
 dcl EISAFLAG_NO_IO_MERGE   fixed bin(31) value('00000001'xn);
 dcl EISAFLAG_SLOT_IO_FIRST fixed bin(31) value('00000002'xn);
 dcl EISA_NO_MAX_FUNCTION   fixed bin(31) value('FF'xn);
 dcl NUM_EISA_RANGES        fixed bin(31) value(4);


 /*  Driver entries */

 dcl REGSTR_VAL_DRVDESC      TCHAR value('DriverDesc');
     /* value of enum\dev\inst\DRV */
 dcl REGSTR_VAL_DEVLOADER    TCHAR value('DevLoader');
      /* value of DRV */
 dcl REGSTR_VAL_STATICVXD    TCHAR value('StaticVxD');
     /* value of DRV */
 dcl REGSTR_VAL_PROPERTIES   TCHAR value('Properties');
     /* value of DRV */
 dcl REGSTR_VAL_MANUFACTURER TCHAR value('Manufacturer');
 dcl REGSTR_VAL_EXISTS       TCHAR value('Exists');
     /* value of HCC\HW\ENUM\ROOT\dev\inst */
 dcl REGSTR_VAL_CMENUMFLAGS  TCHAR value('CMEnumFlags');
     /* (binary ULONG) */
 dcl REGSTR_VAL_CMDRIVFLAGS  TCHAR value('CMDrivFlags');
     /* (binary ULONG) */
 dcl REGSTR_VAL_ENUMERATOR   TCHAR value('Enumerator');
     /* value of DRV */
 dcl REGSTR_VAL_DEVICEDRIVER TCHAR value('DeviceDriver');
     /* value of DRV */
 dcl REGSTR_VAL_PORTNAME     TCHAR value('PortName');
     /* VCOMM uses this for it's port names */
 dcl REGSTR_VAL_INFPATH      TCHAR value('InfPath');
 dcl REGSTR_VAL_INFSECTION   TCHAR value('InfSection');

 dcl REGSTR_VAL_INFSECTIONEXT      TCHAR value('InfSectionExt');
 dcl REGSTR_VAL_POLLING            TCHAR value('Polling');
     /* SCSI specific */
 dcl REGSTR_VAL_DONTLOADIFCONFLICT TCHAR value('DontLoadIfConflict');
     /* SCSI specific */
 dcl REGSTR_VAL_PORTSUBCLASS       TCHAR value('PortSubClass');
 dcl REGSTR_VAL_NETCLEAN           TCHAR value('NetClean');
     /* Driver required for NetClean boot */
 dcl REGSTR_VAL_IDE_NO_SERIALIZE   TCHAR value('IDENoSerialize');
     /* IDE specific */
 dcl REGSTR_VAL_NOCMOSORFDPT       TCHAR value('NoCMOSorFDPT');
     /* IDE specific */
 dcl REGSTR_VAL_COMVERIFYBASE      TCHAR value('COMVerifyBase');
     /* VCD specific */
 dcl REGSTR_VAL_MATCHINGDEVID      TCHAR value('MatchingDeviceId');
 dcl REGSTR_VAL_DRIVERDATE         TCHAR value('DriverDate');
     /* value of DRV */
 dcl REGSTR_VAL_DRIVERVERSION      TCHAR value('DriverVersion');
     /* value of DRV */

 /*  Driver keys */

 dcl REGSTR_KEY_OVERRIDE          TCHAR value('Override');
     /* key under the software section */

 /* used by CONFIGMG */

 dcl REGSTR_VAL_CONFIGMG          TCHAR value('CONFIGMG');
    /* Config Manager VxD name */
 dcl REGSTR_VAL_SYSDM             TCHAR value('SysDM');
     /* The device installer DLL */
 dcl REGSTR_VAL_SYSDMFUNC         TCHAR value('SysDMFunc');
     /* The device installer DLL function */
 dcl REGSTR_VAL_PRIVATE           TCHAR value('Private');
     /* The private library */
 dcl REGSTR_VAL_PRIVATEFUNC       TCHAR value('PrivateFunc');
     /* The private library function */
 dcl REGSTR_VAL_DETECT            TCHAR value('Detect');
     /* The detection library */
 dcl REGSTR_VAL_DETECTFUNC        TCHAR value('DetectFunc');
     /* The detection library function */
 dcl REGSTR_VAL_ASKFORCONFIG      TCHAR value('AskForConfig');
     /* The AskForConfig library */
 dcl REGSTR_VAL_ASKFORCONFIGFUNC  TCHAR value('AskForConfigFunc');
     /* The AskForConfig library function */
 dcl REGSTR_VAL_WAITFORUNDOCK     TCHAR value('WaitForUndock');
     /* The WaitForUndock library */
 dcl REGSTR_VAL_WAITFORUNDOCKFUNC TCHAR value('WaitForUndockFunc');
     /* The WaitForUndock library function */
 dcl REGSTR_VAL_REMOVEROMOKAY     TCHAR value('RemoveRomOkay');
     /* The RemoveRomOkay library */
 dcl REGSTR_VAL_REMOVEROMOKAYFUNC TCHAR value('RemoveRomOkayFunc');
     /* The RemoveRomOkay library function */

 /* used in IDCONFIGDB */
 dcl REGSTR_VAL_CURCONFIG      TCHAR value('CurrentConfig');
     /*value of idconfigdb */
 dcl REGSTR_VAL_FRIENDLYNAME   TCHAR value('FriendlyName');
     /*value of idconfigdb */
 dcl REGSTR_VAL_CURRENTCONFIG  TCHAR value('CurrentConfig');
     /*value of idconfigdb */
 dcl REGSTR_VAL_MAP            TCHAR value('Map');
     /*value of idconfigdb */
 dcl REGSTR_VAL_ID             TCHAR value('CurrentID');
    /*value of idconfigdb */
 dcl REGSTR_VAL_DOCKED         TCHAR value('CurrentDockedState');
     /*value of idconfigdb */
 dcl REGSTR_VAL_CHECKSUM       TCHAR value('CurrentChecksum');
     /*value of idconfigdb */
 dcl REGSTR_VAL_HWDETECT       TCHAR value('HardwareDetect');
     /*value of idconfigdb */
 dcl REGSTR_VAL_INHIBITRESULTS TCHAR value('InhibitResults');
     /*value of idconfigdb */

 /* used in HKEY_CURRENT_CONFIG */
 dcl REGSTR_VAL_PROFILEFLAGS   TCHAR value('ProfileFlags');
     /* value of HKEY_CURRENT_CONFIG */

 /* used in PCMCIA */
 dcl REGSTR_KEY_PCMCIA     TCHAR value('PCMCIA\');
     /* PCMCIA dev ID prefix */
 dcl REGSTR_KEY_PCUNKNOWN  TCHAR value('UNKNOWN_MANUFACTURER');
     /* PCMCIA dev ID manuf */
 dcl REGSTR_VAL_PCSSDRIVER TCHAR value('Driver');
     /* value of DRV */
 dcl REGSTR_KEY_PCMTD      TCHAR value('MTD-');
     /* MTD dev ID component */
 dcl REGSTR_VAL_PCMTDRIVER TCHAR value('MTD');
     /* value of Mem Tech DRV */

 /* used in hardware\enum\dev\inst by Device Installer */
 dcl REGSTR_VAL_HARDWAREID TCHAR value('HardwareID');
     /* value of enum\dev\inst */

 /* value names under class brach REGSTR_KEY_CLASS + class name       */
 /* and for the drivers REGSTR_KEY_CLASS\classname\xxxx               */
 dcl REGSTR_VAL_INSTALLER          TCHAR value('Installer');
     /* 16-bit class installer module/entry point */
 dcl REGSTR_VAL_INSTALLER_32       TCHAR value('Installer32');
     /* 32-bit class installer module/entry point */
 dcl REGSTR_VAL_INSICON            TCHAR value('Icon');
     /* value of class\name */
 dcl REGSTR_VAL_LEGACYINFOPT       TCHAR value('LegacyInfOption');
     /* used for translating to old-style INF option names */
 dcl REGSTR_VAL_ENUMPROPPAGES      TCHAR value('EnumPropPages');
     /* For Class/Device Properties (16-bit) */
 dcl REGSTR_VAL_ENUMPROPPAGES_32   TCHAR value('EnumPropPages32');
     /* For Class/Device Properties (32-bit) */
 dcl REGSTR_VAL_BASICPROPERTIES    TCHAR value('BasicProperties');
     /* For CPL basic Properties */
 dcl REGSTR_VAL_BASICPROPERTIES_32 TCHAR value('BasicProperties32');
     /* For CPL basic Properties (32-bit) */
 dcl REGSTR_VAL_COINSTALLERS_32    TCHAR value('CoInstallers32');
     /* Device-specific co-installer multi-sz list (32-bit) */
 dcl REGSTR_VAL_PRIVATEPROBLEM     TCHAR value('PrivateProblem');
     /* For Handling Private Problems */

 /* names used for display driver set information */
 dcl REGSTR_KEY_CURRENT TCHAR value('Current');
     /* current mode information */
 dcl REGSTR_KEY_DEFAULT TCHAR value('Default');
     /* default configuration */
 dcl REGSTR_KEY_MODES   TCHAR value('Modes');
     /* modes subtree */

 dcl REGSTR_VAL_MODE        TCHAR value('Mode');
     /* default mode */
 dcl REGSTR_VAL_BPP         TCHAR value('BPP');
     /* bits per pixel */
 dcl REGSTR_VAL_HRES        TCHAR value('HRes');
     /* horizontal resolution */
 dcl REGSTR_VAL_VRES        TCHAR value('VRes');
     /* vertical resolution */
 dcl REGSTR_VAL_FONTSIZE    TCHAR value('FontSize');
     /* used in default or override */
 dcl REGSTR_VAL_DRV         TCHAR value('drv');
     /* the driver file */
 dcl REGSTR_VAL_GRB         TCHAR value('grb');
     /* the grabber file */
 dcl REGSTR_VAL_VDD         TCHAR value('vdd');
     /* vdds used here */
 dcl REGSTR_VAL_VER         TCHAR value('Ver');
 dcl REGSTR_VAL_MAXRES      TCHAR value('MaxResolution');
     /* max res for monitors */
 dcl REGSTR_VAL_DPMS        TCHAR value('DPMS');
     /* DPMS enabled */
 dcl REGSTR_VAL_RESUMERESET TCHAR value('ResumeReset');
     /* need reset on resume */

 dcl REGSTR_VAL_DESCRIPTION TCHAR value('Description');

 /* keys in fontsize tree */
 dcl REGSTR_KEY_SYSTEM TCHAR value('System');
     /* entries for system.ini */
 dcl REGSTR_KEY_USER   TCHAR value('User');
     /* entries for win.ini */
 dcl REGSTR_VAL_DPI    TCHAR value('dpi');
     /* dpi of fontsize */

 /* Used by PCIC socket services */

 dcl REGSTR_VAL_PCICOPTIONS TCHAR value('PCICOptions');
     /* Binary DWORD. IRQ mask in low word. # skts in high */
 %if NEC_98 = '' %then %do;
 dcl PCIC_DEFAULT_IRQMASK fixed bin(15) value('4EB8'xn);
     /* Default IRQ masks */
 %end; %else %do;
 dcl PCIC_DEFAULT_IRQMASK fixed bin(15) value('1468'xn);
     /* Default IRQ masks */
 %end; /* NEC_98 */
 dcl PCIC_DEFAULT_NUMSOCKETS fixed bin(31) value(0);
     /* 0 = Automatic detection */
 dcl REGSTR_VAL_PCICIRQMAP   TCHAR value('PCICIRQMap');
     /* Binary 16 byte IRQ map table */

 /* names used for control panel entries */
 dcl REGSTR_PATH_APPEARANCE  TCHAR value('Control Panel\Appearance');
 dcl REGSTR_PATH_LOOKSCHEMES TCHAR
     value('Control Panel\Appearance\Schemes');
 dcl REGSTR_VAL_CUSTOMCOLORS TCHAR value('CustomColors');

 dcl REGSTR_PATH_SCREENSAVE      TCHAR value('Control Panel\Desktop');
 dcl REGSTR_VALUE_USESCRPASSWORD TCHAR value('ScreenSaveUsePassword');
 dcl REGSTR_VALUE_SCRPASSWORD    TCHAR value('ScreenSave_Data');

 dcl REGSTR_VALUE_LOWPOWERTIMEOUT TCHAR
     value('ScreenSaveLowPowerTimeout');
 dcl REGSTR_VALUE_POWEROFFTIMEOUT TCHAR
     value('ScreenSavePowerOffTimeout');
 dcl REGSTR_VALUE_LOWPOWERACTIVE TCHAR
     value('ScreenSaveLowPowerActive');
 dcl REGSTR_VALUE_POWEROFFACTIVE TCHAR
     value('ScreenSavePowerOffActive');

 /* used for Windows applets */
 dcl REGSTR_PATH_WINDOWSAPPLETS TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Applets');


 /* system tray.  Flag values defined in systrap.h */

 dcl REGSTR_PATH_SYSTRAY TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Applets\' ||
           'SysTray');
 dcl REGSTR_VAL_SYSTRAYSVCS        TCHAR value('Services');
 dcl REGSTR_VAL_SYSTRAYBATFLAGS    TCHAR value('PowerFlags');
 dcl REGSTR_VAL_SYSTRAYPCCARDFLAGS TCHAR value('PCMCIAFlags');


 /* Used by system networking components to store per-user values. */
 /* All keys here are under HKCU.                                  */

 dcl REGSTR_PATH_NETWORK_USERSETTINGS TCHAR value('Network');

 dcl REGSTR_KEY_NETWORK_PERSISTENT TCHAR value('\Persistent');
 dcl REGSTR_KEY_NETWORK_RECENT     TCHAR value('\Recent');
 dcl REGSTR_VAL_REMOTE_PATH        TCHAR value('RemotePath');
 dcl REGSTR_VAL_USER_NAME          TCHAR value('UserName');
 dcl REGSTR_VAL_PROVIDER_NAME      TCHAR value('ProviderName');
 dcl REGSTR_VAL_CONNECTION_TYPE    TCHAR value('ConnectionType');
 dcl REGSTR_VAL_UPGRADE            TCHAR value('Upgrade');

 dcl REGSTR_KEY_LOGON              TCHAR value('\Logon');
 dcl REGSTR_VAL_MUSTBEVALIDATED    TCHAR value('MustBeValidated');
 dcl REGSTR_VAL_RUNLOGINSCRIPT     TCHAR value('ProcessLoginScript');

 /* NetworkProvider entries. These entries are under                  */
 /* REGSTR_PATH_SERVICES\xxx\NetworkProvider                          */

 dcl REGSTR_KEY_NETWORKPROVIDER    TCHAR value('\NetworkProvider');
 dcl REGSTR_PATH_NW32NETPROVIDER   TCHAR value(REGSTR_PATH_SERVICES ||
     '\NWNP32' || REGSTR_KEY_NETWORKPROVIDER);
 dcl REGSTR_PATH_MS32NETPROVIDER   TCHAR value(REGSTR_PATH_SERVICES ||
     '\MSNP32' || REGSTR_KEY_NETWORKPROVIDER);
 dcl REGSTR_VAL_AUTHENT_AGENT      TCHAR value('AuthenticatingAgent');


 /* Entries under REGSTR_PATH_REALMODENET */

 dcl REGSTR_VAL_PREFREDIR     TCHAR value('PreferredRedir');
 dcl REGSTR_VAL_AUTOSTART     TCHAR value('AutoStart');
 dcl REGSTR_VAL_AUTOLOGON     TCHAR value('AutoLogon');
 dcl REGSTR_VAL_NETCARD       TCHAR value('Netcard');
 dcl REGSTR_VAL_TRANSPORT     TCHAR value('Transport');
 dcl REGSTR_VAL_DYNAMIC       TCHAR value('Dynamic');
 dcl REGSTR_VAL_TRANSITION    TCHAR value('Transition');
 dcl REGSTR_VAL_STATICDRIVE   TCHAR value('StaticDrive');
 dcl REGSTR_VAL_LOADHI        TCHAR value('LoadHi');
 dcl REGSTR_VAL_LOADRMDRIVERS TCHAR value('LoadRMDrivers');
 dcl REGSTR_VAL_SETUPN        TCHAR value('SetupN');
 dcl REGSTR_VAL_SETUPNPATH    TCHAR value('SetupNPath');

 /* Entries under REGSTR_PATH_CVNETWORK */

 dcl REGSTR_VAL_WRKGRP_FORCEMAPPING TCHAR value('WrkgrpForceMapping');
 dcl REGSTR_VAL_WRKGRP_REQUIRED     TCHAR value('WrkgrpRequired');


 /* NT-compatible place where the name of the currently logged-on     */
 /* user is stored.                                                   */

 dcl REGSTR_PATH_CURRENT_CONTROL_SET TCHAR
     value('System\CurrentControlSet\Control');
 dcl REGSTR_VAL_CURRENT_USER         TCHAR value('Current User');

 /* section where password providers are installed (each provider has */
 /* subkey under this key)                                            */
 dcl REGSTR_PATH_PWDPROVIDER  TCHAR
     value('System\CurrentControlSet\Control\PwdProvider');
 dcl REGSTR_VAL_PWDPROVIDER_PATH        TCHAR value('ProviderPath');
 dcl REGSTR_VAL_PWDPROVIDER_DESC        TCHAR value('Description');
 dcl REGSTR_VAL_PWDPROVIDER_CHANGEPWD   TCHAR value('ChangePassword');
 dcl REGSTR_VAL_PWDPROVIDER_CHANGEPWDHWND TCHAR
     value('ChangePasswordHwnd');
 dcl REGSTR_VAL_PWDPROVIDER_GETPWDSTATUS TCHAR
     value('GetPasswordStatus');
 dcl REGSTR_VAL_PWDPROVIDER_ISNP        TCHAR value('NetworkProvider');
 dcl REGSTR_VAL_PWDPROVIDER_CHANGEORDER TCHAR value('ChangeOrder');


 /* Used by administrator configuration tool and various components   */
 /* who enforce policies.                                             */

 dcl REGSTR_PATH_POLICIES TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Policies');

 /* used to control remote update of administrator policies */
 dcl REGSTR_PATH_UPDATE   TCHAR
     value('System\CurrentControlSet\Control\Update');
 dcl REGSTR_VALUE_ENABLE     TCHAR value('Enable');
 dcl REGSTR_VALUE_VERBOSE    TCHAR value('Verbose');
 dcl REGSTR_VALUE_NETPATH    TCHAR value('NetworkPath');
 dcl REGSTR_VALUE_DEFAULTLOC TCHAR value('UseDefaultNetLocation');


 /* Entries under REGSTR_PATH_POLICIES */

 dcl REGSTR_KEY_NETWORK   TCHAR value('Network');
 /* dcl REGSTR_KEY_SYSTEM    TCHAR value('System') -- see above */
 dcl REGSTR_KEY_PRINTERS  TCHAR value('Printers');
 dcl REGSTR_KEY_WINOLDAPP TCHAR value('WinOldApp');

 /* (following are values REG_DWORD, legal values 0 or 1,             */
 /* treat as '0' if value not present)                                */

     /* policies under NETWORK key */
 dcl REGSTR_VAL_NOFILESHARING      TCHAR value('NoFileSharing');
     /* '1'prevents server from loading */
 dcl REGSTR_VAL_NOPRINTSHARING     TCHAR value('NoPrintSharing');
 dcl REGSTR_VAL_NOFILESHARINGCTRL  TCHAR value('NoFileSharingControl');
     /* '1'removes sharing ui */
 dcl REGSTR_VAL_NOPRINTSHARINGCTRL TCHAR value('NoPrintSharingControl');
 dcl REGSTR_VAL_HIDESHAREPWDS      TCHAR value('HideSharePwds');
     /* '1'hides share passwords with asterisks */
 dcl REGSTR_VAL_DISABLEPWDCACHING  TCHAR value('DisablePwdCaching');
     /* '1'disables caching */
 dcl REGSTR_VAL_ALPHANUMPWDS       TCHAR value('AlphanumPwds');
     /* '1'forces alphanumeric passwords */
 dcl REGSTR_VAL_NETSETUP_DISABLE   TCHAR value('NoNetSetup');
 dcl REGSTR_VAL_NETSETUP_NOCONFIGPAGE TCHAR
     value('NoNetSetupConfigPage');
 dcl REGSTR_VAL_NETSETUP_NOIDPAGE  TCHAR value('NoNetSetupIDPage');
 dcl REGSTR_VAL_NETSETUP_NOSECURITYPAGE TCHAR
     value('NoNetSetupSecurityPage');
 dcl REGSTR_VAL_SYSTEMCPL_NOVIRTMEMPAGE  TCHAR value('NoVirtMemPage');
 dcl REGSTR_VAL_SYSTEMCPL_NODEVMGRPAGE   TCHAR value('NoDevMgrPage');
 dcl REGSTR_VAL_SYSTEMCPL_NOCONFIGPAGE   TCHAR value('NoConfigPage');
 dcl REGSTR_VAL_SYSTEMCPL_NOFILESYSPAGE  TCHAR value('NoFileSysPage');
 dcl REGSTR_VAL_DISPCPL_NODISPCPL        TCHAR value('NoDispCPL');
 dcl REGSTR_VAL_DISPCPL_NOBACKGROUNDPAGE TCHAR
     value('NoDispBackgroundPage');
 dcl REGSTR_VAL_DISPCPL_NOSCRSAVPAGE    TCHAR value('NoDispScrSavPage');
 dcl REGSTR_VAL_DISPCPL_NOAPPEARANCEPAGE TCHAR
     value('NoDispAppearancePage');
 dcl REGSTR_VAL_DISPCPL_NOSETTINGSPAGE   TCHAR
     value('NoDispSettingsPage');
 dcl REGSTR_VAL_SECCPL_NOSECCPL      TCHAR value('NoSecCPL');
 dcl REGSTR_VAL_SECCPL_NOPWDPAGE     TCHAR value('NoPwdPage');
 dcl REGSTR_VAL_SECCPL_NOADMINPAGE   TCHAR value('NoAdminPage');
 dcl REGSTR_VAL_SECCPL_NOPROFILEPAGE TCHAR value('NoProfilePage');
 dcl REGSTR_VAL_PRINTERS_HIDETABS    TCHAR value('NoPrinterTabs');
 dcl REGSTR_VAL_PRINTERS_NODELETE    TCHAR value('NoDeletePrinter');
 dcl REGSTR_VAL_PRINTERS_NOADD       TCHAR value('NoAddPrinter');
 dcl REGSTR_VAL_WINOLDAPP_DISABLED   TCHAR value('Disabled');
 dcl REGSTR_VAL_WINOLDAPP_NOREALMODE TCHAR value('NoRealMode');
 dcl REGSTR_VAL_NOENTIRENETWORK      TCHAR value('NoEntireNetwork');
 dcl REGSTR_VAL_NOWORKGROUPCONTENTS  TCHAR value('NoWorkgroupContents');

 /* REG_DWORD, 0=off, otherwise value is minimum # of chars to allow  */
 /* in password                                                       */
 dcl REGSTR_VAL_MINPWDLEN     TCHAR value('MinPwdLen');

 /* REG_DWORD, 0=off, otherwise value is # of days for pwd to expire  */
 dcl REGSTR_VAL_PWDEXPIRATION TCHAR value('PwdExpiration');

 dcl REGSTR_VAL_WIN31PROVIDER TCHAR value('Win31Provider'); /* REG_SZ */

 /* policies under SYSTEM key */
 dcl REGSTR_VAL_DISABLEREGTOOLS TCHAR value('DisableRegistryTools');

 dcl REGSTR_PATH_WINLOGON TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Winlogon');
 dcl REGSTR_VAL_LEGALNOTICECAPTION TCHAR value('LegalNoticeCaption');
     /* REG_SZ */
 dcl REGSTR_VAL_LEGALNOTICETEXT    TCHAR value('LegalNoticeText');
     /* REG_SZ */
 dcl REGSTR_VAL_DRIVE_SPINDOWN     TCHAR value('NoDispSpinDown');

 dcl REGSTR_VAL_RESTRICTRUN        TCHAR value('RestrictRun');

 /* Entries in policy file. (Won't be in local registry, only policy  */
 /* hive)                                                             */
 dcl REGSTR_KEY_POL_USERS      TCHAR value('Users');
 dcl REGSTR_KEY_POL_COMPUTERS  TCHAR value('Computers');
 dcl REGSTR_KEY_POL_USERGROUPS TCHAR value('UserGroups');
 dcl REGSTR_KEY_POL_DEFAULT    TCHAR value('.default');
 dcl REGSTR_KEY_POL_USERGROUPDATA TCHAR
     value('GroupData\UserGroups\Priority');


 /* Entries for time zone information under LOCAL_MACHINE */

 dcl REGSTR_PATH_TIMEZONE  TCHAR
     value('System\CurrentControlSet\Control\TimeZoneInformation');
 dcl REGSTR_VAL_TZBIAS     TCHAR value('Bias');
 dcl REGSTR_VAL_TZDLTBIAS  TCHAR value('DaylightBias');
 dcl REGSTR_VAL_TZSTDBIAS  TCHAR value('StandardBias');
 dcl REGSTR_VAL_TZACTBIAS  TCHAR value('ActiveTimeBias');
 dcl REGSTR_VAL_TZDLTFLAG  TCHAR value('DaylightFlag');
 dcl REGSTR_VAL_TZSTDSTART TCHAR value('StandardStart');
 dcl REGSTR_VAL_TZDLTSTART TCHAR value('DaylightStart');
 dcl REGSTR_VAL_TZDLTNAME  TCHAR value('DaylightName');
 dcl REGSTR_VAL_TZSTDNAME  TCHAR value('StandardName');
 dcl REGSTR_VAL_TZNOCHANGESTART TCHAR value('NoChangeStart');
 dcl REGSTR_VAL_TZNOCHANGEEND TCHAR value('NoChangeEnd');
 dcl REGSTR_VAL_TZNOAUTOTIME TCHAR value('DisableAutoDaylightTimeSet');

 /* Entries for floating point processor existence under LOCAL_MACHINE*/

 dcl REGSTR_PATH_FLOATINGPOINTPROCESSOR  TCHAR
     value('HARDWARE\DESCRIPTION\System\FloatingPointProcessor');
 dcl REGSTR_PATH_FLOATINGPOINTPROCESSOR0 TCHAR
     value('HARDWARE\DESCRIPTION\System\FloatingPointProcessor\0');


 /* Entries for computer name under LOCAL_MACHINE */

 dcl REGSTR_PATH_COMPUTRNAME TCHAR
     value('System\CurrentControlSet\Control\ComputerName\' ||
           'ComputerName');
 dcl REGSTR_VAL_COMPUTRNAME  TCHAR value('ComputerName');

 /* Entry so that we force a reboot on shutdown / single instance dos */
 /* app                                                               */
 dcl REGSTR_PATH_SHUTDOWN       TCHAR
     value('System\CurrentControlSet\Control\Shutdown');
 dcl REGSTR_VAL_FORCEREBOOT     TCHAR value('ForceReboot');
 dcl REGSTR_VAL_SETUPPROGRAMRAN TCHAR value('SetupProgramRan');
 dcl REGSTR_VAL_DOES_POLLING    TCHAR value('PollingSupportNeeded');


 /*      Entries for known system DLLs under LOCAL_MACHINE            */
 /*                                                                   */
 /*      The VAL keys here are the actual DLL names (FOO.DLL)         */

 dcl REGSTR_PATH_KNOWNDLLS TCHAR
     value('System\CurrentControlSet\Control\SessionManager\' ||
           'KnownDLLs');
 dcl REGSTR_PATH_KNOWN16DLLS TCHAR
     value('System\CurrentControlSet\Control\SessionManager\' ||
           'Known16DLLs');

 /* Entries here for system dlls we need to version check in case     */
 /* overwritten                                                       */
 dcl REGSTR_PATH_CHECKVERDLLS TCHAR
     value('System\CurrentControlSet\Control\SessionManager\' ||
           'CheckVerDLLs');
 dcl REGSTR_PATH_WARNVERDLLS TCHAR
     value('System\CurrentControlSet\Control\SessionManager\' ||
           'WarnVerDLLs');

 /* Entries here for app ini files we (msgsrv32) need to hack         */
 dcl REGSTR_PATH_HACKINIFILE TCHAR
     value('System\CurrentControlSet\Control\SessionManager\' ||
           'HackIniFiles');

 /* Keys here for bad applications we want to warn the user about     */
 /* before running                                                    */
 dcl REGSTR_PATH_CHECKBADAPPS TCHAR
     value('System\CurrentControlSet\Control\SessionManager\' ||
           ' CheckBadApps');

 /* Keys here for applications we need to patch */
 dcl REGSTR_PATH_APPPATCH TCHAR
     value('System\CurrentControlSet\Control\SessionManager\' ||
           'AppPatches');

 dcl REGSTR_PATH_CHECKBADAPPS400 TCHAR
     value('System\CurrentControlSet\Control\SessionManager\' ||
           'CheckBadApps400');

 dcl REGSTR_PATH_SHELLSERVICEOBJECT          TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'ShellServiceObject');
 dcl REGSTR_PATH_SHELLSERVICEOBJECTDELAYED   TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'ShellServiceObjectDelayLoad');

 /* Entries for known system VxDs under LOCAL_MACHINE                 */
 /*                                                                   */
 /* The VAL keys here are the full path names of VxDs                 */
 /* (c:\app\vapp.vxd)                                                 */
 /* It is suggested that the keynames be the same as the module name  */
 /* of the VxD. This section is used to dyna-load VxDs with           */
 /* CreateFile(\.\vxd_regstr_keyname).                                */


 dcl REGSTR_PATH_KNOWNVXDS TCHAR
     value('System\CurrentControlSet\Control\SessionManager\KnownVxDs');


 /* Entries for values in uninstaller keys under                      */
 /* REGSTR_PATH_UNINSTALL \ appname                                   */

 dcl REGSTR_VAL_UNINSTALLER_DISPLAYNAME TCHAR value('DisplayName');
 dcl REGSTR_VAL_UNINSTALLER_COMMANDLINE TCHAR value('UninstallString');


 /* Entries for known per user settings: Under HKEY_CURRENT_USER */

 dcl REGSTR_PATH_DESKTOP     TCHAR value(REGSTR_PATH_SCREENSAVE);
 dcl REGSTR_PATH_MOUSE       TCHAR value('Control Panel\Mouse');
 dcl REGSTR_PATH_KEYBOARD    TCHAR value('Control Panel\Keyboard');
 dcl REGSTR_PATH_COLORS      TCHAR value('Control Panel\Colors');
 dcl REGSTR_PATH_SOUND       TCHAR value('Control Panel\Sound');
 dcl REGSTR_PATH_METRICS     TCHAR
     value('Control Panel\Desktop\WindowMetrics');
 dcl REGSTR_PATH_ICONS       TCHAR value('Control Panel\Icons');
 dcl REGSTR_PATH_CURSORS     TCHAR value('Control Panel\Cursors');
 dcl REGSTR_PATH_CHECKDISK   TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\' ||
           'Applets\Check Drive');
 dcl REGSTR_PATH_CHECKDISKSET   TCHAR value('Settings');
 dcl REGSTR_PATH_CHECKDISKUDRVS TCHAR value('NoUnknownDDErrDrvs');

 /*  Entries under REGSTR_PATH_FAULT */
 dcl REGSTR_PATH_FAULT        TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Fault');
 dcl REGSTR_VAL_FAULT_LOGFILE TCHAR value('LogFile');


 /*  Entries under REGSTR_PATH_AEDEBUG */
 dcl REGSTR_PATH_AEDEBUG         TCHAR
     value('Software\Microsoft\Windows NT\CurrentVersion\AeDebug');
 dcl REGSTR_VAL_AEDEBUG_DEBUGGER TCHAR value('Debugger');
 dcl REGSTR_VAL_AEDEBUG_AUTO     TCHAR value('Auto');


 /*  Entries under REGSTR_PATH_GRPCONV */

 dcl REGSTR_PATH_GRPCONV TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\GrpConv');


 /*  Entries under the RegItem key in a shell namespace */

 dcl REGSTR_VAL_REGITEMDELETEMESSAGE TCHAR value('Removal Message');


 /* Entries for the Drives Tools page                                 */
 /*                                                                   */
 /* NOTE that these items are not recorded for removable drives.      */
 /* These keys record X=DSKTLSYSTEMTIME where X is the drive letter.  */
 /* Since these tools actually work on the disk in the drive, as      */
 /* opposed to the drive itself, it is pointless to record them on a  */
 /* removable media since if a different disk is inserted in the      */
 /* drive, the data is  meaningless.                                  */

 dcl REGSTR_PATH_LASTCHECK    TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Explorer\' ||
           'LastCheck');
 dcl REGSTR_PATH_LASTOPTIMIZE TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Explorer\' ||
           'LastOptimize');
 dcl REGSTR_PATH_LASTBACKUP   TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Explorer\' ||
           'LastBackup');

 /* The above 3 keys record with the registry value of the drive      */
 /* letter as SYSTEMTIME structure                                    */


 /* Entries under HKEY_LOCAL_MACHINE for Check Drive specific stuff */

 dcl REGSTR_PATH_CHKLASTCHECK TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Applets\' ||
           'Check Drive\LastCheck');
 dcl REGSTR_PATH_CHKLASTSURFAN TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Applets\' ||
           'Check Drive\LastSurfaceAnalysis');


 /* The above 2 keys record the following binary structure which is   */
 /* a system time structure with the addition of a result code field. */
 /* Note that the time part of REGSTR_PATH_CHKLASTCHECK is effectively*/
 /* identical to REGSTR_PATH_LASTCHECK under the explorer key         */

 define structure
   1 DSKTLSYSTEMTIME,
     2 wYear         type WORD,
     2 wMonth        type WORD,
     2 wDayOfWeek    type WORD,
     2 wDay          type WORD,
     2 wHour         type WORD,
     2 wMinute       type WORD,
     2 wSecond       type WORD,
     2 wMilliseconds type WORD,
     2 wResult       type WORD;

 define alias  PDSKTLSYSTEMTIME handle DSKTLSYSTEMTIME;
 define alias LPDSKTLSYSTEMTIME handle DSKTLSYSTEMTIME;


 /* The following are defines for the wResult field */

 dcl DTRESULTOK   fixed bin(31) value(0);
     /* Operation was successful, no errors */
 dcl DTRESULTFIX  fixed bin(31) value(1);
     /* Operation was successful, errors were found */
     /*   but all were fixed. */
 dcl DTRESULTPROB fixed bin(31) value(2);
     /* Operation was not successful or errors */
     /*   were found and some or all were not fixed. */
 dcl DTRESULTPART fixed bin(31) value(3);
     /* Operation was partially completed but was */
     /*   terminated either by the user or an error. */


 /*  Entries for persistent shares */

 dcl REGSTR_KEY_SHARES         TCHAR
     value('Software\Microsoft\Windows\CurrentVersion\Network\LanMan');
 dcl REGSTR_VAL_SHARES_FLAGS   TCHAR value('Flags');
 dcl REGSTR_VAL_SHARES_TYPE    TCHAR value('Type');
 dcl REGSTR_VAL_SHARES_PATH    TCHAR value('Path');
 dcl REGSTR_VAL_SHARES_REMARK  TCHAR value('Remark');
 dcl REGSTR_VAL_SHARES_RW_PASS TCHAR value('Parm1');
 dcl REGSTR_VAL_SHARES_RO_PASS TCHAR value('Parm2');

 /* Entries for printer settings under LOCAL_MACHINE */

 dcl REGSTR_PATH_PRINT         TCHAR
     value('System\CurrentControlSet\Control\Print');
 dcl REGSTR_PATH_PRINTERS      TCHAR
     value('System\CurrentControlSet\Control\Print\Printers');
 dcl REGSTR_PATH_PROVIDERS     TCHAR
     value('System\CurrentControlSet\Control\Print\Providers');
 dcl REGSTR_PATH_MONITORS      TCHAR
     value('System\CurrentControlSet\Control\Print\Monitors');
 dcl REGSTR_PATH_ENVIRONMENTS  TCHAR
     value('System\CurrentControlSet\Control\Print\Environments');
 dcl REGSTR_VAL_START_ON_BOOT  TCHAR value('StartOnBoot');
 dcl REGSTR_VAL_PRINTERS_MASK  TCHAR value('PrintersMask');
 dcl REGSTR_VAL_DOS_SPOOL_MASK TCHAR value('DOSSpoolMask');
 dcl REGSTR_KEY_CURRENT_ENV    TCHAR value('\Windows 4.0');
 dcl REGSTR_KEY_DRIVERS        TCHAR value('\Drivers');
 dcl REGSTR_KEY_PRINT_PROC     TCHAR value('\Print Processors');

 /* Entries for MultiMedia under HKEY_CURRENT_USER */

 dcl REGSTR_PATH_EVENTLABELS  TCHAR value('AppEvents\EventLabels');
 dcl REGSTR_PATH_SCHEMES      TCHAR value('AppEvents\Schemes');
 dcl REGSTR_PATH_APPS         TCHAR value(REGSTR_PATH_SCHEMES ||
                                         '\Apps');
 dcl REGSTR_PATH_APPS_DEFAULT TCHAR value(REGSTR_PATH_SCHEMES ||
                                         '\Apps\.Default');
 dcl REGSTR_PATH_NAMES        TCHAR value(REGSTR_PATH_SCHEMES ||
                                         '\Names');
 dcl REGSTR_PATH_MULTIMEDIA   TCHAR value(REGSTR_PATH_SETUP ||
                                         '\Multimedia');
 dcl REGSTR_PATH_MULTIMEDIA_AUDIO TCHAR
     value('Software\Microsoft\Multimedia\Audio');


 /* Entries for MultiMedia under HKEY_LOCAL_MACHINE */

 dcl REGSTR_PATH_MEDIARESOURCES    TCHAR
     value(REGSTR_PATH_CURRENT_CONTROL_SET || '\MediaResources');
 dcl REGSTR_PATH_MEDIAPROPERTIES   TCHAR
     value(REGSTR_PATH_CURRENT_CONTROL_SET || '\MediaProperties');
 dcl REGSTR_PATH_PRIVATEPROPERTIES TCHAR
     value(REGSTR_PATH_MEDIAPROPERTIES || '\PrivateProperties');
 dcl REGSTR_PATH_PUBLICPROPERTIES  TCHAR
     value(REGSTR_PATH_MEDIAPROPERTIES || '\PublicProperties');

 /* joysticks */
 dcl REGSTR_PATH_JOYOEM     TCHAR value(REGSTR_PATH_PRIVATEPROPERTIES ||
                                       '\Joystick\OEM');
 dcl REGSTR_PATH_JOYCONFIG  TCHAR value(REGSTR_PATH_MEDIARESOURCES ||
                                       '\Joystick');
 dcl REGSTR_KEY_JOYCURR     TCHAR value('CurrentJoystickSettings');
 dcl REGSTR_KEY_JOYSETTINGS TCHAR value('JoystickSettings');

 /* joystick values found under REGSTR_PATH_JOYCONFIG */
 dcl REGSTR_VAL_JOYUSERVALUES  TCHAR value('JoystickUserValues');
 dcl REGSTR_VAL_JOYCALLOUT     TCHAR value('JoystickCallout');

 /* joystick values found under REGSTR_KEY_JOYCURR and                */
 /* REGSTR_KEY_JOYSETTINGS                                            */
 dcl REGSTR_VAL_JOYNCONFIG     TCHAR value('Joystick%dConfiguration');
 dcl REGSTR_VAL_JOYNOEMNAME    TCHAR value('Joystick%dOEMName');
 dcl REGSTR_VAL_JOYNOEMCALLOUT TCHAR value('Joystick%dOEMCallout');

 /* joystick values found under keys under REGSTR_PATH_JOYOEM */
 dcl REGSTR_VAL_JOYOEMCALLOUT        TCHAR value('OEMCallout');
 dcl REGSTR_VAL_JOYOEMNAME           TCHAR value('OEMName');
 dcl REGSTR_VAL_JOYOEMDATA           TCHAR value('OEMData');
 dcl REGSTR_VAL_JOYOEMXYLABEL        TCHAR value('OEMXYLabel');
 dcl REGSTR_VAL_JOYOEMZLABEL         TCHAR value('OEMZLabel');
 dcl REGSTR_VAL_JOYOEMRLABEL         TCHAR value('OEMRLabel');
 dcl REGSTR_VAL_JOYOEMPOVLABEL       TCHAR value('OEMPOVLabel');
 dcl REGSTR_VAL_JOYOEMULABEL         TCHAR value('OEMULabel');
 dcl REGSTR_VAL_JOYOEMVLABEL         TCHAR value('OEMVLabel');
 dcl REGSTR_VAL_JOYOEMTESTMOVEDESC   TCHAR value('OEMTestMoveDesc');
 dcl REGSTR_VAL_JOYOEMTESTBUTTONDESC TCHAR value('OEMTestButtonDesc');
 dcl REGSTR_VAL_JOYOEMTESTMOVECAP    TCHAR value('OEMTestMoveCap');
 dcl REGSTR_VAL_JOYOEMTESTBUTTONCAP  TCHAR value('OEMTestButtonCap');
 dcl REGSTR_VAL_JOYOEMTESTWINCAP     TCHAR value('OEMTestWinCap');
 dcl REGSTR_VAL_JOYOEMCALCAP         TCHAR value('OEMCalCap');
 dcl REGSTR_VAL_JOYOEMCALWINCAP      TCHAR value('OEMCalWinCap');
 dcl REGSTR_VAL_JOYOEMCAL1           TCHAR value('OEMCal1');
 dcl REGSTR_VAL_JOYOEMCAL2           TCHAR value('OEMCal2');
 dcl REGSTR_VAL_JOYOEMCAL3           TCHAR value('OEMCal3');
 dcl REGSTR_VAL_JOYOEMCAL4           TCHAR value('OEMCal4');
 dcl REGSTR_VAL_JOYOEMCAL5           TCHAR value('OEMCal5');
 dcl REGSTR_VAL_JOYOEMCAL6           TCHAR value('OEMCal6');
 dcl REGSTR_VAL_JOYOEMCAL7           TCHAR value('OEMCal7');
 dcl REGSTR_VAL_JOYOEMCAL8           TCHAR value('OEMCal8');
 dcl REGSTR_VAL_JOYOEMCAL9           TCHAR value('OEMCal9');
 dcl REGSTR_VAL_JOYOEMCAL10          TCHAR value('OEMCal10');
 dcl REGSTR_VAL_JOYOEMCAL11          TCHAR value('OEMCal11');
 dcl REGSTR_VAL_JOYOEMCAL12          TCHAR value('OEMCal12');

 %end; /*#INC_REGSTR */

