 /*********************************************************************/
 /*                                                                   */
 /* shlwapi.cpy - Interface for the Windows light-weight utility APIs */
 /*                                                                   */
 /* Version 1.0                                                       */
 /*                                                                   */
 /* Copyright 1991-1998, Microsoft Corp.      All rights reserved.    */
 /*                                                                   */
 /*********************************************************************/

 %dcl #INC_SHLWAPI char ext;
 %if #INC_SHLWAPI = '' %then %do;
 %#INC_SHLWAPI = 'Y';

 %dcl NOSHLWAPI char ext;
 %if NOSHLWAPI = '' %then %do;

 %dcl #WIN32_IE fixed ext;
 %if #WIN32_IE = 0 %then %do;
   %#WIN32_IE = 1280;
 %end;

 /* %include objbase -- elided as no COM support */

 /* Pull in WINREG.CPY (includes WINBASE.CPY) if necessary */
 %dcl #WINREG_ char ext;
 %if #WINREG_ = '' %then %do;
   %include winreg;
 %end;

 %dcl UNICODE char ext;


 /* Define API decoration for direct importing of DLL references. */
 %dcl LWSTDAPI char ext;
 %LWSTDAPI = STDAPI;
 %dcl LWSTDAPI_ entry;
 %LWSTDAPI_: proc (type) returns (char);
   dcl type char;
   return (STDAPI_(type));
 %end LWSTDAPI_;

 %dcl LWSTDAPI_void char ext; /* used in place of LWSTDAPI_(void) */
 %LWSTDAPI_void = STDAPICALLTYPE;

 %dcl LWSTDAPIV char ext;
 %LWSTDAPIV = STDAPIV;
 %dcl LWSTDAPIV_ entry;
 %LWSTDAPIV_: proc (type) returns (char);
   dcl type char;
   return (STDAPIV_(type));
 %end LWSTDAPIV_;

 %dcl LWSTDAPIV_void char ext; /* used in place of LWSTDAPIV_(void) */
 %LWSTDAPIV_void = STDAPIVCALLTYPE;


 /* Users of this header may define any number of these constants */
 /* to avoid the definitions of each functional group.            */
 /*                                                               */
 /*    NO_SHLWAPI_STRFCNS    String functions                     */
 /*    NO_SHLWAPI_PATH       Path functions                       */
 /*    NO_SHLWAPI_REG        Registry functions                   */
 /*    NO_SHLWAPI_STREAM     Stream functions                     */
 /*    NO_SHLWAPI_GDI        GDI helper functions                 */


 %dcl NO_SHLWAPI_STRFCNS char ext;
 %if NO_SHLWAPI_STRFCNS = '' %then %do;

 /* =============== String Routines ================================ */


 dcl StrChrA
     entry (char (*) varz byaddr nonasgn,
            type WORD)
     LWSTDAPI_(type LPSTR) external('StrChrA');
 dcl StrChrW
     entry (char (*) varz byaddr nonasgn,
            type WORD)
     LWSTDAPI_(type LPWSTR) external('StrChrW');

 dcl StrChrIA
     entry (char (*) varz byaddr nonasgn,
            type WORD)
     LWSTDAPI_(type LPSTR) external('StrChrIA');
 dcl StrChrIW
     entry (WCHAR (*) varz byaddr nonasgn,
            type WORD)
     LWSTDAPI_(type LPWSTR) external('StrChrIW');

 dcl StrCmpNA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(fixed bin (31)) external('StrCmpNA');
 dcl StrCmpNW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(fixed bin (31)) external('StrCmpNW');

 dcl StrCmpNIA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(fixed bin (31)) external('StrCmpNIA');
 dcl StrCmpNIW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(fixed bin (31)) external('StrCmpNIW');

 dcl StrCSpnA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(fixed bin (31)) external('StrCSpnA');
 dcl StrCSpnW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(fixed bin (31)) external('StrCSpnW');

 dcl StrCSpnIA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(fixed bin (31)) external('StrCSpnIA');
 dcl StrCSpnIW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(fixed bin (31)) external('StrCSpnIW');

 dcl StrDupA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPSTR) external('StrDupA');
 dcl StrDupW
     entry (WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPWSTR) external('StrDupW');

 dcl StrFormatByteSizeA
     entry (type DWORD,
            char (*) varz byaddr,
            type UINT)
     LWSTDAPI_(type LPSTR) external('StrFormatByteSizeA');
 dcl StrFormatByteSize64A
     entry (type LONGLONG,
            char (*) varz byaddr,
            type UINT)
     LWSTDAPI_(type LPSTR) external('StrFormatByteSize64A');
 dcl StrFormatByteSizeW
     entry (type LONGLONG,
            WCHAR (*) varz byaddr,
            type UINT)
     LWSTDAPI_(type LPWSTR) external('StrFormatByteSizeW');

 dcl StrFormatKBSizeW
     entry (type LONGLONG,
            WCHAR (*) varz byaddr,
            type UINT)
     LWSTDAPI_(type LPSTR) external('StrFormatKBSizeW');
 dcl StrFormatKBSizeA
     entry (type LONGLONG,
            char (*) varz byaddr,
            type UINT)
     LWSTDAPI_(type LPWSTR) external('StrFormatKBSizeA');

 dcl StrFromTimeIntervalA
     entry (char (*) varz byaddr,
            type UINT,
            type DWORD,
            fixed bin(31))
     LWSTDAPI_(fixed bin (31)) external('StrFromTimeIntervalA');
 dcl StrFromTimeIntervalW
     entry (WCHAR (*) varz byaddr,
            type UINT,
            type DWORD,
            fixed bin(31))
     LWSTDAPI_(fixed bin (31)) external('StrFromTimeIntervalW');

 dcl StrIsIntlEqualA
     entry (type BOOL,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(type BOOL) external('StrIsIntlEqualA');
 dcl StrIsIntlEqualW
     entry (type BOOL,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(type BOOL) external('StrIsIntlEqualW');

 dcl StrNCatA
     entry (char (*) varz byaddr,
            char (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(type LPSTR) external('StrNCatA');
 dcl StrNCatW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(type LPWSTR) external('StrNCatW');

 dcl StrPBrkA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPSTR) external('StrPBrkA');
 dcl StrPBrkW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPWSTR) external('StrPBrkW');

 dcl StrRChrA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            type WORD)
     LWSTDAPI_(type LPSTR) external('StrRChrA');
 dcl StrRChrW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            type WORD)
     LWSTDAPI_(type LPWSTR) external('StrRChrW');

 dcl StrRChrIA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            type WORD)
     LWSTDAPI_(type LPSTR) external('StrRChrIA');
 dcl StrRChrIW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            type WORD)
     LWSTDAPI_(type LPWSTR) external('StrRChrIW');

 dcl StrRStrIA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPSTR) external('StrRStrIA');
 dcl StrRStrIW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPWSTR) external('StrRStrIW');

 dcl StrSpnA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(fixed bin (31)) external('StrSpnA');
 dcl StrSpnW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(fixed bin (31)) external('StrSpnW');

 dcl StrStrA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPSTR) external('StrStrA');
 dcl StrStrW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPWSTR) external('StrStrW');

 dcl StrStrIA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPSTR) external('StrStrIA');
 dcl StrStrIW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPWSTR) external('StrStrIW');

 dcl StrToIntA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(fixed bin (31)) external('StrToIntA');
 dcl StrToIntW
     entry (WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(fixed bin (31)) external('StrToIntW');

 dcl StrToIntExA
     entry (char (*) varz byaddr nonasgn,
            type DWORD,
            fixed bin (31) byaddr)
     LWSTDAPI_(type BOOL) external('StrToIntExA');
 dcl StrToIntExW
     entry (WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            fixed bin (31) byaddr)
     LWSTDAPI_(type BOOL) external('StrToIntExW');

 dcl StrTrimA
     entry (char (*) varz byaddr,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('StrTrimA');
 dcl StrTrimW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('StrTrimW');

 dcl StrCatW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPWSTR) external('StrCatW');

 dcl StrCmpW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(fixed bin (31)) external('StrCmpW');

 dcl StrCmpIW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(fixed bin (31)) external('StrCmpIW');

 dcl StrCpyW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPWSTR) external('StrCpyW');

 dcl StrCpyNW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(type LPWSTR) external('StrCpyNW');

 dcl StrCpyNXA
     entry (char (*) varz byaddr,
            char (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(type LPSTR) external('StrCpyNXA');
 dcl StrCpyNXW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(type LPWSTR) external('StrCpyNXW');

 dcl StrCatBuffW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn,
            fixed bin (31))
     LWSTDAPI_(type LPWSTR) external('StrCatBuffW');
 dcl StrCatBuffA
     entry (char (*) varz byaddr,
            char (*) varz byaddr nonasgn,
            fixed bin (31))
     LWSTDAPI_(type LPSTR) external('StrCatBuffA');

 dcl ChrCmpIA
     entry (type WORD,
            type WORD)
     LWSTDAPI_(type BOOL) external('ChrCmpIA');
 dcl ChrCmpIW
     entry (type WORD,
            type WORD)
     LWSTDAPI_(type BOOL) external('ChrCmpIW');

 %dcl VA_LIST_DEFINED char ext;
 %if VA_LIST_DEFINED = '' %then %do;
   %VA_LIST_DEFINED = 'Y';
   define alias va_list pointer;
 %end;

 dcl wvnsprintfA
     entry (char (*) varz byaddr,
            fixed bin (31),
            char (*) varz byaddr nonasgn,
            type va_list)
     LWSTDAPI_(fixed bin (31)) external('wvnsprintfA');
 dcl wvnsprintfW
     entry (WCHAR (*) varz byaddr,
            fixed bin (31),
            WCHAR (*) varz byaddr nonasgn,
            type va_list)
     LWSTDAPI_(fixed bin (31)) external('wvnsprintfW');

 dcl wnsprintfA
     entry (char (*) varz byaddr,
            fixed bin (31),
            char (*) varz byaddr nonasgn list)
     LWSTDAPIV_(fixed bin(31)) external('wnsprintfA');
 dcl wnsprintfW
     entry (WCHAR (*) varz byaddr,
            fixed bin (31),
            WCHAR (*) varz byaddr nonasgn list)
     LWSTDAPIV_(fixed bin(31)) external('wnsprintfW');

 dcl MLLoadLibraryA
     entry (char (*) varz byaddr nonasgn,
            type HANDLE,
            type DWORD,
            char (*) varz byaddr nonasgn,
            type BOOL)
     LWSTDAPI_(type HINSTANCE) external('MLLoadLibraryA');
 dcl MLLoadLibraryW
     entry (WCHAR (*) varz byaddr nonasgn,
            type HANDLE,
            type DWORD,
            WCHAR (*) varz byaddr nonasgn,
            type BOOL)
     LWSTDAPI_(type HINSTANCE) external('MLLoadLibraryW');

 %dcl MLLoadLibrary char ext;
 %if UNICODE ^= '' %then %do;
   %MLLoadLibrary = 'MLLoadLibraryW';
 %end; %else %do;
   %MLLoadLibrary = 'MLLoadLibraryA';
 %end; /* !UNICODE */

 dcl MLGetUILanguage
     entry ()
     LWSTDAPI_(type LANGID) external('MLGetUILanguage');

 StrIntlEqNA: proc (s1, s2, nChar)
              returns (type BOOL optional)
              options (inline reorder) internal;
   dcl s1    char (*) varz byaddr nonasgn,
       s2    char (*) varz byaddr nonasgn,
       nChar fixed bin(31) byvalue;
   return (StrIsIntlEqualA (TRUE, s1, s2, nChar));
 end StrIntlEqNA;

 StrIntlEqNW: proc (s1, s2, nChar)
              returns (type BOOL optional)
              options (inline reorder) internal;
   dcl s1    WCHAR (*) varz byaddr nonasgn,
       s2    WCHAR (*) varz byaddr nonasgn,
       nChar fixed bin(31) byvalue;
   return (StrIsIntlEqualW (TRUE, s1, s2, nChar));
 end StrIntlEqNW;

 StrIntlEqNIA: proc (s1, s2, nChar)
               returns (type BOOL optional)
               options (inline reorder) internal;
   dcl s1    char (*) varz byaddr nonasgn,
       s2    char (*) varz byaddr nonasgn,
       nChar fixed bin(31) byvalue;
   return (StrIsIntlEqualA (FALSE, s1, s2, nChar));
 end StrIntlEqNIA;

 StrIntlEqNIW: proc (s1, s2, nChar)
               returns (type BOOL optional)
               options (inline reorder) internal;
   dcl s1    WCHAR (*) varz byaddr nonasgn,
       s2    WCHAR (*) varz byaddr nonasgn,
       nChar fixed bin(31) byvalue;
   return (StrIsIntlEqualW (FALSE, s1, s2, nChar));
 end StrIntlEqNIW;

 %if 0 = 1 %then %do;
 /* won't work, as don't have OLE or shellobj.cpy */
 dcl StrRetToStrA
     entry  (type STRRET byaddr,
             type ITEMIDLIST byaddr nonasgn unaligned,
             type LPSTR byaddr)
     LWSTDAPI external('StrRetToStrA');
 dcl StrRetToStrW
     entry  (type STRRET byaddr,
             type ITEMIDLIST byaddr nonasgn unaligned,
             type LPWSTR byaddr)
     LWSTDAPI external('StrRetToStrW');

 %dcl StrRetToStr char ext;
 %if UNICODE ^= '' %then %do;
   %StrRetToStr = 'StrRetToStrW';
 %end; %else %do;
   %StrRetToStr = 'StrRetToStrA';
 %end; /* !UNICODE */

 dcl StrRetToBufA
     entry  (type STRRET byaddr,
             type ITEMIDLIST byaddr nonasgn unaligned,
             type LPSTR byaddr,
             type UINT)
     LWSTDAPI external('StrRetToBufA');
 dcl StrRetToBufW
     entry  (type STRRET byaddr,
             type ITEMIDLIST byaddr nonasgn unaligned,
             type LPSTR byaddr,
             type UINT)
     LWSTDAPI external('StrRetToBufW');

 %dcl StrRetToBuf char ext;
 %if UNICODE ^= '' %then %do;
   %StrRetToBuf = 'StrRetToBufW';
 %end; %else %do;
   %StrRetToBuf = 'StrRetToBufA';
 %end; /* !UNICODE */

 /* helper to duplicate a string using the task allocator */

 dcl SHStrDupA
     entry (char (*) varz byaddr nonasgn,
            type LPWSTR byaddr) /* result is always Unicode */
     LWSTDAPI external('SHStrDupA');

 dcl SHStrDupW
     entry (WCHAR (*) varz byaddr nonasgn,
            type LPWSTR byaddr)
     LWSTDAPI external('SHStrDupW');

 %dcl SHStrDup char ext;
 %if UNICODE ^= '' %then %do;
   %SHStrDup = 'SHStrDupW';
 %end; %else %do;
   %SHStrDup = 'SHStrDupA';
 %end; /* !UNICODE */
 %end; /* %if 0 = 1 %then %do */

 %dcl StrChr              char ext;
 %dcl StrRChr             char ext;
 %dcl StrChrI             char ext;
 %dcl StrRChrI            char ext;
 %dcl StrCmpN             char ext;
 %dcl StrCmpNI            char ext;
 %dcl StrStr              char ext;
 %dcl StrStrI             char ext;
 %dcl StrDup              char ext;
 %dcl StrRStrI            char ext;
 %dcl StrCSpn             char ext;
 %dcl StrCSpnI            char ext;
 %dcl StrSpn              char ext;
 %dcl StrToInt            char ext;
 %dcl StrPBrk             char ext;
 %dcl StrToIntEx          char ext;
 %dcl StrFromTimeInterval char ext;
 %dcl StrIntlEqN          char ext;
 %dcl StrIntlEqNI         char ext;
 %dcl StrFormatByteSize   char ext;
 %dcl StrFormatByteSize64 char ext;
 %dcl StrFormatKBSize     char ext;
 %dcl StrNCat             char ext;
 %dcl StrTrim             char ext;
 %dcl StrCatBuff          char ext;
 %dcl ChrCmpI             char ext;
 %dcl wvnsprintf          char ext;
 %dcl wnsprintf           char ext;
 %dcl MLLoadLibrary       char ext;

 %if UNICODE ^= '' %then %do;
   %StrChr              = 'StrChrW';
   %StrRChr             = 'StrRChrW';
   %StrChrI             = 'StrChrIW';
   %StrRChrI            = 'StrRChrIW';
   %StrCmpN             = 'StrCmpNW';
   %StrCmpNI            = 'StrCmpNIW';
   %StrStr              = 'StrStrW';
   %StrStrI             = 'StrStrIW';
   %StrDup              = 'StrDupW';
   %StrRStrI            = 'StrRStrIW';
   %StrCSpn             = 'StrCSpnW';
   %StrCSpnI            = 'StrCSpnIW';
   %StrSpn              = 'StrSpnW';
   %StrToInt            = 'StrToIntW';
   %StrPBrk             = 'StrPBrkW';
   %StrToIntEx          = 'StrToIntExW';
   %StrFromTimeInterval = 'StrFromTimeIntervalW';
   %StrIntlEqN          = 'StrIntlEqNW';
   %StrIntlEqNI         = 'StrIntlEqNIW';
   %StrFormatByteSize   = 'StrFormatByteSizeW';
   %StrFormatByteSize64 = 'StrFormatByteSize64W';
   %StrFormatKBSize     = 'StrFormatKBSizeW';
   %StrNCat             = 'StrNCatW';
   %StrTrim             = 'StrTrimW';
   %StrCatBuff          = 'StrCatBuffW';
   %ChrCmpI             = 'ChrCmpIW';
   %wvnsprintf          = 'wvnsprintfW';
   %wnsprintf           = 'wnsprintfW';
   %MLLoadLibrary       = 'MLLoadLibraryW';
 %end; %else %do;
   %StrChr              = 'StrChrA';
   %StrRChr             = 'StrRChrA';
   %StrChrI             = 'StrChrIA';
   %StrRChrI            = 'StrRChrIA';
   %StrCmpN             = 'StrCmpNA';
   %StrCmpNI            = 'StrCmpNIA';
   %StrStr              = 'StrStrA';
   %StrStrI             = 'StrStrIA';
   %StrDup              = 'StrDupA';
   %StrRStrI            = 'StrRStrIA';
   %StrCSpn             = 'StrCSpnA';
   %StrCSpnI            = 'StrCSpnIA';
   %StrSpn              = 'StrSpnA';
   %StrToInt            = 'StrToIntA';
   %StrPBrk             = 'StrPBrkA';
   %StrToIntEx          = 'StrToIntExA';
   %StrFromTimeInterval = 'StrFromTimeIntervalA';
   %StrIntlEqN          = 'StrIntlEqNA';
   %StrIntlEqNI         = 'StrIntlEqNIA';
   %StrFormatByteSize   = 'StrFormatByteSizeA';
   %StrFormatByteSize64 = 'StrFormatByteSize64A';
   %StrFormatKBSize     = 'StrFormatKBSizeA';
   %StrNCat             = 'StrNCatA';
   %StrTrim             = 'StrTrimA';
   %StrCatBuff          = 'StrCatBuffA';
   %ChrCmpI             = 'ChrCmpIA';
   %wvnsprintf          = 'wvnsprintfA';
   %wnsprintf           = 'wnsprintfA';
   %MLLoadLibrary       = 'MLLoadLibraryA';
 %end;

 /* Backward compatible to NT's non-standard naming */
 /* (strictly for comctl32)                         */

 dcl IntlStrEqWorkerA
     entry (type BOOL,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(type BOOL) external('IntlStrEqWorkerA');
 dcl IntlStrEqWorkerW
     entry (type BOOL,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            fixed bin(31))
     LWSTDAPI_(type BOOL) external('IntlStrEqWorkerW');

 IntlStrEqNA: proc (s1, s2, nChar)
              returns (type BOOL byvalue optional)
              options (inline reorder) internal;
   dcl s1    char (*) varz byaddr nonasgn,
       s2    char (*) varz byaddr nonasgn,
       nChar fixed bin(31) byvalue;
   return (IntlStrEqWorkerA (TRUE, s1, s2, nChar));
 end IntlStrEqNA;

 IntlStrEqNW: proc (s1, s2, nChar)
              returns (type BOOL byvalue optional)
              options (inline reorder) internal;
   dcl s1    WCHAR (*) varz byaddr nonasgn,
       s2    WCHAR (*) varz byaddr nonasgn,
       nChar fixed bin(31) byvalue;
   return (IntlStrEqWorkerW (TRUE, s1, s2, nChar));
 end IntlStrEqNW;

 IntlStrEqNIA: proc (s1, s2, nChar)
               returns (type BOOL byvalue optional)
               options (inline reorder) internal;
   dcl s1    char (*) varz byaddr nonasgn,
       s2    char (*) varz byaddr nonasgn,
       nChar fixed bin(31) byvalue;
   return (IntlStrEqWorkerA (FALSE, s1, s2, nChar));
 end IntlStrEqNIA;

 IntlStrEqNIW: proc (s1, s2, nChar)
               returns (type BOOL byvalue optional)
               options (inline reorder) internal;
   dcl s1    WCHAR (*) varz byaddr nonasgn,
       s2    WCHAR (*) varz byaddr nonasgn,
       nChar fixed bin(31) byvalue;
   return (IntlStrEqWorkerW (FALSE, s1, s2, nChar));
 end IntlStrEqNIW;


 %dcl IntlStrEqN  char ext;
 %dcl IntlStrEqNI char ext;
 %if UNICODE ^= '' %then %do;
   %IntlStrEqN  = 'IntlStrEqNW';
   %IntlStrEqNI = 'IntlStrEqNIW';
 %end; %else %do;
   %IntlStrEqN  = 'IntlStrEqNA';
   %IntlStrEqNI = 'IntlStrEqNIA';
 %end;

 dcl SZ_CONTENTTYPE_HTMLA       char value('text/html');
 dcl SZ_CONTENTTYPE_HTMLW       WCHAR value('text/html');
 dcl SZ_CONTENTTYPE_CDFA        char value('application/x-cdf');
 dcl SZ_CONTENTTYPE_CDFW        WCHAR value('application/x-cdf');

 %dcl SZ_CONTENTTYPE_HTML char ext;
 %dcl SZ_CONTENTTYPE_CDF  char ext;
 %if UNICODE ^= '' %then %do;
   %SZ_CONTENTTYPE_HTML = 'SZ_CONTENTTYPE_HTMLW';
   %SZ_CONTENTTYPE_CDF  = 'SZ_CONTENTTYPE_CDFW';
 %end; %else %do;
   %SZ_CONTENTTYPE_HTML = 'SZ_CONTENTTYPE_HTMLA';
   %SZ_CONTENTTYPE_CDF  = 'SZ_CONTENTTYPE_CDFA';
 %end;

 PathIsHTMLFileA: proc (pszPath)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl pszPath char (*) varz byaddr nonasgn;
   return (PathIsContentTypeA (pszPath, SZ_CONTENTTYPE_HTMLA));
 end PathIsHTMLFileA;

 PathIsHTMLFileW: proc (pszPath)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl pszPath WCHAR (*) varz byaddr nonasgn;
   return (PathIsContentTypeW (pszPath, SZ_CONTENTTYPE_HTMLW));
 end PathIsHTMLFileW;


 /* Flags for StrToIntEx */
 dcl STIF_DEFAULT     fixed bin(31) value('00000000'xn);
 dcl STIF_SUPPORT_HEX fixed bin(31) value('00000001'xn);


 %dcl StrCatA  char ext;
 %StrCatA  = 'lstrcatA';   /* defined in WinBase */
 %dcl StrCmpA  char ext;
 %StrCmpA  = 'lstrcmpA';   /* defined in WinBase */
 %dcl StrCmpIA char ext;
 %StrCmpIA = 'lstrcmpiA';  /* defined in WinBase */
 %dcl StrCpyA  char ext;
 %StrCpyA  = 'lstrcpyA';   /* defined in WinBase */
 %dcl StrCpyNA char ext;
 %StrCpyNA = 'lstrcpynA';  /* defined in WinBase */


 %dcl StrToLong char ext;
 %StrToLong = 'StrToInt';
 %dcl StrNCmp   char ext;
 %StrNCmp   = 'StrCmpN';
 %dcl StrNCmpI  char ext;
 %StrNCmpI  = 'StrCmpNI';
 %dcl StrNCpy   char ext;
 %StrNCpy   = 'StrCpyN';
 %dcl StrCatN   char ext;
 %StrCatN   = 'StrNCat';

 %dcl StrCat     char ext;
 %dcl StrCmp     char ext;
 %dcl StrCmpI    char ext;
 %dcl StrCpy     char ext;
 %dcl StrCpyN    char ext;
 %dcl StrCpyNX   char ext;
 %dcl StrCatBuff char ext;

 %if UNICODE ^= '' %then %do;
   %StrCat     = 'StrCatW';
   %StrCmp     = 'StrCmpW';
   %StrCmpI    = 'StrCmpIW';
   %StrCpy     = 'StrCpyW';
   %StrCpyN    = 'StrCpyNW';
   %StrCpyNX   = 'StrCpyNXW';
   %StrCatBuff = 'StrCatBuffW';
 %end; %else %do;
   %StrCat     = 'lstrcatA';    /* defined in WinBase */
   %StrCmp     = 'lstrcmpA';    /* defined in WinBase */
   %StrCmpI    = 'lstrcmpiA';   /* defined in WinBase */
   %StrCpy     = 'lstrcpyA';    /* defined in WinBase */
   %StrCpyN    = 'lstrcpynA';   /* defined in WinBase */
   %StrCpyNX   = 'StrCpyNXA';
   %StrCatBuff = 'StrCatBuffA';
 %end;

 %end; /*  NO_SHLWAPI_STRFCNS */


 %dcl NO_SHLWAPI_PATH char ext;
 %if NO_SHLWAPI_PATH = '' %then %do;


 /* =============== Path Routines =================================== */


 dcl PathAddBackslashA
     entry (char (*) varz byaddr)
     LWSTDAPI_(type LPSTR) external('PathAddBackslashA');
 dcl PathAddBackslashW
     entry (WCHAR (*) varz byaddr)
     LWSTDAPI_(type LPWSTR) external('PathAddBackslashW');

 dcl PathAddExtensionA
     entry (char (*) varz byaddr optional,
            char (*) varz byaddr nonasgn optional)
     LWSTDAPI_(type BOOL) external('PathAddExtensionA');
 dcl PathAddExtensionW
     entry (WCHAR (*) varz byaddr optional,
            WCHAR (*) varz byaddr nonasgn optional)
     LWSTDAPI_(type BOOL) external('PathAddExtensionW');

 dcl PathAppendA
     entry (char (*) varz byaddr,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathAppendA');
 dcl PathAppendW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathAppendW');

 dcl PathBuildRootA
     entry (char (*) varz byaddr,
            fixed bin(31))
     LWSTDAPI_(type LPSTR) external('PathBuildRootA');
 dcl PathBuildRootW
     entry (WCHAR (*) varz byaddr,
            fixed bin(31))
     LWSTDAPI_(type LPWSTR) external('PathBuildRootW');

 dcl PathCanonicalizeA
     entry (char (*) varz byaddr,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathCanonicalizeA');
 dcl PathCanonicalizeW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathCanonicalizeW');

 dcl PathCombineA
     entry (char (*) varz byaddr,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPSTR) external('PathCombineA');
 dcl PathCombineW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPWSTR) external('PathCombineW');

 dcl PathCompactPathA
     entry (type HDC,
            char (*) varz byaddr,
            type UINT)
     LWSTDAPI_(type BOOL) external('PathCompactPathA');
 dcl PathCompactPathW
     entry (type HDC,
            WCHAR (*) varz byaddr,
            type UINT)
     LWSTDAPI_(type BOOL) external('PathCompactPathW');

 dcl PathCompactPathExA
     entry (char (*) varz byaddr,
            char (*) varz byaddr nonasgn,
            type UINT,
            type DWORD)
     LWSTDAPI_(type BOOL) external('PathCompactPathExA');
 dcl PathCompactPathExW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn,
            type UINT,
            type DWORD)
     LWSTDAPI_(type BOOL) external('PathCompactPathExW');

 dcl PathCommonPrefixA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr)
     LWSTDAPI_(fixed bin(31)) external('PathCommonPrefixA');
 dcl PathCommonPrefixW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr)
     LWSTDAPI_(fixed bin(31)) external('PathCommonPrefixW');

 dcl PathFileExistsA
     entry (char (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathFileExistsA');
 dcl PathFileExistsW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathFileExistsW');

 dcl PathFindExtensionA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPSTR) external('PathFindExtensionA');
 dcl PathFindExtensionW
     entry (WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPWSTR) external('PathFindExtensionW');

 dcl PathFindFileNameA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPSTR) external('PathFindFileNameA');
 dcl PathFindFileNameW
     entry (WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPWSTR) external('PathFindFileNameW');

 dcl PathFindNextComponentA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPSTR) external('PathFindNextComponentA');
 dcl PathFindNextComponentW
     entry (WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPWSTR) external('PathFindNextComponentW');

 dcl PathFindOnPathA
     entry (char (*) varz byaddr,
            (*) type LPCSTR byaddr optional)  /* set last to sysnull */
     LWSTDAPI_(type BOOL) external('PathFindOnPathA');
 dcl PathFindOnPathW
     entry (WCHAR (*) varz byaddr,
            (*) type LPCWSTR byaddr optional) /* set last to sysnull */
     LWSTDAPI_(type BOOL) external('PathFindOnPathW');

 dcl PathGetArgsA
     entry (char (*) varz byaddr nonasgn )
     LWSTDAPI_(type LPSTR) external('PathGetArgsA');
 dcl PathGetArgsW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type LPWSTR) external('PathGetArgsW');

 dcl PathFindSuffixArrayA
     entry (char (*) varz byaddr nonasgn,
            (*) type LPCSTR byaddr nonasgn,
            fixed bin (31))
     LWSTDAPI_(type LPCSTR) external('PathFindSuffixArrayA');
 dcl PathFindSuffixArrayW
     entry (WCHAR (*) varz byaddr nonasgn,
            (*) type LPCWSTR byaddr nonasgn,
            fixed bin (31))
     LWSTDAPI_(type LPCWSTR) external('PathFindSuffixArrayW');

 dcl PathIsLFNFileSpecA
     entry (char (*) varz byaddr nonasgn)
     STDAPI_(type BOOL) external('PathIsLFNFileSpecA');

 dcl PathIsLFNFileSpecW
     entry (WCHAR (*) varz byaddr nonasgn)
     STDAPI_(type BOOL) external('PathIsLFNFileSpecW');

 dcl PathGetCharTypeA
     entry (char (1))
     LWSTDAPI_(type UINT) external('PathGetCharTypeA');
 dcl PathGetCharTypeW
     entry (WCHAR(1))
     LWSTDAPI_(type UINT) external('PathGetCharTypeW');

 /* Return flags for PathGetCharType */
 dcl GCT_INVALID   type UINT value('0000'xn);
 dcl GCT_LFNCHAR   type UINT value('0001'xn);
 dcl GCT_SHORTCHAR type UINT value('0002'xn);
 dcl GCT_WILD      type UINT value('0004'xn);
 dcl GCT_SEPARATOR type UINT value('0008'xn);

 dcl PathGetDriveNumberA
     entry (char (*) varz byaddr nonasgn )
     LWSTDAPI_(fixed bin(31)) external('PathGetDriveNumberA');
 dcl PathGetDriveNumberW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(fixed bin(31)) external('PathGetDriveNumberW');

 dcl PathIsDirectoryA
     entry (char (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathIsDirectoryA');
 dcl PathIsDirectoryW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathIsDirectoryW');

 dcl PathIsDirectoryEmptyA
     entry (char (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathIsDirectoryEmptyA');
 dcl PathIsDirectoryEmptyW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathIsDirectoryEmptyW');

 dcl PathIsFileSpecA
     entry (char (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathIsFileSpecA');
 dcl PathIsFileSpecW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathIsFileSpecW');

 dcl PathIsPrefixA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsPrefixA');
 dcl PathIsPrefixW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsPrefixW');

 dcl PathIsRelativeA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsRelativeA');
 dcl PathIsRelativeW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathIsRelativeW');

 dcl PathIsRootA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsRootA');
 dcl PathIsRootW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathIsRootW');

 dcl PathIsSameRootA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsSameRootA');
 dcl PathIsSameRootW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsSameRootW');

 dcl PathIsUNCA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsUNCA');
 dcl PathIsUNCW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathIsUNCW');

 dcl PathIsNetworkPathA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsNetworkPathA');
 dcl PathIsNetworkPathW
     entry (WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsNetworkPathW');

 dcl PathIsUNCServerA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsUNCServerA');
 dcl PathIsUNCServerW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathIsUNCServerW');

 dcl PathIsUNCServerShareA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsUNCServerShareA');
 dcl PathIsUNCServerShareW
     entry (WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsUNCServerShareW');

 dcl PathIsContentTypeA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsContentTypeA');
 dcl PathIsContentTypeW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsContentTypeW');

 dcl PathIsURLA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsURLA');
 dcl PathIsURLW
     entry (WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathIsURLW');

 dcl PathMakePrettyA
     entry (char (*) varz byaddr)
     LWSTDAPI_(type BOOL) external('PathMakePrettyA');
 dcl PathMakePrettyW
     entry (WCHAR (*) varz byaddr)
     LWSTDAPI_(type BOOL) external('PathMakePrettyW');

 dcl PathMatchSpecA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathMatchSpecA');
 dcl PathMatchSpecW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathMatchSpecW');

 dcl PathParseIconLocationA
     entry (char (*) varz byaddr)
     LWSTDAPI_(fixed bin(31)) external('PathParseIconLocationA');
 dcl PathParseIconLocationW
     entry (WCHAR (*) varz byaddr)
     LWSTDAPI_(fixed bin(31)) external('PathParseIconLocationW');

 dcl PathQuoteSpacesA
     entry (char (*) varz byaddr )
     LWSTDAPI_void external('PathQuoteSpacesA');
 dcl PathQuoteSpacesW
     entry (WCHAR(*) varz byaddr )
     LWSTDAPI_void external('PathQuoteSpacesW');

 dcl PathRelativePathToA
     entry (char (*) varz byaddr,
            char (*) varz byaddr nonasgn,
            type DWORD,
            char (*) varz byaddr nonasgn,
            type DWORD)
     LWSTDAPI_(type BOOL) external('PathRelativePathToA');
 dcl PathRelativePathToW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD)
     LWSTDAPI_(type BOOL) external('PathRelativePathToW');

 dcl PathRemoveArgsA
     entry (char (*) varz byaddr)
     LWSTDAPI_void external('PathRemoveArgsA');
 dcl PathRemoveArgsW
     entry (WCHAR (*) varz byaddr)
     LWSTDAPI_void external('PathRemoveArgsW');

 dcl PathRemoveBackslashA
     entry (char (*) varz byaddr)
     LWSTDAPI_(type LPSTR) external('PathRemoveBackslashA');
 dcl PathRemoveBackslashW
     entry (WCHAR (*) varz byaddr)
     LWSTDAPI_(type LPWSTR) external('PathRemoveBackslashW');

 dcl PathRemoveBlanksA
     entry (char (*) varz byaddr)
     LWSTDAPI_void external('PathRemoveBlanksA');
 dcl PathRemoveBlanksW
     entry (WCHAR (*) varz byaddr)
     LWSTDAPI_void external('PathRemoveBlanksW');

 dcl PathRemoveExtensionA
     entry (char (*) varz byaddr)
     LWSTDAPI_void external('PathRemoveExtensionA');
 dcl PathRemoveExtensionW
     entry (WCHAR (*) varz byaddr)
     LWSTDAPI_void external('PathRemoveExtensionW');

 dcl PathRemoveFileSpecA
     entry (char (*) varz byaddr)
     LWSTDAPI_(type BOOL) external('PathRemoveFileSpecA');
 dcl PathRemoveFileSpecW
     entry (WCHAR(*) varz byaddr)
     LWSTDAPI_(type BOOL) external('PathRemoveFileSpecW');

 dcl PathRenameExtensionA
     entry (char (*) varz byaddr,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathRenameExtensionA');
 dcl PathRenameExtensionW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('PathRenameExtensionW');

 dcl PathSearchAndQualifyA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type UINT)
     LWSTDAPI_(type BOOL) external('PathSearchAndQualifyA');
 dcl PathSearchAndQualifyW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type UINT)
     LWSTDAPI_(type BOOL) external('PathSearchAndQualifyW');

 dcl PathSetDlgItemPathA
     entry (type HWND,
            fixed bin(31),
            char (*) varz byaddr nonasgn)
     LWSTDAPI_void external('PathSetDlgItemPathA');
 dcl PathSetDlgItemPathW
     entry (type HWND,
            fixed bin(31),
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_void external('PathSetDlgItemPathW');

 dcl PathSkipRootA
     entry (char (*) varz byaddr nonasgn )
     LWSTDAPI_(type LPSTR) external('PathSkipRootA');
 dcl PathSkipRootW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type LPWSTR) external('PathSkipRootW');

 dcl PathStripPathA
     entry (char (*) varz byaddr)
     LWSTDAPI_void external('PathStripPathA');
 dcl PathStripPathW
     entry (WCHAR (*) varz byaddr)
     LWSTDAPI_void external('PathStripPathW');

 dcl PathStripToRootA
     entry (char (*) varz byaddr)
     LWSTDAPI_(type BOOL) external('PathStripToRootA');
 dcl PathStripToRootW
     entry (WCHAR (*) varz byaddr)
     LWSTDAPI_(type BOOL) external('PathStripToRootW');

 dcl PathUnquoteSpacesA
     entry (char (*) varz byaddr)
     LWSTDAPI_void external('PathUnquoteSpacesA');
 dcl PathUnquoteSpacesW
     entry (WCHAR (*) varz byaddr)
     LWSTDAPI_void external('PathUnquoteSpacesW');

 dcl PathMakeSystemFolderA
     entry (char (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathMakeSystemFolderA');
 dcl PathMakeSystemFolderW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathMakeSystemFolderW');

 dcl PathUnmakeSystemFolderA
     entry (char (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathUnmakeSystemFolderA');
 dcl PathUnmakeSystemFolderW
     entry (WCHAR (*) varz byaddr nonasgn )
     LWSTDAPI_(type BOOL) external('PathUnmakeSystemFolderW');

 dcl PathIsSystemFolderA
     entry (char (*) varz byaddr nonasgn,
            type DWORD)
     LWSTDAPI_(type BOOL) external('PathIsSystemFolderA');
 dcl PathIsSystemFolderW
     entry (WCHAR (*) varz byaddr nonasgn,
            type DWORD)
     LWSTDAPI_(type BOOL) external('PathIsSystemFolderW');

 dcl PathUndecorateA
     entry (char (*) varz byaddr)
     LWSTDAPI_void external('PathUndecorateA');
 dcl PathUndecorateW
     entry (WCHAR (*) varz byaddr)
     LWSTDAPI_void external('PathUndecorateW');

 dcl PathUnExpandEnvStringsA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type UINT)
     LWSTDAPI_(type BOOL) external('PathUnExpandEnvStringsA');
 dcl PathUnExpandEnvStringsW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type UINT)
     LWSTDAPI_(type BOOL) external('PathUnExpandEnvStringsW');


 %dcl PathAddBackslash       char ext;
 %dcl PathAddExtension       char ext;
 %dcl PathAppend             char ext;
 %dcl PathBuildRoot          char ext;
 %dcl PathCanonicalize       char ext;
 %dcl PathCombine            char ext;
 %dcl PathCompactPath        char ext;
 %dcl PathCompactPathEx      char ext;
 %dcl PathCommonPrefix       char ext;
 %dcl PathFileExists         char ext;
 %dcl PathFindExtension      char ext;
 %dcl PathFindFileName       char ext;
 %dcl PathFindNextComponent  char ext;
 %dcl PathFindOnPath         char ext;
 %dcl PathGetArgs            char ext;
 %dcl PathGetCharType        char ext;
 %dcl PathGetDriveNumber     char ext;
 %dcl PathIsDirectory        char ext;
 %dcl PathIsDirectoryEmpty   char ext;
 %dcl PathIsFileSpec         char ext;
 %dcl PathIsPrefix           char ext;
 %dcl PathIsRelative         char ext;
 %dcl PathIsRoot             char ext;
 %dcl PathIsSameRoot         char ext;
 %dcl PathIsUNC              char ext;
 %dcl PathIsNetworkPath      char ext;
 %dcl PathIsUNCServer        char ext;
 %dcl PathIsUNCServerShare   char ext;
 %dcl PathIsContentType      char ext;
 %dcl PathIsHTMLFile         char ext;
 %dcl PathIsURL              char ext;
 %dcl PathMakePretty         char ext;
 %dcl PathMatchSpec          char ext;
 %dcl PathParseIconLocation  char ext;
 %dcl PathQuoteSpaces        char ext;
 %dcl PathRelativePathTo     char ext;
 %dcl PathRemoveArgs         char ext;
 %dcl PathRemoveBackslash    char ext;
 %dcl PathRemoveBlanks       char ext;
 %dcl PathRemoveExtension    char ext;
 %dcl PathRemoveFileSpec     char ext;
 %dcl PathRenameExtension    char ext;
 %dcl PathSearchAndQualify   char ext;
 %dcl PathSetDlgItemPath     char ext;
 %dcl PathSkipRoot           char ext;
 %dcl PathStripPath          char ext;
 %dcl PathStripToRoot        char ext;
 %dcl PathUnquoteSpaces      char ext;
 %dcl PathMakeSystemFolder   char ext;
 %dcl PathUnmakeSystemFolder char ext;
 %dcl PathIsSystemFolder     char ext;
 %dcl PathFindSuffixArray    char ext;
 %dcl PathIsLFNFileSpec      char ext;
 %dcl PathUndecorate         char ext;
 %dcl PathUnExpandEnvStrings char ext;

 %if UNICODE ^= '' %then %do;
   %PathAddBackslash       = 'PathAddBackslashW';
   %PathAddExtension       = 'PathAddExtensionW';
   %PathAppend             = 'PathAppendW';
   %PathBuildRoot          = 'PathBuildRootW';
   %PathCanonicalize       = 'PathCanonicalizeW';
   %PathCombine            = 'PathCombineW';
   %PathCompactPath        = 'PathCompactPathW';
   %PathCompactPathEx      = 'PathCompactPathExW';
   %PathCommonPrefix       = 'PathCommonPrefixW';
   %PathFileExists         = 'PathFileExistsW';
   %PathFindExtension      = 'PathFindExtensionW';
   %PathFindFileName       = 'PathFindFileNameW';
   %PathFindNextComponent  = 'PathFindNextComponentW';
   %PathFindOnPath         = 'PathFindOnPathW';
   %PathGetArgs            = 'PathGetArgsW';
   %PathGetCharType        = 'PathGetCharTypeW';
   %PathGetDriveNumber     = 'PathGetDriveNumberW';
   %PathIsDirectory        = 'PathIsDirectoryW';
   %PathIsDirectoryEmpty   = 'PathIsDirectoryEmptyW';
   %PathIsFileSpec         = 'PathIsFileSpecW';
   %PathIsPrefix           = 'PathIsPrefixW';
   %PathIsRelative         = 'PathIsRelativeW';
   %PathIsRoot             = 'PathIsRootW';
   %PathIsSameRoot         = 'PathIsSameRootW';
   %PathIsUNC              = 'PathIsUNCW';
   %PathIsNetworkPath      = 'PathIsNetworkPathW';
   %PathIsUNCServer        = 'PathIsUNCServerW';
   %PathIsUNCServerShare   = 'PathIsUNCServerShareW';
   %PathIsContentType      = 'PathIsContentTypeW';
   %PathIsHTMLFile         = 'PathIsHTMLFileW';
   %PathIsURL              = 'PathIsURLW';
   %PathMakePretty         = 'PathMakePrettyW';
   %PathMatchSpec          = 'PathMatchSpecW';
   %PathParseIconLocation  = 'PathParseIconLocationW';
   %PathQuoteSpaces        = 'PathQuoteSpacesW';
   %PathRelativePathTo     = 'PathRelativePathToW';
   %PathRemoveArgs         = 'PathRemoveArgsW';
   %PathRemoveBackslash    = 'PathRemoveBackslashW';
   %PathRemoveBlanks       = 'PathRemoveBlanksW';
   %PathRemoveExtension    = 'PathRemoveExtensionW';
   %PathRemoveFileSpec     = 'PathRemoveFileSpecW';
   %PathRenameExtension    = 'PathRenameExtensionW';
   %PathSearchAndQualify   = 'PathSearchAndQualifyW';
   %PathSetDlgItemPath     = 'PathSetDlgItemPathW';
   %PathSkipRoot           = 'PathSkipRootW';
   %PathStripPath          = 'PathStripPathW';
   %PathStripToRoot        = 'PathStripToRootW';
   %PathUnquoteSpaces      = 'PathUnquoteSpacesW';
   %PathMakeSystemFolder   = 'PathMakeSystemFolderW';
   %PathUnmakeSystemFolder = 'PathUnmakeSystemFolderW';
   %PathIsSystemFolder     = 'PathIsSystemFolderW';
   %PathFindSuffixArray    = 'PathFindSuffixArrayW';
   %PathIsLFNFileSpec      = 'PathIsLFNFileSpecW';
   %PathUndecorate         = 'PathUndecorateW';
   %PathUnExpandEnvStrings = 'PathUnExpandEnvStringsW';
 %end; %else %do;
   %PathAddBackslash       = 'PathAddBackslashA';
   %PathAddExtension       = 'PathAddExtensionA';
   %PathAppend             = 'PathAppendA';
   %PathBuildRoot          = 'PathBuildRootA';
   %PathCanonicalize       = 'PathCanonicalizeA';
   %PathCombine            = 'PathCombineA';
   %PathCompactPath        = 'PathCompactPathA';
   %PathCompactPathEx      = 'PathCompactPathExA';
   %PathCommonPrefix       = 'PathCommonPrefixA';
   %PathFileExists         = 'PathFileExistsA';
   %PathFindExtension      = 'PathFindExtensionA';
   %PathFindFileName       = 'PathFindFileNameA';
   %PathFindNextComponent  = 'PathFindNextComponentA';
   %PathFindOnPath         = 'PathFindOnPathA';
   %PathGetArgs            = 'PathGetArgsA';
   %PathGetCharType        = 'PathGetCharTypeA';
   %PathGetDriveNumber     = 'PathGetDriveNumberA';
   %PathIsDirectory        = 'PathIsDirectoryA';
   %PathIsDirectoryEmpty   = 'PathIsDirectoryEmptyA';
   %PathIsFileSpec         = 'PathIsFileSpecA';
   %PathIsPrefix           = 'PathIsPrefixA';
   %PathIsRelative         = 'PathIsRelativeA';
   %PathIsRoot             = 'PathIsRootA';
   %PathIsSameRoot         = 'PathIsSameRootA';
   %PathIsUNC              = 'PathIsUNCA';
   %PathIsNetworkPath      = 'PathIsNetworkPathA';
   %PathIsUNCServer        = 'PathIsUNCServerA';
   %PathIsUNCServerShare   = 'PathIsUNCServerShareA';
   %PathIsContentType      = 'PathIsContentTypeA';
   %PathIsHTMLFile         = 'PathIsHTMLFileA';
   %PathIsURL              = 'PathIsURLA';
   %PathMakePretty         = 'PathMakePrettyA';
   %PathMatchSpec          = 'PathMatchSpecA';
   %PathParseIconLocation  = 'PathParseIconLocationA';
   %PathQuoteSpaces        = 'PathQuoteSpacesA';
   %PathRelativePathTo     = 'PathRelativePathToA';
   %PathRemoveArgs         = 'PathRemoveArgsA';
   %PathRemoveBackslash    = 'PathRemoveBackslashA';
   %PathRemoveBlanks       = 'PathRemoveBlanksA';
   %PathRemoveExtension    = 'PathRemoveExtensionA';
   %PathRemoveFileSpec     = 'PathRemoveFileSpecA';
   %PathRenameExtension    = 'PathRenameExtensionA';
   %PathSearchAndQualify   = 'PathSearchAndQualifyA';
   %PathSetDlgItemPath     = 'PathSetDlgItemPathA';
   %PathSkipRoot           = 'PathSkipRootA';
   %PathStripPath          = 'PathStripPathA';
   %PathStripToRoot        = 'PathStripToRootA';
   %PathUnquoteSpaces      = 'PathUnquoteSpacesA';
   %PathMakeSystemFolder   = 'PathMakeSystemFolderA';
   %PathUnmakeSystemFolder = 'PathUnmakeSystemFolderA';
   %PathIsSystemFolder     = 'PathIsSystemFolderA';
   %PathFindSuffixArray    = 'PathFindSuffixArrayA';
   %PathIsLFNFileSpec      = 'PathIsLFNFileSpecA';
   %PathUndecorate         = 'PathUndecorateA';
   %PathUnExpandEnvStrings = 'PathUnExpandEnvStringsA';
 %end;


 define ordinal URL_SCHEME
   ( URL_SCHEME_INVALID     value(-1),
     URL_SCHEME_UNKNOWN     value( 0),
     URL_SCHEME_FTP,
     URL_SCHEME_HTTP,
     URL_SCHEME_GOPHER,
     URL_SCHEME_MAILTO,
     URL_SCHEME_NEWS,
     URL_SCHEME_NNTP,
     URL_SCHEME_TELNET,
     URL_SCHEME_WAIS,
     URL_SCHEME_FILE,
     URL_SCHEME_MK,
     URL_SCHEME_HTTPS,
     URL_SCHEME_SHELL,
     URL_SCHEME_SNEWS,
     URL_SCHEME_LOCAL,
     URL_SCHEME_JAVASCRIPT,
     URL_SCHEME_VBSCRIPT,
     URL_SCHEME_ABOUT,
     URL_SCHEME_RES,
     URL_SCHEME_MAXVALUE
   ) prec (31);

 define ordinal URL_PART
   ( URL_PART_NONE       value(0),
     URL_PART_SCHEME     value(1),
     URL_PART_HOSTNAME,
     URL_PART_USERNAME,
     URL_PART_PASSWORD,
     URL_PART_PORT,
     URL_PART_QUERY
   ) prec (31);


 define ordinal URLIS
   ( URLIS_URL,
     URLIS_OPAQUE,
     URLIS_NOHISTORY,
     URLIS_FILEURL,
     URLIS_APPLIABLE,
     URLIS_DIRECTORY,
     URLIS_HASQUERY
   ) prec (31);

 dcl URL_UNESCAPE                    type DWORD value('10000000'xu);
 dcl URL_ESCAPE_UNSAFE               type DWORD value('20000000'xu);
 dcl URL_PLUGGABLE_PROTOCOL          type DWORD value('40000000'xu);
 dcl URL_WININET_COMPATIBILITY       type DWORD value('80000000'xu);
 dcl URL_DONT_ESCAPE_EXTRA_INFO      type DWORD value('02000000'xu);
 dcl URL_DONT_UNESCAPE_EXTRA_INFO    type DWORD
     value(URL_DONT_ESCAPE_EXTRA_INFO);
 dcl URL_BROWSER_MODE                type DWORD
     value(URL_DONT_ESCAPE_EXTRA_INFO);
 dcl URL_ESCAPE_SPACES_ONLY          type DWORD value('04000000'xu);
 dcl URL_DONT_SIMPLIFY               type DWORD value('08000000'xu);
 dcl URL_NO_META                     type DWORD
     value(URL_DONT_SIMPLIFY);
 dcl URL_UNESCAPE_INPLACE            type DWORD value('00100000'xu);
 dcl URL_CONVERT_IF_DOSPATH          type DWORD value('00200000'xu);
 dcl URL_UNESCAPE_HIGH_ANSI_ONLY     type DWORD value('00400000'xu);
 dcl URL_INTERNAL_PATH               type DWORD value('00800000'xu);
     /* Will escape #'s in paths */
 dcl URL_FILE_USE_PATHURL            type DWORD value('00010000'xu);
 dcl URL_ESCAPE_PERCENT              type DWORD value('00001000'xu);
 dcl URL_ESCAPE_SEGMENT_ONLY         type DWORD value('00002000'xu);
     /* Treat the entire URL param as one URL segment. */

 dcl URL_PARTFLAG_KEEPSCHEME         type DWORD value('00000001'xu);

 dcl URL_APPLY_DEFAULT               type DWORD value('00000001'xu);
 dcl URL_APPLY_GUESSSCHEME           type DWORD value('00000002'xu);
 dcl URL_APPLY_GUESSFILE             type DWORD value('00000004'xu);
 dcl URL_APPLY_FORCEAPPLY            type DWORD value('00000008'xu);


 dcl UrlCompareA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            type BOOL)
     LWSTDAPI_(fixed bin(31)) external('UrlCompareA');

 dcl UrlCompareW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            type BOOL)
     LWSTDAPI_(fixed bin(31)) external('UrlCompareW');

 dcl UrlCombineA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD)
     LWSTDAPI external('UrlCombineA');

 dcl UrlCombineW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD)
     LWSTDAPI external('UrlCombineW');

 dcl UrlCanonicalizeA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD)
     LWSTDAPI external('UrlCanonicalizeA');

 dcl UrlCanonicalizeW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD)
     LWSTDAPI external('UrlCanonicalizeW');

 dcl UrlIsOpaqueA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('UrlIsOpaqueA');
 dcl UrlIsOpaqueW
     entry (WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('UrlIsOpaqueW');

 dcl UrlIsNoHistoryA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('UrlIsNoHistoryA');
 dcl UrlIsNoHistoryW
     entry (WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type BOOL) external('UrlIsNoHistoryW');

 UrlIsFileUrlA: proc (pszURL)
                returns (type BOOL byvalue optional)
                options (inline reorder) internal;
   dcl pszURL char (*) varz byaddr nonasgn;
   return (UrlIsA (pszURL, URLIS_FILEURL));
 end UrlIsFileUrlA;

 UrlIsFileUrlW: proc (pszURL)
                returns (type BOOL byvalue optional)
                options (inline reorder) internal;
   dcl pszURL WCHAR (*) varz byaddr nonasgn;
   return (UrlIsW (pszURL, URLIS_FILEURL));
 end UrlIsFileUrlW;

 dcl UrlIsA
     entry (char (*) varz byaddr nonasgn,
            type URLIS)
     LWSTDAPI_(type BOOL) external('UrlIsA');
 dcl UrlIsW
     entry (WCHAR (*) varz byaddr nonasgn,
            type URLIS)
     LWSTDAPI_(type BOOL) external('UrlIsW');

 dcl UrlGetLocationA
     entry (char (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPCSTR) external('UrlGetLocationA');

 dcl UrlGetLocationW
     entry (Wchar (*) varz byaddr nonasgn)
     LWSTDAPI_(type LPCWSTR) external('UrlGetLocationW');

 dcl UrlUnescapeA
     entry (char (*) varz byaddr,
            char (*) varz byaddr optional,
            type DWORD byaddr optional,
            type DWORD)
     LWSTDAPI external('UrlUnescapeA');

 dcl UrlUnescapeW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr optional,
            type DWORD byaddr optional,
            type DWORD)
     LWSTDAPI external('UrlUnescapeW');

 dcl UrlEscapeA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD)
     LWSTDAPI external('UrlEscapeA');
 dcl UrlEscapeW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD)
     LWSTDAPI external('UrlEscapeW');

 dcl UrlCreateFromPathA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD)
     LWSTDAPI external('UrlCreateFromPathA');
 dcl UrlCreateFromPathW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD)
     LWSTDAPI external('UrlCreateFromPathW');

 dcl PathCreateFromUrlA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr optional,
            type DWORD byaddr,
            type DWORD)
     LWSTDAPI external('PathCreateFromUrlA');
 dcl PathCreateFromUrlW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD)
     LWSTDAPI external('PathCreateFromUrlW');

 dcl UrlHashA
     entry (char (*) varz byaddr nonasgn,
            type LPBYTE,
            type DWORD)
     LWSTDAPI external('UrlHashA');
 dcl UrlHashW
     entry (WCHAR (*) varz byaddr nonasgn,
            type LPBYTE,
            type DWORD)
     LWSTDAPI external('UrlHashW');

 dcl UrlGetPartA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD,
            type DWORD)
     LWSTDAPI external('UrlGetPartA');
 dcl UrlGetPartW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type DWORD byaddr optional,
            type DWORD,
            type DWORD)
     LWSTDAPI external('UrlGetPartW');

 dcl UrlApplySchemeA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type DWORD byaddr,
            type DWORD)
     LWSTDAPI external('UrlApplySchemeA');
 dcl UrlApplySchemeW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type DWORD byaddr,
            type DWORD)
     LWSTDAPI external('UrlApplySchemeW');

 dcl HashData
     entry (type LPBYTE,
            type DWORD,
            type LPBYTE,
            type DWORD)
     LWSTDAPI external('HashData');

 %dcl UrlCompare          char ext;
 %dcl UrlCombine          char ext;
 %dcl UrlCanonicalize     char ext;
 %dcl UrlIsOpaque         char ext;
 %dcl UrlIsFileUrl        char ext;
 %dcl UrlGetLocation      char ext;
 %dcl UrlUnescape         char ext;
 %dcl UrlEscape           char ext;
 %dcl UrlCreateFromPath   char ext;
 %dcl PathCreateFromUrl   char ext;
 %dcl UrlHash             char ext;
 %dcl UrlGetPart          char ext;
 %dcl UrlApplyScheme      char ext;
 %dcl UrlIs               char ext;
 %if UNICODE ^= '' %then %do;
   %UrlCompare          = 'UrlCompareW';
   %UrlCombine          = 'UrlCombineW';
   %UrlCanonicalize     = 'UrlCanonicalizeW';
   %UrlIsOpaque         = 'UrlIsOpaqueW';
   %UrlIsFileUrl        = 'UrlIsFileUrlW';
   %UrlGetLocation      = 'UrlGetLocationW';
   %UrlUnescape         = 'UrlUnescapeW';
   %UrlEscape           = 'UrlEscapeW';
   %UrlCreateFromPath   = 'UrlCreateFromPathW';
   %PathCreateFromUrl   = 'PathCreateFromUrlW';
   %UrlHash             = 'UrlHashW';
   %UrlGetPart          = 'UrlGetPartW';
   %UrlApplyScheme      = 'UrlApplySchemeW';
   %UrlIs               = 'UrlIsW';
 %end; %else %do;
   %UrlCompare          = 'UrlCompareA';
   %UrlCombine          = 'UrlCombineA';
   %UrlCanonicalize     = 'UrlCanonicalizeA';
   %UrlIsOpaque         = 'UrlIsOpaqueA';
   %UrlIsFileUrl        = 'UrlIsFileUrlA';
   %UrlGetLocation      = 'UrlGetLocationA';
   %UrlUnescape         = 'UrlUnescapeA';
   %UrlEscape           = 'UrlEscapeA';
   %UrlCreateFromPath   = 'UrlCreateFromPathA';
   %PathCreateFromUrl   = 'PathCreateFromUrlA';
   %UrlHash             = 'UrlHashA';
   %UrlGetPart          = 'UrlGetPartA';
   %UrlApplyScheme      = 'UrlApplySchemeA';
   %UrlIs               = 'UrlIsA';
 %end; /*UNICODE */

 UrlEscapeSpaces: proc (pszUrl, pszEscaped, pcchEscaped)
                  returns (type HRESULT byvalue optional)
                  options (inline reorder) internal;
   dcl pszUrl      TSTR byaddr nonasgn,
       pszEscaped  TSTR byaddr,
       pcchEscaped type DWORD byaddr optional;
   return (UrlCanonicalize (pszUrl, pszEscaped, pcchEscaped,
                            ior (URL_ESCAPE_SPACES_ONLY,
                                 URL_DONT_ESCAPE_EXTRA_INFO)));
 end UrlEscapeSpaces;

 UrlUnescapeInPlace: proc (pszUrl, dwFlags)
                     returns (type HRESULT byvalue optional)
                     options (inline reorder) internal;
   dcl pszUrl  TSTR byaddr nonasgn,
       dwFlags type DWORD byvalue;
   return (UrlUnescape (pszUrl, *, *,
                        ior (dwFlags, URL_UNESCAPE_INPLACE)));
 end UrlUnescapeInPlace;

 %end; /*  NO_SHLWAPI_PATH */


 %dcl NO_SHLWAPI_REG char ext;
 %if NO_SHLWAPI_REG = '' %then %do;

 /* =============== Registry Routines =============================== */

 /* SHDeleteEmptyKey mimics RegDeleteKey as it behaves on NT. */
 /* SHDeleteKey mimics RegDeleteKey as it behaves on Win95.   */

 dcl SHDeleteEmptyKeyA
     entry (type HKEY,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type DWORD) external('SHDeleteEmptyKeyA');
 dcl SHDeleteEmptyKeyW
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type DWORD) external('SHDeleteEmptyKeyW');

 dcl SHDeleteKeyA
     entry (type HKEY,
            char (*) varz byaddr nonasgn)
     LWSTDAPI_(type DWORD) external('SHDeleteKeyA');
 dcl SHDeleteKeyW
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn)
     LWSTDAPI_(type DWORD) external('SHDeleteKeyW');


 /* These functions open the key, get/set/delete the value, */
 /*  then close the key.                                    */

 dcl SHDeleteValueA
     entry (type HKEY,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional)
     LWSTDAPI_(type DWORD) external('SHDeleteValueA');
 dcl SHDeleteValueW
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional)
     LWSTDAPI_(type DWORD) external('SHDeleteValueW');

 dcl SHGetValueA
     entry (type HKEY,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            type DWORD byaddr,
            type LPVOID, /* address of result buffer */
            type DWORD byaddr)
     LWSTDAPI_(type DWORD) external('SHGetValueA');
 dcl SHGetValueW
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type DWORD byaddr,
            type LPVOID, /* address of result buffer */
            type DWORD byaddr)
     LWSTDAPI_(type DWORD) external('SHGetValueW');

 dcl SHSetValueA
     entry (type HKEY,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPCVOID,
            type DWORD)
     LWSTDAPI_(type DWORD) external('SHSetValueA');
 dcl SHSetValueW
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPCVOID,
            type DWORD)
     LWSTDAPI_(type DWORD) external('SHSetValueW');

 /* These functions work just like RegQueryValueEx, except if the   */
 /* data type is REG_EXPAND_SZ, then these will go ahead and expand */
 /* out the string.                                                 */
 /* *pdwType will always be massaged to REG_SZ if this happens.     */
 /* REG_SZ values are also guaranteed to be null terminated.        */

 dcl SHQueryValueExA
     entry (type HKEY,
            char (*) varz byaddr nonasgn,
            type DWORD byaddr optional, /* must omit */
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr)
     LWSTDAPI_(type DWORD) external('SHQueryValueExA');
 dcl SHQueryValueExW
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD byaddr optional, /* must omit */
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr)
     LWSTDAPI_(type DWORD) external('SHQueryValueExW');

 /* Enumeration functions support. */

 dcl SHEnumKeyExA
     entry (type HKEY,
            type DWORD,
            char (*) varz byaddr,
            type DWORD byaddr)
     LWSTDAPI_(type LONG) external('SHEnumKeyExA');
 dcl SHEnumKeyExW
     entry (type HKEY,
            type DWORD,
            WCHAR (*) varz byaddr,
            type DWORD byaddr)
     LWSTDAPI_(type LONG) external('SHEnumKeyExW');

 dcl SHEnumValueA
     entry (type HKEY,
            type DWORD,
            char (*) varz byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr)
     LWSTDAPI_(type LONG) external('SHEnumValueA');
 dcl SHEnumValueW
     entry (type HKEY,
            type DWORD,
            WCHAR (*) varz byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr)
     LWSTDAPI_(type LONG) external('SHEnumValueW');

 dcl SHQueryInfoKeyA
     entry (type HKEY,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr)
     LWSTDAPI_(type LONG) external('SHQueryInfoKeyA');
 dcl SHQueryInfoKeyW
     entry (type HKEY,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr)
     LWSTDAPI_(type LONG) external('SHQueryInfoKeyW');

 /* recursive key copy */
 dcl SHCopyKeyA
     entry (type HKEY,
            char (*) varz byaddr nonasgn,
            type HKEY,
            type DWORD)
     LWSTDAPI_(type DWORD) external('SHCopyKeyA');
 dcl SHCopyKeyW
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn,
            type HKEY,
            type DWORD)
     LWSTDAPI_(type DWORD) external('SHCopyKeyW');

 /* Getting and setting file system paths with environment variables */

 dcl SHRegGetPathA
     entry (type HKEY,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type DWORD)
     LWSTDAPI_(type DWORD) external('SHRegGetPathA');
 dcl SHRegGetPathW
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type DWORD)
     LWSTDAPI_(type DWORD) external('SHRegGetPathW');

 dcl SHRegSetPathA
     entry (type HKEY,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            type DWORD)
     LWSTDAPI_(type DWORD) external('SHRegSetPathA');
 dcl SHRegSetPathW
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD)
     LWSTDAPI_(type DWORD) external('SHRegSetPathW');

 %dcl SHDeleteEmptyKey char ext;
 %dcl SHDeleteKey      char ext;
 %dcl SHDeleteValue    char ext;
 %dcl SHGetValue       char ext;
 %dcl SHSetValue       char ext;
 %dcl SHQueryValueEx   char ext;
 %dcl SHEnumKeyEx      char ext;
 %dcl SHEnumValue      char ext;
 %dcl SHQueryInfoKey   char ext;
 %dcl SHCopyKey        char ext;
 %dcl SHRegGetPath     char ext;
 %dcl SHRegSetPath     char ext;

 %if UNICODE ^= '' %then %do;
   %SHDeleteEmptyKey = 'SHDeleteEmptyKeyW';
   %SHDeleteKey      = 'SHDeleteKeyW';
   %SHDeleteValue    = 'SHDeleteValueW';
   %SHGetValue       = 'SHGetValueW';
   %SHSetValue       = 'SHSetValueW';
   %SHQueryValueEx   = 'SHQueryValueExW';
   %SHEnumKeyEx      = 'SHEnumKeyExW';
   %SHEnumValue      = 'SHEnumValueW';
   %SHQueryInfoKey   = 'SHQueryInfoKeyW';
   %SHCopyKey        = 'SHCopyKeyW';
   %SHRegGetPath     = 'SHRegGetPathW';
   %SHRegSetPath     = 'SHRegSetPathW';
 %end; %else %do;
   %SHDeleteEmptyKey = 'SHDeleteEmptyKeyA';
   %SHDeleteKey      = 'SHDeleteKeyA';
   %SHDeleteValue    = 'SHDeleteValueA';
   %SHGetValue       = 'SHGetValueA';
   %SHSetValue       = 'SHSetValueA';
   %SHQueryValueEx   = 'SHQueryValueExA';
   %SHEnumKeyEx      = 'SHEnumKeyExA';
   %SHEnumValue      = 'SHEnumValueA';
   %SHQueryInfoKey   = 'SHQueryInfoKeyA';
   %SHCopyKey        = 'SHCopyKeyA';
   %SHRegGetPath     = 'SHRegGetPathA';
   %SHRegSetPath     = 'SHRegSetPathA';
 %end;


 /*******************************************/
 /* User Specific Registry Access Functions */
 /*******************************************/

 /* Type definitions. */
 define ordinal SHREGDEL_FLAGS
   ( SHREGDEL_DEFAULT value('00000000'xn)
       /* Delete's HKCU, or HKLM if HKCU is not found. */
   , SHREGDEL_HKCU    value('00000001'xn)
       /* Delete HKCU only */
   , SHREGDEL_HKLM    value('00000010'xn)
       /* Delete HKLM only. */
   , SHREGDEL_BOTH    value('00000011'xn)
       /* Delete both HKCU and HKLM. */
   ) precision (31);

 define ordinal SHREGENUM_FLAGS
   ( SHREGENUM_DEFAULT value('00000000'xn)
       /* Enumerates HKCU or HKLM if not found. */
   , SHREGENUM_HKCU    value('00000001'xn)
       /* Enumerates HKCU only */
   , SHREGENUM_HKLM    value('00000010'xn)
       /* Enumerates HKLM only. */
   , SHREGENUM_BOTH    value('00000011'xn)
       /* Enumerates both HKCU and HKLM without duplicates. */
       /* This option is NYI. */
   ) precision (31);


 dcl SHREGSET_HKCU       fixed bin(31) value('00000001'xn);
     /* Write to HKCU if empty. */
 dcl SHREGSET_FORCE_HKCU fixed bin(31) value('00000002'xn);
     /* Write to HKCU. */
 dcl SHREGSET_HKLM       fixed bin(31) value('00000004'xn);
     /* Write to HKLM if empty. */
 dcl SHREGSET_FORCE_HKLM fixed bin(31) value('00000008'xn);
     /* Write to HKLM. */
 dcl SHREGSET_DEFAULT    fixed bin(31) value(ior (SHREGSET_FORCE_HKCU,
                                                  SHREGSET_HKLM));
     /* Default is ior (SHREGSET_FORCE_HKCU, SHREGSET_HKLM). */


 define alias HUSKEY type HANDLE;
 /* HUSKEY is a Handle to a User Specific KEY. */
 define alias PHUSKEY pointer;

 dcl SHRegCreateUSKeyA
     entry (char (*) varz byaddr nonasgn,
            type REGSAM,
            type HUSKEY,
            type HUSKEY byaddr,
            type DWORD)
     LWSTDAPI_(type LONG) external('SHRegCreateUSKeyA');
 dcl SHRegCreateUSKeyW
     entry (WCHAR (*) varz byaddr nonasgn,
            type REGSAM,
            type HUSKEY,
            type HUSKEY byaddr,
            type DWORD)
     LWSTDAPI_(type LONG) external('SHRegCreateUSKeyW');

 dcl SHRegOpenUSKeyA
     entry (char (*) varz byaddr nonasgn,
            type REGSAM,
            type HUSKEY,
            type HUSKEY byaddr,
            type BOOL)
     LWSTDAPI_(type LONG) external('SHRegOpenUSKeyA');
 dcl SHRegOpenUSKeyW
     entry (WCHAR (*) varz byaddr nonasgn,
            type REGSAM,
            type HUSKEY,
            type HUSKEY byaddr,
            type BOOL)
     LWSTDAPI_(type LONG) external('SHRegOpenUSKeyW');

 dcl SHRegQueryUSValueA
     entry (type HUSKEY,
            char (*) varz byaddr nonasgn,
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr,
            type BOOL,
            type LPVOID,
            type DWORD)
     LWSTDAPI_(type LONG) external('SHRegQueryUSValueA');
 dcl SHRegQueryUSValueW
     entry (type HUSKEY,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr,
            type BOOL,
            type LPVOID,
            type DWORD)
     LWSTDAPI_(type LONG) external('SHRegQueryUSValueW');

 dcl SHRegWriteUSValueA
     entry (type HUSKEY,
            char (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPVOID,
            type DWORD,
            type DWORD)
     LWSTDAPI_(type LONG) external('SHRegWriteUSValueA');
 dcl SHRegWriteUSValueW
     entry (type HUSKEY,
            WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPVOID,
            type DWORD,
            type DWORD)
     LWSTDAPI_(type LONG) external('SHRegWriteUSValueW');

 dcl SHRegDeleteUSValueA
     entry (type HUSKEY,
            char (*) varz byaddr nonasgn,
            type SHREGDEL_FLAGS)
     LWSTDAPI_(type LONG) external('SHRegDeleteUSValueA');
 dcl SHRegDeleteUSValueW
     entry (type HUSKEY,
            WCHAR (*) varz byaddr nonasgn,
            type SHREGDEL_FLAGS)
     LWSTDAPI_(type LONG) external('SHRegDeleteUSValueW');

 dcl SHRegDeleteEmptyUSKeyA
     entry (type HUSKEY,
            char (*) varz byaddr nonasgn,
            type SHREGDEL_FLAGS)
     LWSTDAPI_(type LONG) external('SHRegDeleteEmptyUSKeyA');
 dcl SHRegDeleteEmptyUSKeyW
     entry (type HUSKEY,
            WCHAR (*) varz byaddr nonasgn,
            type SHREGDEL_FLAGS)
     LWSTDAPI_(type LONG) external('SHRegDeleteEmptyUSKeyW');

 dcl SHRegEnumUSKeyA
     entry (type HUSKEY,
            type DWORD,
            char (*) varz byaddr,
            type DWORD byaddr,
            type SHREGENUM_FLAGS)
     LWSTDAPI_(type LONG) external('SHRegEnumUSKeyA');
 dcl SHRegEnumUSKeyW
     entry (type HUSKEY,
            type DWORD,
            WCHAR (*) varz byaddr,
            type DWORD byaddr,
            type SHREGENUM_FLAGS)
     LWSTDAPI_(type LONG) external('SHRegEnumUSKeyW');

 dcl SHRegEnumUSValueA
     entry (type HUSKEY,
            type DWORD,
            char (*) varz byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr,
            type SHREGENUM_FLAGS)
     LWSTDAPI_(type LONG) external('SHRegEnumUSValueA');
 dcl SHRegEnumUSValueW
     entry (type HUSKEY,
            type DWORD,
            WCHAR (*) varz byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr,
            type SHREGENUM_FLAGS)
     LWSTDAPI_(type LONG) external('SHRegEnumUSValueW');

 dcl SHRegQueryInfoUSKeyA
     entry (type HUSKEY,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type SHREGENUM_FLAGS)
     LWSTDAPI_(type LONG) external('SHRegQueryInfoUSKeyA');
 dcl SHRegQueryInfoUSKeyW
     entry (type HUSKEY,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            type SHREGENUM_FLAGS)
     LWSTDAPI_(type LONG) external('SHRegQueryInfoUSKeyW');

 dcl SHRegCloseUSKey
     entry (type HUSKEY )
     LWSTDAPI_(type LONG) external('SHRegCloseUSKey');


 /* These calls are equal to an SHRegOpenUSKey, SHRegQueryUSValue, */
 /* and then a SHRegCloseUSKey.                                    */
 dcl SHRegGetUSValueA
     entry (char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr,
            type BOOL,
            type LPVOID,
            type DWORD)
     LWSTDAPI_(type LONG) external('SHRegGetUSValueA');
 dcl SHRegGetUSValueW
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr,
            type BOOL,
            type LPVOID,
            type DWORD)
     LWSTDAPI_(type LONG) external('SHRegGetUSValueW');

 dcl SHRegSetUSValueA
     entry (char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPVOID,
            type DWORD,
            type DWORD)
     LWSTDAPI_(type LONG) external('SHRegSetUSValueA');
 dcl SHRegSetUSValueW
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            type LPVOID,
            type DWORD,
            type DWORD)
     LWSTDAPI_(type LONG) external('SHRegSetUSValueW');

 dcl SHRegGetIntA
     entry (type HKEY,
            char (*) varz byaddr nonasgn optional,
            fixed bin(31))
     LWSTDAPI_(fixed bin(31)) external('SHRegGetIntA');
 dcl SHRegGetIntW
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn optional,
            fixed bin(31))
     LWSTDAPI_(fixed bin(31)) external('SHRegGetIntW');

 %dcl SHRegCreateUSKey      char ext;
 %dcl SHRegOpenUSKey        char ext;
 %dcl SHRegQueryUSValue     char ext;
 %dcl SHRegWriteUSValue     char ext;
 %dcl SHRegDeleteUSValue    char ext;
 %dcl SHRegDeleteEmptyUSKey char ext;
 %dcl SHRegEnumUSKey        char ext;
 %dcl SHRegEnumUSValue      char ext;
 %dcl SHRegQueryInfoUSKey   char ext;
 %dcl SHRegGetUSValue       char ext;
 %dcl SHRegSetUSValue       char ext;
 %dcl SHRegGetInt           char ext;

 %if UNICODE ^= '' %then %do;
   %SHRegCreateUSKey      = 'SHRegCreateUSKeyW';
   %SHRegOpenUSKey        = 'SHRegOpenUSKeyW';
   %SHRegQueryUSValue     = 'SHRegQueryUSValueW';
   %SHRegWriteUSValue     = 'SHRegWriteUSValueW';
   %SHRegDeleteUSValue    = 'SHRegDeleteUSValueW';
   %SHRegDeleteEmptyUSKey = 'SHRegDeleteEmptyUSKeyW';
   %SHRegEnumUSKey        = 'SHRegEnumUSKeyW';
   %SHRegEnumUSValue      = 'SHRegEnumUSValueW';
   %SHRegQueryInfoUSKey   = 'SHRegQueryInfoUSKeyW';
   %SHRegGetUSValue       = 'SHRegGetUSValueW';
   %SHRegSetUSValue       = 'SHRegSetUSValueW';
   %SHRegGetInt           = 'SHRegGetIntW';
 %end; %else %do;
   %SHRegCreateUSKey      = 'SHRegCreateUSKeyA';
   %SHRegOpenUSKey        = 'SHRegOpenUSKeyA';
   %SHRegQueryUSValue     = 'SHRegQueryUSValueA';
   %SHRegWriteUSValue     = 'SHRegWriteUSValueA';
   %SHRegDeleteUSValue    = 'SHRegDeleteUSValueA';
   %SHRegDeleteEmptyUSKey = 'SHRegDeleteEmptyUSKeyA';
   %SHRegEnumUSKey        = 'SHRegEnumUSKeyA';
   %SHRegEnumUSValue      = 'SHRegEnumUSValueA';
   %SHRegQueryInfoUSKey   = 'SHRegQueryInfoUSKeyA';
   %SHRegGetUSValue       = 'SHRegGetUSValueA';
   %SHRegSetUSValue       = 'SHRegSetUSValueA';
   %SHRegGetInt           = 'SHRegGetIntA';
 %end;

 dcl SHRegGetBoolUSValueA
     entry (char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            type BOOL,
            type BOOL)
     LWSTDAPI_(type BOOL) external('SHRegGetBoolUSValueA');
 dcl SHRegGetBoolUSValueW
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type BOOL,
            type BOOL)
     LWSTDAPI_(type BOOL) external('SHRegGetBoolUSValueW');
 %dcl SHRegGetBoolUSValue char ext;
 %if UNICODE ^= '' %then %do;
   %SHRegGetBoolUSValue='SHRegGetBoolUSValueW';
 %end; %else %do;
   %SHRegGetBoolUSValue='SHRegGetBoolUSValueA';
 %end;

 /*  Association APIs                                                 */
 /*                                                                   */
 /*  these APIs are to assist in accessing the data in HKCR           */
 /*  getting the Command strings and exe paths                        */
 /*  for different verbs and extensions are simplified this way       */


 dcl ( ASSOCF_INIT_BYEXENAME       value('00000002'xu),
          /* executable is being passed in */
       ASSOCF_OPEN_BYEXENAME       value('00000002'xu),
          /* executable is being passed in */
       ASSOCF_INIT_DEFAULTTOSTAR   value('00000004'xu),
          /* treat "*" as the BaseClass */
       ASSOCF_INIT_DEFAULTTOFOLDER value('00000008'xu),
          /* treat "Folder" as the BaseClass */
       ASSOCF_NOUSERSETTINGS       value('00000010'xu),
          /* dont use HKCU */
       ASSOCF_NOTRUNCATE           value('00000020'xu),
          /* dont truncate the return string */
       ASSOCF_VERIFY               value('00000040'xu),
          /* verify data is accurate (DISK HITS) */
       ASSOCF_REMAPRUNDLL          value('00000080'xu),
          /* actually gets info about rundlls target if applicable */
       ASSOCF_NOFIXUPS             value('00000100'xu),
          /*  attempt to fix errors if found */
       ASSOCF_IGNOREBASECLASS      value('00000200'xu)
          /*  dont recurse into the baseclass */
     ) fixed bin (31);
 define alias ASSOCF type DWORD;

 define ordinal ASSOCSTR
   ( ASSOCSTR_COMMAND value(1),/* shell\verb\command string */
     ASSOCSTR_EXECUTABLE,     /* the executable part of command string*/
     ASSOCSTR_FRIENDLYDOCNAME,/* friendly name of the document type */
     ASSOCSTR_FRIENDLYAPPNAME,/* friendly name of executable */
     ASSOCSTR_NOOPEN,         /* noopen value */
     ASSOCSTR_SHELLNEWVALUE,  /* query values under the shellnew key */
     ASSOCSTR_DDECOMMAND,     /* template for DDE commands */
     ASSOCSTR_DDEIFEXEC,
                        /* DDECOMMAND to use if just create a process */
     ASSOCSTR_DDEAPPLICATION, /* Application name in DDE broadcast */
     ASSOCSTR_DDETOPIC,       /* Topic Name in DDE broadcast */
     ASSOCSTR_MAX             /* last item in enum... */
   ) prec(31);

 define ordinal ASSOCKEY
   ( ASSOCKEY_SHELLEXECCLASS value(1),
       /*  the key that should be passed to ShellExec(hkeyClass) */
    ASSOCKEY_APP,
       /* the "Application" key for the association */
    ASSOCKEY_CLASS,           /* the progid or class key */
    ASSOCKEY_BASECLASS,       /* the BaseClass key */
    ASSOCKEY_MAX              /* last item in enum... */
   ) prec(31);

 define ordinal ASSOCDATA
   ( ASSOCDATA_MSIDESCRIPTOR value(1),
       /* Component Descriptor to pass to MSI APIs */
     ASSOCDATA_NOACTIVATEHANDLER,
       /* restrict attempts to activate window */
     ASSOCDATA_QUERYCLASSSTORE,
       /* should check with the NT Class Store */
     ASSOCDATA_HASPERUSERASSOC,
       /* defaults to user specified association */
    ASSOCDATA_MAX
   ) prec(31);

 define ordinal ASSOCENUM
   ( ASSOCENUM_NONE
   ) prec(31);


 /* Definitions of IQueryAssociations and AssocCreate elided here */
 /* Add in when have COM support...                               */


 /*  wrappers for the interface */
 dcl AssocQueryStringA
     entry (type ASSOCF,
            type ASSOCSTR,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr,
            type DWORD byaddr)
     LWSTDAPI external('AssocQueryStringA');
 dcl AssocQueryStringW
     entry (type ASSOCF,
            type ASSOCSTR,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr,
            type DWORD byaddr)
     LWSTDAPI external('AssocQueryStringW');
 %dcl AssocQueryString char ext;
 %if UNICODE ^= '' %then %do;
   %AssocQueryString='AssocQueryStringW';
 %end; %else %do;
   %AssocQueryString='AssocQueryStringA';
 %end;

 dcl AssocQueryStringByKeyA
     entry (type ASSOCF,
            type ASSOCSTR,
            type HKEY,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr,
            type DWORD byaddr)
     LWSTDAPI external('AssocQueryStringByKeyA');
 dcl AssocQueryStringByKeyW
     entry (type ASSOCF,
            type ASSOCSTR,
            type HKEY,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr,
            type DWORD byaddr)
     LWSTDAPI external('AssocQueryStringByKeyW');
 %dcl AssocQueryStringByKey char ext;
 %if UNICODE ^= '' %then %do;
   %AssocQueryStringByKey='AssocQueryStringByKeyW';
 %end; %else %do;
   %AssocQueryStringByKey='AssocQueryStringByKeyA';
 %end;

 dcl AssocQueryKeyA
     entry (type ASSOCF,
            type ASSOCSTR,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            type HKEY byaddr)
     LWSTDAPI external('AssocQueryKeyA');
 dcl AssocQueryKeyW
     entry (type ASSOCF,
            type ASSOCSTR,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            type HKEY byaddr)
     LWSTDAPI external('AssocQueryKeyW');
 %dcl AssocQueryKey char ext;
 %if UNICODE ^= '' %then %do;
   %AssocQueryKey='AssocQueryKeyW';
 %end; %else %do;
   %AssocQueryKey='AssocQueryKeyA';
 %end;


 %end; /*  NO_SHLWAPI_REG */


 %dcl NO_SHLWAPI_STREAM char ext;
 %if NO_SHLWAPI_STREAM = '' %then %do;

 /* =============== Stream Routines ================================ */

 %dcl #_IStream_INTERFACE_DEFINED__ char ext;
 %if #_IStream_INTERFACE_DEFINED__ ^= '' %then %do;
 dcl SHOpenRegStreamA
     entry (type HKEY,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            type DWORD)
     LWSTDAPI_(handle IStream) external('SHOpenRegStreamA');
 dcl SHOpenRegStreamW
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD)
     LWSTDAPI_(handle IStream) external('SHOpenRegStreamW');
 %dcl SHOpenRegStream char ext;
 %if UNICODE ^= '' %then %do;
   %SHOpenRegStream='SHOpenRegStreamW';
 %end; %else %do;
   %SHOpenRegStream='SHOpenRegStreamA';
 %end; /* !UNICODE */

 dcl SHOpenRegStream2A
     entry (type HKEY,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn,
            type DWORD)
     LWSTDAPI_(handle IStream) external('SHOpenRegStream2A');
 dcl SHOpenRegStream2W
     entry (type HKEY,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn,
            type DWORD)
     LWSTDAPI_(handle IStream) external('SHOpenRegStream2W');
 %dcl SHOpenRegStream2 char ext;
 %if UNICODE ^= '' %then %do;
   %SHOpenRegStream2='SHOpenRegStream2W';
 %end; %else %do;
   %SHOpenRegStream2='SHOpenRegStream2A';
 %end; /* !UNICODE */
 /* New code always wants new implementation... */
 %SHOpenRegStream = SHOpenRegStream2;


 dcl SHCreateStreamOnFileA
     entry (char (*) varz byaddr nonasgn,
            type DWORD,
            handle IStream byaddr)
     LWSTDAPI external('SHCreateStreamOnFileA');

 dcl SHCreateStreamOnFileW
     entry (WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            handle IStream byaddr)
     LWSTDAPI external('SHCreateStreamOnFileW');
 %dcl SHCreateStreamOnFile char ext;
 %if UNICODE ^= '' %then %do;
   %SHCreateStreamOnFile='SHCreateStreamOnFileW';
 %end; %else %do;
   %SHCreateStreamOnFile='SHCreateStreamOnFileA';
 %end; /* !UNICODE */

 %end;

 %end; /* NO_SHLWAPI_STREAM */

 %if #WIN32_IE >= 1280 %then %do;

 /* SHAutoComplete                                                    */
 /*      hwndEdit - HWND of editbox, ComboBox or ComboBoxEx.          */
 /*      dwFlags  - Flags to indicate what to AutoAppend or           */
 /*                 AutoSuggest for the editbox.                      */
 /*                                                                   */
 /*    Caller needs to have called CoInitialize() or OleInitialize()  */
 /*    and cannot call CoUninit/OleUninit until after                 */
 /*    WM_DESTROY on hwndEdit.                                        */

 /*  dwFlags values: */
 dcl SHACF_DEFAULT                   type DWORD value('00000000'xu);
     /* Currently ior (SHACF_FILESYSTEM, SHACF_URLALL)         */
 dcl SHACF_FILESYSTEM                type DWORD value('00000001'xu);
     /* This includes the File System as well as the rest of   */
     /* the shell (Desktop\My Computer\Control Panel\)         */
 dcl SHACF_URLHISTORY                type DWORD value('00000002'xu);
     /* URLs in the User's History                             */
 dcl SHACF_URLMRU                    type DWORD value('00000004'xu);
     /* URLs in the User's Recently Used list.                 */
 dcl SHACF_URLALL                    type DWORD
                        value(ior(SHACF_URLHISTORY, SHACF_URLMRU));
 dcl SHACF_USETAB                    type DWORD value('00000008'xu);
     /* URLs in the User's Recently Used list.                 */
 dcl SHACF_AUTOSUGGEST_FORCE_ON      type DWORD value('10000000'xu);
     /* Ignore the registry default and force the feature on.  */
 dcl SHACF_AUTOSUGGEST_FORCE_OFF     type DWORD value('20000000'xu);
     /* Ignore the registry default and force the feature off. */
 dcl SHACF_AUTOAPPEND_FORCE_ON       type DWORD value('40000000'xu);
     /* Ignore the registry default and force the feature on.  */
     /* (Also know as AutoComplete)                            */
 dcl SHACF_AUTOAPPEND_FORCE_OFF      type DWORD value('80000000'xu);
    /* Ignore the registry default and force the feature off.  */
    /* (Also know as AutoComplete)                             */

 dcl SHAutoComplete entry
     entry (type HWND,
            type DWORD)
     LWSTDAPI external('SHAutoComplete');

 %if 0 = 1 %then %do; /* following commented out, as no COM support */
 dcl SHSetThreadRef
     entry (handle IUnknown)
     STDAPI external('SHSetThreadRef');
 dcl SHGetThreadRef
     entry (handle IUnknown byaddr)
     STDAPI external('SHGetThreadRef');
 %end;

 %end;

 dcl CTF_INSIST          type DWORD value('00000001'xu);
     /* SHCreateThread() dwFlags - call pfnThreadProc synchronously */
     /* if CreateThread() fails                                     */
 dcl CTF_THREAD_REF      type DWORD value('00000002'xu);
     /* hold a reference to the creating thread */
 dcl CTF_PROCESS_REF     type DWORD value('00000004'xu);
     /* hold a reference to the creating process */
 dcl CTF_COINIT          type DWORD value('00000008'xu);
     /* init COM for the created thread */

 dcl SHCreateThread
     entry (type LPTHREAD_START_ROUTINE,
            pointer,
            type DWORD,
            type LPTHREAD_START_ROUTINE optional byvalue)
     LWSTDAPI_(type BOOL) external('SHCreateThread');



 %dcl NO_SHLWAPI_GDI char ext;
 %if NO_SHLWAPI_GDI = '' %then  %do;

 /* ===== GDI helper functions  ===================================== */

 dcl SHCreateShellPalette
     entry (type HDC)
     LWSTDAPI_(type HPALETTE) external('SHCreateShellPalette');

 %if #WIN32_IE >= 1280 %then %do;

 dcl ColorRGBToHLS
     entry (type COLORREF,
            type WORD byaddr,
            type WORD byaddr,
            type WORD byaddr)
     LWSTDAPI_void external('ColorRGBToHLS');

 dcl ColorHLSToRGB
     entry (type WORD,
            type WORD,
            type WORD)
     LWSTDAPI_(type COLORREF) external('ColorHLSToRGB');

 dcl ColorAdjustLuma
     entry (type COLORREF,
            fixed bin(31),
            type BOOL)
     LWSTDAPI_(type COLORREF) external('ColorAdjustLuma');

 %end; /* _WIN32_IE >= 0x0500*/

 %end; /* NO_SHLWAPI_GDI */


 /* ====== DllGetVersion  =========================================== */

 define structure
   1 DLLVERSIONINFO,
     2 cbSize         type DWORD,
     2 dwMajorVersion type DWORD, /* Major version     */
     2 dwMinorVersion type DWORD, /* Minor version     */
     2 dwBuildNumber  type DWORD, /* Build number      */
     2 dwPlatformID   type DWORD; /* DLLVER_PLATFORM_* */

 /* Platform IDs for DLLVERSIONINFO */
 dcl DLLVER_PLATFORM_WINDOWS type DWORD value('00000001'xu);
     /* Windows 95 */
 dcl DLLVER_PLATFORM_NT      type DWORD value('00000002'xu);
     /* Windows NT */


 /* The caller should always GetProcAddress("DllGetVersion"), not */
 /* implicitly link to it.                                        */

 define alias DLLGETVERSIONPROC
        entry (type DLLVERSIONINFO byaddr)
        returns (type HRESULT byvalue optional)
        limited CALLBACK;

 /* DllInstall (to be implemented by self-installing DLLs) */
 dcl DllInstall
     entry (type BOOL,
            char (*) varz byaddr nonasgn)
     STDAPI external('DllInstall');

 %end;

 %end; /* _INC_SHLWAPI */

