 /*********************************************************************/
 /*                                                                   */
 /* VfW.CPY - Video for Windows include file                          */
 /*                                                                   */
 /* Copyright (c) 1991-1995, Microsoft Corp.  All rights reserved.    */
 /*                                                                   */
 /* This include files defines interfaces to the following            */
 /* video components                                                  */
 /*                                                                   */
 /*     COMPMAN     - Installable Compression Manager.                */
 /*     DRAWDIB     - Routines for drawing to the display.            */
 /*     VIDEO       - Video Capture Driver Interface                  */
 /*                                                                   */
 /*     AVIFMT      - AVI File Format structure definitions.          */
 /*     MMREG       - FOURCC and other things                         */
 /*                                                                   */
 /*     AVIFile     - Interface for reading AVI Files and AVI Streams */
 /*     MCIWND      - MCI/AVI window class                            */
 /*     AVICAP      - AVI Capture Window class                        */
 /*                                                                   */
 /*     MSACM       - Audio compression manager.                      */
 /*                                                                   */
 /* The following symbols control inclusion of various parts of this  */
 /* file:                                                             */
 /*                                                                   */
 /*     NOCOMPMAN   - dont include COMPMAN                            */
 /*     NODRAWDIB   - dont include DRAWDIB                            */
 /*     NOVIDEO     - dont include video capture interface            */
 /*                                                                   */
 /*     NOAVIFMT    - dont include AVI file format structs            */
 /*     NOMMREG     - dont include MMREG                              */
 /*                                                                   */
 /*     NOAVIFILE   - dont include AVIFile interface                  */
 /*                   (AVIFile interface is NOT available in PL/I!!!) */
 /*     NOMCIWND    - dont include AVIWnd class.                      */
 /*     NOAVICAP    - dont include AVICap class.                      */
 /*                                                                   */
 /*     NOMSACM     - dont include ACM stuff.                         */
 /*                                                                   */
 /*********************************************************************/

 %dcl #INC_VFW char ext;
 %if #INC_VFW = '' %then %do;
 %#INC_VFW = 'Y';

 %dcl UNICODE char ext;

 %dcl #WINGDI_ char ext;
 %if #WINGDI_ = '' %then %do;
 %include WinGDI; /* needed for BITMAPINFOHEADER and BITMAPINFO */
 %end;

 %dcl #INC_MMSYSTEM char ext;
 %if #INC_MMSYSTEM = '' %then %do;
 %include mmsystem; /* for PL/I - always include */
 %end;

 /*********************************************************************/
 /*                                                                   */
 /*  types                                                            */
 /*                                                                   */
 /*********************************************************************/

 %dcl VFWAPI char ext;
 %VFWAPI='WINAPI';
 %dcl VFWAPIV char ext;
 %VFWAPIV='WINAPIV';

 /*********************************************************************/
 /*                                                                   */
 /*  VideoForWindowsVersion() - returns version of VfW                */
 /*                                                                   */
 /*********************************************************************/

 dcl VideoForWindowsVersion
     entry ()
     returns (type DWORD byvalue optional)
     PASCAL external('VideoForWindowsVersion');

 /*********************************************************************/
 /*                                                                   */
 /*  call these to start stop using VfW from your app.                */
 /*                                                                   */
 /*********************************************************************/

 dcl InitVFW
     entry ()
     returns (type LONG byvalue optional)
     VFWAPI external('InitVFW');

 dcl TermVFW
     entry ()
     returns (type LONG byvalue optional)
     VFWAPI external('TermVFW');

 %aviTWOCC: proc (ch0, ch1) returns (char);
   dcl (ch0, ch1) char;
   return ('ior (rank (' || ch0 || '), ' ||
                'isll ( rank (' || ch1 || '),  8))');
 %end aviTWOCC;
 %activate aviTWOCC;

 /*********************************************************************/
 /*                                                                   */
 /*  COMPMAN - Installable Compression Manager.                       */
 /*                                                                   */
 /*********************************************************************/

 %dcl NOCOMPMAN char ext;
 %if NOCOMPMAN = '' %then %do;

 dcl ICVERSION fixed bin(15) value('0104'xn);

 DECLARE_HANDLE (HIC);

 /* this code in biCompression means the DIB must be accesed via */
 /* 48 bit pointers! using *ONLY* the selector given.            */
 dcl BI_1632 fixed bin(31) value('32333631'xn); /* '1632' */

 %dcl #ICTYPE_VIDEO char ext;
 %if #ICTYPE_VIDEO = '' %then %do;
 %#ICTYPE_VIDEO = 'Y';
 dcl ICTYPE_VIDEO  type FOURCC value(mmioFOURCC('v', 'i', 'd', 'c'));
 dcl ICTYPE_AUDIO  type FOURCC value(mmioFOURCC('a', 'u', 'd', 'c'));
 %end;

 dcl ICERR_OK              fixed bin (31) value (0);
 dcl ICERR_DONTDRAW        fixed bin (31) value (1);
 dcl ICERR_NEWPALETTE      fixed bin (31) value (2);
 dcl ICERR_GOTOKEYFRAME    fixed bin (31) value (3);
 dcl ICERR_STOPDRAWING     fixed bin (31) value (4);

 dcl ICERR_UNSUPPORTED     fixed bin (31) value (-1);
 dcl ICERR_BADFORMAT       fixed bin (31) value (-2);
 dcl ICERR_MEMORY          fixed bin (31) value (-3);
 dcl ICERR_INTERNAL        fixed bin (31) value (-4);
 dcl ICERR_BADFLAGS        fixed bin (31) value (-5);
 dcl ICERR_BADPARAM        fixed bin (31) value (-6);
 dcl ICERR_BADSIZE         fixed bin (31) value (-7);
 dcl ICERR_BADHANDLE       fixed bin (31) value (-8);
 dcl ICERR_CANTUPDATE      fixed bin (31) value (-9);
 dcl ICERR_ABORT           fixed bin (31) value (-10);
 dcl ICERR_ERROR           fixed bin (31) value (-100);
 dcl ICERR_BADBITDEPTH     fixed bin (31) value (-200);
 dcl ICERR_BADIMAGESIZE    fixed bin (31) value (-201);

 dcl ICERR_CUSTOM          fixed bin (31) value (-400);
 /* errors less than ICERR_CUSTOM... */

 /* Values for dwFlags of ICOpen() */
 dcl ICMODE_COMPRESS       fixed bin(31) value(1);
 dcl ICMODE_DECOMPRESS     fixed bin(31) value(2);
 dcl ICMODE_FASTDECOMPRESS fixed bin(31) value(3);
 dcl ICMODE_QUERY          fixed bin(31) value(4);
 dcl ICMODE_FASTCOMPRESS   fixed bin(31) value(5);
 dcl ICMODE_DRAW           fixed bin(31) value(8);

 /* Flags for AVI file index */
 dcl AVIIF_LIST            fixed bin(31) value('00000001'xn);
 dcl AVIIF_TWOCC           fixed bin(31) value('00000002'xn);
 dcl AVIIF_KEYFRAME        fixed bin(31) value('00000010'xn);

 /* quality flags */
 dcl ICQUALITY_LOW         fixed bin(31) value(0);
 dcl ICQUALITY_HIGH        fixed bin(31) value(10000);
 dcl ICQUALITY_DEFAULT     fixed bin(31) value(-1);

 /*********************************************************************/

 dcl ICM_USER          fixed bin(31) value(DRV_USER+'0000'xn);

 dcl ICM_RESERVED_LOW  fixed bin(31) value(DRV_USER+'1000'xn);
 dcl ICM_RESERVED_HIGH fixed bin(31) value(DRV_USER+'2000'xn);
 dcl ICM_RESERVED      fixed bin(31) value(ICM_RESERVED_LOW);

 /*********************************************************************/
 /*   messages.                                                       */
 /*********************************************************************/

 dcl ICM_GETSTATE          fixed bin(31) value(ICM_RESERVED+0);
     /* Get compressor state */
 dcl ICM_SETSTATE          fixed bin(31) value(ICM_RESERVED+1);
     /* Set compressor state */
 dcl ICM_GETINFO           fixed bin(31) value(ICM_RESERVED+2);
     /* Query info about the compressor */

 dcl ICM_CONFIGURE         fixed bin(31) value(ICM_RESERVED+10);
     /* show the configure dialog */
 dcl ICM_ABOUT             fixed bin(31) value(ICM_RESERVED+11);
     /* show the about box */

 dcl ICM_GETDEFAULTQUALITY fixed bin(31) value(ICM_RESERVED+30);
     /* get the default value for quality */
 dcl ICM_GETQUALITY        fixed bin(31) value(ICM_RESERVED+31);
     /* get the current value for quality */
 dcl ICM_SETQUALITY        fixed bin(31) value(ICM_RESERVED+32);
     /* set the default value for quality */

 dcl ICM_SET               fixed bin(31) value(ICM_RESERVED+40);
     /* Tell the driver something */
 dcl ICM_GET               fixed bin(31) value(ICM_RESERVED+41);
     /* Ask the driver something */

 /* Constants for ICM_SET: */
 dcl ICM_FRAMERATE    type FOURCC value(mmioFOURCC('F','r','m','R'));
 dcl ICM_KEYFRAMERATE type FOURCC value(mmioFOURCC('K','e','y','R'));

 /*********************************************************************/
 /*                                                                   */
 /*     ICM specific messages.                                        */
 /*                                                                   */
 /*********************************************************************/

 dcl ICM_COMPRESS_GET_FORMAT    fixed bin(31) value(ICM_USER+4);
     /* get compress format or size */
 dcl ICM_COMPRESS_GET_SIZE      fixed bin(31) value(ICM_USER+5);
     /* get output size */
 dcl ICM_COMPRESS_QUERY         fixed bin(31) value(ICM_USER+6);
     /* query support for compress */
 dcl ICM_COMPRESS_BEGIN         fixed bin(31) value(ICM_USER+7);
     /* begin a series of compress calls. */
 dcl ICM_COMPRESS               fixed bin(31) value(ICM_USER+8);
     /* compress a frame */
 dcl ICM_COMPRESS_END           fixed bin(31) value(ICM_USER+9);
     /* end of a series of compress calls. */

 dcl ICM_DECOMPRESS_GET_FORMAT  fixed bin(31) value(ICM_USER+10);
     /* get decompress format or size */
 dcl ICM_DECOMPRESS_QUERY       fixed bin(31) value(ICM_USER+11);
     /* query support for dempress */
 dcl ICM_DECOMPRESS_BEGIN       fixed bin(31) value(ICM_USER+12);
     /* start a series of decompress calls */
 dcl ICM_DECOMPRESS             fixed bin(31) value(ICM_USER+13);
     /* decompress a frame */
 dcl ICM_DECOMPRESS_END         fixed bin(31) value(ICM_USER+14);
     /* end a series of decompress calls */
 dcl ICM_DECOMPRESS_SET_PALETTE fixed bin(31) value(ICM_USER+29);
     /* fill in the DIB color table */
 dcl ICM_DECOMPRESS_GET_PALETTE fixed bin(31) value(ICM_USER+30);
     /* fill in the DIB color table */

 dcl ICM_DRAW_QUERY             fixed bin(31) value(ICM_USER+31);
     /* query support for dempress */
 dcl ICM_DRAW_BEGIN             fixed bin(31) value(ICM_USER+15);
     /* start a series of draw calls */
 dcl ICM_DRAW_GET_PALETTE       fixed bin(31) value(ICM_USER+16);
     /* get the palette needed for drawing */
 dcl ICM_DRAW_START             fixed bin(31) value(ICM_USER+18);
     /* start decompress clock */
 dcl ICM_DRAW_STOP              fixed bin(31) value(ICM_USER+19);
     /* stop decompress clock */
 dcl ICM_DRAW_END               fixed bin(31) value(ICM_USER+21);
     /* end a series of draw calls */
 dcl ICM_DRAW_GETTIME           fixed bin(31) value(ICM_USER+32);
     /* get value of decompress clock */
 dcl ICM_DRAW                   fixed bin(31) value(ICM_USER+33);
     /* generalized "render" message */
 dcl ICM_DRAW_WINDOW            fixed bin(31) value(ICM_USER+34);
     /* drawing window has moved or hidden */
 dcl ICM_DRAW_SETTIME           fixed bin(31) value(ICM_USER+35);
     /* set correct value for decompress clock */
 dcl ICM_DRAW_REALIZE           fixed bin(31) value(ICM_USER+36);
     /* realize palette for drawing */
 dcl ICM_DRAW_FLUSH             fixed bin(31) value(ICM_USER+37);
     /* clear out buffered frames */
 dcl ICM_DRAW_RENDERBUFFER      fixed bin(31) value(ICM_USER+38);
     /* draw undrawn things in queue */

 dcl ICM_DRAW_START_PLAY        fixed bin(31) value(ICM_USER+39);
     /* start of a play */
 dcl ICM_DRAW_STOP_PLAY         fixed bin(31) value(ICM_USER+40);
     /* end of a play */

 dcl ICM_DRAW_SUGGESTFORMAT     fixed bin(31) value(ICM_USER+50);
    /* Like ICGetDisplayFormat */
 dcl ICM_DRAW_CHANGEPALETTE     fixed bin(31) value(ICM_USER+51);
     /* for animating palette */

 dcl ICM_GETBUFFERSWANTED       fixed bin(31) value(ICM_USER+41);
     /* ask about prebuffering */

 dcl ICM_GETDEFAULTKEYFRAMERATE fixed bin(31) value(ICM_USER+42);
 /* get the default value for key frames */

 dcl ICM_DECOMPRESSEX_BEGIN     fixed bin(31) value(ICM_USER+60);
     /* start a series of decompress calls */
 dcl ICM_DECOMPRESSEX_QUERY     fixed bin(31) value(ICM_USER+61);
    /* start a series of decompress calls */
 dcl ICM_DECOMPRESSEX           fixed bin(31) value(ICM_USER+62);
    /* decompress a frame */
 dcl ICM_DECOMPRESSEX_END       fixed bin(31) value(ICM_USER+63);
     /* end a series of decompress calls */

 dcl ICM_COMPRESS_FRAMES_INFO   fixed bin(31) value(ICM_USER+70);
     /* tell about compress to come */
 dcl ICM_SET_STATUS_PROC        fixed bin(31) value(ICM_USER+72);
     /* set status callback */

 /*********************************************************************/

 define structure
   1 ICOPEN,
     2 dwSize      type DWORD,/* size(:ICOPEN:) */
     2 fccType     type DWORD,/* 'vidc' */
     2 fccHandler  type DWORD,/* */
     2 dwVersion   type DWORD,/* version of compman opening you */
     2 dwFlags     type DWORD,/* LOWORD is type specific */
     2 dwError     type LRESULT,/* error return. */
     2 pV1Reserved type LPVOID,/* Reserved */
     2 pV2Reserved type LPVOID,/* Reserved */
     2 dnDevNode   type DWORD;/* Devnode for PnP devices */

 /*********************************************************************/

 define structure
   1 ICINFO,
     2 dwSize        type DWORD,/* size(:ICINFO:) */
     2 fccType       type DWORD,/* compressor type 'vidc' 'audc' */
     2 fccHandler    type DWORD,/* compressor sub-type  */
                                /* 'rle ' 'jpeg' 'pcm ' */
     2 dwFlags       type DWORD,/* flags LOWORD is type specific */
     2 dwVersion     type DWORD,/* version of the driver */
     2 dwVersionICM  type DWORD,/* version of the ICM used */
     /* under Win32, the driver always returns UNICODE strings. */
     2 szName        WCHAR (16-1) varz,/* short name */
     2 szDescription WCHAR (128-1) varz,/* long name */
     2 szDriver      WCHAR (128-1) varz;
                     /* driver that contains compressor */

 /* Flags for the <dwFlags> field of the <ICINFO> structure. */
 dcl VIDCF_QUALITY        fixed bin(15) value('0001'xn);
     /* supports quality */
 dcl VIDCF_CRUNCH         fixed bin(15) value('0002'xn);
     /* supports crunching to a frame size */
 dcl VIDCF_TEMPORAL       fixed bin(15) value('0004'xn);
     /* supports inter-frame compress */
 dcl VIDCF_COMPRESSFRAMES fixed bin(15) value('0008'xn);
     /* wants the compress all frames message */
 dcl VIDCF_DRAW           fixed bin(15) value('0010'xn);
     /* supports drawing */
 dcl VIDCF_FASTTEMPORALC  fixed bin(15) value('0020'xn);
     /* does not need prev frame on compress */
 dcl VIDCF_FASTTEMPORALD  fixed bin(15) value('0080'xn);
     /* does not need prev frame on decompress */
 /* dcl VIDCF_QUALITYTIME    fixed bin(15) value('0040'xn) */
     /* supports temporal quality */
 /* dcl VIDCF_FASTTEMPORAL   fixed bin(15)
        value(ior(VIDCF_FASTTEMPORALC, VIDCF_FASTTEMPORALD)) */

 /*********************************************************************/

 dcl ICCOMPRESS_KEYFRAME type DWORD value('00000001'xu);

 define structure
   1 ICCOMPRESS,
     2 dwFlags     type DWORD,/* flags */
     2 lpbiOutput  type LPBITMAPINFOHEADER,/* output format */
     2 lpOutput    type LPVOID,/* output data */
     2 lpbiInput   type LPBITMAPINFOHEADER,
                   /* format of frame to compress */
     2 lpInput     type LPVOID,/* frame data to compress */
     2 lpckid      type LPDWORD,/* ckid for data in AVI file */
     2 lpdwFlags   type LPDWORD,/* flags in the AVI index. */
     2 lFrameNum   type LONG,/* frame number of seq. */
     2 dwFrameSize type DWORD,/* reqested size in bytes. (if non zero)*/
     2 dwQuality   type DWORD,/* quality */
     /* these are new fields */
     2 lpbiPrev    type LPBITMAPINFOHEADER,/* format of previous frame*/
     2 lpPrev      type LPVOID;/* previous frame */

 /*********************************************************************/

 dcl ICCOMPRESSFRAMES_PADDING type DWORD value('00000001'xu);

 define structure
   1 ICCOMPRESSFRAMES,
     2 dwFlags     type DWORD,/* flags */
     2 lpbiOutput  type LPBITMAPINFOHEADER,/* output format */
     2 lOutput     type LPARAM,/* output identifier */
     2 lpbiInput   type LPBITMAPINFOHEADER,
                        /* format of frame to compress */
     2 lInput      type LPARAM,/* input identifier */
     2 lStartFrame type LONG,/* start frame */
     2 lFrameCount type LONG,/* # of frames */
     2 lQuality    type LONG,/* quality */
     2 lDataRate   type LONG,/* data rate */
     2 lKeyRate    type LONG,/* key frame rate */
     2 dwRate      type DWORD,/* frame rate, as always */
     2 dwScale     type DWORD,
     2 dwOverheadPerFrame type DWORD,
     2 dwReserved2 type DWORD,

     2 GetData     entry (type LPARAM,
                          type LONG,
                          type LPVOID,
                          type LONG)
                   returns (type LONG byvalue optional)
                   limited CALLBACK,
     2 PutData     entry (type LPARAM,
                          type LONG,
                          type LPVOID,
                          type LONG)
                   returns (type LONG byvalue optional)
                   limited CALLBACK;

 /* messages for Status callback */
 dcl ICSTATUS_START  fixed bin (31) value (0);
 dcl ICSTATUS_STATUS fixed bin (31) value (1); /* l == % done */
 dcl ICSTATUS_END    fixed bin (31) value (2);
 dcl ICSTATUS_ERROR  fixed bin (31) value (3);
                     /* l == error string (LPSTR) */
 dcl ICSTATUS_YIELD  fixed bin (31) value (4);
 /* return nonzero means abort operation in progress */

 define structure
   1 ICSETSTATUSPROC,
     2 dwFlags type DWORD,
     2 lParam  type LPARAM,
     2 Status  entry (type LPARAM,
                      type UINT,
                      type LONG)
               returns (type LONG byvalue optional)
               limited CALLBACK;

 /*********************************************************************/

 dcl ICDECOMPRESS_HURRYUP     type DWORD value('80000000'xu);
     /* don't draw just buffer (hurry up!) */
 dcl ICDECOMPRESS_UPDATE      type DWORD value('40000000'xu);
     /* don't draw just update screen */
 dcl ICDECOMPRESS_PREROLL     type DWORD value('20000000'xu);
     /* this frame is before real start */
 dcl ICDECOMPRESS_NULLFRAME   type DWORD value('10000000'xu);
    /* repeat last frame */
 dcl ICDECOMPRESS_NOTKEYFRAME type DWORD value('08000000'xu);
     /* this frame is not a key frame */

 define structure
   1 ICDECOMPRESS,
     2 dwFlags    type DWORD,/* flags (from AVI index...) */
     2 lpbiInput  type LPBITMAPINFOHEADER,
                  /* BITMAPINFO of compressed data */
                  /* biSizeImage has the chunk size */
     2 lpInput    type LPVOID,/* compressed data */
     2 lpbiOutput type LPBITMAPINFOHEADER,/* DIB to decompress to */
     2 lpOutput   type LPVOID,
     2 ckid       type DWORD;/* ckid from AVI file */

 define structure
   1 ICDECOMPRESSEX,          /* same as ICM_DECOMPRESS */
     2 dwFlags    type DWORD,
     2 lpbiSrc    type LPBITMAPINFOHEADER,
                  /* BITMAPINFO of compressed data */
     2 lpSrc      type LPVOID,/* compressed data */
     2 lpbiDst    type LPBITMAPINFOHEADER,/* DIB to decompress to */
     2 lpDst      type LPVOID,/* output data */
     /* new for ICM_DECOMPRESSEX */
     2 xDst       fixed bin(31),/* destination rectangle */
     2 yDst       fixed bin(31),
     2 dxDst      fixed bin(31),
     2 dyDst      fixed bin(31),
     2 xSrc       fixed bin(31),/* source rectangle */
     2 ySrc       fixed bin(31),
     2 dxSrc      fixed bin(31),
     2 dySrc      fixed bin(31);


 /*********************************************************************/

 dcl ICDRAW_QUERY      type DWORD value('00000001'xu);
 /* test for support */
 dcl ICDRAW_FULLSCREEN type DWORD value('00000002'xu);
 /* draw to full screen */
 dcl ICDRAW_HDC        type DWORD value('00000004'xu);
 /* draw to a HDC/HWND */
 dcl ICDRAW_ANIMATE    type DWORD value('00000008'xu);
 /* expect palette animation */
 dcl ICDRAW_CONTINUE   type DWORD value('00000010'xu);
 /* draw is a continuation of previous draw */
 dcl ICDRAW_MEMORYDC   type DWORD value('00000020'xu);
 /* DC is offscreen, by the way */
 dcl ICDRAW_UPDATING   type DWORD value('00000040'xu);
 /* We're updating, as opposed to playing */
 dcl ICDRAW_RENDER     type DWORD value('00000080'xu);
 /* used to render data not draw it */
 dcl ICDRAW_BUFFER     type DWORD value('00000100'xu);
 /* please buffer this data offscreen, we will need to update it */

 define structure
   1 ICDRAWBEGIN,
     2 dwFlags type DWORD,/* flags */
     2 hpal    type HPALETTE,/* palette to draw with */
     2 hwnd    type HWND,/* window to draw to */
     2 hdc     type HDC,/* HDC to draw to */
     2 xDst    fixed bin(31),/* destination rectangle */
     2 yDst    fixed bin(31),
     2 dxDst   fixed bin(31),
     2 dyDst   fixed bin(31),
     2 lpbi    type LPBITMAPINFOHEADER,/* format of frame to draw */
     2 xSrc    fixed bin(31),/* source rectangle */
     2 ySrc    fixed bin(31),
     2 dxSrc   fixed bin(31),
     2 dySrc   fixed bin(31),
     2 dwRate  type DWORD,/* frames/second = (dwRate/dwScale) */
     2 dwScale type DWORD;


 /*********************************************************************/

 dcl ICDRAW_HURRYUP     type DWORD value('80000000'xu);
     /* don't draw just buffer (hurry up!) */
 dcl ICDRAW_UPDATE      type DWORD value('40000000'xu);
     /* don't draw just update screen */
 dcl ICDRAW_PREROLL     type DWORD value('20000000'xu);
     /* this frame is before real start */
 dcl ICDRAW_NULLFRAME   type DWORD value('10000000'xu);
    /* repeat last frame */
 dcl ICDRAW_NOTKEYFRAME type DWORD value('08000000'xu);
     /* this frame is not a key frame */

 define structure
   1 ICDRAW,
     2 dwFlags  type DWORD,/* flags */
     2 lpFormat type LPVOID,/* format of frame to decompress */
     2 lpData   type LPVOID,/* frame data to decompress */
     2 cbData   type DWORD,
     2 lTime    type LONG; /* time in drawbegin units*/
                           /*(see dwRate and dwScale) */

 define structure
   1 ICDRAWSUGGEST,
     2 lpbiIn          type LPBITMAPINFOHEADER,/* format to be drawn */
     2 lpbiSuggest     type LPBITMAPINFOHEADER,
               /* location for suggested format (or NULL to get size) */
     2 dxSrc           fixed bin(31),/* source extent or 0 */
     2 dySrc           fixed bin(31),
     2 dxDst           fixed bin(31),/* dest extent or 0 */
     2 dyDst           fixed bin(31),
     2 hicDecompressor type HIC;/* decompressor you can talk to */

 /*********************************************************************/

 define structure
   1 ICPALETTE,
     2 dwFlags type DWORD,/* flags (from AVI index...) */
     2 iStart  fixed bin(31),/* first palette to change */
     2 iLen    fixed bin(31),/* count of entries to change. */
     2 lppe    type LPPALETTEENTRY;/* palette */


 /*********************************************************************/
 /*                                                                   */
 /*   ICM function declarations                                       */
 /*                                                                   */
 /*********************************************************************/

 dcl ICInfo
     entry (type DWORD,
            type DWORD,
            type ICINFO byaddr)
     returns (type BOOL byvalue optional)
     VFWAPI external('ICInfo');

 dcl ICInstall
     entry (type DWORD,
            type DWORD,
            type LPARAM,
            char (*) varz byaddr optional,
            type UINT)
     returns (type BOOL byvalue optional)
     VFWAPI external('ICInstall');

 dcl ICRemove
     entry (type DWORD,
            type DWORD,
            type UINT)
     returns (type BOOL byvalue optional)
     VFWAPI external('ICRemove');

 dcl ICGetInfo
     entry (type HIC,
            type ICINFO byaddr,
            type DWORD)
     returns (type LRESULT byvalue optional)
     VFWAPI external('ICGetInfo');

 dcl ICOpen
     entry (type DWORD,
            type DWORD,
            type UINT)
     returns (type HIC byvalue optional)
     VFWAPI external('ICOpen');

 dcl ICOpenFunction
     entry (type DWORD,
            type DWORD,
            type UINT,
            type FARPROC)
     returns (type HIC byvalue optional)
     VFWAPI external('ICOpenFunction');

 dcl ICClose
     entry (type HIC)
     returns (type LRESULT byvalue optional)
     VFWAPI external('ICClose');

 dcl ICSendMessage
     entry (type HIC,
            type UINT,
            type DWORD,
            type DWORD)
     returns (type LRESULT byvalue optional)
     VFWAPI external('ICSendMessage');

 /* Values for wFlags of ICInstall() */
 dcl ICINSTALL_UNICODE  type UINT value('8000'xn);

 dcl ICINSTALL_FUNCTION type UINT value('0001'xn);
     /* lParam is a DriverProc (function ptr) */
 dcl ICINSTALL_DRIVER   type UINT value('0002'xn);
     /* lParam is a driver name (string) */
 dcl ICINSTALL_HDRV     type UINT value('0004'xn);
     /* lParam is a HDRVR (driver handle) */

 dcl ICINSTALL_DRIVERW  type UINT value('8002'xn);
     /* lParam is a unicode driver name */

 /*********************************************************************/
 /*                                                                   */
 /*   query macros                                                    */
 /*                                                                   */
 /*********************************************************************/

 dcl ICMF_CONFIGURE_QUERY type DWORD value('00000001'xu);
 dcl ICMF_ABOUT_QUERY     type DWORD value('00000001'xu);

 ICQueryAbout: proc (hic)
               returns (bit (1))
               options (inline reorder) internal;
   dcl hic type HIC byvalue;
   dcl (bin, iunsigned) builtin;
   return (ICSendMessage (hic, ICM_ABOUT, iunsigned(bin(-1,31)),
                                          ICMF_ABOUT_QUERY)
           = ICERR_OK);
 end ICQueryAbout;

 ICAbout: proc (hic, hwnd)
          returns (type LRESULT byvalue optional)
          options (inline reorder) internal;
   dcl hic  type HIC byvalue,
       hwnd type HWND byvalue;
   dcl binvalue builtin;
   return (ICSendMessage (hic, ICM_ABOUT, binvalue (hwnd), 0));
 end ICAbout;

 ICQueryConfigure: proc (hic)
                   returns (bit (1))
                   options (inline reorder) internal;
   dcl hic type HIC byvalue;
   dcl (bin, iunsigned) builtin;
   return (ICSendMessage (hic, ICM_CONFIGURE, iunsigned(bin(-1,31)),
                                              ICMF_CONFIGURE_QUERY)
           = ICERR_OK);
 end ICQueryConfigure;

 ICConfigure: proc (hic, hwnd)
              returns (type LRESULT byvalue optional)
              options (inline reorder) internal;
   dcl hic  type HIC byvalue,
       hwnd type HWND byvalue;
   dcl binvalue builtin;
   return (ICSendMessage (hic, ICM_CONFIGURE, binvalue (hwnd), 0));
 end ICConfigure;


 /*********************************************************************/
 /*                                                                   */
 /*   get/set state macros                                            */
 /*                                                                   */
 /*********************************************************************/

 ICGetState: proc (hic, pv, cb)
             returns (type LRESULT byvalue optional)
             options (inline reorder) internal;
   dcl hic  type HIC byvalue,
       pv   type LPVOID byvalue,
       cb   type DWORD byvalue;
   dcl binvalue builtin;
   return (ICSendMessage (hic, ICM_GETSTATE, binvalue (pv), cb));
 end ICGetState;

 ICSetState: proc (hic, pv, cb)
             returns (type LRESULT byvalue optional)
             options (inline reorder) internal;
   dcl hic  type HIC byvalue,
       pv   type LPVOID byvalue,
       cb   type DWORD byvalue;
   dcl binvalue builtin;
   return (ICSendMessage (hic, ICM_SETSTATE, binvalue (pv), cb));
 end ICSetState;

 ICGetStateSize: proc (hic)
                 returns (fixed bin (31))
                 options (inline reorder) internal;
   dcl hic type HIC byvalue;
   dcl sysnull builtin;
   return (ICGetState (hic, sysnull(), 0));
 end ICGetStateSize;


 /*********************************************************************/
 /*                                                                   */
 /*   get value macros                                                */
 /*                                                                   */
 /*********************************************************************/

 ICGetDefaultQuality: proc (hic)
                      returns (type LRESULT byvalue optional)
                      options (inline reorder) internal;
   dcl hic type HIC byvalue;
   dcl dwICValue type DWORD;
   dcl (addr, binvalue, stg) builtin;
   call ICSendMessage (hic, ICM_GETDEFAULTQUALITY,
                       binvalue (addr (dwICValue)), stg (dwICValue));
   return (dwICValue);
 end ICGetDefaultQuality;

 ICGetDefaultKeyFrameRate: proc (hic)
                           returns (type LRESULT byvalue optional)
                           options (inline reorder) internal;
   dcl hic type HIC byvalue;
   dcl dwICValue type DWORD;
   dcl (addr, binvalue, stg) builtin;
   call ICSendMessage (hic, ICM_GETDEFAULTKEYFRAMERATE,
                       binvalue (addr (dwICValue)), stg (dwICValue));
   return (dwICValue);
 end ICGetDefaultKeyFrameRate;


 /*********************************************************************/
 /*                                                                   */
 /*   draw window macro                                               */
 /*                                                                   */
 /*********************************************************************/

 ICDrawWindow: proc (hic, prc)
               returns (type LRESULT byvalue optional)
               options (inline reorder) internal;
   dcl hic type HIC byvalue,
       prc type RECT byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_DRAW_WINDOW,
                          binvalue (addr (prc)), size (: RECT :)));
 end ICDrawWindow;

 /*********************************************************************/
 /*                                                                   */
 /*   compression functions                                           */
 /*                                                                   */
 /*********************************************************************/

 /* ICCompress()             */
 /*                          */
 /*  compress a single frame */
 dcl ICCompress
     entry (type HIC,
            type DWORD,  /* flags */
            type BITMAPINFOHEADER byaddr optional, /* output format */
            type LPVOID, /* output data */
            type BITMAPINFOHEADER byaddr,
                         /* format of frame to compress */
            type LPVOID, /* frame data to compress */
            type DWORD byaddr optional, /* ckid for data in AVI file */
            type DWORD byaddr, /* flags in the AVI index. */
            type LONG,   /* frame number of seq. */
            type DWORD,  /* reqested size in bytes. (if non zero) */
            type DWORD,  /* quality within one frame */
            type BITMAPINFOHEADER byaddr optional,
                         /* format of previous frame */
            type LPVOID) /* previous frame */
     returns (type DWORD byvalue optional)
     VFWAPIV external('ICCompress');

 /* ICCompressBegin()                                             */
 /*                                                               */
 /*  start compression from a source format (lpbiInput) to a dest */
 /*  format (lpbiOuput) is supported.                             */

 ICCompressBegin: proc (hic, lpbiInput, lpbiOutput)
                  returns (type LRESULT byvalue optional)
                  options (inline reorder) internal;
   dcl hic        type HIC byvalue,
       lpbiInput  type BITMAPINFOHEADER byaddr,
       lpbiOutput type BITMAPINFOHEADER byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_COMPRESS_BEGIN,
                          binvalue (addr (lpbiInput)),
                          binvalue (addr (lpbiOutput))));
 end ICCompressBegin;

 /*  ICCompressQuery()                                               */
 /*                                                                  */
 /*  determines if compression from a source format (lpbiInput) to a */
 /*  dest format (lpbiOuput) is supported.                           */

 ICCompressQuery: proc (hic, lpbiInput, lpbiOutput)
                  returns (type LRESULT byvalue optional)
                  options (inline reorder) internal;
   dcl hic        type HIC byvalue,
       lpbiInput  type BITMAPINFOHEADER byaddr,
       lpbiOutput type BITMAPINFOHEADER byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_COMPRESS_QUERY,
                          binvalue (addr (lpbiInput)),
                          binvalue (addr (lpbiOutput))));
 end ICCompressQuery;

 /*   ICCompressGetFormat()                                           */
 /*                                                                   */
 /*  get the output format, (format of compressed data)               */
 /*  if lpbiOutput is NULL return the size in bytes needed for format.*/

 ICCompressGetFormat: proc (hic, lpbiInput, lpbiOutput)
                      returns (type LRESULT byvalue optional)
                      options (inline reorder) internal;
   dcl hic        type HIC byvalue,
       lpbiInput  type BITMAPINFOHEADER byaddr,
       lpbiOutput type BITMAPINFOHEADER byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_COMPRESS_GET_FORMAT,
                          binvalue (addr (lpbiInput)),
                          binvalue (addr (lpbiOutput))));
 end ICCompressGetFormat;

 ICCompressGetFormatSize: proc (hic, lpbi)
                          returns (type LRESULT byvalue optional)
                          options (inline reorder) internal;
   dcl hic  type HIC byvalue,
       lpbi type BITMAPINFOHEADER byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_COMPRESS_GET_FORMAT,
                          binvalue (addr (lpbi)), 0));
 end ICCompressGetFormatSize;

 /*  ICCompressSize()                              */
 /*                                                */
 /*  return the maximal size of a compressed frame */

 ICCompressGetSize: proc (hic, lpbiInput, lpbiOutput)
                    returns (type LRESULT byvalue optional)
                    options (inline reorder) internal;
   dcl hic        type HIC byvalue,
       lpbiInput  type BITMAPINFOHEADER byaddr,
       lpbiOutput type BITMAPINFOHEADER byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_COMPRESS_GET_SIZE,
                          binvalue (addr (lpbiInput)),
                          binvalue (addr (lpbiOutput))));
 end ICCompressGetSize;

 ICCompressEnd: proc (hic)
                returns (type LRESULT byvalue optional)
                options (inline reorder) internal;
   dcl hic type HIC byvalue;

   return (ICSendMessage (hic, ICM_COMPRESS_END, 0, 0));
 end ICCompressEnd;


 /*********************************************************************/
 /*                                                                   */
 /*   decompression functions                                         */
 /*                                                                   */
 /*********************************************************************/

 /*  ICDecompress()            */
 /*                            */
 /*  decompress a single frame */

 dcl ICDecompress
     entry (type HIC,
            type DWORD,  /* flags (from AVI index...) */
            type BITMAPINFOHEADER byaddr,
                         /* BITMAPINFO of compressed data */
                         /* biSizeImage has the chunk size */
            type LPVOID, /* data */
            type BITMAPINFOHEADER byaddr, /* DIB to decompress to */
            type LPVOID)
     returns (type DWORD byvalue optional)
     VFWAPIV external('ICDecompress');

 /*  ICDecompressBegin()                                          */
 /*                                                               */
 /*  start compression from a source format (lpbiInput) to a dest */
 /*  format (lpbiOutput) is supported.                            */

 ICDecompressBegin: proc (hic, lpbiInput, lpbiOutput)
                    returns (type LRESULT byvalue optional)
                    options (inline reorder) internal;
   dcl hic        type HIC byvalue,
       lpbiInput  type BITMAPINFOHEADER byaddr,
       lpbiOutput type BITMAPINFOHEADER byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_DECOMPRESS_BEGIN,
                          binvalue (addr (lpbiInput)),
                          binvalue (addr (lpbiOutput))));
 end ICDecompressBegin;


 /*  ICDecompressQuery()                                             */
 /*                                                                  */
 /*  determines if compression from a source format (lpbiInput) to a */
 /*  dest format (lpbiOutput) is supported.                          */

 ICDecompressQuery: proc (hic, lpbiInput, lpbiOutput)
                    returns (type LRESULT byvalue optional)
                    options (inline reorder) internal;
   dcl hic        type HIC byvalue,
       lpbiInput  type BITMAPINFOHEADER byaddr,
       lpbiOutput type BITMAPINFOHEADER byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_DECOMPRESS_QUERY,
                          binvalue (addr (lpbiInput)),
                          binvalue (addr (lpbiOutput))));
 end ICDecompressQuery;


 /*  ICDecompressGetFormat()                                          */
 /*                                                                   */
 /*  get the output format, (format of un-compressed data)            */
 /*  if lpbiOutput is NULL return the size in bytes needed for format.*/

 ICDecompressGetFormat: proc (hic, lpbiInput, lpbiOutput)
                        returns (type LRESULT byvalue optional)
                        options (inline reorder) internal;
   dcl hic        type HIC byvalue,
       lpbiInput  type BITMAPINFOHEADER byaddr,
       lpbiOutput type BITMAPINFOHEADER byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_DECOMPRESS_GET_FORMAT,
                          binvalue (addr (lpbiInput)),
                          binvalue (addr (lpbiOutput))));
 end ICDecompressGetFormat;

 ICDecompressGetFormatSize: proc (hic, lpbi)
                            returns (type LRESULT byvalue optional)
                            options (inline reorder) internal;
   dcl hic  type HIC byvalue,
       lpbi type BITMAPINFOHEADER byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_DECOMPRESS_GET_FORMAT,
                          binvalue (addr (lpbi)), 0));
 end ICDecompressGetFormatSize;

 /*  ICDecompressGetPalette() */
 /*                           */
 /*  get the output palette   */

 ICDecompressGetPalette: proc (hic, lpbiInput, lpbiOutput)
                         returns (type LRESULT byvalue optional)
                         options (inline reorder) internal;
   dcl hic        type HIC byvalue,
       lpbiInput  type BITMAPINFOHEADER byaddr,
       lpbiOutput type BITMAPINFOHEADER byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_DECOMPRESS_GET_PALETTE,
                          binvalue (addr (lpbiInput)),
                          binvalue (addr (lpbiOutput))));
 end ICDecompressGetPalette;

 ICDecompressSetPalette: proc (hic, lpbiPalette)
                         returns (type LRESULT byvalue optional)
                         options (inline reorder) internal;
   dcl hic         type HIC byvalue,
       lpbiPalette type BITMAPINFOHEADER byaddr;
   dcl (addr, binvalue) builtin;

   return (ICSendMessage (hic, ICM_DECOMPRESS_SET_PALETTE,
                          binvalue (addr (lpbiPalette)), 0));
 end ICDecompressSetPalette;


 ICDecompressEnd: proc (hic)
                  returns (type LRESULT byvalue optional)
                  options (inline reorder) internal;
   dcl hic type HIC byvalue;

   return (ICSendMessage (hic, ICM_DECOMPRESS_END, 0, 0));
 end ICDecompressEnd;


 /*********************************************************************/
 /*                                                                   */
 /*   decompression (ex) functions                                    */
 /*                                                                   */
 /*********************************************************************/

 /* On Win16 these functions are macros that call ICMessage.        */
 /* ICMessage will not work on NT. Rather than add new entrypoints  */
 /* we have given them as inline functions                          */

 /*  ICDecompressEx()            */
 /*                              */
 /*  decompress a single frame   */

 ICDecompressEx: proc (hic, dwFlags,
                       lpbiSrc, lpSrc, xSrc, ySrc, dxSrc, dySrc,
                       lpbiDst, lpDst, xDst, yDst, dxDst, dyDst)
                 returns (type LRESULT byvalue optional)
                 options (inline reorder) internal;

   dcl hic     type HIC byvalue,
       dwFlags type DWORD byvalue,
       lpbiSrc type BITMAPINFOHEADER byaddr,
       lpSrc   type LPVOID byvalue,
       xSrc    fixed bin (31) byvalue,
       ySrc    fixed bin (31) byvalue,
       dxSrc   fixed bin (31) byvalue,
       dySrc   fixed bin (31) byvalue,
       lpbiDst type BITMAPINFOHEADER byaddr,
       lpDst   type LPVOID byvalue,
       xDst    fixed bin (31) byvalue,
       yDst    fixed bin (31) byvalue,
       dxDst   fixed bin (31) byvalue,
       dyDst   fixed bin (31) byvalue;

   dcl ic type ICDECOMPRESSEX;
   dcl (addr, binvalue, stg) builtin;

   ic.dwFlags = dwFlags;
   ic.lpbiSrc = lpbiSrc;
   ic.lpSrc   = lpSrc;
   ic.xSrc    = xSrc;
   ic.ySrc    = ySrc;
   ic.dxSrc   = dxSrc;
   ic.dySrc   = dySrc;
   ic.lpbiDst = lpbiDst;
   ic.lpDst   = lpDst;
   ic.xDst    = xDst;
   ic.yDst    = yDst;
   ic.dxDst   = dxDst;
   ic.dyDst   = dyDst;

   /* note that ICM swaps round the length and pointer */
   /* length in lparam2, pointer in lparam1 */
   return (ICSendMessage (hic, ICM_DECOMPRESSEX,
                          binvalue (addr (ic)), stg (ic)));
 end ICDecompressEx;

 /*  ICDecompressExBegin()                                        */
 /*                                                               */
 /*  start compression from a source format (lpbiInput) to a dest */
 /*  format (lpbiOutput) is supported.                            */

 ICDecompressExBegin: proc (hic, dwFlags,
                            lpbiSrc, lpSrc, xSrc, ySrc, dxSrc, dySrc,
                            lpbiDst, lpDst, xDst, yDst, dxDst, dyDst)
                      returns (type LRESULT byvalue optional)
                      options (inline reorder) internal;

   dcl hic     type HIC byvalue,
       dwFlags type DWORD byvalue,
       lpbiSrc type BITMAPINFOHEADER byaddr,
       lpSrc   type LPVOID byvalue,
       xSrc    fixed bin (31) byvalue,
       ySrc    fixed bin (31) byvalue,
       dxSrc   fixed bin (31) byvalue,
       dySrc   fixed bin (31) byvalue,
       lpbiDst type BITMAPINFOHEADER byaddr,
       lpDst   type LPVOID byvalue,
       xDst    fixed bin (31) byvalue,
       yDst    fixed bin (31) byvalue,
       dxDst   fixed bin (31) byvalue,
       dyDst   fixed bin (31) byvalue;

   dcl ic type ICDECOMPRESSEX;
   dcl (addr, binvalue, stg) builtin;

   ic.dwFlags = dwFlags;
   ic.lpbiSrc = lpbiSrc;
   ic.lpSrc   = lpSrc;
   ic.xSrc    = xSrc;
   ic.ySrc    = ySrc;
   ic.dxSrc   = dxSrc;
   ic.dySrc   = dySrc;
   ic.lpbiDst = lpbiDst;
   ic.lpDst   = lpDst;
   ic.xDst    = xDst;
   ic.yDst    = yDst;
   ic.dxDst   = dxDst;
   ic.dyDst   = dyDst;

   /* note that ICM swaps round the length and pointer */
   /* length in lparam2, pointer in lparam1 */
   return (ICSendMessage (hic, ICM_DECOMPRESSEX_BEGIN,
                          binvalue (addr (ic)), stg (ic)));
 end ICDecompressExBegin;

 /* ICDecompressExQuery() */

 ICDecompressExQuery: proc (hic, dwFlags,
                            lpbiSrc, lpSrc, xSrc, ySrc, dxSrc, dySrc,
                            lpbiDst, lpDst, xDst, yDst, dxDst, dyDst)
                      returns (type LRESULT byvalue optional)
                      options (inline reorder) internal;

   dcl hic     type HIC byvalue,
       dwFlags type DWORD byvalue,
       lpbiSrc type BITMAPINFOHEADER byaddr,
       lpSrc   type LPVOID byvalue,
       xSrc    fixed bin (31) byvalue,
       ySrc    fixed bin (31) byvalue,
       dxSrc   fixed bin (31) byvalue,
       dySrc   fixed bin (31) byvalue,
       lpbiDst type BITMAPINFOHEADER byaddr optional,
       lpDst   type LPVOID byvalue,
       xDst    fixed bin (31) byvalue,
       yDst    fixed bin (31) byvalue,
       dxDst   fixed bin (31) byvalue,
       dyDst   fixed bin (31) byvalue;

   dcl ic type ICDECOMPRESSEX;
   dcl (addr, binvalue, stg) builtin;

   ic.dwFlags = dwFlags;
   ic.lpbiSrc = lpbiSrc;
   ic.lpSrc   = lpSrc;
   ic.xSrc    = xSrc;
   ic.ySrc    = ySrc;
   ic.dxSrc   = dxSrc;
   ic.dySrc   = dySrc;
   ic.lpbiDst = lpbiDst;
   ic.lpDst   = lpDst;
   ic.xDst    = xDst;
   ic.yDst    = yDst;
   ic.dxDst   = dxDst;
   ic.dyDst   = dyDst;

   /* note that ICM swaps round the length and pointer */
   /* length in lparam2, pointer in lparam1 */
   return (ICSendMessage (hic, ICM_DECOMPRESSEX_QUERY,
                          binvalue (addr (ic)), stg (ic)));
 end ICDecompressExQuery;

 ICDecompressExEnd: proc (hic)
                    returns (type LRESULT byvalue optional)
                    options (inline reorder) internal;
   dcl hic type HIC;

   return (ICSendMessage (hic, ICM_DECOMPRESSEX_END, 0, 0));
 end ICDecompressExEnd;


 /*********************************************************************/
 /*                                                                   */
 /*   drawing functions                                               */
 /*                                                                   */
 /*********************************************************************/

 /*  ICDrawBegin()                                                    */
 /*                                                                   */
 /*  start decompressing data with format (lpbiInput) directly to the */
 /*  screen, return zero if the decompressor supports drawing.        */

 dcl ICDrawBegin
     entry (type HIC,
            type DWORD,    /* flags */
            type HPALETTE, /* palette to draw with */
            type HWND,     /* window to draw to */
            type HDC,      /* HDC to draw to */
            fixed bin(31), /* destination rectangle */
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type BITMAPINFOHEADER byaddr, /* format of frame to draw */
            fixed bin(31), /* source rectangle */
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type DWORD,    /* frames/second = (dwRate/dwScale) */
            type DWORD)
     returns (type DWORD byvalue optional)
     VFWAPIV external('ICDrawBegin');

 /* ICDraw()                                */
 /*                                         */
 /*  decompress data directly to the screen */

 dcl ICDraw
     entry (type HIC,
            type DWORD,  /* flags */
            type LPVOID, /* format of frame to decompress */
            type LPVOID, /* frame data to decompress */
            type DWORD,  /* size of data */
            type LONG)   /* time to draw this frame */
     returns (type DWORD byvalue optional)
     VFWAPIV external('ICDraw');

 /* ICMessage is not supported on Win32, so provide an inline */
 /* function to do the same job                               */

 ICDrawSuggestFormat: proc (hic, lpbiIn, lpbiOut,
                            dxSrc, dySrc, dxDst, dyDst, hicDecomp)
                      returns (type LRESULT optional byvalue)
                      options (inline reorder) internal;

   dcl hic       type HIC byvalue,
       lpbiIn    type BITMAPINFOHEADER byaddr,
       lpbiOut   type BITMAPINFOHEADER byaddr,
       dxSrc     fixed bin(31) byvalue,
       dySrc     fixed bin(31) byvalue,
       dxDst     fixed bin(31) byvalue,
       dyDst     fixed bin(31) byvalue,
       hicDecomp type HIC byvalue;

   dcl ic type ICDRAWSUGGEST;
   dcl (addr, binvalue, stg) builtin;

   ic.lpbiIn          = lpbiIn;
   ic.lpbiSuggest     = lpbiOut;
   ic.dxSrc           = dxSrc;
   ic.dySrc           = dySrc;
   ic.dxDst           = dxDst;
   ic.dyDst           = dyDst;
   ic.hicDecompressor = hicDecomp;

   /* note that ICM swaps round the length and pointer */
   /* length in lparam2, pointer in lparam1 */
   return (ICSendMessage (hic, ICM_DRAW_SUGGESTFORMAT,
                          binvalue (addr (ic)), stg(ic)));
 end ICDrawSuggestFormat;

 /*  ICDrawQuery()                                                   */
 /*                                                                  */
 /*  determines if the compressor is willing to render the specified */
 /*  format.                                                         */

 ICDrawQuery: proc (hic, lpbiInput)
              returns (type LRESULT byvalue optional)
              options (inline reorder) internal;
   dcl hic       type HIC byvalue,
       lpbiInput type BITMAPINFO byaddr;
   dcl (addr, binvalue) builtin;
   return (ICSendMessage (hic, ICM_DRAW_QUERY,
                          binvalue (addr (lpbiInput)), 0));
 end ICDrawQuery;

 ICDrawChangePalette: proc (hic, lpbiInput)
                      returns (type LRESULT byvalue optional)
                      options (inline reorder) internal;
   dcl hic       type HIC byvalue,
       lpbiInput type BITMAPINFO byaddr;
   dcl (addr, binvalue) builtin;
   return (ICSendMessage (hic, ICM_DRAW_CHANGEPALETTE,
                          binvalue (addr (lpbiInput)), 0));
 end ICDrawChangePalette;

 ICGetBuffersWanted: proc (hic, lpdwBuffers)
                     returns (type LRESULT byvalue optional)
                     options (inline reorder) internal;
   dcl hic         type HIC byvalue,
       lpdwBuffers type DWORD byaddr;
   dcl (addr, binvalue) builtin;
   return (ICSendMessage (hic, ICM_GETBUFFERSWANTED,
                          binvalue (addr (lpdwBuffers)), 0));
 end ICGetBuffersWanted;

 ICDrawEnd: proc (hic)
            returns (type LRESULT byvalue optional)
            options (inline reorder) internal;
   dcl hic type HIC byvalue;
   return (ICSendMessage (hic, ICM_DRAW_END, 0, 0));
 end ICDrawEnd;

 ICDrawStart: proc (hic)
              returns (type LRESULT byvalue optional)
              options (inline reorder) internal;
   dcl hic type HIC byvalue;
   return (ICSendMessage (hic, ICM_DRAW_START, 0, 0));
 end ICDrawStart;

 ICDrawStartPlay: proc (hic, lFrom, lTo)
              returns (type LRESULT byvalue optional)
              options (inline reorder) internal;
   dcl hic   type HIC byvalue,
       lFrom type DWORD byvalue,
       lTo   type DWORD byvalue;
   return (ICSendMessage (hic, ICM_DRAW_START_PLAY, lFrom, lTo));
 end ICDrawStartPlay;

 ICDrawStop: proc (hic)
             returns (type LRESULT byvalue optional)
             options (inline reorder) internal;
   dcl hic type HIC byvalue;
   return (ICSendMessage (hic, ICM_DRAW_STOP, 0, 0));
 end ICDrawStop;

 ICDrawStopPlay: proc (hic)
                 returns (type LRESULT byvalue optional)
                 options (inline reorder) internal;
   dcl hic type HIC byvalue;
   return (ICSendMessage (hic, ICM_DRAW_STOP_PLAY, 0, 0));
 end ICDrawStopPlay;

 ICDrawGetTime: proc (hic, lplTime)
                returns (type LRESULT byvalue optional)
                options (inline reorder) internal;
   dcl hic     type HIC byvalue,
       lplTime type DWORD byaddr;
   dcl (addr, binvalue) builtin;
   return (ICSendMessage (hic, ICM_DRAW_GETTIME,
                          binvalue (addr (lplTime)), 0));
 end ICDrawGetTime;

 ICDrawSetTime: proc (hic, lTime)
                returns (type LRESULT byvalue optional)
                options (inline reorder) internal;
   dcl hic   type HIC byvalue,
       lTime type DWORD byvalue;
   return (ICSendMessage (hic, ICM_DRAW_SETTIME, lTime, 0));
 end ICDrawSetTime;

 ICDrawRealize: proc (hic, hdc, fBackground)
                returns (type LRESULT byvalue optional)
                options (inline reorder) internal;
   dcl hic         type HIC byvalue,
       hdc         type HDC byvalue,
       fBackground type BOOL byvalue;
   dcl binvalue builtin;
   return (ICSendMessage (hic, ICM_DRAW_REALIZE,
                          binvalue (hdc), fBackground));
 end ICDrawRealize;

 ICDrawFlush: proc (hic)
              returns (type LRESULT byvalue optional)
              options (inline reorder) internal;
   dcl hic type HIC byvalue;
   return (ICSendMessage (hic, ICM_DRAW_FLUSH, 0, 0));
 end ICDrawFlush;

 ICDrawRenderBuffer: proc (hic)
                     returns (type LRESULT byvalue optional)
                     options (inline reorder) internal;
   dcl hic type HIC byvalue;
   return (ICSendMessage (hic, ICM_DRAW_RENDERBUFFER, 0, 0));
 end ICDrawRenderBuffer;

 /*********************************************************************/
 /*                                                                   */
 /*   Status callback functions                                       */
 /*                                                                   */
 /*********************************************************************/

 /*  ICSetStatusProc()                */
 /*                                   */
 /*  Set the status callback function */

 /* ICMessage is not supported on NT */
 ICSetStatusProc: proc (hic, dwFlags, lParam, fpfnStatus)
                  returns (type LRESULT byvalue optional)
                  options (inline reorder) internal;
   dcl hic        type HIC byvalue,
       dwFlags    type DWORD byvalue,
       lParam     type LRESULT byvalue,
       fpfnStatus entry (type LPARAM,
                         type UINT,
                         type LONG)
                  returns (type LONG byvalue optional)
                  limited CALLBACK;

   dcl ic type ICSETSTATUSPROC;
   dcl (addr, binvalue, stg) builtin;

   ic.dwFlags = dwFlags;
   ic.lParam = lParam;
   ic.Status = fpfnStatus;

   /* note that ICM swaps round the length and pointer */
   /* length in lparam2, pointer in lparam1 */
   return (ICSendMessage (hic, ICM_SET_STATUS_PROC,
                          binvalue (addr (ic)), stg(ic)));
 end ICSetStatusProc;

 /*********************************************************************/
 /*                                                                   */
 /* helper routines for DrawDib and MCIAVI...                         */
 /*                                                                   */
 /*********************************************************************/

 ICDecompressOpen: proc (fccType, fccHandler, lpbiIn, lpbiOut)
                   returns (type HIC byvalue optional)
                   options (inline reorder) internal;
   dcl fccType    type DWORD byvalue,
       fccHandler type DWORD byvalue,
       lpbiIn     type BITMAPINFOHEADER byaddr,
       lpbiOut    type BITMAPINFOHEADER byaddr optional;
   return (ICLocate (fccType, fccHandler, lpbiIn, lpbiOut,
                     ICMODE_DECOMPRESS));
 end ICDecompressOpen;

 ICDrawOpen: proc (fccType, fccHandler, lpbiIn)
             returns (type HIC byvalue optional)
             options (inline reorder) internal;
   dcl fccType    type DWORD byvalue,
       fccHandler type DWORD byvalue,
       lpbiIn     type BITMAPINFOHEADER byaddr;
   return (ICLocate (fccType, fccHandler, lpbiIn, *, ICMODE_DRAW));
 end ICDrawOpen;

 dcl ICLocate
     entry (type DWORD,
            type DWORD,
            type BITMAPINFOHEADER byaddr,
            type BITMAPINFOHEADER byaddr optional,
            type WORD)
     returns (type HIC byvalue optional)
     VFWAPI external('ICLocate');

 dcl ICGetDisplayFormat
     entry (type HIC,
            type BITMAPINFOHEADER byaddr,
            type BITMAPINFOHEADER byaddr optional,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type HIC byvalue optional)
     VFWAPI external('ICGetDisplayFormat');

 /*********************************************************************/
 /* Higher level functions                                            */
 /*********************************************************************/

 dcl ICImageCompress
     entry (type HIC,    /* compressor to use */
            type UINT,   /* flags (none yet) */
            type BITMAPINFO byaddr, /* format to compress from */
            type LPVOID, /* data to compress */
            type BITMAPINFO byaddr optional,
                         /* compress to this (* ==> default) */
            type LONG,   /* quality to use */
            type LONG byaddr) /* compress to this size (0=whatever) */
     returns (type HANDLE byvalue optional)
     VFWAPI external('ICImageCompress');

 dcl ICImageDecompress  entry (
            type HIC,    /* compressor to use */
            type UINT,   /* flags (none yet) */
            type BITMAPINFO byaddr, /* format to decompress from */
            type LPVOID, /* data to decompress */
            type BITMAPINFO byaddr optional)
                         /* decompress to this (* ==> default) */
     returns (type HANDLE byvalue optional)
     VFWAPI external('ICImageDecompress');

 /* Structure used by ICSeqCompressFrame and ICCompressorChoose */
 /* routines. Make sure this matches the autodoc in icm.c!      */

 define structure
   1 COMPVARS,
     2 cbSize     type LONG, /* set to sizeof(COMPVARS) before */
                             /* calling ICCompressorChoose */
     2 dwFlags    type DWORD, /* see below... */
     2 hic        type HIC, /* HIC of chosen compressor */
     2 fccType    type DWORD, /* basically ICTYPE_VIDEO */
     2 fccHandler type DWORD, /* handler of chosen compressor or */
                              /* "" or "DIB " */
     2 lpbiIn     type LPBITMAPINFO, /* input format */
     2 lpbiOut    type LPBITMAPINFO,
                  /* output format - will compress to this */
     2 lpBitsOut  type LPVOID,
     2 lpBitsPrev type LPVOID,
     2 lFrame     type LONG,
     2 lKey       type LONG, /* key frames how often? */
     2 lDataRate  type LONG, /* desired data rate KB/Sec */
     2 lQ         type LONG, /* desired quality */
     2 lKeyCount  type LONG,
     2 lpState    type LPVOID, /* state of compressor */
     2 cbState    type LONG; /* size of the state */
 define alias PCOMPVARS handle COMPVARS;

 /* FLAGS for dwFlags element of COMPVARS structure:        */
 /* set this flag if you initialize COMPVARS before calling */
 /* ICCompressorChoose                                      */
 dcl ICMF_COMPVARS_VALID type DWORD value('00000001'xu);
     /* COMPVARS contains valid data */

 /*  allows user to choose compressor, quality etc... */
 dcl ICCompressorChoose
     entry (type HWND,  /* parent window for dialog */
            type UINT,  /* flags */
            type LPVOID,/* input format (optional) */
            type LPVOID,/* input data (optional) */
            type COMPVARS byaddr,/* data about the compressor/dlg */
            char (*) varz byaddr optional) /* dialog title (optional) */
     returns (type BOOL byvalue optional)
     VFWAPI external('ICCompressorChoose');

 /* defines for uiFlags */
 dcl ICMF_CHOOSE_KEYFRAME       type UINT value('0001'xu);
     /* show KeyFrame Every box */
 dcl ICMF_CHOOSE_DATARATE       type UINT value('0002'xu);
     /* show DataRate box */
 dcl ICMF_CHOOSE_PREVIEW        type UINT value('0004'xu);
     /* allow expanded preview dialog */
 dcl ICMF_CHOOSE_ALLCOMPRESSORS type UINT value('0008'xu);
     /* don't only show those that can handle the input format */
     /* or input data */

 dcl ICSeqCompressFrameStart
     entry (type COMPVARS byaddr,
            type BITMAPINFO byaddr)
     returns (type BOOL byvalue optional)
     VFWAPI external('ICSeqCompressFrameStart');

 dcl ICSeqCompressFrameEnd
     entry (type COMPVARS byaddr)
     VFWAPI external('ICSeqCompressFrameEnd');

 dcl ICSeqCompressFrame
     entry (type COMPVARS byaddr,/* set by ICCompressorChoose */
            type UINT,        /* flags */
            type LPVOID,      /* input DIB bits */
            type BOOL byaddr, /* did it end up being a key frame? */
            type LONG byaddr) /* size to compress to/of returned image*/
     returns (type LPVOID byvalue optional)
     VFWAPI external('ICSeqCompressFrame');

 dcl ICCompressorFree
     entry (type COMPVARS byaddr)
     VFWAPI external('ICCompressorFree');

 %end;  /* NOCOMPMAN */

 /*********************************************************************/
 /*                                                                   */
 /*  DRAWDIB - Routines for drawing to the display.                   */
 /*                                                                   */
 /*********************************************************************/

 %dcl NODRAWDIB char ext;
 %if NODRAWDIB = '' %then %do;

 define alias HDRAWDIB type HANDLE; /* hdd */

 /*********************************************************************/
 /* DrawDib Flags                                                     */
 /*********************************************************************/

 dcl DDF_UPDATE        type UINT value('0002'xu);
     /* re-draw the last DIB */
 dcl DDF_SAME_HDC      type UINT value('0004'xu);
     /* HDC same as last call (all setup) */
 dcl DDF_SAME_DRAW     type UINT value('0008'xu);
     /* draw params are the same */
 dcl DDF_DONTDRAW      type UINT value('0010'xu);
     /* dont draw frame, just decompress */
 dcl DDF_ANIMATE       type UINT value('0020'xu);
     /* allow palette animation */
 dcl DDF_BUFFER        type UINT value('0040'xu);
     /* always buffer image */
 dcl DDF_JUSTDRAWIT    type UINT value('0080'xu);
     /* just draw it with GDI */
 dcl DDF_FULLSCREEN    type UINT value('0100'xu);
     /* use DisplayDib */
 dcl DDF_BACKGROUNDPAL type UINT value('0200'xu);
     /* Realize palette in background */
 dcl DDF_NOTKEYFRAME   type UINT value('0400'xu);
     /* this is a partial frame update, hint */
 dcl DDF_HURRYUP       type UINT value('0800'xu);
     /* hurry up please! */
 dcl DDF_HALFTONE      type UINT value('1000'xu);
     /* always halftone */

 dcl DDF_PREROLL       type UINT value (DDF_DONTDRAW);
    /* Builing up a non-keyframe */
 dcl DDF_SAME_DIB      type UINT value (DDF_SAME_DRAW);
 dcl DDF_SAME_SIZE     type UINT value (DDF_SAME_DRAW);

 /*********************************************************************/
 /*                                                                   */
 /*     DrawDib functions                                             */
 /*                                                                   */
 /*********************************************************************/

 dcl DrawDibOpen
     entry ()
     returns (type HDRAWDIB byvalue optional)
     VFWAPI external('DrawDibOpen');

 dcl DrawDibClose
     entry (type HDRAWDIB)
     returns (type BOOL byvalue optional)
     VFWAPI external('DrawDibClose');

 dcl DrawDibGetBuffer
     entry (type HDRAWDIB,
            type BITMAPINFOHEADER byaddr optional,
            type DWORD,
            type DWORD)
     returns (type LPVOID byvalue optional)
     VFWAPI external('DrawDibGetBuffer');

 /* get the palette used for drawing DIBs */
 dcl DrawDibGetPalette
     entry (type HDRAWDIB )
     returns (type HPALETTE byvalue optional)
     VFWAPI external('DrawDibGetPalette');

 /* get the palette used for drawing DIBs */
 dcl DrawDibSetPalette
     entry (type HDRAWDIB,
            type HPALETTE)
     returns (type BOOL byvalue optional)
     VFWAPI external('DrawDibSetPalette');

 dcl DrawDibChangePalette
     entry (type HDRAWDIB,
            fixed bin(31),
            fixed bin(31),
            (*) type PALETTEENTRY byaddr)
     returns (type BOOL byvalue optional)
     VFWAPI external('DrawDibChangePalette');

 /* realize the palette in a HDD */
 dcl DrawDibRealize
     entry (type HDRAWDIB,
            type HDC,
            type BOOL)
     returns (type UINT byvalue optional)
     VFWAPI external('DrawDibRealize');

 /*  start of streaming playback */
 dcl DrawDibStart
     entry (type HDRAWDIB,
            type DWORD)
     returns (type BOOL byvalue optional)
     VFWAPI external('DrawDibStart');

 /* start of streaming playback */
 dcl DrawDibStop
     entry (type HDRAWDIB )
     returns (type BOOL byvalue optional)
     VFWAPI external('DrawDibStop');

 /*  prepare to draw */
 dcl DrawDibBegin
     entry (type HDRAWDIB,
            type HDC,
            fixed bin(31),
            fixed bin(31),
            type BITMAPINFOHEADER byaddr optional,
            fixed bin(31),
            fixed bin(31),
            type UINT)
     returns (type BOOL byvalue optional)
     VFWAPI external('DrawDibBegin');

 /* actualy draw a DIB to the screen. */
 dcl DrawDibDraw
     entry (type HDRAWDIB,
            type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type BITMAPINFOHEADER byaddr optional,
            type LPVOID,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type UINT)
     returns (type BOOL byvalue optional)
     VFWAPI external('DrawDibDraw');

 /* DrawDibUpdate()                                           */
 /*                                                           */
 /* redraw the last image (may only be valid with DDF_BUFFER) */

 DrawDibUpdate: proc (hdd, hdc, x, y)
                returns (type BOOL byvalue optional)
                options (inline reorder) internal;
  dcl hdd type HDRAWDIB byvalue,
      hdc type HDC byvalue,
      x   fixed bin(31) byvalue,
      y   fixed bin(31) byvalue;
   dcl sysnull builtin;
   return (DrawDibDraw (hdd, hdc, x, y, 0, 0, *, sysnull(),
                        0, 0, 0, 0, DDF_UPDATE));
 end DrawDibUpdate;

 /* DrawDibEnd() */
 dcl DrawDibEnd
     entry (type HDRAWDIB)
     returns (type BOOL byvalue optional)
     VFWAPI external('DrawDibEnd');

 /* DrawDibTime()  [for debugging purposes only] */
 define structure
   1 DRAWDIBTIME,
     2 timeCount      type LONG,
     2 timeDraw       type LONG,
     2 timeDecompress type LONG,
     2 timeDither     type LONG,
     2 timeStretch    type LONG,
     2 timeBlt        type LONG,
     2 timeSetDIBits  type LONG;

 define alias LPDRAWDIBTIME handle DRAWDIBTIME;

 dcl DrawDibTime
     entry (type HDRAWDIB,
            type DRAWDIBTIME byaddr)
     returns (type BOOL byvalue optional)
     VFWAPI external('DrawDibTime');

 /* display profiling */
 dcl PD_CAN_DRAW_DIB      type DWORD value('0001'xu);
     /* if you can draw at all */
 dcl PD_CAN_STRETCHDIB    type DWORD value('0002'xu);
     /* basicly RC_STRETCHDIB */
 dcl PD_STRETCHDIB_1_1_OK type DWORD value('0004'xu);
     /* is it fast? */
 dcl PD_STRETCHDIB_1_2_OK type DWORD value('0008'xu);
     /* ... */
 dcl PD_STRETCHDIB_1_N_OK type DWORD value('0010'xu);
     /* ... */

 dcl DrawDibProfileDisplay
     entry (type BITMAPINFOHEADER byaddr)
     returns (type DWORD byvalue optional)
     VFWAPI external('DrawDibProfileDisplay');

 %end;  /* NODRAWDIB */

 /*********************************************************************/
 /*                                                                   */
 /*  AVIFMT - AVI file format definitions                             */
 /*                                                                   */
 /*********************************************************************/

 %dcl NOAVIFMT char ext;
 %if NOAVIFMT = '' %then %do;

 /*********************************************************************/
 /* The following is a short description of the AVI file format.      */
 /* Please see the accompanying documentation for a full explanation. */
 /*                                                                   */
 /* An AVI file is the following RIFF form:                           */
 /*                                                                   */
 /* RIFF('AVI'                                                        */
 /*       LIST('hdrl'                                                 */
 /*        avih(<MainAVIHeader>)                                      */
 /*                  LIST ('strl'                                     */
 /*                      strh(<Stream header>)                        */
 /*                      strf(<Stream format>)                        */
 /*                      ... additional header data                   */
 /*            LIST('movi'                                            */
 /*         { LIST('rec'                                              */
 /*                SubChunk...                                        */
 /*             )                                                     */
 /*             | SubChunk } ....                                     */
 /*            )                                                      */
 /*            [ <AVIIndex> ]                                         */
 /*      )                                                            */
 /*                                                                   */
 /* The main file header specifies how many streams are present. For  */
 /* each one, there must be a stream header chunk and a stream format */
 /* chunk, enlosed in a 'strl' LIST chunk. The 'strf' chunk contains  */
 /* type-specific format information; for a video stream, this should */
 /* be a BITMAPINFO structure, including palette. For an audio stream,*/
 /* this should be a WAVEFORMAT (or PCMWAVEFORMAT) structure.         */
 /*                                                                   */
 /* The actual data is contained in subchunks within the 'movi' LIST  */
 /* chunk.  The first two characters of each data chunk are the       */
 /* stream number with which that data is associated.                 */
 /*                                                                   */
 /* Some defined chunk types:                                         */
 /*           Video Streams:                                          */
 /*                  ##db:  RGB DIB bits                              */
 /*                  ##dc:  RLE8 compressed DIB bits                  */
 /*                  ##pc:  Palette Change                            */
 /*                                                                   */
 /*           Audio Streams:                                          */
 /*                  ##wb:  waveform audio bytes                      */
 /*                                                                   */
 /* The grouping into LIST 'rec' chunks implies only that the contents*/
 /* of the chunk should be read into memory at the same time.         */
 /* This grouping is used for files specifically intended to be played*/
 /* from CD-ROM.                                                      */
 /*                                                                   */
 /* The index chunk at the end of the file should contain one entry   */
 /* for each data chunk in the file.                                  */
 /*                                                                   */
 /* Limitations for the current software:                             */
 /* Only one video stream and one audio stream are allowed.           */
 /* The streams must start at the beginning of the file.              */
 /*                                                                   */
 /*                                                                   */
 /* To register codec types please obtain a copy of the Multimedia    */
 /* Developer Registration Kit from:                                  */
 /*                                                                   */
 /*  Microsoft Corporation                                            */
 /*  Multimedia Systems Group                                         */
 /*  Product Marketing                                                */
 /*  One Microsoft Way                                                */
 /*  Redmond, WA 98052-6399                                           */
 /*********************************************************************/


 define alias TWOCC type WORD;

 /* form types, list types, and chunk types */
 dcl formtypeAVI           type FOURCC
                           value(mmioFOURCC('A', 'V', 'I', ' '));
 dcl listtypeAVIHEADER     type FOURCC
                           value(mmioFOURCC('h', 'd', 'r', 'l'));
 dcl ckidAVIMAINHDR        type FOURCC
                           value(mmioFOURCC('a', 'v', 'i', 'h'));
 dcl listtypeSTREAMHEADER  type FOURCC
                           value(mmioFOURCC('s', 't', 'r', 'l'));
 dcl ckidSTREAMHEADER      type FOURCC
                           value(mmioFOURCC('s', 't', 'r', 'h'));
 dcl ckidSTREAMFORMAT      type FOURCC
                           value(mmioFOURCC('s', 't', 'r', 'f'));
 dcl ckidSTREAMHANDLERDATA type FOURCC
                           value(mmioFOURCC('s', 't', 'r', 'd'));
 dcl ckidSTREAMNAME        type FOURCC
                           value(mmioFOURCC('s', 't', 'r', 'n'));

 dcl listtypeAVIMOVIE      type FOURCC
                           value(mmioFOURCC('m', 'o', 'v', 'i'));
 dcl listtypeAVIRECORD     type FOURCC
                           value(mmioFOURCC('r', 'e', 'c', ' '));

 dcl ckidAVINEWINDEX       type FOURCC
                           value(mmioFOURCC('i', 'd', 'x', '1'));

 /* Stream types for the <fccType> field of the stream header. */
 dcl streamtypeVIDEO       type FOURCC
                           value(mmioFOURCC('v', 'i', 'd', 's'));
 dcl streamtypeAUDIO       type FOURCC
                           value(mmioFOURCC('a', 'u', 'd', 's'));
 dcl streamtypeMIDI        type FOURCC
                           value(mmioFOURCC('m', 'i', 'd', 's'));
 dcl streamtypeTEXT        type FOURCC
                           value(mmioFOURCC('t', 'x', 't', 's'));

 /* Basic chunk types */
 dcl cktypeDIBbits         type TWOCC value(aviTWOCC('d', 'b'));
 dcl cktypeDIBcompressed   type TWOCC value(aviTWOCC('d', 'c'));
 dcl cktypePALchange       type TWOCC value(aviTWOCC('p', 'c'));
 dcl cktypeWAVEbytes       type TWOCC value(aviTWOCC('w', 'b'));

 /* Chunk id to use for extra chunks for padding. */
 dcl ckidAVIPADDING        type FOURCC
                           value(mmioFOURCC('J', 'U', 'N', 'K'));

 /* Useful macros */

 /* Macro to get stream number out of a FOURCC ckid */

 FromHex: proc (n) returns (type BYTE byvalue)
          options (inline reorder) internal;
   dcl n char (1) byvalue;
   dcl rank builtin;
   if n >= 'A' then
     return (rank (n) + 10 - rank ('A'));
   else
     return (rank (n) - rank ('0'));
 end FromHex;

 StreamFromFOURCC: proc (fcc) returns (type WORD byvalue)
                   options (inline reorder) internal;
   dcl fcc type FOURCC byvalue;
   dcl (byte, isll, unsigned) builtin;
   return (isll (FromHex (byte (LOBYTE (LOWORD (fcc)))), 4)
           + FromHex (byte (HIBYTE (LOWORD (fcc)))));
 end StreamFromFOURCC;


 /* Macro to get TWOCC chunk type out of a FOURCC ckid */
 TWOCCFromFOURCC: proc (fcc) returns (type WORD byvalue)
                  options (inline reorder) internal;
   dcl fcc type FOURCC byvalue;
   return (HIWORD (fcc));
 end TWOCCFromFOURCC;

 /* Macro to make a ckid for a chunk out of a TWOCC */
 /* and a stream number from 0-255.                 */

 ToHex: proc (n) returns (char (1) byvalue)
        options (inline reorder) internal;
   dcl n type BYTE byvalue;
   dcl (byte, rank) builtin;
   if n > 9 then
     return (byte (n - 10 + rank ('A')));
   else
     return (byte (n + rank ('0')));
 end ToHex;

 MAKEAVICKID: proc (tcc, stream) returns (type LONG byvalue)
              options (inline reorder) internal;
   dcl tcc    type TWOCC byvalue,
       stream type WORD byvalue;
   dcl (iand, ior, isll, isrl) builtin;
   return (MAKELONG (ior (isll (ToHex (iand (stream, '0f'xn)), 8),
                          ToHex (isrl (iand (stream, 'f0'xn), 4))),
                     tcc));
 end MAKEAVICKID;

 /* Main AVI File Header */

 /* flags for use in <dwFlags> in AVIFileHdr */
 dcl AVIF_HASINDEX       type DWORD value('00000010'xu);
     /* Index at end of file? */
 dcl AVIF_MUSTUSEINDEX   type DWORD value('00000020'xu);
 dcl AVIF_ISINTERLEAVED  type DWORD value('00000100'xu);
 dcl AVIF_TRUSTCKTYPE    type DWORD value('00000800'xu);
     /* Use CKType to find key frames? */
 dcl AVIF_WASCAPTUREFILE type DWORD value('00010000'xu);
 dcl AVIF_COPYRIGHTED    type DWORD value('00020000'xu);

 /* The AVI File Header LIST chunk should be padded to this size */
 dcl AVI_HEADERSIZE      fixed bin(31) value(2048);
     /* size of AVI header list */

 define structure
   1 MainAVIHeader,
     2 dwMicroSecPerFrame    type DWORD,/* frame display rate (or 0L) */
     2 dwMaxBytesPerSec      type DWORD,/* max. transfer rate */
     2 dwPaddingGranularity  type DWORD,/* pad to multiples of this */
                                        /* size: normally 2K. */
     2 dwFlags               type DWORD,/* the ever-present flags */
     2 dwTotalFrames         type DWORD,/* # frames in file */
     2 dwInitialFrames       type DWORD,
     2 dwStreams             type DWORD,
     2 dwSuggestedBufferSize type DWORD,
     2 dwWidth               type DWORD,
     2 dwHeight              type DWORD,
     2 dwReserved (4)        type DWORD;

 /*  Stream header */

 dcl AVISF_DISABLED         type DWORD value('00000001'xu);

 dcl AVISF_VIDEO_PALCHANGES type DWORD value('00010000'xu);

 define structure
   1 AVIStreamHeader,
     2 fccType         type FOURCC,
     2 fccHandler      type FOURCC,
     2 dwFlags         type DWORD,/* Contains AVITF_* flags */
     2 wPriority       type WORD,
     2 wLanguage       type WORD,
     2 dwInitialFrames type DWORD,
     2 dwScale         type DWORD,
     2 dwRate          type DWORD,/* dwRate / dwScale = samples/second*/
     2 dwStart         type DWORD,
     2 dwLength        type DWORD,/* In units above... */
     2 dwSuggestedBufferSize type DWORD,
     2 dwQuality       type DWORD,
     2 dwSampleSize    type DWORD,
     2 rcFrame         type RECT;


 /* Flags for index */
 %if NOCOMPMAN ^= '' %then %do;
 dcl AVIIF_LIST     type DWORD value('00000001'xu);
     /* chunk is a 'LIST' */
 dcl AVIIF_KEYFRAME type DWORD value('00000010'xu);
     /* this frame is a key frame. */
 %end;

 dcl AVIIF_NOTIME   type DWORD value('00000100'xu);
     /* this frame doesn't take any time */
 dcl AVIIF_COMPUSE  type DWORD value('0FFF0000'xu);
     /* these bits are for compressor use */

 define structure
   1 AVIINDEXENTRY,
     2 ckid          type DWORD,
     2 dwFlags       type DWORD,
     2 dwChunkOffset type DWORD,/* Position of chunk */
     2 dwChunkLength type DWORD;/* Length of chunk */

 /* Palette change chunk   */
 /*                        */
 /* Used in video streams. */
 define structure
   1 AVIPALCHANGE,
     2 bFirstEntry type BYTE,/* first entry to change */
     2 bNumEntries type BYTE,/* # entries to change (0 if 256) */
     2 wFlags      type WORD,/* Mostly to preserve alignment... */
     2 peNew (1)   type PALETTEENTRY;/* New color specifications */

 %end; /* NOAVIFMT */

 /*********************************************************************/
 /*                                                                   */
 /*  MMREG.CPY (standard include file for MM defines,                 */
 /*  like FOURCC and things)                                          */
 /*********************************************************************/

 %dcl NOMMREG char ext;
 %if NOMMREG = '' %then %do;
  %dcl #INC_MMREG fixed;
  %if #INC_MMREG = 0 %then %do;
  %include mmreg;
  %end;
 %end;

 /*********************************************************************/
 /*                                                                   */
 /*  AVIFile - routines for reading/writing standard AVI files        */
 /*                                                                   */
 /*********************************************************************/

 /* !!! This section defines and uses COM Interfaces !!! */
 /* !!! This has been omitted for PL/I.              !!! */

 /*********************************************************************/
 /*                                                                   */
 /*  MCIWnd - Window class for MCI objects                            */
 /*                                                                   */
 /*********************************************************************/

 %dcl NOMCIWND char ext;
 %if NOMCIWND = '' %then %do;
 /* ----------------------------------------------------------------- */
 /* MCIWnd                                                            */
 /*                                                                   */
 /* MCIWnd window class header file.                                  */
 /*                                                                   */
 /* the MCIWnd window class is a window class for controlling MCI     */
 /* devices. MCI devices include, wave files, midi files, AVI Video,  */
 /* cd audio, vcr, video disc, and others..                           */
 /*                                                                   */
 /* to learn more about MCI and mci command sets see the              */
 /* "Microsoft Multimedia Programmers's guide" in the Win31 SDK       */
 /*                                                                   */
 /* the easiest use of the MCIWnd class is like so:                   */
 /*                                                                   */
 /*     hwnd = MCIWndCreate(hwndParent, hInstance, 0, "chimes.wav")   */
 /*     ...                                                           */
 /*     call MCIWndPlay(hwnd)                                         */
 /*     call MCIWndStop(hwnd)                                         */
 /*     call MCIWndPause(hwnd)                                        */
 /*     ....                                                          */
 /*     call MCIWndDestroy(hwnd)                                      */
 /*                                                                   */
 /* this will create a window with a play/pause, stop and a playbar   */
 /* and start the wave file playing.                                  */
 /*                                                                   */
 /* mciwnd.h defines macros for all the most common MCI commands,     */
 /* but any string command can be used if needed.                     */
 /*                                                                   */
 /* Note: unlike the mciSendString() API, no alias or file name needs */
 /* to be specifed, since the device to use is implied by the window  */
 /* handle.                                                           */
 /*                                                                   */
 /*     MCIWndSendString(hwnd, "setaudio stream to 2");               */
 /*                                                                   */
 /* (C) Copyright 1991 - 1998 Microsoft Corporation.                  */
 /*     All rights reserved.                                          */
 /*                                                                   */
 /* WIN32:                                                            */
 /*                                                                   */
 /* MCIWnd supports both ansi and unicode interfaces. For any message */
 /* that takes or returns a text string, two versions of the message  */
 /* are defined, appended with A or W for Ansi or Wide Char.          */
 /* The message or api itself is defined to be one or other of these  */
 /* depending on whether you have UNICODE defined in your application.*/
 /* Thus for the api MCIWndCreate, there are in fact two apis,        */
 /* MCIWndCreateA and MCIWndCreateW. If you call MCIWndCreate, this   */
 /* will be re-routed to MCIWndCreateA unless UNICODE is defined when */
 /* building your application. In any one application, you can mix    */
 /* calls to the Ansi and Unicode entrypoints.                        */
 /*                                                                   */
 /* If you use SendMessage instead of the macros below such as        */
 /* MCIWndOpen(), you will see that the messages have changed for     */
 /* WIN32, to support Ansi and Unicode entrypoints. In particular,    */
 /* MCI_OPEN has been replaced by MCWNDM_OPENA, or MCIWNDM_OPENW      */
 /* (MCIWNDM_OPEN is defined to be one or other of these).            */
 /*                                                                   */
 /* Also, note that the WIN32 implementation of MCIWnd uses UNICODE   */
 /* so all apis and messages supporting ANSI strings do so by mapping */
 /* them to UNICODE strings and then calling the corresponding        */
 /* UNICODE entry point.                                              */
 /*                                                                   */
 /* ----------------------------------------------------------------- */

 %dcl MCIWndSM char ext;
 %MCIWndSM = SendMessage;

 dcl MCIWND_WINDOW_CLASS char value('MCIWndClass');

 dcl MCIWndCreateA
     entry (type HWND,
            type HINSTANCE,
            type DWORD,
            char(*) varz byaddr nonasgn)
     returns (type HWND byvalue optional)
     VFWAPIV external('MCIWndCreateA');

 dcl MCIWndCreateW
     entry (type HWND,
            type HINSTANCE,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn)
     returns (type HWND byvalue optional)
     VFWAPIV external('MCIWndCreateW');

 %dcl MCIWndCreate char ext;
 %if UNICODE ^= '' %then %do;
   %MCIWndCreate='MCIWndCreateW';
 %end; %else %do;
   %MCIWndCreate='MCIWndCreateA';
 %end;

 dcl MCIWndRegisterClass
     entry ()
     returns (type BOOL byvalue optional)
     VFWAPIV external('MCIWndRegisterClass');

 /* Flags for the MCIWndOpen command */
 dcl MCIWNDOPENF_NEW          type UINT value('0001'xu);
 /* open a new file */

 /* window styles */
 dcl MCIWNDF_NOAUTOSIZEWINDOW type DWORD value('0001'xu);
     /* when movie size changes */
 dcl MCIWNDF_NOPLAYBAR        type DWORD value('0002'xu);
     /* no toolbar */
 dcl MCIWNDF_NOAUTOSIZEMOVIE  type DWORD value('0004'xu);
     /* when window size changes */
 dcl MCIWNDF_NOMENU           type DWORD value('0008'xu);
     /* no popup menu from RBUTTONDOWN */
 dcl MCIWNDF_SHOWNAME         type DWORD value('0010'xu);
     /* show name in caption */
 dcl MCIWNDF_SHOWPOS          type DWORD value('0020'xu);
     /* show position in caption */
 dcl MCIWNDF_SHOWMODE         type DWORD value('0040'xu);
     /* show mode in caption */
 dcl MCIWNDF_SHOWALL          type DWORD value('0070'xu);
     /* show all */

 dcl MCIWNDF_NOTIFYMODE       type DWORD value('0100'xu);
     /* tell parent of mode change */
 dcl MCIWNDF_NOTIFYPOS        type DWORD value('0200'xu);
     /* tell parent of pos change */
 dcl MCIWNDF_NOTIFYSIZE       type DWORD value('0400'xu);
     /* tell parent of size change */
 dcl MCIWNDF_NOTIFYERROR      type DWORD value('1000'xu);
     /* tell parent of an error */
 dcl MCIWNDF_NOTIFYALL        type DWORD value('1F00'xu);
     /* tell all */

 dcl MCIWNDF_NOTIFYANSI       type DWORD value('0080'xu);

 /* The MEDIA notification includes a text string.                  */
 /* To receive notifications in ANSI instead of unicode set the     */
 /* MCIWNDF_NOTIFYANSI style bit. The macro below includes this bit */
 /* by default unless you define UNICODE in your application.       */

 dcl MCIWNDF_NOTIFYMEDIAA     type DWORD value('0880'xu);
     /* tell parent of media change */
 dcl MCIWNDF_NOTIFYMEDIAW     type DWORD value('0800'xu);
     /* tell parent of media change */


 %if UNICODE ^= '' %then %do;
 dcl MCIWNDF_NOTIFYMEDIA      type DWORD value(MCIWNDF_NOTIFYMEDIAW);
 %end; %else %do;
 dcl MCIWNDF_NOTIFYMEDIA      type DWORD value(MCIWNDF_NOTIFYMEDIAA);
 %end;

 dcl MCIWNDF_RECORD           type DWORD value('2000'xn);
     /* Give a record button */
 dcl MCIWNDF_NOERRORDLG       type DWORD value('4000'xu);
     /* Show Error Dlgs for MCI cmds? */
 dcl MCIWNDF_NOOPEN           type DWORD value('8000'xu);
     /* Don't allow user to open things */

 /* can macros */

 MCIWndCanPlay: proc (hwnd) returns (type BOOL byvalue)
                options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_CAN_PLAY, 0, 0));
 end MCIWndCanPlay;

 MCIWndCanRecord: proc (hwnd) returns (type BOOL byvalue)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_CAN_RECORD, 0, 0));
 end MCIWndCanRecord;

 MCIWndCanSave: proc (hwnd) returns (type BOOL byvalue)
                options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_CAN_SAVE, 0, 0));
 end MCIWndCanSave;

 MCIWndCanWindow: proc (hwnd) returns (type BOOL byvalue)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_CAN_WINDOW, 0, 0));
 end MCIWndCanWindow;

 MCIWndCanEject: proc (hwnd) returns (type BOOL byvalue)
                 options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_CAN_EJECT, 0, 0));
 end MCIWndCanEject;

 MCIWndCanConfig: proc (hwnd) returns (type BOOL byvalue)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_CAN_CONFIG, 0, 0));
 end MCIWndCanConfig;

 MCIWndPaletteKick: proc (hwnd)
                    returns (type BOOL byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_PALETTEKICK, 0, 0));
 end MCIWndPaletteKick;


 MCIWndSave: proc (hwnd, szFile)
             returns (type LONG byvalue optional)
             options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       szFile TSTR byaddr;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCI_SAVE, 0, binvalue (addr (szFile))));
 end MCIWndSave;

 MCIWndSaveDialog: proc (hwnd)
                   returns (type LONG byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSave (hwnd, pli_b2z(-1)));
 end MCIWndSaveDialog;

 /* if you dont give a device it will use the current device.... */
 MCIWndNew: proc (hwnd, lp)
            returns (type LONG byvalue optional)
            options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lp   TSTR byaddr optional;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_NEW, 0, binvalue (addr (lp))));
 end MCIWndNew;

 MCIWndRecord: proc (hwnd)
               returns (type LONG byvalue optional)
               options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCI_RECORD, 0, 0));
 end MCIWndRecord;

 MCIWndOpen: proc (hwnd, sz, f)
             returns (type LONG byvalue optional)
             options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       sz   TSTR byaddr optional,
       f    type UINT;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_OPEN, (f), binvalue (addr (sz))));
 end MCIWndOpen;

 MCIWndOpenDialog: proc (hwnd)
                   returns (type LONG byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndOpen (hwnd, pli_b2z(-1), 0));
 end MCIWndOpenDialog;


 MCIWndClose: proc (hwnd)
              returns (type LONG byvalue optional)
              options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCI_CLOSE, 0, 0));
 end MCIWndClose;

 MCIWndPlay: proc (hwnd)
             returns (type LONG byvalue optional)
             options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCI_PLAY, 0, 0));
 end MCIWndPlay;

 MCIWndStop: proc (hwnd)
             returns (type LONG byvalue optional)
             options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCI_STOP, 0, 0));
 end MCIWndStop;

 MCIWndPause: proc (hwnd)
              returns (type LONG byvalue optional)
              options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCI_PAUSE, 0, 0));
 end MCIWndPause;

 MCIWndResume: proc (hwnd)
               returns (type LONG byvalue optional)
               options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCI_RESUME, 0, 0));
 end MCIWndResume;

 MCIWndSeek: proc (hwnd, lPos)
             returns (type LONG byvalue optional)
             options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lPos type LONG byvalue;
   return (MCIWndSM (hwnd, MCI_SEEK, 0, (lPos)));
 end MCIWndSeek;

 MCIWndEject: proc (hwnd)
              returns (type LONG byvalue optional)
              options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_EJECT, 0, 0));
 end MCIWndEject;


 MCIWndHome: proc (hwnd)
             returns (type LONG byvalue optional)
             options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSeek (hwnd, MCIWND_START));
 end MCIWndHome;

 MCIWndEnd: proc (hwnd)
            returns (type LONG byvalue optional)
            options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSeek (hwnd, MCIWND_END));
 end MCIWndEnd;


 MCIWndGetSource: proc (hwnd, prc)
                  returns (type LONG byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       prc  type RECT byaddr;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_GET_SOURCE, 0, binvalue(addr(prc))));
 end MCIWndGetSource;

 MCIWndPutSource: proc (hwnd, prc)
                  returns (type LONG byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       prc  type RECT byaddr;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_PUT_SOURCE, 0, binvalue(addr(prc))));
 end MCIWndPutSource;


 MCIWndGetDest: proc (hwnd, prc)
                returns (type LONG byvalue optional)
                options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       prc  type RECT byaddr;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_GET_DEST, 0, binvalue (addr (prc))));
 end MCIWndGetDest;

 MCIWndPutDest: proc (hwnd, prc)
                returns (type LONG byvalue optional)
                options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       prc  type RECT byaddr;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_PUT_DEST, 0, binvalue (addr (prc))));
 end MCIWndPutDest;


 MCIWndPlayReverse: proc (hwnd)
                    returns (type LONG byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_PLAYREVERSE, 0, 0));
 end MCIWndPlayReverse;

 MCIWndPlayFrom: proc (hwnd, lPos)
                 returns (type LONG byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lPos type LONG byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_PLAYFROM, 0, (lPos)));
 end MCIWndPlayFrom;

 MCIWndPlayTo: proc (hwnd, lPos)
               returns (type LONG byvalue optional)
               options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lPos type LONG byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_PLAYTO, 0, (lPos)));
 end MCIWndPlayTo;

 MCIWndPlayFromTo: proc (hwnd, lStart, lEnd)
                   returns (type LONG byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       lStart type LONG byvalue,
       lEnd   type LONG byvalue;
   call MCIWndSeek (hwnd, lStart);
   return (MCIWndPlayTo (hwnd, lEnd));
 end MCIWndPlayFromTo;


 MCIWndGetDeviceID: proc (hwnd)
                    returns (type UINT byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETDEVICEID, 0, 0));
 end MCIWndGetDeviceID;

 MCIWndGetAlias: proc (hwnd)
                 returns (type UINT byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETALIAS, 0, 0));
 end MCIWndGetAlias;

 MCIWndGetMode: proc (hwnd, lp, len)
                returns (type LONG byvalue optional)
                options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lp   TSTR byaddr,
       len  type UINT byvalue;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_GETMODE,
                           (len), binvalue (addr (lp))));
 end MCIWndGetMode;

 MCIWndGetPosition: proc (hwnd)
                    returns (type LONG byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETPOSITION, 0, 0));
 end MCIWndGetPosition;

 MCIWndGetPositionString: proc (hwnd, lp, len)
                          returns (type LONG byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lp   TSTR byaddr,
       len  type UINT byvalue;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_GETPOSITION,
                           (len), binvalue(addr(lp))));
 end MCIWndGetPositionString;

 MCIWndGetStart: proc (hwnd)
                 returns (type LONG byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETSTART, 0, 0));
 end MCIWndGetStart;

 MCIWndGetLength: proc (hwnd)
                  returns (type LONG byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETLENGTH, 0, 0));
 end MCIWndGetLength;

 MCIWndGetEnd: proc (hwnd)
               returns (type LONG byvalue optional)
               options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETEND, 0, 0));
 end MCIWndGetEnd;


 MCIWndStep: proc (hwnd, n)
             returns (type LONG byvalue optional)
             options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       n    fixed bin (31) byvalue;
   return (MCIWndSM (hwnd, MCI_STEP, 0, (n)));
 end MCIWndStep;


 MCIWndDestroy: proc (hwnd)
                options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   call MCIWndSM (hwnd, WM_CLOSE, 0, 0);
 end MCIWndDestroy;

 MCIWndSetZoom: proc (hwnd, iZoom)
                options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       iZoom type UINT byvalue;
   call MCIWndSM (hwnd, MCIWNDM_SETZOOM, 0, (iZoom));
 end MCIWndSetZoom;

 MCIWndGetZoom: proc (hwnd)
                returns (type UINT byvalue optional)
                options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETZOOM, 0, 0));
 end MCIWndGetZoom;

 MCIWndSetVolume: proc (hwnd, iVol)
                  returns (type LONG byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       iVol type UINT byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_SETVOLUME, 0, (iVol)));
 end MCIWndSetVolume;

 MCIWndGetVolume: proc (hwnd)
                  returns (type LONG byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETVOLUME, 0, 0));
 end MCIWndGetVolume;

 MCIWndSetSpeed: proc (hwnd, iSpeed)
                 returns (type LONG byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       iSpeed type UINT byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_SETSPEED, 0, (iSpeed)));
 end MCIWndSetSpeed;

 MCIWndGetSpeed: proc (hwnd)
                 returns (type LONG byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETSPEED, 0, 0));
 end MCIWndGetSpeed;

 MCIWndSetTimeFormat: proc (hwnd, lp)
                      returns (type LONG byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lp   TSTR byaddr;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_SETTIMEFORMAT,
                           0, binvalue (addr (lp))));
 end MCIWndSetTimeFormat;

 MCIWndGetTimeFormat: proc (hwnd, lp, len)
                      returns (type LONG byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lp   TSTR byaddr,
       len  type UINT byvalue;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_GETTIMEFORMAT,
                           (len), binvalue (addr (lp))));
 end MCIWndGetTimeFormat;

 MCIWndValidateMedia: proc (hwnd)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   call MCIWndSM (hwnd, MCIWNDM_VALIDATEMEDIA, 0, 0);
 end MCIWndValidateMedia;


 MCIWndSetRepeat: proc (hwnd, f)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       f    type BOOL byvalue;
   call MCIWndSM (hwnd, MCIWNDM_SETREPEAT, 0, (f));
 end MCIWndSetRepeat;

 MCIWndGetRepeat: proc (hwnd)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETREPEAT, 0, 0));
 end MCIWndGetRepeat;


 MCIWndUseFrames: proc (hwnd)
                  returns (type LONG byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSetTimeFormat (hwnd, 'frames'));
 end MCIWndUseFrames;

 MCIWndUseTime: proc (hwnd)
                returns (type LONG byvalue optional)
                options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSetTimeFormat (hwnd, 'ms'));
 end MCIWndUseTime;


 MCIWndSetActiveTimer: proc (hwnd, active)
                       options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       active type UINT byvalue;
   call MCIWndSM (hwnd, MCIWNDM_SETACTIVETIMER, (active), 0);
 end MCIWndSetActiveTimer;

 MCIWndSetInactiveTimer: proc (hwnd, inactive)
                         options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       inactive type UINT byvalue;
   call MCIWndSM (hwnd, MCIWNDM_SETINACTIVETIMER, (inactive), 0);
 end MCIWndSetInactiveTimer;

 MCIWndSetTimers: proc (hwnd, active, inactive)
                  options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       active   type UINT byvalue,
       inactive type UINT byvalue;
   call MCIWndSM (hwnd, MCIWNDM_SETTIMERS, (active), (inactive));
 end MCIWndSetTimers;

 MCIWndGetActiveTimer: proc (hwnd)
                       returns (type UINT byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETACTIVETIMER, 0, 0));
 end MCIWndGetActiveTimer;

 MCIWndGetInactiveTimer: proc (hwnd)
                         returns (type UINT byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETINACTIVETIMER, 0, 0));
 end MCIWndGetInactiveTimer;


 MCIWndRealize: proc (hwnd, fBkgnd)
                returns (type LONG byvalue optional)
                options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       fBkgnd type BOOL byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_REALIZE, (fBkgnd), 0));
 end MCIWndRealize;


 MCIWndSendString: proc (hwnd, sz)
                   returns (type LONG byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       sz     TSTR byaddr;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_SENDSTRING, 0, binvalue (addr(sz))));
 end MCIWndSendString;

 MCIWndReturnString: proc (hwnd, lp, len)
                     returns (type LONG byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lp   TSTR byaddr,
       len  type UINT byvalue;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_RETURNSTRING,
                           (len), binvalue (addr (lp))));
 end MCIWndReturnString;

 MCIWndGetError: proc (hwnd, lp, len)
                 returns (type LONG byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lp   TSTR byaddr optional,
       len  type UINT byvalue;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_GETERROR,
                           (len), binvalue (addr (lp))));
 end MCIWndGetError;


 /* MCIWndActivate(hwnd, f) has been removed by Microsoft */

 MCIWndGetPalette: proc (hwnd)
                   returns (type HPALETTE byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETPALETTE, 0, 0));
 end MCIWndGetPalette;

 MCIWndSetPalette: proc (hwnd, hpal)
                   returns (type LONG byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       hpal type HPALETTE byvalue;
   dcl binvalue builtin;
   return (MCIWndSM (hwnd, MCIWNDM_SETPALETTE, binvalue (hpal), 0));
 end MCIWndSetPalette;


 MCIWndGetFileName: proc (hwnd, lp, len)
                    returns (type LONG byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lp   TSTR byaddr,
       len  type UINT byvalue;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_GETFILENAME,
                           (len), binvalue (addr (lp))));
 end MCIWndGetFileName;

 MCIWndGetDevice: proc (hwnd, lp, len)
                  returns (type LONG byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lp   TSTR byaddr,
       len  type UINT byvalue;
   dcl (addr, binvalue) builtin;
   return (MCIWndSM (hwnd, MCIWNDM_GETDEVICE,
                           (len), binvalue (addr (lp))));
 end MCIWndGetDevice;


 MCIWndGetStyles: proc (hwnd)
                  returns (type UINT byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_GETSTYLES, 0, 0));
 end MCIWndGetStyles;

 MCIWndChangeStyles: proc (hwnd, mask, value)
                     returns (type LONG byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       mask  type UINT byvalue,
       value type LONG byvalue;
   return (MCIWndSM (hwnd, MCIWNDM_CHANGESTYLES, (mask), (value)));
 end MCIWndChangeStyles;


 /* PL/I note: following routine is only useful when the AVIFile  */
 /*            interface is supported. See above for explanation. */
 MCIWndOpenInterface: proc (hwnd, pUnk)
                      returns (type LONG byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       pUnk  pointer byvalue; /* type LPUNKNOWN */
   dcl binvalue builtin;
   return (MCIWndSM (hwnd, MCIWNDM_OPENINTERFACE, 0, binvalue (pUnk)));
 end MCIWndOpenInterface;


 MCIWndSetOwner: proc (hwnd, hwndP)
                      returns (type LONG byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hwndP type HWND byvalue;
   dcl binvalue builtin;
   return (MCIWndSM (hwnd, MCIWNDM_SETOWNER, binvalue (hwndP), 0));
 end MCIWndSetOwner;

 /* Messages an app will send to MCIWND */

 /* all the text-related messages are defined out of order above */
 /* (they need to be defined before the MCIWndOpen() macros      */

 dcl MCIWNDM_GETDEVICEID      fixed bin(31) value(WM_USER + 100);
 dcl MCIWNDM_GETSTART         fixed bin(31) value(WM_USER + 103);
 dcl MCIWNDM_GETLENGTH        fixed bin(31) value(WM_USER + 104);
 dcl MCIWNDM_GETEND           fixed bin(31) value(WM_USER + 105);
 dcl MCIWNDM_EJECT            fixed bin(31) value(WM_USER + 107);
 dcl MCIWNDM_SETZOOM          fixed bin(31) value(WM_USER + 108);
 dcl MCIWNDM_GETZOOM          fixed bin(31) value(WM_USER + 109);
 dcl MCIWNDM_SETVOLUME        fixed bin(31) value(WM_USER + 110);
 dcl MCIWNDM_GETVOLUME        fixed bin(31) value(WM_USER + 111);
 dcl MCIWNDM_SETSPEED         fixed bin(31) value(WM_USER + 112);
 dcl MCIWNDM_GETSPEED         fixed bin(31) value(WM_USER + 113);
 dcl MCIWNDM_SETREPEAT        fixed bin(31) value(WM_USER + 114);
 dcl MCIWNDM_GETREPEAT        fixed bin(31) value(WM_USER + 115);
 dcl MCIWNDM_REALIZE          fixed bin(31) value(WM_USER + 118);
 dcl MCIWNDM_VALIDATEMEDIA    fixed bin(31) value(WM_USER + 121);
 dcl MCIWNDM_PLAYFROM         fixed bin(31) value(WM_USER + 122);
 dcl MCIWNDM_PLAYTO           fixed bin(31) value(WM_USER + 123);
 dcl MCIWNDM_GETPALETTE       fixed bin(31) value(WM_USER + 126);
 dcl MCIWNDM_SETPALETTE       fixed bin(31) value(WM_USER + 127);
 dcl MCIWNDM_SETTIMERS        fixed bin(31) value(WM_USER + 129);
 dcl MCIWNDM_SETACTIVETIMER   fixed bin(31) value(WM_USER + 130);
 dcl MCIWNDM_SETINACTIVETIMER fixed bin(31) value(WM_USER + 131);
 dcl MCIWNDM_GETACTIVETIMER   fixed bin(31) value(WM_USER + 132);
 dcl MCIWNDM_GETINACTIVETIMER fixed bin(31) value(WM_USER + 133);
 dcl MCIWNDM_CHANGESTYLES     fixed bin(31) value(WM_USER + 135);
 dcl MCIWNDM_GETSTYLES        fixed bin(31) value(WM_USER + 136);
 dcl MCIWNDM_GETALIAS         fixed bin(31) value(WM_USER + 137);
 dcl MCIWNDM_PLAYREVERSE      fixed bin(31) value(WM_USER + 139);
 dcl MCIWNDM_GET_SOURCE       fixed bin(31) value(WM_USER + 140);
 dcl MCIWNDM_PUT_SOURCE       fixed bin(31) value(WM_USER + 141);
 dcl MCIWNDM_GET_DEST         fixed bin(31) value(WM_USER + 142);
 dcl MCIWNDM_PUT_DEST         fixed bin(31) value(WM_USER + 143);
 dcl MCIWNDM_CAN_PLAY         fixed bin(31) value(WM_USER + 144);
 dcl MCIWNDM_CAN_WINDOW       fixed bin(31) value(WM_USER + 145);
 dcl MCIWNDM_CAN_RECORD       fixed bin(31) value(WM_USER + 146);
 dcl MCIWNDM_CAN_SAVE         fixed bin(31) value(WM_USER + 147);
 dcl MCIWNDM_CAN_EJECT        fixed bin(31) value(WM_USER + 148);
 dcl MCIWNDM_CAN_CONFIG       fixed bin(31) value(WM_USER + 149);
 dcl MCIWNDM_PALETTEKICK      fixed bin(31) value(WM_USER + 150);
 dcl MCIWNDM_OPENINTERFACE    fixed bin(31) value(WM_USER + 151);
 dcl MCIWNDM_SETOWNER         fixed bin(31) value(WM_USER + 152);

 /*define both A and W messages */
 dcl MCIWNDM_SENDSTRINGA      fixed bin(31) value(WM_USER + 101);
 dcl MCIWNDM_GETPOSITIONA     fixed bin(31) value(WM_USER + 102);
 dcl MCIWNDM_GETMODEA         fixed bin(31) value(WM_USER + 106);
 dcl MCIWNDM_SETTIMEFORMATA   fixed bin(31) value(WM_USER + 119);
 dcl MCIWNDM_GETTIMEFORMATA   fixed bin(31) value(WM_USER + 120);
 dcl MCIWNDM_GETFILENAMEA     fixed bin(31) value(WM_USER + 124);
 dcl MCIWNDM_GETDEVICEA       fixed bin(31) value(WM_USER + 125);
 dcl MCIWNDM_GETERRORA        fixed bin(31) value(WM_USER + 128);
 dcl MCIWNDM_NEWA             fixed bin(31) value(WM_USER + 134);
 dcl MCIWNDM_RETURNSTRINGA    fixed bin(31) value(WM_USER + 138);
 dcl MCIWNDM_OPENA            fixed bin(31) value(WM_USER + 153);

 dcl MCIWNDM_SENDSTRINGW      fixed bin(31) value(WM_USER + 201);
 dcl MCIWNDM_GETPOSITIONW     fixed bin(31) value(WM_USER + 202);
 dcl MCIWNDM_GETMODEW         fixed bin(31) value(WM_USER + 206);
 dcl MCIWNDM_SETTIMEFORMATW   fixed bin(31) value(WM_USER + 219);
 dcl MCIWNDM_GETTIMEFORMATW   fixed bin(31) value(WM_USER + 220);
 dcl MCIWNDM_GETFILENAMEW     fixed bin(31) value(WM_USER + 224);
 dcl MCIWNDM_GETDEVICEW       fixed bin(31) value(WM_USER + 225);
 dcl MCIWNDM_GETERRORW        fixed bin(31) value(WM_USER + 228);
 dcl MCIWNDM_NEWW             fixed bin(31) value(WM_USER + 234);
 dcl MCIWNDM_RETURNSTRINGW    fixed bin(31) value(WM_USER + 238);
 dcl MCIWNDM_OPENW            fixed bin(31) value(WM_USER + 252);

 /* map defaults to A or W depending on app's UNICODE setting */

 %if UNICODE ^= '' %then %do;
 dcl MCIWNDM_SENDSTRING    fixed bin(31) value(MCIWNDM_SENDSTRINGW);
 dcl MCIWNDM_GETPOSITION   fixed bin(31) value(MCIWNDM_GETPOSITIONW);
 dcl MCIWNDM_GETMODE       fixed bin(31) value(MCIWNDM_GETMODEW);
 dcl MCIWNDM_SETTIMEFORMAT fixed bin(31) value(MCIWNDM_SETTIMEFORMATW);
 dcl MCIWNDM_GETTIMEFORMAT fixed bin(31) value(MCIWNDM_GETTIMEFORMATW);
 dcl MCIWNDM_GETFILENAME   fixed bin(31) value(MCIWNDM_GETFILENAMEW);
 dcl MCIWNDM_GETDEVICE     fixed bin(31) value(MCIWNDM_GETDEVICEW);
 dcl MCIWNDM_GETERROR      fixed bin(31) value(MCIWNDM_GETERRORW);
 dcl MCIWNDM_NEW           fixed bin(31) value(MCIWNDM_NEWW);
 dcl MCIWNDM_RETURNSTRING  fixed bin(31) value(MCIWNDM_RETURNSTRINGW);
 dcl MCIWNDM_OPEN          fixed bin(31) value(MCIWNDM_OPENW);
 %end; %else %do;
 dcl MCIWNDM_SENDSTRING    fixed bin(31) value(MCIWNDM_SENDSTRINGA);
 dcl MCIWNDM_GETPOSITION   fixed bin(31) value(MCIWNDM_GETPOSITIONA);
 dcl MCIWNDM_GETMODE       fixed bin(31) value(MCIWNDM_GETMODEA);
 dcl MCIWNDM_SETTIMEFORMAT fixed bin(31) value(MCIWNDM_SETTIMEFORMATA);
 dcl MCIWNDM_GETTIMEFORMAT fixed bin(31) value(MCIWNDM_GETTIMEFORMATA);
 dcl MCIWNDM_GETFILENAME   fixed bin(31) value(MCIWNDM_GETFILENAMEA);
 dcl MCIWNDM_GETDEVICE     fixed bin(31) value(MCIWNDM_GETDEVICEA);
 dcl MCIWNDM_GETERROR      fixed bin(31) value(MCIWNDM_GETERRORA);
 dcl MCIWNDM_NEW           fixed bin(31) value(MCIWNDM_NEWA);
 dcl MCIWNDM_RETURNSTRING  fixed bin(31) value(MCIWNDM_RETURNSTRINGA);
 dcl MCIWNDM_OPEN          fixed bin(31) value(MCIWNDM_OPENA);
 %end;

 /* note that the source text for MCIWND will thus contain            */
 /* support for eg MCIWNDM_SENDSTRING (both the 16-bit entrypoint and */
 /* in win32 mapped to MCIWNDM_SENDSTRINGW), and MCIWNDM_SENDSTRINGA  */
 /* (the win32 ansi thunk).                                           */

 /* Messages MCIWND will send to an app */
 dcl MCIWNDM_NOTIFYMODE    fixed bin(31) value(WM_USER + 200);
     /* wp = hwnd, lp = mode */
 dcl MCIWNDM_NOTIFYPOS     fixed bin(31) value(WM_USER + 201);
     /* wp = hwnd, lp = pos */
 dcl MCIWNDM_NOTIFYSIZE    fixed bin(31) value(WM_USER + 202);
     /* wp = hwnd */
 dcl MCIWNDM_NOTIFYMEDIA   fixed bin(31) value(WM_USER + 203);
     /* wp = hwnd, lp = fn */
 dcl MCIWNDM_NOTIFYERROR   fixed bin(31) value(WM_USER + 205);
     /* wp = hwnd, lp = error */

 /* special seek values for START and END */
 dcl MCIWND_START  fixed bin(31) value(-1);
 dcl MCIWND_END    fixed bin(31) value(-2);

 %end; /* NOMCIWND */

 /*********************************************************************/
 /*                                                                   */
 /*  VIDEO - Video Capture Driver Interface                           */
 /*                                                                   */
 /*********************************************************************/
 %dcl NOAVICAP char ext;
 %dcl NOVIDEO char ext;
 %if (NOAVICAP='') | (NOVIDEO='') %then %do;

 /* video data types */
 DECLARE_HANDLE (HVIDEO);
 define alias LPHVIDEO pointer;

 /*********************************************************************/
 /*                                                                   */
 /*                           Error Return Values                     */
 /*                                                                   */
 /*********************************************************************/

 dcl DV_ERR_OK              fixed bin(31) value(0);
     /* No error */
 dcl DV_ERR_BASE            fixed bin(31) value(1);
     /* Error Base */
 dcl DV_ERR_NONSPECIFIC     fixed bin(31) value(DV_ERR_BASE);
 dcl DV_ERR_BADFORMAT       fixed bin(31) value(DV_ERR_BASE + 1);
     /* unsupported video format */
 dcl DV_ERR_STILLPLAYING    fixed bin(31) value(DV_ERR_BASE + 2);
     /* still something playing */
 dcl DV_ERR_UNPREPARED      fixed bin(31) value(DV_ERR_BASE + 3);
     /* header not prepared */
 dcl DV_ERR_SYNC            fixed bin(31) value(DV_ERR_BASE + 4);
     /* device is synchronous */
 dcl DV_ERR_TOOMANYCHANNELS fixed bin(31) value(DV_ERR_BASE + 5);
     /* number of channels exceeded */
 dcl DV_ERR_NOTDETECTED     fixed bin(31) value(DV_ERR_BASE + 6);
     /* HW not detected */
 dcl DV_ERR_BADINSTALL      fixed bin(31) value(DV_ERR_BASE + 7);
     /* Can not get Profile */
 dcl DV_ERR_CREATEPALETTE   fixed bin(31) value(DV_ERR_BASE + 8);
 dcl DV_ERR_SIZEFIELD       fixed bin(31) value(DV_ERR_BASE + 9);
 dcl DV_ERR_PARAM1          fixed bin(31) value(DV_ERR_BASE + 10);
 dcl DV_ERR_PARAM2          fixed bin(31) value(DV_ERR_BASE + 11);
 dcl DV_ERR_CONFIG1         fixed bin(31) value(DV_ERR_BASE + 12);
 dcl DV_ERR_CONFIG2         fixed bin(31) value(DV_ERR_BASE + 13);
 dcl DV_ERR_FLAGS           fixed bin(31) value(DV_ERR_BASE + 14);
 dcl DV_ERR_13              fixed bin(31) value(DV_ERR_BASE + 15);

 dcl DV_ERR_NOTSUPPORTED    fixed bin(31) value(DV_ERR_BASE + 16);
     /* function not suported */
 dcl DV_ERR_NOMEM           fixed bin(31) value(DV_ERR_BASE + 17);
     /* out of memory */
 dcl DV_ERR_ALLOCATED       fixed bin(31) value(DV_ERR_BASE + 18);
     /* device is allocated */
 dcl DV_ERR_BADDEVICEID     fixed bin(31) value(DV_ERR_BASE + 19);
 dcl DV_ERR_INVALHANDLE     fixed bin(31) value(DV_ERR_BASE + 20);
 dcl DV_ERR_BADERRNUM       fixed bin(31) value(DV_ERR_BASE + 21);
 dcl DV_ERR_NO_BUFFERS      fixed bin(31) value(DV_ERR_BASE + 22);
     /* out of buffers */

 dcl DV_ERR_MEM_CONFLICT    fixed bin(31) value(DV_ERR_BASE + 23);
     /* Mem conflict detected */
 dcl DV_ERR_IO_CONFLICT     fixed bin(31) value(DV_ERR_BASE + 24);
     /* I/O conflict detected */
 dcl DV_ERR_DMA_CONFLICT    fixed bin(31) value(DV_ERR_BASE + 25);
     /* DMA conflict detected */
 dcl DV_ERR_INT_CONFLICT    fixed bin(31) value(DV_ERR_BASE + 26);
     /* Interrupt conflict detected */
 dcl DV_ERR_PROTECT_ONLY    fixed bin(31) value(DV_ERR_BASE + 27);
     /* Can not run in standard mode */
 dcl DV_ERR_LASTERROR       fixed bin(31) value(DV_ERR_BASE + 27);

 dcl DV_ERR_USER_MSG        fixed bin(31) value(DV_ERR_BASE + 1000);
     /* Hardware specific errors */

 /*********************************************************************/
 /*                                                                   */
 /*                        Callback Messages                          */
 /*                                                                   */
 /* Note that the values for all installable driver callback messages */
 /* are identical, (ie. MM_DRVM_DATA has the same value for capture   */
 /* drivers, installable video codecs, and the audio compression      */
 /* manager).                                                         */
 /*********************************************************************/


 dcl DV_VM_OPEN  fixed bin(15) value(MM_DRVM_OPEN);
 /* Obsolete messages */
 dcl DV_VM_CLOSE fixed bin(15) value(MM_DRVM_CLOSE);
 dcl DV_VM_DATA  fixed bin(15) value(MM_DRVM_DATA);
 dcl DV_VM_ERROR fixed bin(15) value(MM_DRVM_ERROR);

 /*********************************************************************/
 /*                                                                   */
 /*                        Structures                                 */
 /*                                                                   */
 /*********************************************************************/

 /* video data block header */
 define structure
   1 VIDEOHDR,
     2 lpData         type LPBYTE,/* pointer to locked data buffer */
     2 dwBufferLength type DWORD,/* Length of data buffer */
     2 dwBytesUsed    type DWORD,/* Bytes actually used */
     2 dwTimeCaptured type DWORD,/* Milliseconds from start of stream */
     2 dwUser         type DWORD,/* for client's use */
     2 dwFlags        type DWORD,/* assorted flags (see defines) */
     2 dwReserved (4) type DWORD;/* reserved for driver */
 define alias  PVIDEOHDR handle VIDEOHDR;
 define alias LPVIDEOHDR handle VIDEOHDR;

 /* dwFlags field of VIDEOHDR */
 dcl VHDR_DONE     type DWORD value('00000001'xu);
     /* Done bit */
 dcl VHDR_PREPARED type DWORD value('00000002'xu);
     /* Set if this header has been prepared */
 dcl VHDR_INQUEUE  type DWORD value('00000004'xu);
     /* Reserved for driver */
 dcl VHDR_KEYFRAME type DWORD value('00000008'xu);
     /* Key Frame */

 /* Channel capabilities structure */
 define structure
   1 CHANNEL_CAPS,
     2 dwFlags            type DWORD,/* Capability flags*/
     2 dwSrcRectXMod      type DWORD,/* Granularity of src rect in x */
     2 dwSrcRectYMod      type DWORD,/* Granularity of src rect in y */
     2 dwSrcRectWidthMod  type DWORD,/* Granularity of src rect width */
     2 dwSrcRectHeightMod type DWORD,/* Granularity of src rect height*/
     2 dwDstRectXMod      type DWORD,/* Granularity of dst rect in x */
     2 dwDstRectYMod      type DWORD,/* Granularity of dst rect in y */
     2 dwDstRectWidthMod  type DWORD,/* Granularity of dst rect width */
     2 dwDstRectHeightMod type DWORD;/* Granularity of dst rect height*/
 define alias  PCHANNEL_CAPS handle CHANNEL_CAPS;
 define alias LPCHANNEL_CAPS handle CHANNEL_CAPS;

 /* dwFlags of CHANNEL_CAPS */
 dcl VCAPS_OVERLAY      type DWORD value('00000001'xu);
     /* overlay channel */
 dcl VCAPS_SRC_CAN_CLIP type DWORD value('00000002'xu);
     /* src rect can clip */
 dcl VCAPS_DST_CAN_CLIP type DWORD value('00000004'xu);
     /* dst rect can clip */
 dcl VCAPS_CAN_SCALE    type DWORD value('00000008'xu);
     /* allows src != dst */

 /*********************************************************************/
 /*                                                                   */
 /*        API Flags                                                  */
 /*                                                                   */
 /*********************************************************************/

 /* Types of channels to open with the videoOpen function */
 dcl VIDEO_EXTERNALIN          type DWORD value('0001'xu);
 dcl VIDEO_EXTERNALOUT         type DWORD value('0002'xu);
 dcl VIDEO_IN                  type DWORD value('0004'xu);
 dcl VIDEO_OUT                 type DWORD value('0008'xu);

 /* Is a driver dialog available for this channel? */
 dcl VIDEO_DLG_QUERY           type DWORD value('0010'xu);

 /* videoConfigure (both GET and SET) */
 dcl VIDEO_CONFIGURE_QUERY     type DWORD value('8000'xu);

 /* videoConfigure (SET only) */
 dcl VIDEO_CONFIGURE_SET       type DWORD value('1000'xu);

 /* videoConfigure (GET only) */
 dcl VIDEO_CONFIGURE_GET       type DWORD value('2000'xu);
 dcl VIDEO_CONFIGURE_QUERYSIZE type DWORD value('0001'xu);

 dcl VIDEO_CONFIGURE_CURRENT   type DWORD value('0010'xu);
 dcl VIDEO_CONFIGURE_NOMINAL   type DWORD value('0020'xu);
 dcl VIDEO_CONFIGURE_MIN       type DWORD value('0040'xu);
 dcl VIDEO_CONFIGURE_MAX       type DWORD value('0080'xu);

 /*********************************************************************/
 /*                                                                   */
 /*          CONFIGURE MESSAGES                                       */
 /*                                                                   */
 /*********************************************************************/

 dcl DVM_USER            fixed bin(31) value('4000'xn);

 dcl DVM_CONFIGURE_START fixed bin(31) value('1000'xn);
 dcl DVM_CONFIGURE_END   fixed bin(31) value('1FFF'xn);

 dcl DVM_PALETTE         fixed bin(31) value(DVM_CONFIGURE_START + 1);
 dcl DVM_FORMAT          fixed bin(31) value(DVM_CONFIGURE_START + 2);
 dcl DVM_PALETTERGB555   fixed bin(31) value(DVM_CONFIGURE_START + 3);
 dcl DVM_SRC_RECT        fixed bin(31) value(DVM_CONFIGURE_START + 4);
 dcl DVM_DST_RECT        fixed bin(31) value(DVM_CONFIGURE_START + 5);

 %end; /* NOVIDEO */

 /*********************************************************************/
 /*                                                                   */
 /*  AVICAP - Window class for AVI capture                            */
 /*                                                                   */
 /*********************************************************************/


 %dcl NOAVICAP char ext;
 %if NOAVICAP = '' %then %do;
 /* SendMessage in C */

 AVICapSM: proc (hwnd, m, w, l)
           returns (optional type LRESULT byvalue)
           options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       m    type UINT byvalue,
       w    type WPARAM byvalue,
       l    type LPARAM byvalue;
   if IsWindow (hwnd) = 0 then
     return (0);
   else
     return (SendMessage (hwnd, m, w, l));
 end AVICapSM;

 /* ----------------------------------------------------------------- */
 /* Window Messages  WM_CAP... which can be sent to an AVICAP window  */
 /* ----------------------------------------------------------------- */

 /* UNICODE                                                           */
 /*                                                                   */
 /* The Win32 version of AVICAP on NT supports UNICODE applications:  */
 /* for each API or message that takes a char or string parameter,    */
 /* there are two versions, ApiNameA and ApiNameW.                    */
 /* The default name ApiName is %dcl defined to one or other          */
 /* depending on whether UNICODE is defined.                          */
 /* Apps can call the A and A and W apis directly, and mix them.      */
 /*                                                                   */
 /* The 32-bit AVICAP on NT uses unicode exclusively internally.      */
 /* ApiNameA() will be implemented as a call to ApiNameW() together   */
 /* with translation of strings.                                      */

 /* Defines start of the message range */
 dcl WM_CAP_START         fixed bin (31) value (WM_USER);
 /* start of unicode messages */
 dcl WM_CAP_UNICODE_START fixed bin (31) value (WM_USER+100);

 dcl ( WM_CAP_GET_CAPSTREAMPTR         value(WM_CAP_START+  1)

     , WM_CAP_SET_CALLBACK_ERRORW      value(WM_CAP_UNICODE_START+  2)
     , WM_CAP_SET_CALLBACK_STATUSW     value(WM_CAP_UNICODE_START+  3)
     , WM_CAP_SET_CALLBACK_ERRORA      value(WM_CAP_START+  2)
     , WM_CAP_SET_CALLBACK_STATUSA     value(WM_CAP_START+  3)

 %if UNICODE ^= '' %then %do;
     , WM_CAP_SET_CALLBACK_ERROR      value(WM_CAP_SET_CALLBACK_ERRORW)
     , WM_CAP_SET_CALLBACK_STATUS     value(WM_CAP_SET_CALLBACK_STATUSW)
 %end; %else %do;
     , WM_CAP_SET_CALLBACK_ERROR      value(WM_CAP_SET_CALLBACK_ERRORA)
     , WM_CAP_SET_CALLBACK_STATUS     value(WM_CAP_SET_CALLBACK_STATUSA)
 %end;

     , WM_CAP_SET_CALLBACK_YIELD       value(WM_CAP_START+  4)
     , WM_CAP_SET_CALLBACK_FRAME       value(WM_CAP_START+  5)
     , WM_CAP_SET_CALLBACK_VIDEOSTREAM value(WM_CAP_START+  6)
     , WM_CAP_SET_CALLBACK_WAVESTREAM  value(WM_CAP_START+  7)
     , WM_CAP_GET_USER_DATA            value(WM_CAP_START+  8)
     , WM_CAP_SET_USER_DATA            value(WM_CAP_START+  9)

     , WM_CAP_DRIVER_CONNECT           value(WM_CAP_START+ 10)
     , WM_CAP_DRIVER_DISCONNECT        value(WM_CAP_START+ 11)
     , WM_CAP_DRIVER_GET_NAMEA         value(WM_CAP_START+ 12)
     , WM_CAP_DRIVER_GET_VERSIONA      value(WM_CAP_START+ 13)
     , WM_CAP_DRIVER_GET_NAMEW         value(WM_CAP_UNICODE_START+ 12)
     , WM_CAP_DRIVER_GET_VERSIONW      value(WM_CAP_UNICODE_START + 13)

 %if UNICODE ^= '' %then %do;
     , WM_CAP_DRIVER_GET_NAME          value(WM_CAP_DRIVER_GET_NAMEW)
     , WM_CAP_DRIVER_GET_VERSION       value(WM_CAP_DRIVER_GET_VERSIONW)
 %end; %else %do;
     , WM_CAP_DRIVER_GET_NAME          value(WM_CAP_DRIVER_GET_NAMEA)
     , WM_CAP_DRIVER_GET_VERSION       value(WM_CAP_DRIVER_GET_VERSIONA)
 %end;

     , WM_CAP_DRIVER_GET_CAPS          value(WM_CAP_START+ 14)

     , WM_CAP_FILE_SET_CAPTURE_FILEA   value(WM_CAP_START+ 20)
     , WM_CAP_FILE_GET_CAPTURE_FILEA   value(WM_CAP_START+ 21)
     , WM_CAP_FILE_SAVEASA             value(WM_CAP_START+ 23)
     , WM_CAP_FILE_SAVEDIBA            value(WM_CAP_START+ 25)
     , WM_CAP_FILE_SET_CAPTURE_FILEW   value(WM_CAP_UNICODE_START+ 20)
     , WM_CAP_FILE_GET_CAPTURE_FILEW   value(WM_CAP_UNICODE_START+ 21)
     , WM_CAP_FILE_SAVEASW             value(WM_CAP_UNICODE_START+ 23)
     , WM_CAP_FILE_SAVEDIBW            value(WM_CAP_UNICODE_START+ 25)

 %if UNICODE ^= '' %then %do;
     , WM_CAP_FILE_SET_CAPTURE_FILE value(WM_CAP_FILE_SET_CAPTURE_FILEW)
     , WM_CAP_FILE_GET_CAPTURE_FILE value(WM_CAP_FILE_GET_CAPTURE_FILEW)
     , WM_CAP_FILE_SAVEAS              value(WM_CAP_FILE_SAVEASW)
     , WM_CAP_FILE_SAVEDIB             value(WM_CAP_FILE_SAVEDIBW)
 %end; %else %do;
     , WM_CAP_FILE_SET_CAPTURE_FILE value(WM_CAP_FILE_SET_CAPTURE_FILEA)
     , WM_CAP_FILE_GET_CAPTURE_FILE value(WM_CAP_FILE_GET_CAPTURE_FILEA)
     , WM_CAP_FILE_SAVEAS              value(WM_CAP_FILE_SAVEASA)
     , WM_CAP_FILE_SAVEDIB             value(WM_CAP_FILE_SAVEDIBA)
 %end;

     /* out of order to save on %ifs */
     , WM_CAP_FILE_ALLOCATE            value(WM_CAP_START+ 22)
     , WM_CAP_FILE_SET_INFOCHUNK       value(WM_CAP_START+ 24)

     , WM_CAP_EDIT_COPY                value(WM_CAP_START+ 30)

     , WM_CAP_SET_AUDIOFORMAT          value(WM_CAP_START+ 35)
     , WM_CAP_GET_AUDIOFORMAT          value(WM_CAP_START+ 36)

     , WM_CAP_DLG_VIDEOFORMAT          value(WM_CAP_START+ 41)
     , WM_CAP_DLG_VIDEOSOURCE          value(WM_CAP_START+ 42)
     , WM_CAP_DLG_VIDEODISPLAY         value(WM_CAP_START+ 43)
     , WM_CAP_GET_VIDEOFORMAT          value(WM_CAP_START+ 44)
     , WM_CAP_SET_VIDEOFORMAT          value(WM_CAP_START+ 45)
     , WM_CAP_DLG_VIDEOCOMPRESSION     value(WM_CAP_START+ 46)

     , WM_CAP_SET_PREVIEW              value(WM_CAP_START+ 50)
     , WM_CAP_SET_OVERLAY              value(WM_CAP_START+ 51)
     , WM_CAP_SET_PREVIEWRATE          value(WM_CAP_START+ 52)
     , WM_CAP_SET_SCALE                value(WM_CAP_START+ 53)
     , WM_CAP_GET_STATUS               value(WM_CAP_START+ 54)
     , WM_CAP_SET_SCROLL               value(WM_CAP_START+ 55)

     , WM_CAP_GRAB_FRAME               value(WM_CAP_START+ 60)
     , WM_CAP_GRAB_FRAME_NOSTOP        value(WM_CAP_START+ 61)

     , WM_CAP_SEQUENCE                 value(WM_CAP_START+ 62)
     , WM_CAP_SEQUENCE_NOFILE          value(WM_CAP_START+ 63)
     , WM_CAP_SET_SEQUENCE_SETUP       value(WM_CAP_START+ 64)
     , WM_CAP_GET_SEQUENCE_SETUP       value(WM_CAP_START+ 65)

     , WM_CAP_SET_MCI_DEVICEA          value(WM_CAP_START+ 66)
     , WM_CAP_GET_MCI_DEVICEA          value(WM_CAP_START+ 67)
     , WM_CAP_SET_MCI_DEVICEW          value(WM_CAP_UNICODE_START+ 66)
     , WM_CAP_GET_MCI_DEVICEW          value(WM_CAP_UNICODE_START+ 67)

 %if UNICODE ^= '' %then %do;
     , WM_CAP_SET_MCI_DEVICE           value(WM_CAP_SET_MCI_DEVICEW)
     , WM_CAP_GET_MCI_DEVICE           value(WM_CAP_GET_MCI_DEVICEW)
 %end; %else %do;
     , WM_CAP_SET_MCI_DEVICE           value(WM_CAP_SET_MCI_DEVICEA)
     , WM_CAP_GET_MCI_DEVICE           value(WM_CAP_GET_MCI_DEVICEA)
 %end;

     , WM_CAP_STOP                     value(WM_CAP_START+ 68)
     , WM_CAP_ABORT                    value(WM_CAP_START+ 69)

     , WM_CAP_SINGLE_FRAME_OPEN        value(WM_CAP_START+ 70)
     , WM_CAP_SINGLE_FRAME_CLOSE       value(WM_CAP_START+ 71)
     , WM_CAP_SINGLE_FRAME             value(WM_CAP_START+ 72)

     , WM_CAP_PAL_OPENA                value(WM_CAP_START+ 80)
     , WM_CAP_PAL_SAVEA                value(WM_CAP_START+ 81)
     , WM_CAP_PAL_OPENW                value(WM_CAP_UNICODE_START+ 80)
     , WM_CAP_PAL_SAVEW                value(WM_CAP_UNICODE_START+ 81)

 %if UNICODE ^= '' %then %do;
     , WM_CAP_PAL_OPEN                 value(WM_CAP_PAL_OPENW)
     , WM_CAP_PAL_SAVE                 value(WM_CAP_PAL_SAVEW)
 %end; %else %do;
     , WM_CAP_PAL_OPEN                 value(WM_CAP_PAL_OPENA)
     , WM_CAP_PAL_SAVE                 value(WM_CAP_PAL_SAVEA)
 %end;

     , WM_CAP_PAL_PASTE                value(WM_CAP_START+ 82)
     , WM_CAP_PAL_AUTOCREATE           value(WM_CAP_START+ 83)
     , WM_CAP_PAL_MANUALCREATE         value(WM_CAP_START+ 84)

     /* Following added post VFW 1.1 */
     , WM_CAP_SET_CALLBACK_CAPCONTROL  value(WM_CAP_START+ 85)
     ) fixed bin(31);

 /* Defines end of the message range */
 dcl WM_CAP_UNICODE_END  fixed bin(31) value(WM_CAP_PAL_SAVEW);
 dcl WM_CAP_END          fixed bin(31) value(WM_CAP_UNICODE_END);

 /* ----------------------------------------------------------------- */
 /*  Message crackers for above moved below for PL/I (needs defines)  */
 /* ----------------------------------------------------------------- */

 /* ----------------------------------------------------------------- */
 /*  Structures                                                       */
 /* ----------------------------------------------------------------- */

 define structure
   1 CAPDRIVERCAPS,
     2 wDeviceIndex        type UINT,/* Driver index in system.ini */
     2 fHasOverlay         type BOOL,/* Can device overlay? */
     2 fHasDlgVideoSource  type BOOL,/* Has Video source dlg? */
     2 fHasDlgVideoFormat  type BOOL,/* Has Format dlg? */
     2 fHasDlgVideoDisplay type BOOL,/* Has External out dlg? */
     2 fCaptureInitialized type BOOL,/* Driver ready to capture? */
     2 fDriverSuppliesPalettes type BOOL,/* Can driver make palettes? */
     /* following always NULL on Win32. */
     2 hVideoIn            type HANDLE,/* Driver In channel */
     2 hVideoOut           type HANDLE,/* Driver Out channel */
     2 hVideoExtIn         type HANDLE,/* Driver Ext In channel */
     2 hVideoExtOut        type HANDLE;/* Driver Ext Out channel */

 define alias  PCAPDRIVERCAPS handle CAPDRIVERCAPS;
 define alias LPCAPDRIVERCAPS handle CAPDRIVERCAPS;

 define structure
   1 CAPSTATUS,
     2 uiImageWidth         type UINT,/* Width of the image */
     2 uiImageHeight        type UINT,/* Height of the image */
     2 fLiveWindow          type BOOL,/* Now Previewing video? */
     2 fOverlayWindow       type BOOL,/* Now Overlaying video? */
     2 fScale               type BOOL,/* Scale image to client? */
     2 ptScroll             type POINT,/* Scroll position */
     2 fUsingDefaultPalette type BOOL,/* Using default driver palette?*/
     2 fAudioHardware       type BOOL,/* Audio hardware present? */
     2 fCapFileExists       type BOOL,/* Does capture file exist? */
     2 dwCurrentVideoFrame  type DWORD,/* # of video frames cap'td */
     2 dwCurrentVideoFramesDropped type DWORD,
                                      /* # of video frames dropped */
     2 dwCurrentWaveSamples type DWORD,/* # of wave samples cap'td */
     2 dwCurrentTimeElapsedMS type DWORD,/* Elapsed capture duration */
     2 hPalCurrent          type HPALETTE,/* Current palette in use */
     2 fCapturingNow        type BOOL,/* Capture in progress? */
     2 dwReturn         type DWORD,/* Error value after any operation */
     2 wNumVideoAllocated type UINT,/* Actual number of video buffers */
     2 wNumAudioAllocated type UINT;/* Actual number of audio buffers */

 define alias  PCAPSTATUS handle CAPSTATUS;
 define alias LPCAPSTATUS handle CAPSTATUS;

 /* Default values in parenthesis */
 define structure
   1 CAPTUREPARMS,
     2 dwRequestMicroSecPerFrame type DWORD,/* Requested capture rate */
     2 fMakeUserHitOKToCapture type BOOL,/* Show "Hit OK to cap" dlg? */
     2 wPercentDropForError    type UINT,/* Give error msg if > (10%) */
     2 fYield             type BOOL,/* Capture via background task? */
     2 dwIndexSize        type DWORD,/* Max index size in frames (32K)*/
     2 wChunkGranularity  type UINT,/* Junk chunk granularity (2K) */
     2 fUsingDOSMemory    type BOOL,/* Use DOS buffers? */
     2 wNumVideoRequested type UINT,/* # video buffers, If 0, autocalc*/
     2 fCaptureAudio      type BOOL,/* Capture audio? */
     2 wNumAudioRequested type UINT,/* # audio buffers, If 0, autocalc*/
     2 vKeyAbort          type UINT,/* Virtual key causing abort */
     2 fAbortLeftMouse    type BOOL,/* Abort on left mouse? */
     2 fAbortRightMouse   type BOOL,/* Abort on right mouse? */
     2 fLimitEnabled      type BOOL,/* Use wTimeLimit? */
     2 wTimeLimit         type UINT,/* Seconds to capture */
     2 fMCIControl        type BOOL,/* Use MCI video source? */
     2 fStepMCIDevice     type BOOL,/* Step MCI device? */
     2 dwMCIStartTime     type DWORD,/* Time to start in MS */
     2 dwMCIStopTime      type DWORD,/* Time to stop in MS */
     2 fStepCaptureAt2x   type BOOL,/* Perform spatial averaging 2x */
     2 wStepCaptureAverageFrames type UINT,/*Temporal average n Frames*/
     2 dwAudioBufferSize type DWORD,/*Size of audio bufs (0 = default)*/
     2 fDisableWriteCache type BOOL,/* Attempt to disable write cache */
     2 AVStreamMaster     type UINT;/* Which stream controls length? */

 define alias  PCAPTUREPARMS handle CAPTUREPARMS;
 define alias LPCAPTUREPARMS handle CAPTUREPARMS;

 /* ----------------------------------------------------------------- */
 /* AVStreamMaster                                                    */
 /* Since Audio and Video streams generally use non-synchronized      */
 /* capture clocks, this flag determines whether the audio stream is  */
 /* to be considered the master or controlling clock when writing     */
 /* the AVI file:                                                     */
 /*                                                                   */
 /*  AVSTREAMMASTER_AUDIO  - Audio is master, video frame duration is */
 /*                          forced to match audio duration (VFW 1.0, */
 /*                          1.1 default)                             */
 /*  AVSTREAMMASTER_NONE   - No master, audio and video streams may   */
 /*                          be of different lengths                  */
 /* ----------------------------------------------------------------- */
 dcl AVSTREAMMASTER_AUDIO fixed bin(31) value(0);
     /* Audio master (VFW 1.0, 1.1) */
 dcl AVSTREAMMASTER_NONE fixed bin(31) value(1);
     /* No master */

 define structure
   1 CAPINFOCHUNK,
    2 fccInfoID type FOURCC,/* Chunk ID, "ICOP" for copyright */
    2 lpData    type LPVOID,/* pointer to data */
    2 cbData    type LONG;  /* size of lpData */

 define alias  PCAPINFOCHUNK handle CAPINFOCHUNK;
 define alias LPCAPINFOCHUNK handle CAPINFOCHUNK;

 /* ----------------------------------------------------------------- */
 /*  Callback Definitions                                             */
 /* ----------------------------------------------------------------- */

 define alias CAPYIELDCALLBACK
        entry (type HWND)
        returns (type LRESULT byvalue optional)
        limited CALLBACK;

 define alias CAPSTATUSCALLBACKW
        entry (type HWND,
               fixed bin(31),
               type LPCWSTR)
        returns (type LRESULT byvalue optional)
        limited CALLBACK;

 define alias CAPERRORCALLBACKW
        entry (type HWND,
               fixed bin(31),
               type LPCWSTR)
     returns (type LRESULT byvalue optional)
        limited CALLBACK;

 define alias CAPSTATUSCALLBACKA
        entry (type HWND,
               fixed bin(31),
               type LPCSTR)
        returns (type LRESULT byvalue optional)
        limited CALLBACK;

 define alias CAPERRORCALLBACKA
        entry (type HWND,
               fixed bin(31),
               type LPCSTR)
        returns (type LRESULT byvalue optional)
        limited CALLBACK;

 %if UNICODE ^= '' %then %do;
 define alias CAPSTATUSCALLBACK type CAPSTATUSCALLBACKW;
 define alias CAPERRORCALLBACK  type CAPERRORCALLBACKW;
 %end; %else %do;
 define alias CAPSTATUSCALLBACK type CAPSTATUSCALLBACKA;
 define alias CAPERRORCALLBACK  type CAPERRORCALLBACKA;
 %end;

 define alias CAPVIDEOCALLBACK
        entry (type HWND,
               type VIDEOHDR byaddr)
     returns (type LRESULT byvalue optional)
        limited CALLBACK;

 define alias CAPWAVECALLBACK
        entry (type HWND,
               type WAVEHDR byaddr)
        returns (type LRESULT byvalue optional)
        limited CALLBACK;

 define alias CAPCONTROLCALLBACK
        entry (type HWND,
               fixed bin(31))
        returns (type LRESULT byvalue optional)
        limited CALLBACK;

 /* ---------------------------------------------------------------- */
 /*  CapControlCallback states                                       */
 /* ---------------------------------------------------------------- */
 dcl CONTROLCALLBACK_PREROLL   fixed bin(31) value(1);
     /* Waiting to start capture */
 dcl CONTROLCALLBACK_CAPTURING fixed bin(31) value(2);
     /* Now capturing */


 /* ----------------------------------------------------------------- */
 /*  Message crackers for above (moved from above for PL/I)           */
 /* ----------------------------------------------------------------- */

 /* message wrapper macros are defined for the default messages only. */
 /* Apps that wish to mix Ansi and UNICODE message sending will have  */
 /* to reference the _A and _W messages directly                      */

 capSetCallbackOnError: proc (hwnd, fpProc)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       fpProc type CAPERRORCALLBACK optional byvalue;
   dcl (binvalue, entryaddr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_CALLBACK_ERROR,
                     0, binvalue (entryaddr (fpProc))));
 end capSetCallbackOnError;

 capSetCallbackOnStatus: proc (hwnd, fpProc)
                         returns (type BOOL byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       fpProc type CAPSTATUSCALLBACK optional byvalue;
   dcl (binvalue, entryaddr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_CALLBACK_STATUS,
                     0, binvalue (entryaddr (fpProc))));
 end capSetCallbackOnStatus;

 capSetCallbackOnYield: proc (hwnd, fpProc)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       fpProc type CAPYIELDCALLBACK optional byvalue;
   dcl (binvalue, entryaddr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_CALLBACK_YIELD,
                     0, binvalue (entryaddr (fpProc))));
 end capSetCallbackOnYield;

 capSetCallbackOnFrame: proc (hwnd, fpProc)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       fpProc type CAPVIDEOCALLBACK optional byvalue;
              /* there is no CAPFRAMECALLBACK type, but it is the same*/
   dcl (binvalue, entryaddr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_CALLBACK_FRAME,
                     0, binvalue (entryaddr (fpProc))));
 end capSetCallbackOnFrame;

 capSetCallbackOnVideoStream: proc (hwnd, fpProc)
                              returns (type BOOL byvalue optional)
                              options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       fpProc type CAPVIDEOCALLBACK optional byvalue;
   dcl (binvalue, entryaddr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_CALLBACK_VIDEOSTREAM,
                     0, binvalue (entryaddr (fpProc))));
 end capSetCallbackOnVideoStream;

 capSetCallbackOnWaveStream: proc (hwnd, fpProc)
                             returns (type BOOL byvalue optional)
                             options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       fpProc type CAPWAVECALLBACK optional byvalue;
   dcl (binvalue, entryaddr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_CALLBACK_WAVESTREAM,
                     0, binvalue (entryaddr (fpProc))));
 end capSetCallbackOnWaveStream;

 capSetCallbackOnCapControl: proc (hwnd, fpProc)
                             returns (type BOOL byvalue optional)
                             options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       fpProc type CAPCONTROLCALLBACK optional byvalue;
   dcl (binvalue, entryaddr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_CALLBACK_CAPCONTROL,
                     0, binvalue (entryaddr (fpProc))));
 end capSetCallbackOnCapControl;


 capSetUserData: proc (hwnd, lUser)
                 returns (type BOOL byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       lUser type LONG byvalue;
   return (AVICapSM (hwnd, WM_CAP_SET_USER_DATA, 0, (lUser)));
 end capSetUserData;

 capGetUserData: proc (hwnd)
                 returns (type LONG byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_GET_USER_DATA, 0, 0));
 end capGetUserData;


 capDriverConnect: proc (hwnd, i)
                   returns (type BOOL byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       i    fixed bin (31) byvalue;
   return (AVICapSM (hwnd, WM_CAP_DRIVER_CONNECT, (i), 0));
 end capDriverConnect;

 capDriverDisconnect: proc (hwnd)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_DRIVER_DISCONNECT, 0, 0));
 end capDriverDisconnect;

 capDriverGetName: proc (hwnd, szName, wSize)
                   returns (type BOOL byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       szName TSTR byaddr,
       wSize  fixed bin (31) byvalue;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_DRIVER_GET_NAME,
                           (wSize), binvalue (addr (szName))));
 end capDriverGetName;

 capDriverGetVersion: proc (hwnd, szVer, wSize)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       szVer TSTR byaddr,
       wSize fixed bin (31) byvalue;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_DRIVER_GET_VERSION,
                           (wSize), binvalue (addr (szVer))));
 end capDriverGetVersion;

 capDriverGetCaps: proc (hwnd, s, wSize)
                   returns (type BOOL byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       s     type CAPDRIVERCAPS byaddr,
       wSize fixed bin (31) byvalue;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_DRIVER_GET_CAPS,
                           (wSize), binvalue (addr (s))));
 end capDriverGetCaps;


 capFileSetCaptureFile: proc (hwnd, szName)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       szName TSTR byaddr;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_FILE_SET_CAPTURE_FILE,
                           0, binvalue (addr (szName))));
 end capFileSetCaptureFile;

 capFileGetCaptureFile: proc (hwnd, szName, wSize)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       szName TSTR byaddr,
       wSize  fixed bin (31) byvalue;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_FILE_GET_CAPTURE_FILE,
                           (wSize), binvalue (addr (szName))));
 end capFileGetCaptureFile;

 capFileAlloc: proc (hwnd, dwSize)
               returns (type BOOL byvalue optional)
               options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       dwSize type DWORD byvalue;
   return (AVICapSM (hwnd, WM_CAP_FILE_ALLOCATE, 0, (dwSize)));
 end capFileAlloc;

 capFileSaveAs: proc (hwnd, szName)
                returns (type BOOL byvalue optional)
                options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       szName TSTR byaddr;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_FILE_SAVEAS,
                           0, binvalue (addr (szName))));
 end capFileSaveAs;

 capFileSetInfoChunk: proc (hwnd, lpInfoChunk)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd        type HWND byvalue,
       lpInfoChunk type CAPINFOCHUNK byaddr;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_FILE_SET_INFOCHUNK,
                           0, binvalue (addr (lpInfoChunk))));
 end capFileSetInfoChunk;

 capFileSaveDIB: proc (hwnd, szName)
                 returns (type BOOL byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       szName TSTR byaddr;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_FILE_SAVEDIB,
                           0, binvalue (addr (szName))));
 end capFileSaveDIB;


 capEditCopy: proc (hwnd)
              returns (type BOOL byvalue optional)
              options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_EDIT_COPY, 0, 0));
 end capEditCopy;


 capSetAudioFormat: proc (hwnd, s, wSize)
                    returns (type BOOL byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       s     type WAVEFORMATEX byaddr,
       wSize fixed bin (31) byvalue;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_AUDIOFORMAT,
                           (wSize), binvalue (addr (s))));
 end capSetAudioFormat;

 capGetAudioFormat: proc (hwnd, s, wSize)
                    returns (type DWORD byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       s     type WAVEFORMATEX byaddr,
       wSize fixed bin (31) byvalue;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_GET_AUDIOFORMAT,
                           (wSize), binvalue (addr (s))));
 end capGetAudioFormat;

 capGetAudioFormatSize: proc (hwnd)
                        returns (type DWORD byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_GET_AUDIOFORMAT, 0, 0));
 end capGetAudioFormatSize;


 capDlgVideoFormat: proc (hwnd)
                    returns (type BOOL byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_DLG_VIDEOFORMAT, 0, 0));
 end capDlgVideoFormat;

 capDlgVideoSource: proc (hwnd)
                    returns (type BOOL byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_DLG_VIDEOSOURCE, 0, 0));
 end capDlgVideoSource;

 capDlgVideoDisplay: proc (hwnd)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_DLG_VIDEODISPLAY, 0, 0));
 end capDlgVideoDisplay;

 capDlgVideoCompression: proc (hwnd)
                         returns (type BOOL byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_DLG_VIDEOCOMPRESSION, 0, 0));
 end capDlgVideoCompression;


 capGetVideoFormat: proc (hwnd, s, wSize)
                    returns (type DWORD byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       s     type BITMAPINFO byaddr optional,
       wSize fixed bin (31) byvalue;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_GET_VIDEOFORMAT,
                           (wSize), binvalue (addr (s))));
 end capGetVideoFormat;

 capGetVideoFormatSize: proc (hwnd)
                        returns (type DWORD byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_GET_VIDEOFORMAT, 0, 0));
 end capGetVideoFormatSize;

 capSetVideoFormat: proc (hwnd, s, wSize)
                    returns (type BOOL byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       s     type BITMAPINFO byaddr,
       wSize fixed bin (31) byvalue;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_VIDEOFORMAT,
                           (wSize), binvalue (addr (s))));
 end capSetVideoFormat;


 capPreview: proc (hwnd, f)
             returns (type BOOL byvalue optional)
             options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       f     type BOOL byvalue;
   return (AVICapSM (hwnd, WM_CAP_SET_PREVIEW, (f), 0));
 end capPreview;

 capPreviewRate: proc (hwnd, wMS)
             returns (type BOOL byvalue optional)
             options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       wMS   fixed bin (31) byvalue;
   return (AVICapSM (hwnd, WM_CAP_SET_PREVIEWRATE, (wMS), 0));
 end capPreviewRate;

 capOverlay: proc (hwnd, f)
             returns (type BOOL byvalue optional)
             options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       f     type BOOL byvalue;
   return (AVICapSM (hwnd, WM_CAP_SET_OVERLAY, (f), 0));
 end capOverlay;

 capPreviewScale: proc (hwnd, f)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       f     type BOOL byvalue;
   return (AVICapSM (hwnd, WM_CAP_SET_SCALE, (f), 0));
 end capPreviewScale;

 capGetStatus: proc (hwnd, s, wSize)
               returns (type BOOL byvalue optional)
               options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       s     type CAPSTATUS byaddr,
       wSize fixed bin (31);
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_GET_STATUS,
                           (wSize), binvalue (addr (s))));
 end capGetStatus;

 capSetScrollPos: proc (hwnd, lpP)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       lpP   type POINT byaddr;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_SCROLL,
                           0, binvalue (addr (lpP))));
 end capSetScrollPos;


 capGrabFrame: proc (hwnd)
               returns (type BOOL byvalue optional)
               options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_GRAB_FRAME, 0, 0));
 end capGrabFrame;

 capGrabFrameNoStop: proc (hwnd)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_GRAB_FRAME_NOSTOP, 0, 0));
 end capGrabFrameNoStop;


 capCaptureSequence: proc (hwnd)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_SEQUENCE, 0, 0));
 end capCaptureSequence;

 capCaptureSequenceNoFile: proc (hwnd)
                           returns (type BOOL byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_SEQUENCE_NOFILE, 0, 0));
 end capCaptureSequenceNoFile;

 capCaptureStop: proc (hwnd)
                 returns (type BOOL byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_STOP, 0, 0));
 end capCaptureStop;

 capCaptureAbort: proc (hwnd)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_ABORT, 0, 0));
 end capCaptureAbort;


 capCaptureSingleFrameOpen: proc (hwnd)
                            returns (type BOOL byvalue optional)
                            options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_SINGLE_FRAME_OPEN, 0, 0));
 end capCaptureSingleFrameOpen;

 capCaptureSingleFrameClose: proc (hwnd)
                             returns (type BOOL byvalue optional)
                             options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_SINGLE_FRAME_CLOSE, 0, 0));
 end capCaptureSingleFrameClose;

 capCaptureSingleFrame: proc (hwnd)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_SINGLE_FRAME, 0, 0));
 end capCaptureSingleFrame;


 capCaptureGetSetup: proc (hwnd, s, wSize)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       s     type CAPTUREPARMS byaddr,
       wSize fixed bin (31);
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_GET_SEQUENCE_SETUP,
                           (wSize), binvalue (addr (s))));
 end capCaptureGetSetup;

 capCaptureSetSetup: proc (hwnd, s, wSize)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       s     type CAPTUREPARMS byaddr,
       wSize fixed bin (31);
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_SEQUENCE_SETUP,
                           (wSize), binvalue (addr (s))));
 end capCaptureSetSetup;


 capSetMCIDeviceName: proc (hwnd, szName)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       szName TSTR byaddr;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_SET_MCI_DEVICE,
                           0, binvalue (addr (szName))));
 end capSetMCIDeviceName;

 capGetMCIDeviceName: proc (hwnd, szName, wSize)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       szName TSTR byaddr,
       wSize  fixed bin (31) byvalue;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_GET_MCI_DEVICE,
                           (wSize), binvalue (addr (szName))));
 end capGetMCIDeviceName;


 capPaletteOpen: proc (hwnd, szName)
                 returns (type BOOL byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       szName TSTR byaddr;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_PAL_OPEN,
                           0, binvalue (addr (szName))));
 end capPaletteOpen;

 capPaletteSave: proc (hwnd, szName)
                 returns (type BOOL byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       szName TSTR byaddr;
   dcl (binvalue, addr) builtin;
   return (AVICapSM (hwnd, WM_CAP_PAL_SAVE,
                           0, binvalue (addr (szName))));
 end capPaletteSave;

 capPalettePaste: proc (hwnd)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (AVICapSM (hwnd, WM_CAP_PAL_PASTE, 0, 0));
 end capPalettePaste;

 capPaletteAuto: proc (hwnd, iFrames, iColors)
                 returns (type BOOL byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       iFrames fixed bin (31) byvalue,
       iColors type DWORD byvalue;
   return (AVICapSM (hwnd, WM_CAP_PAL_AUTOCREATE,
                           (iFrames), (iColors)));
 end capPaletteAuto;

 capPaletteManual: proc (hwnd, fGrab, iColors)
                   returns (type BOOL byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       fGrab   type BOOL byvalue,
       iColors type DWORD byvalue;
   return (AVICapSM (hwnd, WM_CAP_PAL_MANUALCREATE,
                           (fGrab), (iColors)));
 end capPaletteManual;


 /* --------------------------------------------------------------- */
 /*  The only exported functions from AVICAP.DLL                    */
 /* --------------------------------------------------------------- */

 dcl capCreateCaptureWindowA
     entry (char (*) varz byaddr nonasgn,
            type DWORD,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type HWND,
            fixed bin(31))
     returns (type HWND byvalue optional)
     VFWAPI external('capCreateCaptureWindowA');

 dcl capGetDriverDescriptionA
     entry (type UINT,
            char (*) varz byaddr optional,
            fixed bin(31),
            char (*) varz byaddr optional,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     VFWAPI external('capGetDriverDescriptionA');

 dcl capCreateCaptureWindowW
     entry (WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type HWND,
            fixed bin(31))
     returns (type HWND byvalue optional)
     VFWAPI external('capCreateCaptureWindowW');

 dcl capGetDriverDescriptionW
     entry (type UINT,
            WCHAR (*) varz byaddr optional,
            fixed bin(31),
            WCHAR (*) varz byaddr optional,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     VFWAPI external('capGetDriverDescriptionW');

 %dcl capCreateCaptureWindow  char ext;
 %dcl capGetDriverDescription char ext;
 %if UNICODE ^= '' %then %do;
   %capCreateCaptureWindow ='capCreateCaptureWindowW';
   %capGetDriverDescription='capGetDriverDescriptionW';
 %end; %else %do;
   %capCreateCaptureWindow ='capCreateCaptureWindowA';
   %capGetDriverDescription='capGetDriverDescriptionA';
 %end;


 /* ----------------------------------------------------------------- */
 /* New Information chunk IDs                                         */
 /* ----------------------------------------------------------------- */
 dcl infotypeDIGITIZATION_TIME fixed bin (31)
                               value(mmioFOURCC('I','D','I','T'));
 dcl infotypeSMPTE_TIME        fixed bin (31)
                               value(mmioFOURCC('I','S','M','P'));

 /* ----------------------------------------------------------------- */
 /* String IDs from status and error callbacks                        */
 /* ----------------------------------------------------------------- */

 dcl IDS_CAP_BEGIN               fixed bin(31) value(300);
     /* "Capture Start" */
 dcl IDS_CAP_END                 fixed bin(31) value(301);
     /* "Capture End" */

 dcl IDS_CAP_INFO                fixed bin(31) value(401);
     /* "%s" */
 dcl IDS_CAP_OUTOFMEM            fixed bin(31) value(402);
     /* "Out of memory" */
 dcl IDS_CAP_FILEEXISTS          fixed bin(31) value(403);
     /* "File '%s' exists -- overwrite it?" */
 dcl IDS_CAP_ERRORPALOPEN        fixed bin(31) value(404);
     /* "Error opening palette '%s'" */
 dcl IDS_CAP_ERRORPALSAVE        fixed bin(31) value(405);
     /* "Error saving palette '%s'" */
 dcl IDS_CAP_ERRORDIBSAVE        fixed bin(31) value(406);
     /* "Error saving frame '%s'" */
 dcl IDS_CAP_DEFAVIEXT           fixed bin(31) value(407);
     /* "avi" */
 dcl IDS_CAP_DEFPALEXT           fixed bin(31) value(408);
     /* "pal" */
 dcl IDS_CAP_CANTOPEN            fixed bin(31) value(409);
     /* "Cannot open '%s'" */
 dcl IDS_CAP_SEQ_MSGSTART        fixed bin(31) value(410);
     /* "Select OK to start capture\nof video sequence\nto %s." */
 dcl IDS_CAP_SEQ_MSGSTOP         fixed bin(31) value(411);
     /* "Hit ESCAPE or click to end capture" */

 dcl IDS_CAP_VIDEDITERR          fixed bin(31) value(412);
     /* "An error occurred while trying to run VidEdit." */
 dcl IDS_CAP_READONLYFILE        fixed bin(31) value(413);
     /* "The file '%s' is a read-only file." */
 dcl IDS_CAP_WRITEERROR          fixed bin(31) value(414);
     /* "Unable to write to file '%s'.\nDisk may be full." */
 dcl IDS_CAP_NODISKSPACE         fixed bin(31) value(415);
     /* "There is no space to create a capture file on the */
     /* specified device. "                                */
 dcl IDS_CAP_SETFILESIZE         fixed bin(31) value(416);
     /* "Set File Size" */
 dcl IDS_CAP_SAVEASPERCENT       fixed bin(31) value(417);
     /* "SaveAs: %2ld%%  Hit Escape to abort." */

 dcl IDS_CAP_DRIVER_ERROR        fixed bin(31) value(418);
     /* Driver specific error message */

 dcl IDS_CAP_WAVE_OPEN_ERROR     fixed bin(31) value(419);
     /* "Error: Cannot open the wave input device.\n */
     /* Check sample size, frequency, and channels." */
 dcl IDS_CAP_WAVE_ALLOC_ERROR    fixed bin(31) value(420);
     /* "Error: Out of memory for wave buffers." */
 dcl IDS_CAP_WAVE_PREPARE_ERROR  fixed bin(31) value(421);
     /* "Error: Cannot prepare wave buffers." */
 dcl IDS_CAP_WAVE_ADD_ERROR      fixed bin(31) value(422);
     /* "Error: Cannot add wave buffers." */
 dcl IDS_CAP_WAVE_SIZE_ERROR     fixed bin(31) value(423);
     /* "Error: Bad wave size." */

 dcl IDS_CAP_VIDEO_OPEN_ERROR    fixed bin(31) value(424);
     /* "Error: Cannot open the video input device." */
 dcl IDS_CAP_VIDEO_ALLOC_ERROR   fixed bin(31) value(425);
     /* "Error: Out of memory for video buffers." */
 dcl IDS_CAP_VIDEO_PREPARE_ERROR fixed bin(31) value(426);
     /* "Error: Cannot prepare video buffers." */
 dcl IDS_CAP_VIDEO_ADD_ERROR     fixed bin(31) value(427);
     /* "Error: Cannot add video buffers." */
 dcl IDS_CAP_VIDEO_SIZE_ERROR    fixed bin(31) value(428);
     /* "Error: Bad video size." */

 dcl IDS_CAP_FILE_OPEN_ERROR     fixed bin(31) value(429);
     /* "Error: Cannot open capture file." */
 dcl IDS_CAP_FILE_WRITE_ERROR    fixed bin(31) value(430);
     /* "Error: Cannot write to capture file.  Disk may be full." */
 dcl IDS_CAP_RECORDING_ERROR     fixed bin(31) value(431);
     /* "Error: Cannot write to capture file. */
     /* Data rate too high or disk full."     */
 dcl IDS_CAP_RECORDING_ERROR2    fixed bin(31) value(432);
     /* "Error while recording" */
 dcl IDS_CAP_AVI_INIT_ERROR      fixed bin(31) value(433);
     /* "Error: Unable to initialize for capture." */
 dcl IDS_CAP_NO_FRAME_CAP_ERROR  fixed bin(31) value(434);
     /* "Warning: No frames captured.\nConfirm that vertical */
     /* sync interrupts\nare configured and enabled."        */
 dcl IDS_CAP_NO_PALETTE_WARN     fixed bin(31) value(435);
     /* "Warning: Using default palette." */
 dcl IDS_CAP_MCI_CONTROL_ERROR   fixed bin(31) value(436);
     /* "Error: Unable to access MCI device." */
 dcl IDS_CAP_MCI_CANT_STEP_ERROR fixed bin(31) value(437);
     /* "Error: Unable to step MCI device." */
 dcl IDS_CAP_NO_AUDIO_CAP_ERROR  fixed bin(31) value(438);
     /* "Error: No audio data captured.\nCheck audio card settings." */
 dcl IDS_CAP_AVI_DRAWDIB_ERROR   fixed bin(31) value(439);
     /* "Error: Unable to draw this data format." */
 dcl IDS_CAP_COMPRESSOR_ERROR    fixed bin(31) value(440);
     /* "Error: Unable to initialize compressor." */
 dcl IDS_CAP_AUDIO_DROP_ERROR    fixed bin(31) value(441);
     /* "Error: Audio data was lost during capture, */
     /* reduce capture rate."                       */

 /* status string IDs */
 dcl IDS_CAP_STAT_LIVE_MODE      fixed bin(31) value(500);
     /* "Live window" */
 dcl IDS_CAP_STAT_OVERLAY_MODE   fixed bin(31) value(501);
     /* "Overlay window" */
 dcl IDS_CAP_STAT_CAP_INIT       fixed bin(31) value(502);
     /* "Setting up for capture - Please wait" */
 dcl IDS_CAP_STAT_CAP_FINI       fixed bin(31) value(503);
     /* "Finished capture, now writing frame %ld" */
 dcl IDS_CAP_STAT_PALETTE_BUILD  fixed bin(31) value(504);
     /* "Building palette map" */
 dcl IDS_CAP_STAT_OPTPAL_BUILD   fixed bin(31) value(505);
     /* "Computing optimal palette" */
 dcl IDS_CAP_STAT_I_FRAMES       fixed bin(31) value(506);
     /* "%d frames" */
 dcl IDS_CAP_STAT_L_FRAMES       fixed bin(31) value(507);
     /* "%ld frames" */
 dcl IDS_CAP_STAT_CAP_L_FRAMES   fixed bin(31) value(508);
     /* "Captured %ld frames" */
 dcl IDS_CAP_STAT_CAP_AUDIO      fixed bin(31) value(509);
     /* "Capturing audio" */
 dcl IDS_CAP_STAT_VIDEOCURRENT   fixed bin(31) value(510);
     /* "Captured %ld frames (%ld dropped) %d.%03d sec." */
 dcl IDS_CAP_STAT_VIDEOAUDIO     fixed bin(31) value(511);
     /* "Captured %d.%03d sec. %ld frames (%ld dropped) (%d.%03d fps).*/
     /* %ld audio bytes (%d,%03d sps)"                                */
 dcl IDS_CAP_STAT_VIDEOONLY      fixed bin(31) value(512);
     /* "Captured %d.%03d sec. %ld frames (%ld dropped) (%d.%03d fps)"*/
 dcl IDS_CAP_STAT_FRAMESDROPPED  fixed bin(31) value(513);
     /* "Dropped %ld of %ld frames (%d.%02d%%) during capture." */
 %end; /* NOAVICAP */

 /*********************************************************************/
 /*                                                                   */
 /*  ACM (Audio compression manager)                                  */
 /*                                                                   */
 /*********************************************************************/

 %dcl NOMSACM char ext;
 %if NOMSACM = '' %then %do;
  %dcl #INC_ACM char ext;
  %if #INC_ACM = '' %then %do;
  %include msacm;
  %end;
 %end;

 /*********************************************************************/
 /*                                                                   */
 /*  FilePreview dialog.                                              */
 /*                                                                   */
 /*********************************************************************/
 %dcl #OFN_READONLY fixed ext;
 %if #OFN_READONLY ^= 0 %then %do;

 dcl GetOpenFileNamePreviewA
     entry (type OPENFILENAMEA byaddr)
     returns (type BOOL byvalue optional)
     VFWAPI external('GetOpenFileNamePreviewA');
 dcl GetSaveFileNamePreviewA
     entry (type OPENFILENAMEA byaddr)
     returns (type BOOL byvalue optional)
     VFWAPI external('GetSaveFileNamePreviewA');

 dcl GetOpenFileNamePreviewW
     entry (type OPENFILENAMEW byaddr)
     returns (type BOOL byvalue optional)
     VFWAPI external('GetOpenFileNamePreviewW');
 dcl GetSaveFileNamePreviewW
     entry (type OPENFILENAMEW byaddr)
     returns (type BOOL byvalue optional)
     VFWAPI external('GetSaveFileNamePreviewW');


 %dcl GetOpenFileNamePreview char ext;
 %dcl GetSaveFileNamePreview char ext;
 %if UNICODE ^= '' %then %do;
   %GetOpenFileNamePreview='GetOpenFileNamePreviewW';
   %GetSaveFileNamePreview='GetSaveFileNamePreviewW';
 %end; %else %do;
   %GetOpenFileNamePreview='GetOpenFileNamePreviewA';
   %GetSaveFileNamePreview='GetSaveFileNamePreviewA';
 %end;

 %end; /* #OFN_READONLY */

 %end; /* _INC_VFW */
