 /*++ BUILD Version: 0010    -- Increment this if a change has global */
 /*                             effects                               */
 /*                                                                   */
 /* Copyright 1995 - 1998 Microsoft Corporation                       */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     winsvc.cpy                                                    */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     Header file for the Service Control Manager                   */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*     User Mode - Win32                                             */
 /*                                                                   */
 /*--                                                                 */
 %dcl #WINSVC_ char ext;
 %if #WINSVC_ = '' %then %do;
 %#WINSVC_ = 'Y';

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;

 %dcl UNICODE char ext;

 /* Define API decoration for direct importing of DLL references. */

 %dcl WINADVAPI char ext;
 %WINADVAPI = '';


 /* Constants */

 /* Service database names */

 dcl SERVICES_ACTIVE_DATABASEW WCHAR(14) value('ServicesActive');
 dcl SERVICES_FAILED_DATABASEW WCHAR(14) value('ServicesFailed');

 dcl SERVICES_ACTIVE_DATABASEA char      value('ServicesActive');
 dcl SERVICES_FAILED_DATABASEA char      value('ServicesFailed');

 /* Character to designate that a name is a group */

 dcl SC_GROUP_IDENTIFIERW WCHAR(1) value ('+');
 dcl SC_GROUP_IDENTIFIERA char     value ('+');

 %dcl SERVICES_ACTIVE_DATABASE char ext;
 %dcl SERVICES_FAILED_DATABASE char ext;
 %dcl SC_GROUP_IDENTIFIER char ext;
 %if UNICODE ^= '' %then %do;
 %SERVICES_ACTIVE_DATABASE='SERVICES_ACTIVE_DATABASEW';
 %SERVICES_FAILED_DATABASE='SERVICES_FAILED_DATABASEW';
 %SC_GROUP_IDENTIFIER     ='SC_GROUP_IDENTIFIERW';
 %end; %else %do;
 %SERVICES_ACTIVE_DATABASE='SERVICES_ACTIVE_DATABASEA';
 %SERVICES_FAILED_DATABASE='SERVICES_FAILED_DATABASEA';
 %SC_GROUP_IDENTIFIER     ='SC_GROUP_IDENTIFIERA';
 %end; /* ndef UNICODE */


 /* Value to indicate no change to an optional parameter */
 dcl SERVICE_NO_CHANGE              type DWORD value('ffffffff'xu);

 /* Service State -- for Enum Requests (Bit Mask) */
 dcl SERVICE_ACTIVE                 type DWORD value('00000001'xu);
 dcl SERVICE_INACTIVE               type DWORD value('00000002'xu);
 dcl SERVICE_STATE_ALL              type DWORD
     value(ior (SERVICE_ACTIVE, SERVICE_INACTIVE));

 /* Controls */
 dcl SERVICE_CONTROL_STOP           type DWORD value('00000001'xu);
 dcl SERVICE_CONTROL_PAUSE          type DWORD value('00000002'xu);
 dcl SERVICE_CONTROL_CONTINUE       type DWORD value('00000003'xu);
 dcl SERVICE_CONTROL_INTERROGATE    type DWORD value('00000004'xu);
 dcl SERVICE_CONTROL_SHUTDOWN       type DWORD value('00000005'xu);
 dcl SERVICE_CONTROL_PARAMCHANGE    type DWORD value('00000006'xu);
 dcl SERVICE_CONTROL_NETBINDADD     type DWORD value('00000007'xu);
 dcl SERVICE_CONTROL_NETBINDREMOVE  type DWORD value('00000008'xu);
 dcl SERVICE_CONTROL_NETBINDENABLE  type DWORD value('00000009'xu);
 dcl SERVICE_CONTROL_NETBINDDISABLE type DWORD value('0000000A'xu);

 /* Service State -- for CurrentState */
 dcl SERVICE_STOPPED                type DWORD value('00000001'xu);
 dcl SERVICE_START_PENDING          type DWORD value('00000002'xu);
 dcl SERVICE_STOP_PENDING           type DWORD value('00000003'xu);
 dcl SERVICE_RUNNING                type DWORD value('00000004'xu);
 dcl SERVICE_CONTINUE_PENDING       type DWORD value('00000005'xu);
 dcl SERVICE_PAUSE_PENDING          type DWORD value('00000006'xu);
 dcl SERVICE_PAUSED                 type DWORD value('00000007'xu);

 /* Controls Accepted  (Bit Mask) */
 dcl SERVICE_ACCEPT_STOP            type DWORD value('00000001'xu);
 dcl SERVICE_ACCEPT_PAUSE_CONTINUE  type DWORD value('00000002'xu);
 dcl SERVICE_ACCEPT_SHUTDOWN        type DWORD value('00000004'xu);
 dcl SERVICE_ACCEPT_PARAMCHANGE     type DWORD value('00000008'xu);
 dcl SERVICE_ACCEPT_NETBINDCHANGE   type DWORD value('00000010'xu);

 /* Service Control Manager object specific access types */
 dcl SC_MANAGER_CONNECT             type DWORD value('0001'xu);
 dcl SC_MANAGER_CREATE_SERVICE      type DWORD value('0002'xu);
 dcl SC_MANAGER_ENUMERATE_SERVICE   type DWORD value('0004'xu);
 dcl SC_MANAGER_LOCK                type DWORD value('0008'xu);
 dcl SC_MANAGER_QUERY_LOCK_STATUS   type DWORD value('0010'xu);
 dcl SC_MANAGER_MODIFY_BOOT_CONFIG  type DWORD value('0020'xu);

 dcl SC_MANAGER_ALL_ACCESS          type DWORD
     value (ior (STANDARD_RIGHTS_REQUIRED,
                 SC_MANAGER_CONNECT,
                 SC_MANAGER_CREATE_SERVICE,
                 SC_MANAGER_ENUMERATE_SERVICE,
                 SC_MANAGER_LOCK,
                 SC_MANAGER_QUERY_LOCK_STATUS,
                 SC_MANAGER_MODIFY_BOOT_CONFIG));


 /* Service object specific access type */
 dcl SERVICE_QUERY_CONFIG           type DWORD value('0001'xu);
 dcl SERVICE_CHANGE_CONFIG          type DWORD value('0002'xu);
 dcl SERVICE_QUERY_STATUS           type DWORD value('0004'xu);
 dcl SERVICE_ENUMERATE_DEPENDENTS   type DWORD value('0008'xu);
 dcl SERVICE_START                  type DWORD value('0010'xu);
 dcl SERVICE_STOP                   type DWORD value('0020'xu);
 dcl SERVICE_PAUSE_CONTINUE         type DWORD value('0040'xu);
 dcl SERVICE_INTERROGATE            type DWORD value('0080'xu);
 dcl SERVICE_USER_DEFINED_CONTROL   type DWORD value('0100'xu);

 dcl SERVICE_ALL_ACCESS             type DWORD
     value(ior (STANDARD_RIGHTS_REQUIRED,
                SERVICE_QUERY_CONFIG,
                SERVICE_CHANGE_CONFIG,
                SERVICE_QUERY_STATUS,
                SERVICE_ENUMERATE_DEPENDENTS,
                SERVICE_START,
                SERVICE_STOP,
                SERVICE_PAUSE_CONTINUE,
                SERVICE_INTERROGATE,
                SERVICE_USER_DEFINED_CONTROL));


 /* Info levels for ChangeServiceConfig2 and QueryServiceConfig2 */
 dcl SERVICE_CONFIG_DESCRIPTION     type DWORD value(1);
 dcl SERVICE_CONFIG_FAILURE_ACTIONS type DWORD value(2);

 /* Service description string */
 define structure
   1 SERVICE_DESCRIPTIONA,
     2 lpDescription type LPSTR;
 define alias LPSERVICE_DESCRIPTIONA handle SERVICE_DESCRIPTIONA;

 /* Service description string */
 define structure
   1 SERVICE_DESCRIPTIONW,
     2 lpDescription type LPWSTR;
 define alias LPSERVICE_DESCRIPTIONW handle SERVICE_DESCRIPTIONW;

 %if UNICODE ^= '' %then %do;
 define alias   SERVICE_DESCRIPTION type SERVICE_DESCRIPTIONW;
 define alias LPSERVICE_DESCRIPTION type LPSERVICE_DESCRIPTIONW;
 %end; %else %do;
 define alias   SERVICE_DESCRIPTION type SERVICE_DESCRIPTIONA;
 define alias LPSERVICE_DESCRIPTION type LPSERVICE_DESCRIPTIONA;
 %end; /* UNICODE */

 /* Actions to take on service failure */
 define ordinal
   SC_ACTION_TYPE
     ( SC_ACTION_NONE         value(0),
       SC_ACTION_RESTART      value(1),
       SC_ACTION_REBOOT       value(2),
       SC_ACTION_RUN_COMMAND  value(3)
     ) prec(31);

 define structure
   1 SC_ACTION,
     2 Type  type SC_ACTION_TYPE,
     2 Delay type DWORD;
 define alias LPSC_ACTION handle SC_ACTION;

 define structure
   1 SERVICE_FAILURE_ACTIONSA,
     2 dwResetPeriod type DWORD,
     2 lpRebootMsg   type LPSTR,
     2 lpCommand     type LPSTR,
     2 cActions      type DWORD,
     2 lpsaActions   handle SC_ACTION;
 define alias LPSERVICE_FAILURE_ACTIONSA
        handle SERVICE_FAILURE_ACTIONSA;

 define structure
   1 SERVICE_FAILURE_ACTIONSW,
     2 dwResetPeriod type DWORD,
     2 lpRebootMsg   type LPWSTR,
     2 lpCommand     type LPWSTR,
     2 cActions      type DWORD,
     2 lpsaActions   handle SC_ACTION;

 define alias LPSERVICE_FAILURE_ACTIONSW
        handle SERVICE_FAILURE_ACTIONSW;
 %if UNICODE ^= '' %then %do;
 define alias   SERVICE_FAILURE_ACTIONS type SERVICE_FAILURE_ACTIONSW;
 define alias LPSERVICE_FAILURE_ACTIONS type LPSERVICE_FAILURE_ACTIONSW;
 %end; %else %do;
 define alias   SERVICE_FAILURE_ACTIONS type SERVICE_FAILURE_ACTIONSA;
 define alias LPSERVICE_FAILURE_ACTIONS type LPSERVICE_FAILURE_ACTIONSA;
 %end; /* UNICODE */


 /* Handle Types */

 define alias   SC_HANDLE type HANDLE;
 define alias LPSC_HANDLE pointer; /* to SC_HANDLE */

 define alias SERVICE_STATUS_HANDLE type DWORD;


 /* Info levels for QueryServiceStatusEx */


 define ordinal SC_STATUS_TYPE
   ( SC_STATUS_PROCESS_INFO      value(0)
   ) prec (31);


 /* Info levels for EnumServicesStatusEx */

  define ordinal SC_ENUM_TYPE
    ( SC_ENUM_PROCESS_INFO       value(0)
   ) prec (31);

 /* Service Status Structures */

 define structure
   1 SERVICE_STATUS,
     2 dwServiceType             type DWORD,
     2 dwCurrentState            type DWORD,
     2 dwControlsAccepted        type DWORD,
     2 dwWin32ExitCode           type DWORD,
     2 dwServiceSpecificExitCode type DWORD,
     2 dwCheckPoint              type DWORD,
     2 dwWaitHint                type DWORD;
 define alias LPSERVICE_STATUS handle SERVICE_STATUS;

 define structure
   1 SERVICE_STATUS_PROCESS,
     2 dwServiceType             type DWORD,
     2 dwCurrentState            type DWORD,
     2 dwControlsAccepted        type DWORD,
     2 dwWin32ExitCode           type DWORD,
     2 dwServiceSpecificExitCode type DWORD,
     2 dwCheckPoint              type DWORD,
     2 dwWaitHint                type DWORD,
     2 dwProcessId               type DWORD,
     2 dwServiceFlags            type DWORD;
 define alias LPSERVICE_STATUS_PROCESS handle SERVICE_STATUS_PROCESS;

 /* Service Status Enumeration Structure */

 define structure
   1 ENUM_SERVICE_STATUSA,
     2 lpServiceName type LPSTR,
     2 lpDisplayName type LPSTR,
     2 ServiceStatus type SERVICE_STATUS;
 define alias LPENUM_SERVICE_STATUSA handle ENUM_SERVICE_STATUSA;

 define structure
   1 ENUM_SERVICE_STATUSW,
     2 lpServiceName type LPWSTR,
     2 lpDisplayName type LPWSTR,
     2 ServiceStatus type SERVICE_STATUS;
 define alias LPENUM_SERVICE_STATUSW handle ENUM_SERVICE_STATUSW;

 %if UNICODE ^= '' %then %do;
 define alias   ENUM_SERVICE_STATUS type ENUM_SERVICE_STATUSW;
 define alias LPENUM_SERVICE_STATUS type LPENUM_SERVICE_STATUSW;
 %end; %else %do;
 define alias   ENUM_SERVICE_STATUS type ENUM_SERVICE_STATUSA;
 define alias LPENUM_SERVICE_STATUS type LPENUM_SERVICE_STATUSA;
 %end; /* UNICODE */

 define structure
   1 ENUM_SERVICE_STATUS_PROCESSA,
     2 lpServiceName type LPSTR,
     2 lpDisplayName type LPSTR,
     2 ServiceStatusProcess type SERVICE_STATUS_PROCESS;
 define alias LPENUM_SERVICE_STATUS_PROCESSA
        handle ENUM_SERVICE_STATUS_PROCESSA;

 define structure
   1 ENUM_SERVICE_STATUS_PROCESSW,
     2 lpServiceName type LPWSTR,
     2 lpDisplayName type LPWSTR,
     2 ServiceStatusProcess type SERVICE_STATUS_PROCESS;
 define alias LPENUM_SERVICE_STATUS_PROCESSW
        handle ENUM_SERVICE_STATUS_PROCESSW;

 %if UNICODE ^= '' %then %do;
 define alias   ENUM_SERVICE_STATUS_PROCESS
         type   ENUM_SERVICE_STATUS_PROCESSW;
 define alias LPENUM_SERVICE_STATUS_PROCESS
         type LPENUM_SERVICE_STATUS_PROCESSW;
 %end; %else %do;
 define alias   ENUM_SERVICE_STATUS_PROCESS
         type   ENUM_SERVICE_STATUS_PROCESSA;
 define alias LPENUM_SERVICE_STATUS_PROCESS
         type LPENUM_SERVICE_STATUS_PROCESSA;
 %end; /* UNICODE */


 /* Structures for the Lock API functions */

 define alias SC_LOCK type LPVOID;

 define structure
   1 QUERY_SERVICE_LOCK_STATUSA,
     2 fIsLocked      type DWORD,
     2 lpLockOwner    type LPSTR,
     2 dwLockDuration type DWORD;
 define alias LPQUERY_SERVICE_LOCK_STATUSA
        handle QUERY_SERVICE_LOCK_STATUSA;

 define structure
   1 QUERY_SERVICE_LOCK_STATUSW,
     2 fIsLocked      type DWORD,
     2 lpLockOwner    type LPWSTR,
     2 dwLockDuration type DWORD;
 define alias LPQUERY_SERVICE_LOCK_STATUSW
        handle QUERY_SERVICE_LOCK_STATUSW;

 %if UNICODE ^= '' %then %do;
 define alias QUERY_SERVICE_LOCK_STATUS type QUERY_SERVICE_LOCK_STATUSW;
 define alias LPQUERY_SERVICE_LOCK_STATUS
        type LPQUERY_SERVICE_LOCK_STATUSW;
 %end; %else %do;
 define alias QUERY_SERVICE_LOCK_STATUS type QUERY_SERVICE_LOCK_STATUSA;
 define alias LPQUERY_SERVICE_LOCK_STATUS
        type LPQUERY_SERVICE_LOCK_STATUSA;
 %end; /* UNICODE */


 /* Query Service Configuration Structure */

 define structure
   1 QUERY_SERVICE_CONFIGA,
     2 dwServiceType      type DWORD,
     2 dwStartType        type DWORD,
     2 dwErrorControl     type DWORD,
     2 lpBinaryPathName   type LPSTR,
     2 lpLoadOrderGroup   type LPSTR,
     2 dwTagId            type DWORD,
     2 lpDependencies     type LPSTR,
     2 lpServiceStartName type LPSTR,
     2 lpDisplayName      type LPSTR;
 define alias LPQUERY_SERVICE_CONFIGA handle QUERY_SERVICE_CONFIGA;

 define structure
   1 QUERY_SERVICE_CONFIGW,
     2 dwServiceType      type DWORD,
     2 dwStartType        type DWORD,
     2 dwErrorControl     type DWORD,
     2 lpBinaryPathName   type LPWSTR,
     2 lpLoadOrderGroup   type LPWSTR,
     2 dwTagId            type DWORD,
     2 lpDependencies     type LPWSTR,
     2 lpServiceStartName type LPWSTR,
     2 lpDisplayName      type LPWSTR;
 define alias LPQUERY_SERVICE_CONFIGW handle QUERY_SERVICE_CONFIGW;

 %if UNICODE ^= '' %then %do;
 define alias   QUERY_SERVICE_CONFIG type QUERY_SERVICE_CONFIGW;
 define alias LPQUERY_SERVICE_CONFIG type LPQUERY_SERVICE_CONFIGW;
 %end; %else %do;
 define alias   QUERY_SERVICE_CONFIG type QUERY_SERVICE_CONFIGA;
 define alias LPQUERY_SERVICE_CONFIG type LPQUERY_SERVICE_CONFIGA;
 %end; /* UNICODE */


 /* Function Prototype for the Service Main Function */

 define alias LPSERVICE_MAIN_FUNCTIONW
              entry (type DWORD,
                     type LPWSTR byaddr)
              limited WINAPI;

 define alias LPSERVICE_MAIN_FUNCTIONA
              entry  (type DWORD,
                      type LPSTR byaddr)
              limited WINAPI;

 %if UNICODE ^= '' %then %do;
 define alias LPSERVICE_MAIN_FUNCTION type LPSERVICE_MAIN_FUNCTIONW;
 %end; %else %do;
 define alias LPSERVICE_MAIN_FUNCTION type LPSERVICE_MAIN_FUNCTIONA;
 %end; /*UNICODE */


 /* Service Start Table */

 define structure
   1 SERVICE_TABLE_ENTRYA,
     2 lpServiceName type LPSTR,
     2 lpServiceProc type LPSERVICE_MAIN_FUNCTIONA;
 define alias LPSERVICE_TABLE_ENTRYA handle SERVICE_TABLE_ENTRYA;

 define structure
   1 SERVICE_TABLE_ENTRYW,
     2 lpServiceName type LPWSTR,
     2 lpServiceProc type LPSERVICE_MAIN_FUNCTIONW;
 define alias LPSERVICE_TABLE_ENTRYW handle SERVICE_TABLE_ENTRYW;

 %if UNICODE ^= '' %then %do;
 define alias   SERVICE_TABLE_ENTRY type SERVICE_TABLE_ENTRYW;
 define alias LPSERVICE_TABLE_ENTRY type LPSERVICE_TABLE_ENTRYW;
 %end; %else %do;
 define alias   SERVICE_TABLE_ENTRY type SERVICE_TABLE_ENTRYA;
 define alias LPSERVICE_TABLE_ENTRY type LPSERVICE_TABLE_ENTRYA;
 %end; /* UNICODE */

 /* Prototype for the Service Control Handler Function */

 define alias LPHANDLER_FUNCTION
              entry (type DWORD)
              limited WINAPI;

 define alias LPHANDLER_FUNCTION_EX
              entry (type DWORD,
                     type DWORD,
                     type LPVOID,
                     type LPVOID)
              returns (type DWORD byvalue optional)
              limited WINAPI;


 /*********************************************************************/
 /* API Function Prototypes                                           */
 /*********************************************************************/

 dcl ChangeServiceConfigA
     entry (type SC_HANDLE,
            type DWORD,
            type DWORD,
            type DWORD,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type DWORD byaddr,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn)
      returns (type BOOL byvalue optional)
      WINADVAPI WINAPI ext('ChangeServiceConfigA');

 dcl ChangeServiceConfigW
     entry (type SC_HANDLE,
            type DWORD,
            type DWORD,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD byaddr,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('ChangeServiceConfigW');

 %dcl ChangeServiceConfig char ext;
 %if UNICODE ^= '' %then %do;
   %ChangeServiceConfig='ChangeServiceConfigW';
 %end; %else %do;
   %ChangeServiceConfig='ChangeServiceConfigA';
 %end; /* !UNICODE */

 dcl ChangeServiceConfig2A
     entry (type SC_HANDLE,
            type DWORD,
            type LPVOID)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('ChangeServiceConfig2A');

 dcl ChangeServiceConfig2W
     entry (type SC_HANDLE,
            type DWORD,
            type LPVOID)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('ChangeServiceConfig2W');

 %dcl ChangeServiceConfig2 char ext;
 %if UNICODE ^= '' %then %do;
   %ChangeServiceConfig2='ChangeServiceConfig2W';
 %end; %else %do;
   %ChangeServiceConfig2='ChangeServiceConfig2A';
 %end; /* !UNICODE */

 dcl CloseServiceHandle
     entry (type SC_HANDLE)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('CloseServiceHandle');

 dcl ControlService
     entry (type SC_HANDLE,
            type DWORD,
            type SERVICE_STATUS byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('ControlService');

 dcl CreateServiceA
     entry (type SC_HANDLE,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type DWORD byaddr,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn)
     returns (type SC_HANDLE byvalue optional)
     WINADVAPI WINAPI ext('CreateServiceA');

 dcl CreateServiceW
     entry (type SC_HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD byaddr,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn)
     returns (type SC_HANDLE byvalue optional)
     WINADVAPI WINAPI ext('CreateServiceW');

 %dcl CreateService char ext;
 %if UNICODE ^= '' %then %do;
   %CreateService='CreateServiceW';
 %end; %else %do;
   %CreateService='CreateServiceA';
 %end; /* !UNICODE */

 dcl DeleteService
     entry (type SC_HANDLE)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('DeleteService');

 dcl EnumDependentServicesA
     entry (type SC_HANDLE,
            type DWORD,
            type ENUM_SERVICE_STATUSA byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('EnumDependentServicesA');

 dcl EnumDependentServicesW
     entry (type SC_HANDLE,
            type DWORD,
            type ENUM_SERVICE_STATUSW byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('EnumDependentServicesW');

 %dcl EnumDependentServices char ext;
 %if UNICODE ^= '' %then %do;
   %EnumDependentServices='EnumDependentServicesW';
 %end; %else %do;
   %EnumDependentServices='EnumDependentServicesA';
 %end; /* !UNICODE */

 dcl EnumServicesStatusA
     entry (type SC_HANDLE,
            type DWORD,
            type DWORD,
            type ENUM_SERVICE_STATUSA byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('EnumServicesStatusA');

 dcl EnumServicesStatusW
     entry (type SC_HANDLE,
            type DWORD,
            type DWORD,
            type ENUM_SERVICE_STATUSW byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('EnumServicesStatusW');

 %dcl EnumServicesStatus char ext;
 %if UNICODE ^= '' %then %do;
   %EnumServicesStatus='EnumServicesStatusW';
 %end; %else %do;
   %EnumServicesStatus='EnumServicesStatusA';
 %end; /* !UNICODE */

 dcl EnumServicesStatusExA
     entry (type SC_HANDLE,
            type SC_ENUM_TYPE,
            type DWORD,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            char (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('EnumServicesStatusExA');

 dcl EnumServicesStatusExW
     entry (type SC_HANDLE,
            type SC_ENUM_TYPE,
            type DWORD,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr,
            WCHAR (*) varz byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('EnumServicesStatusExW');

 %dcl EnumServicesStatusEx char ext;
 %if UNICODE ^= '' %then %do;
   %EnumServicesStatusEx='EnumServicesStatusExW';
 %end; %else %do;
   %EnumServicesStatusEx='EnumServicesStatusExA';
 %end; /* !UNICODE */

 dcl GetServiceKeyNameA
     entry (type SC_HANDLE,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('GetServiceKeyNameA');

 dcl GetServiceKeyNameW
     entry (type SC_HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('GetServiceKeyNameW');

 %dcl GetServiceKeyName char ext;
 %if UNICODE ^= '' %then %do;
   %GetServiceKeyName='GetServiceKeyNameW';
 %end; %else %do;
   %GetServiceKeyName='GetServiceKeyNameA';
 %end; /* !UNICODE */

 dcl GetServiceDisplayNameA
     entry (type SC_HANDLE,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('GetServiceDisplayNameA');

 dcl GetServiceDisplayNameW
     entry (type SC_HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('GetServiceDisplayNamew');

 %dcl GetServiceDisplayName char ext;
 %if UNICODE ^= '' %then %do;
   %GetServiceDisplayName='GetServiceDisplayNameW';
 %end; %else %do;
   %GetServiceDisplayName='GetServiceDisplayNameA';
 %end;/* !UNICODE */

 dcl LockServiceDatabase
     entry (type SC_HANDLE)
     returns (type SC_LOCK byvalue optional)
     WINADVAPI WINAPI ext('LockServiceDatabase');

 dcl NotifyBootConfigStatus
     entry (type BOOL)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('NotifyBootConfigStatus');

 dcl OpenSCManagerA
     entry (char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type SC_HANDLE byvalue optional)
     WINADVAPI WINAPI ext('OpenSCManagerA');

 dcl OpenSCManagerW
     entry (WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type SC_HANDLE byvalue optional)
     WINADVAPI WINAPI ext('OpenSCManagerW');

 %dcl OpenSCManager char ext;
 %if UNICODE ^= '' %then %do;
   %OpenSCManager='OpenSCManagerW';
 %end; %else %do;
   %OpenSCManager='OpenSCManagerA';
 %end; /* !UNICODE */

 dcl OpenServiceA
     entry (type SC_HANDLE,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type SC_HANDLE byvalue optional)
     WINADVAPI WINAPI ext('OpenServiceA');

 dcl OpenServiceW
     entry (type SC_HANDLE,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type SC_HANDLE byvalue optional)
     WINADVAPI WINAPI ext('OpenServiceW');

 %dcl OpenService char ext;
 %if UNICODE ^= '' %then %do;
   %OpenService='OpenServiceW';
 %end; %else %do;
   %OpenService='OpenServiceA';
 %end; /* !UNICODE */

 dcl QueryServiceConfigA
     entry (type SC_HANDLE,
            type QUERY_SERVICE_CONFIGA byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('QueryServiceConfigA');

 dcl QueryServiceConfigW
     entry (type SC_HANDLE,
            type QUERY_SERVICE_CONFIGW byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('QueryServiceConfigW');

 %dcl QueryServiceConfig char ext;
 %if UNICODE ^= '' %then %do;
   %QueryServiceConfig='QueryServiceConfigW';
 %end; %else %do;
   %QueryServiceConfig='QueryServiceConfigA';
 %end; /* !UNICODE */

 dcl QueryServiceConfig2A
     entry (type SC_HANDLE,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('QueryServiceConfig2A');

 dcl QueryServiceConfig2W
     entry (type SC_HANDLE,
            type DWORD,
            type LPBYTE,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('QueryServiceConfig2W');

 %dcl QueryServiceConfig2 char ext;
 %if UNICODE ^= '' %then %do;
   %QueryServiceConfig2='QueryServiceConfig2W';
 %end; %else %do;
   %QueryServiceConfig2='QueryServiceConfig2A';
 %end; /* !UNICODE */

 dcl QueryServiceLockStatusA
     entry (type SC_HANDLE,
            type QUERY_SERVICE_LOCK_STATUSA byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('QueryServiceLockStatusA');

 dcl QueryServiceLockStatusW
     entry (type SC_HANDLE,
            type QUERY_SERVICE_LOCK_STATUSW byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('QueryServiceLockStatusW');

 %dcl QueryServiceLockStatus char ext;
 %if UNICODE ^= '' %then %do;
   %QueryServiceLockStatus='QueryServiceLockStatusW';
 %end; %else %do;
   %QueryServiceLockStatus='QueryServiceLockStatusA';
 %end; /* !UNICODE */

 dcl QueryServiceObjectSecurity
     entry (type SC_HANDLE,
            type SECURITY_INFORMATION,
            type PSECURITY_DESCRIPTOR,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('QueryServiceObjectSecurity');

 dcl QueryServiceStatus
     entry (type SC_HANDLE,
            type SERVICE_STATUS byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('QueryServiceStatus');

 dcl RegisterServiceCtrlHandlerA
     entry (char(*) varz byaddr nonasgn,
            type LPHANDLER_FUNCTION)
     returns (type SERVICE_STATUS_HANDLE byvalue optional)
     WINADVAPI WINAPI ext('RegisterServiceCtrlHandlerA');

 dcl RegisterServiceCtrlHandlerW
     entry (WCHAR(*) varz byaddr nonasgn,
            type LPHANDLER_FUNCTION)
     returns (type SERVICE_STATUS_HANDLE byvalue optional)
     WINADVAPI WINAPI ext('RegisterServiceCtrlHandlerW');

 %dcl RegisterServiceCtrlHandler char ext;
 %if UNICODE ^= '' %then %do;
   %RegisterServiceCtrlHandler='RegisterServiceCtrlHandlerW';
 %end; %else %do;
   %RegisterServiceCtrlHandler='RegisterServiceCtrlHandlerA';
 %end; /* !UNICODE */

 dcl RegisterServiceCtrlHandlerExA
     entry (char(*) varz byaddr nonasgn,
            type LPHANDLER_FUNCTION_EX,
            type LPVOID)
     returns (type SERVICE_STATUS_HANDLE byvalue optional)
     WINADVAPI WINAPI ext('RegisterServiceCtrlHandlerExA');

 dcl RegisterServiceCtrlHandlerExW
     entry (WCHAR(*) varz byaddr nonasgn,
            type LPHANDLER_FUNCTION_EX,
            type LPVOID)
     returns (type SERVICE_STATUS_HANDLE byvalue optional)
     WINADVAPI WINAPI ext('RegisterServiceCtrlHandlerExW');

 %dcl RegisterServiceCtrlHandlerEx char ext;
 %if UNICODE ^= '' %then %do;
   %RegisterServiceCtrlHandlerEx='RegisterServiceCtrlHandlerExW';
 %end; %else %do;
   %RegisterServiceCtrlHandlerEx='RegisterServiceCtrlHandlerExA';
 %end; /* !UNICODE */

 dcl SetServiceObjectSecurity
     entry (type SC_HANDLE,
            type SECURITY_INFORMATION,
            type PSECURITY_DESCRIPTOR)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('SetServiceObjectSecurity');

 dcl SetServiceStatus
     entry (type SERVICE_STATUS_HANDLE,
            type SERVICE_STATUS byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('SetServiceStatus');

 dcl StartServiceCtrlDispatcherA
     entry (type SERVICE_TABLE_ENTRYA byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('StartServiceCtrlDispatcherA');

 dcl StartServiceCtrlDispatcherW
     entry (type SERVICE_TABLE_ENTRYW byaddr nonasgn)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('StartServiceCtrlDispatcherW');

 %dcl StartServiceCtrlDispatcher char ext;
 %if UNICODE ^= '' %then %do;
   %StartServiceCtrlDispatcher='StartServiceCtrlDispatcherW';
 %end; %else %do;
   %StartServiceCtrlDispatcher='StartServiceCtrlDispatcherA';
 %end; /* !UNICODE */


 dcl StartServiceA
     entry (type SC_HANDLE,
            type DWORD,
            type LPCSTR byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('StartServiceA');

 dcl StartServiceW
     entry (type SC_HANDLE,
            type DWORD,
            type LPCWSTR byaddr)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('StartServiceW');

 %dcl StartService char ext;
 %if UNICODE ^= '' %then %do;
   %StartService='StartServiceW';
 %end; %else %do;
   %StartService='StartServiceA';
 %end; /* !UNICODE */

 dcl UnlockServiceDatabase
     entry (type SC_LOCK)
     returns (type BOOL byvalue optional)
     WINADVAPI WINAPI ext('UnlockServiceDatabase');

 %end; /* #WINSVC_ */
