 /* $XConsortium: Xutil.h,v 11.73 91/07/30 16:21:37 rws Exp $         */
 /*********************************************************************/
 /* Copyright 1987 by Digital Equipment Corporation, Maynard,         */
 /* Massachusetts, and the Massachusetts Institute of Technology,     */
 /* Cambridge, Massachusetts.                                         */
 /*                                                                   */
 /*                       All Rights Reserved                         */
 /*                                                                   */
 /* Permission to use, copy, modify, and distribute this software and */
 /* its documentation for any purpose and without fee is hereby       */
 /* granted, provided that the above copyright notice appear in all   */
 /* copies and that both that copyright notice and this permission    */
 /* notice appear in supporting documentation, and that the names of  */
 /* Digital or MIT not be used in advertising or publicity pertaining */
 /* to distribution of the software without specific, written prior   */
 /* permission.                                                       */
 /*                                                                   */
 /* DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,    */
 /* INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,  */
 /* IN NO EVENT SHALL DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR  */
 /* CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM    */
 /* LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,   */
 /* NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN         */
 /* CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.          */
 /*********************************************************************/

 %dcl #XUTIL_H_ char ext;
 %if #XUTIL_H_ = '' %then %do;
 %#XUTIL_H_ = 'Y';

 /* You must include X11\Xlib.cpy before including this file */
 /* PL/I: and keysym.cpy                                     */

 /* Bitmask returned by XParseGeometry(). Each bit tells if the       */
 /* corresponding value (x, y, width, height) was found in the parsed */
 /* string.                                                           */

 dcl NoValue     fixed bin(31) value('0000'xn);
 dcl XValue      fixed bin(31) value('0001'xn);
 dcl YValue      fixed bin(31) value('0002'xn);
 dcl WidthValue  fixed bin(31) value('0004'xn);
 dcl HeightValue fixed bin(31) value('0008'xn);
 dcl AllValues   fixed bin(31) value('000F'xn);
 dcl XNegative   fixed bin(31) value('0010'xn);
 dcl YNegative   fixed bin(31) value('0020'xn);

 /* new version containing base_width, base_height, and win_gravity   */
 /* fields, used with WM_NORMAL_HINTS.                                */

 define structure
   1 XSizeHints,
     2 flags  fixed bin(31),
             /* marks which fields in this structure are defined */
     2 (x, y) fixed bin(31),
             /* obsolete for new window mgrs, but clients */
     2 (width, height) fixed bin(31),
             /* should set so old wm's don't mess up */
     2 (min_width, min_height) fixed bin(31),
     2 (max_width, max_height) fixed bin(31),
     2 (width_inc, height_inc) fixed bin(31),
     2 min_aspect,
       3 x fixed bin(31),/* numerator */
       3 y fixed bin(31),/* denominator */
     2 max_aspect,
       3 x fixed bin(31),/* numerator */
       3 y fixed bin(31),/* denominator */
     2 (base_width, base_height) fixed bin(31),
             /* added by ICCCM version 1 */
     2 win_gravity fixed bin(31); /* added by ICCCM version 1 */


 /* The next block of definitions are for window manager properties   */
 /* that clients and applications use for communication.              */

 /* flags argument in size hints */

 dcl USPosition  fixed bin (31) value (raise2(1,0));
     /* user specified x, y */
 dcl USSize      fixed bin (31) value (raise2(1,1));
     /* user specified width, height */
 dcl PPosition   fixed bin (31) value (raise2(1,2));
     /* program specified position */
 dcl PSize       fixed bin (31) value (raise2(1,3));
     /* program specified size */
 dcl PMinSize    fixed bin (31) value (raise2(1,4));
     /* program specified minimum size */
 dcl PMaxSize    fixed bin (31) value (raise2(1,5));
     /* program specified maximum size */
 dcl PResizeInc  fixed bin (31) value (raise2(1,6));
     /* program specified resize increments */
 dcl PAspect     fixed bin (31) value (raise2(1,7));
     /* program specified min and max aspect ratios */
 dcl PBaseSize   fixed bin (31) value (raise2(1,8));
     /* program specified base for incrementing */
 dcl PWinGravity fixed bin (31) value (raise2(1,9));
     /* program specified window gravity */

 /* obsolete */
 dcl PAllHints fixed bin (31)
     value (ior (PPosition, PSize, PMinSize,
                 PMaxSize, PResizeInc, PAspect));


 define structure
   1 XWMHints,
     2 flags fixed bin(31), /* marks which fields in this structure */
                            /* are defined */
     2 input fixed bin(31), /* does this application rely on the */
                            /* window manager to get keyboard input? */
     2 initial_state fixed bin(31),   /* see below */
     2 icon_pixmap   type Pixmap,     /* pixmap to be used as icon */
     2 icon_window   type Window,     /* window to be used as icon */
     2 (icon_x, icon_y) fixed bin(31),/* initial position of icon */
     2 icon_mask     type Pixmap,     /* icon mask bitmap */
     2 window_group  type XID;        /* id of related window group */
    /* this structure may be extended in the future */


 /* definition for flags of XWMHints */

 dcl InputHint        fixed bin (31) value (raise2(1,0));
 dcl StateHint        fixed bin (31) value (raise2(1,1));
 dcl IconPixmapHint   fixed bin (31) value (raise2(1,2));
 dcl IconWindowHint   fixed bin (31) value (raise2(1,3));
 dcl IconPositionHint fixed bin (31) value (raise2(1,4));
 dcl IconMaskHint     fixed bin (31) value (raise2(1,5));
 dcl WindowGroupHint  fixed bin (31) value (raise2(1,6));
 dcl AllHints         fixed bin (31)
     value (ior (InputHint, StateHint, IconPixmapHint, IconWindowHint,
                 IconPositionHint, IconMaskHint, WindowGroupHint));

 /* definitions for initial window state */
 dcl WithdrawnState fixed bin(31) value(0);
     /* for windows that are not mapped */
 dcl NormalState    fixed bin(31) value(1);
     /* most applications want to start this way */
 dcl IconicState    fixed bin(31) value(3);
     /* application wants to start as an icon */

 /* Obsolete states no longer defined by ICCCM */
 dcl DontCareState fixed bin(31) value(0); /* don't know or care */
 dcl ZoomState     fixed bin(31) value(2);
     /* application wants to start zoomed */
 dcl InactiveState fixed bin(31) value(4);
     /* application believes it is seldom used; */
     /* some wm's may put it on inactive menu */


 /* new structure for manipulating TEXT properties; used with         */
 /* WM_NAME, WM_ICON_NAME, WM_CLIENT_MACHINE, and WM_COMMAND.         */
 define structure
   1 XTextProperty,
     2 value    pointer,   /* same as Property routines, char(*) varz */
     2 encoding type XAtom,   /* prop type */
     2 format   fixed bin(31),/* prop data format: 8, 16, or 32 */
     2 nitems   fixed bin(31);/* number of data items in value*/


 dcl XNoMemory           fixed bin (31) value (-1);
 dcl XLocaleNotSupported fixed bin (31) value (-2);
 dcl XConverterNotFound  fixed bin (31) value (-3);

 define ordinal XICCEncodingStyle
   ( XStringStyle,       /* STRING */
     XCompoundTextStyle, /* COMPOUND_TEXT */
     XTextStyle,         /* text in owner's encoding (current locale)*/
     XStdICCTextStyle)   /* STRING, else COMPOUND_TEXT */
   prec(31);

 define structure
   1 XIconSize,
     2 (min_width, min_height) fixed bin(31),
     2 (max_width, max_height) fixed bin(31),
     2 (width_inc, height_inc) fixed bin(31);

 define structure
   1 XClassHint,
     2 res_name  pointer, /* to char (*) varz */
     2 res_class pointer; /* to char (*) varz */


 /* These routines are used to give some sugar to the image routines  */
 /* so that naive people are more comfortable with them.              */
 /* (The scarcastic "naive" is because the PL/I syntax is horrible.)  */

 XDestroyImage: proc (ximage)
                options (inline reorder) internal;
   dcl ximage handle XImage byvalue;
   call ximage => funcs.destroy_image (ximage);
 end XDestroyImage;

 XGetPixel: proc (ximage, x, y)
            returns (fixed bin (31) byvalue)
            options (inline reorder) internal;
   dcl ximage handle XImage byvalue,
       (x, y) fixed bin (31) byvalue;
   return (ximage => funcs.get_pixel (ximage, x, y));
 end XGetPixel;

 XPutPixel: proc (ximage, x, y, pixel)
            returns (fixed bin (31) byvalue)
            options (inline reorder) internal;
   dcl ximage handle XImage,
       (x, y) fixed bin (31),
       pixel  fixed bin (31);
   return (ximage => funcs.put_pixel (ximage, x, y, pixel));
 end XPutPixel;

 XSubImage: proc (ximage, x, y, width, height)
            returns (handle XImage byvalue)
            options (inline reorder) internal;
   dcl ximage handle XImage byvalue,
       (x, y) fixed bin (31) byvalue,
       (width, height) fixed bin (31) byvalue;
   return (ximage => funcs.sub_image (ximage, x, y, width, height));
 end XSubImage;

 XAddPixel: proc (ximage, value)
            returns (fixed bin (31) byvalue)
            options (inline reorder) internal;
   dcl ximage handle XImage byvalue,
       value  fixed bin (31) byvalue;
   return (ximage => funcs.add_pixel (ximage, value));
 end XAddPixel;


 /* Compose sequence status structure, used in calling XLookupString. */
 define structure
   1 _XComposeStatus,
     2 compose_ptr   type XPointer,/* state table pointer */
     2 chars_matched fixed bin(31);/* match state */

 define alias XComposeStatus type _XComposeStatus;

 /* Keysym macros, used on Keysyms to test for classes of symbols */

 IsKeypadKey: proc (keysym) returns (bit (1) aligned byvalue)
              options (inline reorder) internal;
   dcl keysym fixed bin (31) byvalue;
   return (keysym >= XK_KP_Space & keysym <= XK_KP_Equal);
 end IsKeypadKey;

 IsCursorKey: proc (keysym)
              returns (bit (1) aligned byvalue)
              options (inline reorder) internal;
   dcl keysym fixed bin (31) byvalue;
   return (keysym >= XK_Home & keysym < XK_Select);
 end IsCursorKey;

 IsPFKey: proc (keysym)
          returns (bit (1) aligned byvalue)
          options (inline reorder) internal;
   dcl keysym fixed bin (31) byvalue;
   return (keysym >= XK_KP_F1 & keysym <= XK_KP_F4);
 end IsPFKey;

 IsFunctionKey: proc (keysym)
                returns (bit (1) aligned byvalue)
                options (inline reorder) internal;
   dcl keysym fixed bin (31) byvalue;
   return (keysym >= XK_F1 & keysym <= XK_F35);
 end IsFunctionKey;

 IsMiscFunctionKey: proc (keysym)
                    returns (bit (1) aligned byvalue)
                    options (inline reorder) internal;
   dcl keysym fixed bin (31) byvalue;
   return (keysym >= XK_Select & keysym <= XK_Break);
 end IsMiscFunctionKey;

 IsModifierKey: proc (keysym)
                returns (bit (1) aligned byvalue)
                options (inline reorder) internal;
   dcl keysym fixed bin (31);
   return (  keysym >= XK_Shift_L & keysym <= XK_Hyper_R
           | keysym = XK_Mode_switch
           | keysym =  XK_Num_Lock);
 end IsModifierKey;


 /* opaque reference to Region data type */
 define alias Region pointer;

 /* Return values from XRectInRegion() */
 dcl RectangleOut  fixed bin(31) value(0);
 dcl RectangleIn   fixed bin(31) value(1);
 dcl RectanglePart fixed bin(31) value(2);


 /* Information used by the visual utility routines to find desired   */
 /* visual type from the many visuals a display may support.          */

 define structure
   1 XVisualInfo,
     2 visual        handle Visual,
     2 visualid      type VisualID,
     2 screen        fixed bin(31),
     2 depth         fixed bin(31),
     2 c_class       fixed bin(31), /* C++ */
     2 red_mask      fixed bin(31),
     2 green_mask    fixed bin(31),
     2 blue_mask     fixed bin(31),
     2 colormap_size fixed bin(31),
     2 bits_per_rgb  fixed bin(31);

 dcl VisualNoMask           fixed bin(31) value('0'xn);
 dcl VisualIDMask           fixed bin(31) value('1'xn);
 dcl VisualScreenMask       fixed bin(31) value('2'xn);
 dcl VisualDepthMask        fixed bin(31) value('4'xn);
 dcl VisualClassMask        fixed bin(31) value('8'xn);
 dcl VisualRedMaskMask      fixed bin(31) value('10'xn);
 dcl VisualGreenMaskMask    fixed bin(31) value('20'xn);
 dcl VisualBlueMaskMask     fixed bin(31) value('40'xn);
 dcl VisualColormapSizeMask fixed bin(31) value('80'xn);
 dcl VisualBitsPerRGBMask   fixed bin(31) value('100'xn);
 dcl VisualAllMask          fixed bin(31) value('1FF'xn);

 /* This defines a window manager property that clients may use to    */
 /* share standard color maps of type RGB_COLOR_MAP:                  */
 define structure
   1 XStandardColormap,
     2 colormap   type XColormap,
     2 red_max    fixed bin(31) ,
     2 red_mult   fixed bin(31) ,
     2 green_max  fixed bin(31) ,
     2 green_mult fixed bin(31) ,
     2 blue_max   fixed bin(31) ,
     2 blue_mult  fixed bin(31) ,
     2 base_pixel fixed bin(31) ,
     2 visualid   type VisualID,/* added by ICCCM version 1 */
     2 killid     type XID;/* added by ICCCM version 1 */

 dcl ReleaseByFreeingColormap type XID value(1);
     /* for killid field above */

 /* return codes for XReadBitmapFile and XWriteBitmapFile */
 dcl BitmapSuccess     fixed bin(31) value(0);
 dcl BitmapOpenFailed  fixed bin(31) value(1);
 dcl BitmapFileInvalid fixed bin(31) value(2);
 dcl BitmapNoMemory    fixed bin(31) value(3);

 /*********************************************************************/
 /*                                                                   */
 /* Context Management                                                */
 /*                                                                   */
 /*********************************************************************/


 /* Associative lookup table return codes */

 dcl XCSUCCESS fixed bin(31) value(0); /* No error. */
 dcl XCNOMEM   fixed bin(31) value(1); /* Out of memory */
 dcl XCNOENT   fixed bin(31) value(2); /* No entry in table */

 define alias XContext fixed bin(31);

 /* following two macros make no sense as rhs non-existent */
 %dcl XUniqueContext   char ext; %XUniqueContext   = 'XrmUniqueQuark';
 %dcl XStringToContext char ext; %XStringToContext = 'XrmStringToQuark';


 /* The following declarations are alphabetized. */

 dcl XAllocClassHint
     entry ()
     returns (handle XClassHint byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XAllocClassHint');

 dcl XAllocIconSize
     entry ()
     returns (handle XIconSize byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XAllocIconSize');

 dcl XAllocSizeHints
     entry ()
     returns (handle XSizeHints byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XAllocSizeHints');

 dcl XAllocStandardColormap
     entry ()
     returns (handle XStandardColormap byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XAllocStandardColormap');

 dcl XAllocWMHints
     entry ()
     returns (handle XWMHints byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XAllocWMHints');

 dcl XClipBox
     entry (type Region                     /* r */,
            type XRectangle byaddr)         /* rect_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XClipBox');

 dcl XCreateRegion
     entry ()
     returns (byvalue type Region)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreateRegion');

 dcl XDefaultString
     entry ()
     returns (pointer byvalue)       /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultString');

 dcl XDeleteContext
     entry (handle Display                  /* display */,
            type XID                        /* rid */,
            type XContext)                  /* context */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDeleteContext');

 dcl XDestroyRegion
     entry (type Region)                    /* r */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDestroyRegion');

 dcl XEmptyRegion
     entry (type Region)                    /* r */
     options (byvalue nodescriptor linkage(cdecl))
     external('XEmptyRegion');

 dcl XEqualRegion
     entry (type Region                     /* r1 */,
            type Region)                    /* r2 */
     options (byvalue nodescriptor linkage(cdecl))
     external('XEqualRegion');

 dcl XFindContext
     entry (handle Display                  /* display */,
            type XID                        /* rid */,
            type XContext                   /* context */,
            type XPointer byaddr)           /* data_return */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XFindContext');

 dcl XGetClassHint
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            handle Display)                 /* class_hints_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetClassHint');

 dcl XGetIconSizes
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            (*) handle XIconSize byaddr     /* size_list_return */,
            fixed bin (31) byaddr)          /* count_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetIconSizes');

 dcl XGetNormalHints
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XSizeHints byaddr)         /* hints_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetNormalHints');

 dcl XGetRGBColormaps
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            (*) handle XStandardColormap byaddr /* stdcmap_return */,
            fixed bin (31) byaddr           /* count_return */,
            type XAtom)                     /* property */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetRGBColormaps');

 dcl XGetSizeHints
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XSizeHints byaddr          /* hints_return */,
            type XAtom)                     /* property */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetSizeHints');

 dcl XGetStandardColormap
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XStandardColormap byaddr   /* colormap_return */,
            type XAtom)                     /* property */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetStandardColormap');

 dcl XGetTextProperty
     entry (handle Display                  /* display */,
            type Window                     /* window */,
            type XTextProperty byaddr       /* text_prop_return */,
            type XAtom)                     /* property */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetTextProperty');

 dcl XGetVisualInfo
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* vinfo_mask */,
            type XVisualInfo byaddr         /* vinfo_template */,
            fixed bin (31) byaddr)          /* nitems_return */
     returns (handle XVisualInfo byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetVisualInfo');

 dcl XGetWMClientMachine
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XTextProperty byaddr)      /* text_prop_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetWMClientMachine');

 dcl XGetWMHints
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     returns (handle XWMHints byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetWMHints');

 dcl XGetWMIconName
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XTextProperty byaddr)      /* text_prop_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetWMIconName');

 dcl XGetWMName
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XTextProperty byaddr)      /* text_prop_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetWMName');

 dcl XGetWMNormalHints
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XSizeHints byaddr          /* hints_return */,
            fixed bin (31) byaddr)          /* supplied_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetWMNormalHints');

 dcl XGetWMSizeHints
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XSizeHints byaddr          /* hints_return */,
            fixed bin (31) byaddr           /* supplied_return */,
            type XAtom)                     /* property */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetWMSizeHints');

 dcl XGetZoomHints
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XSizeHints byaddr)         /* zhints_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetZoomHints');

 dcl XIntersectRegion
     entry (type Region                     /* sra */,
            type Region                     /* srb */,
            type Region)                    /* dr_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XIntersectRegion');

 dcl XLookupString
     entry (handle XKeyEvent                /* event_struct */,
            char (*) varz byaddr            /* buffer_return */,
            fixed bin(31)                   /* bytes_buffer */,
            type KeySym byaddr              /* keysym_return */,
            type XComposeStatus byaddr)     /* status_in_out */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XLookupString');

 dcl XMatchVisualInfo
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* screen */,
            fixed bin(31)                   /* depth */,
            fixed bin(31)                   /* class */,
            type XVisualInfo byaddr)        /* vinfo_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XMatchVisualInfo');

 dcl XOffsetRegion
     entry (type Region                     /* r */,
            fixed bin(31)                   /* dx */,
            fixed bin(31))                  /* dy */
     options (byvalue nodescriptor linkage(cdecl))
     external('XOffsetRegion');

 dcl XPointInRegion
     entry (type Region                     /* r */,
            fixed bin(31)                   /* x */,
            fixed bin(31))                  /* y */
     returns (byvalue optional fixed bin (31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XPointInRegion');

 dcl XPolygonRegion
     entry ((*) type XPoint byaddr          /* points */,
            fixed bin(31)                   /* n */,
            fixed bin(31))                  /* fill_rule */
     returns (byvalue optional type Region)
     options (byvalue nodescriptor linkage(cdecl))
     external('XPolygonRegion');

 dcl XRectInRegion
     entry (type Region                     /* r */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            fixed bin(31)                   /* width */,
            fixed bin(31))                  /* height */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XRectInRegion');

 dcl XSaveContext
     entry (handle Display                  /* display */,
            type XID                        /* rid */,
            type XContext                   /* context */,
            char (*) varz byaddr nonasgn)   /* data */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XSaveContext');

 dcl XSetClassHint
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XClassHint byaddr)         /* class_hints */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetClassHint');

 dcl XSetIconSizes
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            (*) type XIconSize byaddr       /* size_list */,
            fixed bin(31))                  /* count */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetIconSizes');

 dcl XSetNormalHints
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            (*) type XSizeHints byaddr)     /* hints */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetNormalHints');

 dcl XSetRGBColormaps
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            (*) type XStandardColormap byaddr /* stdcmaps */,
            fixed bin(31)                   /* count */,
            type XAtom)                     /* property */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetRGBColormaps');

 dcl XSetSizeHints
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XSizeHints byaddr          /* hints */,
            type XAtom)                     /* property */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetSizeHints');

 dcl XSetStandardProperties
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            char (*) varz byaddr nonasgn    /* window_name */,
            char (*) varz byaddr nonasgn    /* icon_name */,
            type Pixmap                     /* icon_pixmap */,
            (*) pointer byaddr              /* argv, to char (*) varz*/,
            fixed bin(31)                   /* argc */,
            type XSizeHints byaddr)         /* hints */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetStandardProperties');

 dcl XSetTextProperty
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XTextProperty byaddr       /* text_prop */,
            type XAtom)                     /* property */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetTextProperty');

 dcl XSetWMClientMachine
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XTextProperty byaddr)      /* text_prop */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWMClientMachine');

 dcl XSetWMHints
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XWMHints byaddr)           /* wm_hints */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWMHints');

 dcl XSetWMIconName
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XTextProperty byaddr)      /* text_prop */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWMIconName');

 dcl XSetWMName
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XTextProperty byaddr)      /* text_prop */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWMName');

 dcl XSetWMNormalHints
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XSizeHints byaddr)         /* hints */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWMNormalHints');

 dcl XSetWMProperties
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XTextProperty byaddr       /* window_name */,
            type XTextProperty byaddr       /* icon_name */,
            (*) pointer byaddr              /* argv, to char (*) varz*/,
            fixed bin(31)                   /* argc */,
            type XSizeHints byaddr          /* normal_hints */,
            type XWMHints byaddr            /* wm_hints */,
            type XClassHint byaddr)         /* class_hints */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWMProperties');

 dcl XmbSetWMProperties
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            char (*) varz byaddr nonasgn    /* window_name */,
            char (*) varz byaddr nonasgn    /* icon_name */,
            (*) pointer byaddr              /* argv, to char (*) varz*/,
            fixed bin(31)                   /* argc */,
            type XSizeHints byaddr          /* normal_hints */,
            type XWMHints byaddr            /* wm_hints */,
            type XClassHint byaddr)         /* class_hints */
     options (byvalue nodescriptor linkage(cdecl))
     external('XmbSetWMProperties');

 dcl XSetWMSizeHints
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XSizeHints byaddr          /* hints */,
            type XAtom)                     /* property */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWMSizeHints');

 dcl XSetRegion
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            type Region)                    /* r */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetRegion');

 dcl XSetStandardColormap
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XStandardColormap byaddr   /* colormap */,
            type XAtom)                     /* property */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetStandardColormap');

 dcl XSetZoomHints
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XSizeHints byaddr)         /* zhints */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetZoomHints');

 dcl XShrinkRegion
     entry (type Region                     /* r */,
            fixed bin(31)                   /* dx */,
            fixed bin(31))                  /* dy */
     options (byvalue nodescriptor linkage(cdecl))
     external('XShrinkRegion');

 dcl XStringListToTextProperty
     entry ((*) pointer byaddr              /* list, to char (*) varz*/,
            fixed bin(31)                   /* count */,
            type XTextProperty byaddr)      /* text_prop_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XStringListToTextProperty');

 dcl XSubtractRegion
     entry (type Region                     /* sra */,
            type Region                     /* srb */,
            type Region)                    /* dr_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSubtractRegion');

 dcl XmbTextListToTextProperty
     entry (handle Display                  /* display */,
            (*) pointer byaddr              /* list, to char (*) varz*/,
            fixed bin(31)                   /* count */,
            type XICCEncodingStyle          /* style */,
            type XTextProperty byaddr)      /* text_prop_return */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XmbTextListToTextProperty');

 dcl XwcTextListToTextProperty
     entry (handle Display                  /* display */,
            (*) pointer byaddr           /* list, to wchar_t (*) varz*/,
            fixed bin(31)                   /* count */,
            type XICCEncodingStyle          /* style */,
            type XTextProperty byaddr)      /* text_prop_return */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XwcTextListToTextProperty');

 dcl XwcFreeStringList
     entry (pointer)                      /* list, to wchar_t (*) varz*/
     options (byvalue nodescriptor linkage(cdecl))
     external('XwcFreeStringList');

 dcl XTextPropertyToStringList
     entry (type XTextProperty byaddr       /* text_prop */,
            pointer byaddr                /* list_return (to (*) ptr)*/,
            fixed bin (31) byaddr)          /* count_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XTextPropertyToStringList');

 dcl XmbTextPropertyToTextList
     entry (handle Display                  /* display */,
            type XTextProperty byaddr       /* text_prop */,
            pointer byaddr                  /* list_return to (*) ptr*/,
            fixed bin (31) byaddr)          /* count_return */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XmbTextPropertyToTextList');

 dcl XwcTextPropertyToTextList
     entry (handle Display                  /* display */,
            type XTextProperty byaddr       /* text_prop */,
            pointer byaddr           /* list_return, wchar_t(*) varz */,
            fixed bin (31) byaddr)          /* count_return */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XwcTextPropertyToTextList');

 dcl XUnionRectWithRegion
     entry (type XRectangle byaddr          /* rectangle */,
            type Region                     /* src_region */,
            type Region)                    /* dest_region_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUnionRectWithRegion');

 dcl XUnionRegion
     entry (type Region                     /* sra */,
            type Region                     /* srb */,
            type Region)                    /* dr_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUnionRegion');

 dcl XWMGeometry
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* screen_number */,
            char (*) varz byaddr nonasgn    /* user_geometry */,
            char (*) varz byaddr nonasgn    /* default_geometry */,
            fixed bin(31)                   /* border_width */,
            type XSizeHints byaddr          /* hints */,
            fixed bin (31) byaddr           /* x_return */,
            fixed bin (31) byaddr           /* y_return */,
            fixed bin (31) byaddr           /* width_return */,
            fixed bin (31) byaddr           /* height_return */,
            fixed bin (31) byaddr)          /* gravity_return */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XWMGeometry');

 dcl XXorRegion
     entry (type Region                     /* sra */,
            type Region                     /* srb */,
            type Region)                    /* dr_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XXorRegion');

 %end; /* #XUTIL_H_ */
